<?php
$mode_title = ( $mode == 'edit' ) ? 'Edit Discount' : 'Add Discount';
$discount_id = ( isset($_GET['object_ID']) ) ? $_GET['object_ID'] : 0;
$expire_modes = array(
	'never' => 'Never Expire',
	'date' => 'Exact Date',
);
$disc_modes = array(
	'percent' => '%',
	'fixed' => stms_isset($stms['global']['currency'], 'USD'),
);
$boxes = array(
	'blue' => 'Blue',
	'green' => 'Green',
	'red' => 'Red',
	'orange' => 'Orange',
	'grey' => 'Grey',
);
$buttons = array(
	'orange-addtocart' => 'Orange - Add To Cart',
	'yellow-addtocart' => 'Yellow - Add To Cart',
	'orange-checkout' => 'Orange - Checkout',
	'yellow-checkout' => 'Yellow - Checkout',
	'orange-download' => 'Orange - Download Now',
	'yellow-download' => 'Yellow - Download Now',
	'orange-order' => 'Orange - Order Now',
	'yellow-order' => 'Yellow - Order Now',
	'upload' => 'Upload Custom Button'
);
$d = sdisc_get_discount($discount_id);
$sets = maybe_unserialize(stms_isset($d->settings));
$coupons = sdisc_get_coupons($discount_id);

$discount_amount = ( !isset($d->amount) ) ? 10 : ( ($d->type == 'percent') ? ceil($d->amount) : $d->amount);
?>
<div id="stms-discount-editor" class="stms-admin-block">
	<h2 class="stms-field-title"><?php echo $mode_title; ?></h2>
	<form name="stms_add_discount" id="stms_add_discount" method="post">
		<input type="hidden" name="action" value="stms_discount_save" />
		<input type="hidden" name="discount_id" value="<?php echo $discount_id; ?>" />
		<?php if ( stms_isset($_GET['saved']) == 'true') : ?><div class="stms-help-msg"><p><strong>Discount settings saved.</strong></p></div><?php endif; ?>
		<table class="form-table">
			<?php if ( $mode == 'edit' ) : ?>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label><strong><span style="color:#cc0000">*</span> <?php _e('Discount ID', 'stms'); ?></strong></label></th>
				<td class="normal_text"><?php echo $discount_id; ?></td>
			</tr>
			<?php endif; ?>
	
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="discount_name"><strong><span style="color:#cc0000">*</span> <?php _e('Discount Name', 'stms'); ?></strong></label></th>
				<td><input class="stms-field widefat" type="text" name="discount_name" id="discount_name" value="<?php echo stms_sanitize($d->name); ?>" /></td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="discount_paysys"><strong><span style="color:#cc0000">*</span><?php _e('Payment System', 'stms'); ?></strong></label></th>
				<td>
					<select name="discount_paysys" id="discount_paysys" class="stms-field-member stms-field widefat">
						<?php
						if ( $direct_pays ) {
							foreach ( $direct_pays as $k => $v ) {
								$selected = ( stms_isset($d->paysys) == $k ) ? ' selected="selected"' : '';
								echo "<option value='{$k}'{$selected}>{$v}</option>";
							}
						}
						if ( $third_pays ) {
							foreach ( $third_pays as $k => $v ) {
								$selected = ( stms_isset($d->paysys) == $k ) ? ' selected="selected"' : '';
								echo "<option value='{$k}'{$selected}>{$v}</option>";
							}
						}
						?>
					</select>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="discount_product"><strong><span style="color:#cc0000">*</span><?php _e('Product', 'stms'); ?></strong></label></th>
				<td>
					<select name="discount_product" id="discount_product" class="stms-field widefat">
						<?php
						if ( $products ) {
							foreach ( $products as $product ) {
								if ( $product->type != 'free' ) {
									$selected = ( stms_isset($d->product_id) == $product->ID ) ? ' selected="selected"' : '';
									echo "<option value='{$product->ID}'{$selected}>$product->title</option>";
								}
							}
						}
						?>
					</select>
				</td>
			</tr>
			<tr valign="top" class="third-discount-prop">
				<th scope="row" style="text-align:right"><label for="discount_product2"><strong><span style="color:#cc0000">*</span> <?php _e('Product (After Discount)', 'stms'); ?></strong></label></th>
				<td>
					<select name="discount_product2" id="discount_product2" class="stms-field widefat">
						<?php
						if ( $products ) {
							foreach ( $products as $product ) {
								if ( $product->type != 'free' ) {
									$selected = ( stms_isset($d->product_id2) == $product->ID ) ? ' selected="selected"' : '';
									echo "<option value='{$product->ID}'{$selected}>$product->title</option>";
								}
							}
						}
						?>
					</select>
					<div class="stms-desc"><strong>Important: </strong>Since InstaMember cannot control the price settings in your 3rd-party payment account, then you have to create additional product for this, but with discounted price. The product must be created in both InstaMember and in your 3rd-party payment account.</div>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="discount_amount"><strong><span style="color:#cc0000">*</span> <?php _e('Discount Amount', 'stms'); ?></strong></label></th>
				<td>
					<input class="widefat stms-field" type="text" name="discount_amount" id="discount_amount" value="<?php echo $discount_amount; ?>" style="width:80px" />
					<select name="discount_type" id="discount_type" class="direct-discount-prop" style="width:auto">
						<?php foreach ( $disc_modes as $k => $v ) {
							$selected = ( stms_isset($d->type) == $k ) ? ' selected="selected"' : '';
							echo "<option value='{$k}'{$selected}>{$v}</option>";
						} ?>
					</select> <span class="third-discount-prop"><?php echo stms_isset($stms['global']['currency'], 'USD'); ?></span>
					<div class="stms-desc"><strong>Note: </strong>If the product is a subscription with recurring payments, the discount will be applied ONLY for the initial payment.</div>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label style="cursor:default"><strong>Enable Coupon(s) for Discount</strong></label></th>
				<td><input type="hidden" name="discount_coupon" value="0" />
					<div class="stms-toggle-btn"></div><input type="checkbox" name="discount_coupon" id="discount_coupon" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="coupon-datasets" value="1" <?php if ( stms_isset($d->is_coupon, 1) == 1 ) echo 'checked="checked"'; ?> />
				</td>
			</tr>
			<?php if ( $_GET['mode'] == 'add' ) { ?>
			<tr valign="top" class="coupon-datasets">
				<th scope="row" style="text-align:right"><label for="discount_cnum"><?php _e('Number of Coupon(s)', 'stms'); ?></label></th>
				<td>
					<input class="stms-field widefat" type="text" name="sets[coupon_num]" id="stms_discount_cnum" value="<?php echo stms_sanitize($sets['coupon_num'], 1); ?>" style="width:80px" />
					<div class="stms-desc">The number of coupon that you want to generate</div>
				</td>
			</tr>
			<?php } else { ?>
				<input type="hidden" name="sets[coupon_num]" id="stms_discount_cnum" value="<?php echo stms_sanitize($sets['coupon_num'], 1); ?>" />
			<?php } ?>
			
			<tr valign="top" class="coupon-datasets">
				<th scope="row" style="text-align:right"><label for="discount_ccount"><?php _e('Coupon Usage Count', 'stms'); ?></label></th>
				<td>
					<input class="stms-field widefat" type="text" name="sets[coupon_limit]" id="discount_ccount" value="<?php echo stms_sanitize($sets['coupon_limit'], 10); ?>" style="width:80px" />
					<div class="stms-desc">How many times each coupon can be used</div>
				</td>
			</tr>
			<tr valign="top" class="coupon-datasets">
				<th scope="row" style="text-align:right"><label for="discount_cexpire"><?php _e('Coupon Expire In', 'stms'); ?></label></th>
				<td>
					<input class="widefat stms-field" type="text" name="sets[coupon_exp]" id="discount_cexpire" value="<?php echo stms_sanitize($sets['coupon_exp']); ?>" style="width:100px" />
					<select name="sets[coupon_exp_mode]" id="stms_discount_cexpire_mode" style="width:auto">
						<?php foreach ( $expire_modes as $k => $v ) {
							$selected = ( stms_isset($sets['coupon_exp_mode']) == $k ) ? ' selected="selected"' : '';
							echo "<option value='{$k}'{$selected}>{$v}</option>";
						} ?>
					</select>
					<div class="stms-desc">If you want the coupon(s) to expire, then choose "Exact Date" and enter the expire date (mm/dd/yy).</div>
				</td>
			</tr>
			<tr valign="top" >
				<th scope="row" style="text-align:right"><label style="cursor:default"><strong>Enable Share for Discount</strong></label></th>
				<td><input type="hidden" name="discount_share" value="0" />
					<div class="stms-toggle-btn"></div><input type="checkbox" name="discount_share" id="discount_share" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="share-datasets" value="1" <?php if ( stms_isset($d->is_share, 0) == 1 ) echo 'checked="checked"'; ?> />
				</td>
			</tr>
			<tr valign="top" class="share-datasets">
				<th scope="row" style="text-align:right"><label for="discount_shareurl"><?php _e('Page URL', 'stms'); ?></label></th>
				<td>
					<input class="stms-field widefat" type="text" name="sets[share_url]" id="discount_shareurl" value="<?php echo stms_sanitize($sets['share_url']); ?>" />
					<div class="stms-desc">Page URL that will be shared on Facebook (must include 'http://')</div>
				</td>
			</tr>
			<tr valign="top" class="share-datasets">
				<th scope="row" style="text-align:right"><label for="discount_sharetitle"><?php _e('Page Title', 'stms'); ?></label></th>
				<td>
					<input class="stms-field widefat" type="text" name="sets[share_title]" id="discount_sharetitle" value="<?php echo stms_sanitize($sets['share_title']); ?>" />
					<div class="stms-desc">Page Title that will be shared on Facebook</div>
				</td>
			</tr>
			<tr valign="top" class="share-datasets">
				<th scope="row" style="text-align:right"><label for="discount_fbdesc"><?php _e('Page Desc.', 'stms'); ?></label></th>
				<td>
					<input class="stms-field widefat" type="text" name="sets[share_desc]" id="discount_fbdesc" value="<?php echo stms_sanitize($sets['share_desc']); ?>" />
					<div class="stms-desc">Description of the page that will be posted on the visitor's Facebook wall</div>
				</td>
			</tr>
			<tr valign="top" class="share-datasets">
				<th scope="row" style="text-align:right"><label for="share_image"><?php _e('Image URL', 'stms'); ?></label></th>
				<td>
					<input class="stms-field widefat" type="text" name="sets[share_image]" id="share_image" value="<?php echo stms_sanitize($sets['share_image']); ?>" style="width:75%" /> <span class="button sdisc-upload" id="share_image_button" data-uploader-title="Upload Image" data-button-text="Insert Image URL">Upload Image</span>
					<div class="stms-desc">Image or Thumbnail URL that will be posted on the visitor's Facebook wall (must include 'http://')</div>
				</td>
			</tr>
			<tr valign="top" class="share-datasets">
				<th scope="row" style="text-align:right"><label for="discount_fbtxt"><?php _e('Facebook Button Label', 'stms'); ?></label></th>
				<td>
					<input class="stms-field widefat" type="text" name="sets[share_fbtxt]" id="discount_fbtxt" value="<?php echo stms_sanitize($sets['share_fbtxt'], 'Share for Discount'); ?>" />
				</td>
			</tr>
		</table>
		
		<div class="stms-admin-block" style="margin:30px 0 15px">
			<h2 class="stms-field-title">Order Form Settings <span class="stms-toggle" data-open="no">+</span></h2>
			<table class="form-table">
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="discount_boxwidth"><strong><?php _e('Box Width', 'stms'); ?></strong></label></th>
				<td>
					<input class="stms-field widefat" type="text" name="sets[box_width]" id="discount_boxwidth" value="<?php echo stms_sanitize($sets['box_width'], '500'); ?>" style="width:80px" /> px
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="discount_boxcolor"><strong><?php _e('Box Color', 'stms'); ?></strong></label></th>
				<td>
					<select name="sets[box_color]" id="discount_boxcolor" class="stms-field widefat">
						<?php foreach ( $boxes as $k => $v ) {
							$selected = ( stms_isset($sets['box_color']) == $k ) ? ' selected="selected"' : '';
							echo "<option value='{$k}'{$selected}>{$v}</option>";
						} ?>
					</select>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_form_before_text"><strong><?php _e('Text Before Form', 'stms'); ?></strong></label></th>
				<td>
					<textarea name="sets[before_text]" id="stms_form_before_text" class="stms-field widefat" style="height:100px"><?php echo stms_sanitize(stms_cleanup($sets['before_text'], '<strong><em><u><i><b><a><img><span><div><ul><ol><li>', false)); ?></textarea>
					<div class="stms-desc">You can enter any content you wish before the form. All line-breaks will be automatically convert to paragraphs. Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;&lt;a&gt;&lt;img&gt;&lt;span&gt;&lt;div&gt;&lt;ul&gt;&lt;ol&gt;&lt;li&gt;</code></div>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_form_after_text"><strong><?php _e('Text After Form', 'stms'); ?></strong></label></th>
				<td>
					<textarea name="sets[after_text]" id="stms_form_after_text" class="stms-field widefat" style="height:100px"><?php echo stms_sanitize(stms_cleanup($sets['after_text'], '<strong><em><u><i><b><a><img><span><div><ul><ol><li>', false)); ?></textarea>
					<div class="stms-desc">You can enter any content you wish after the form. All line-breaks will be automatically convert to paragraphs. Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;&lt;a&gt;&lt;img&gt;&lt;span&gt;&lt;div&gt;&lt;ul&gt;&lt;ol&gt;&lt;li&gt;</code></div>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="discount_button"><strong><?php _e('Order Button', 'stms'); ?></strong></label></th>
				<td>
					<select name="sets[button]" id="discount_button" class="stms-field widefat">
						<?php foreach ( $buttons as $k => $v ) {
							$selected = ( stms_isset($sets['button']) == $k ) ? ' selected="selected"' : '';
							echo "<option value='{$k}'{$selected}>{$v}</option>";
						} ?>
					</select>
					<div class="stms-admin-block" id="disc-btn-preview">
						<code>Button Preview:</code>
						<div id="discount-btn-preview"></div>
					</div>
				</td>
			</tr>
			<tr valign="top" class="custom-button-upload" style="display:none">
				<th scope="row" style="text-align:right"><label for="custom_button"><strong><?php _e('Button Image URL', 'stms'); ?></strong></label></th>
				<td>
					<input class="stms-field widefat" type="text" name="sets[custom_button]" id="custom_button" value="<?php echo stms_sanitize($sets['custom_button']); ?>" style="width:75%" /> <span class="button sdisc-upload" id="custom_button_button" data-uploader-title="Upload Button" data-button-text="Insert Button URL">Upload Button</span>
					<div class="stms-desc">Enter your button image URL (must include 'http://'), or click the "Upload Button" to upload a new one.</div>
				</td>
			</tr>
			<?php if ( $_GET['mode'] == 'edit' ) : ?>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label><strong><?php _e('Shortcode', 'stms'); ?></strong></label></th>
				<td>
					<input class="stms-field widefat" type="text" value="[insta_discount id=&quot;<?php echo $discount_id; ?>&quot;]" readonly />
					<div class="stms-desc">When you're editing a post or page, enter this shortcode into the visual editor to display the discount order form.</div>
				</td>
			</tr>
			<?php endif; ?>
			</table>
		</div>
		<?php if ( $coupons && stms_isset($d->is_coupon) == 1 ) : ?>
		<div class="stms-admin-block" style="margin:0 0 30px">
			<h2 class="stms-field-title">Generated Coupon(s) <span class="stms-toggle" data-open="no">+</span></h2>
			<table class="wp-list-table widefat fixed">
				<thead>
				<tr valign="top">
					<th scope="col">Coupon Code</th>
					<th scope="col" style="text-align:center">Limit</th>
					<th scope="col" style="text-align:center">Used</th>
					<th scope="col" style="text-align:center">Expired</th>
					<th scope="col" style="text-align:center">Delete</th>
				</tr>
				</thead>
				<tbody>
					<?php 
					$i = 0;
					foreach ( $coupons as $coupon ) :
						$class = ( $i%2 ) ? ' class="alternate"' : '';
					?>
					<tr valign="top"<?php echo $class; ?>>
						<td><strong><?php echo stms_sanitize($coupon->code); ?></strong><input type="hidden" name="sets[coupon_id][]" value="<?php echo stms_isset($coupon->ID, 0); ?>" /></td>
						<td style="text-align:center"><?php echo stms_isset($coupon->coupon_limit, 0); ?></td>
						<td style="text-align:center"><?php echo stms_isset($coupon->coupon_used, 0); ?></td>
						<td style="text-align:center"><?php echo (( stms_isset($coupon->exp_mode) == 'never' ) ? 'Never' : date("m/d/Y", strtotime($coupon->exp, stms_time()))); ?></td>
						<td style="text-align:center"><a href="<?php echo admin_url('admin.php?page=stms-settings&action=stms_coupon_delete&ID=' . $coupon->ID . '&discount_id=' . $discount_id); ?>" onclick="return confirm('Are you sure you want to delete this coupon?')">Delete</a></td>
					</tr>
					<?php $i++; endforeach; ?>
				</tbody>
			</table>
		</div>
		<?php endif; ?>
		<p style="text-align:right;">
			<input type="submit" id="stms-submit-discount" name="stms-submit-discount" value="Save Discount" class="button-primary" />
		</p>
	</form>
</div>