<?php
if ( is_admin() ) add_filter('insta_admin_tabs', 'sdisc_add_admin_tab');
function sdisc_add_admin_tab( $tabs ) {
	$custom = array(
		'discount' => 'Discounts/Coupons'
	);

	$offset = insta_insert_tab_after($tabs, 'members', $custom);
	return $tabs;
}

if ( is_admin() ) add_action('insta_admin_styles', 'sdisc_admin_styles');
function sdisc_admin_styles() {
	wp_enqueue_style('sdisc-admin', INSTA_ADDONS_URL . 'discount/css/admin-sdisc.css');
}

if ( is_admin() ) add_action('insta_addons_js', 'sdisc_admin_scripts');
function sdisc_admin_scripts() {
?>
	var _custom_media = true, file_frame;
	jQuery('.sdisc-upload').each(function(){
		jQuery(this).click(function(e){
	    	e.preventDefault();
			
			if ( file_frame ) {
				file_frame = false;
				_custom_media = false;
			}
			file_frame = wp.media.frames.file_frame = wp.media({
				title: jQuery(this).data('uploaderTitle'),
				button: {
					text: jQuery( this ).data('buttonText'),
				},
				multiple: false // Set to true to allow multiple files to be selected
			});
			
			var button = jQuery(this);
			var id = button.attr('id').replace('_button', '');
			_custom_media = true;
			
			file_frame.on( 'select', function() {
				attachment = file_frame.state().get('selection').first().toJSON();
				if ( _custom_media ) {
	        		jQuery("#" + id).val(attachment.url);
	        	}
			});
			file_frame.open(button);
  		});
  	});
  	
	jQuery('a.add_media').on('click', function() {
		_custom_media = false;
	});
  
	jQuery("#discount_paysys").change(function(){
		var option = jQuery("option:selected", this).val();
		if ( option == 'paypal' || option == 'twocheckout' || option == 'authorize' || option == 'payza' ) {
			jQuery('.third-discount-prop').hide();
			jQuery('.direct-discount-prop').show();
		} else {
			jQuery('.third-discount-prop').show();
			jQuery('.direct-discount-prop').hide();
		}
	}).change();
	
	jQuery("#discount_button").change(function(){
		var option = jQuery("option:selected", this).val();
		if ( option == 'upload' ) {
			jQuery('#disc-btn-preview').hide();
			jQuery('.custom-button-upload').show();
		} else {
			jQuery('#disc-btn-preview').show();
			jQuery('.custom-button-upload').hide();
			jQuery('#discount-btn-preview').html('<img src="<?php echo STMS_URL; ?>images/buttons/big-' + option + '-circle.png" border="0" />');
		}
	}).change();
	
	jQuery("#stms_add_discount").validate({
		rules: {
			discount_name: {
				required: true
			},
			discount_amount: {
				required: true,
				number: true
			}
		},
		messages: {
			discount_name: { required: "Please enter a discount name." }
		},
		errorClass: "stms-field-error"
	});
<?php
}

add_action('admin_init', 'sdisc_admin_action');
function sdisc_admin_action() {
	global $wpdb;
	if ( isset($_REQUEST['action']) ) {
		$result = false;
		$action = $_REQUEST['action'];
		switch ( $action ) {
			case 'stms_discount_save':
				$result = true;
				$discount_id = sdisc_save_discount($_POST);
				$url = admin_url('admin.php?page=stms-settings') . '#discount|mode=edit&saved=true&object_ID=' . $discount_id;
				@header('Location:' . $url);
				break;
			
			case 'stms_discount_delete':
				$result = true;
				if ( isset($_GET['ID']) ) {
					$discount_id = intval($_GET['ID']);
					$wpdb->delete("{$wpdb->prefix}stms_coupons", array('discount_id' => $discount_id));
					$wpdb->delete("{$wpdb->prefix}stms_discounts", array('ID' => $discount_id));
				}
				$url = admin_url('admin.php?page=stms-settings') . '#discount';
				@header('Location:' . $url);
				break;
				
			case 'stms_coupon_delete':
				$result = true;
				if ( isset($_GET['ID']) ) {
					$coupon_id = intval($_GET['ID']);
					$wpdb->delete("{$wpdb->prefix}stms_coupons", array('ID' => $coupon_id));
				}
				$url = admin_url('admin.php?page=stms-settings') . '#discount|mode=edit&object_ID=' . $_GET['discount_id'];
				@header('Location:' . $url);
				break;
		}
		
		if ( $result )
			exit;
	}
}

function sdisc_save_discount( $vars ) {
	global $wpdb;
	$discount_id = $vars['discount_id'];
	if ( $discount_id )
		$update = true;
	else 
		$update = false;
	
	$data = array(
		'name' => trim($vars['discount_name']),
		'paysys' => $vars['discount_paysys'],
		'product_id' => $vars['discount_product'],
		'product_id2' => $vars['discount_product2'],
		'amount' => trim($vars['discount_amount']),
		'type' => $vars['discount_type'],
		'is_optin' => $vars['discount_optin'],
		'is_coupon' => $vars['discount_coupon'],
		'is_share' => $vars['discount_share'],
		'settings' => maybe_serialize($vars['sets'])
	);
	
	if ( $update ) {
		$wpdb->update("{$wpdb->prefix}stms_discounts", $data, array('ID' => $discount_id));
	} else {
		$wpdb->insert("{$wpdb->prefix}stms_discounts", $data);
		$discount_id = $wpdb->insert_id;
	}
	
	if ( $vars['discount_coupon'] == 1 ) {
		$num = $vars['sets']['coupon_num'];
		if ( $num > 0 ) {
			for ( $i = 0; $i < $num; $i++ ) {
				$coupon_id = stms_isset($vars['sets']['coupon_id'][$i], 0);
				$args = array(
					'discount_id' => $discount_id,
					'coupon_limit' => $vars['sets']['coupon_limit'],
					'exp' => $vars['sets']['coupon_exp'],
					'exp_mode' => $vars['sets']['coupon_exp_mode']
				);
				$coupon = sdisc_save_coupon($args, $coupon_id);
			}
		}
	}
	return $discount_id;
}

function sdisc_get_discounts( $start = 0, $limit = 0 ) {
	global $wpdb;
	$table = "{$wpdb->prefix}stms_discounts";
	$sql = ( $limit > 0 ) ? "SELECT * FROM {$table} ORDER BY `ID` DESC LIMIT {$start},{$limit}" : "SELECT * FROM {$table} ORDER BY `ID` DESC";
	if ( !$discounts = $wpdb->get_results($sql) ) return false;
	return $discounts;
}

function sdisc_get_discount( $discount_id ) {
	global $wpdb;
	$table = "{$wpdb->prefix}stms_discounts";
	$discount_id = intval($discount_id);
	if ( !$discounts = $wpdb->get_row("SELECT * FROM {$table} WHERE `ID` = {$discount_id}") ) return false;
	return $discounts;	
}

function sdisc_get_coupons( $discount_id ) {
	global $wpdb;
	$table = "{$wpdb->prefix}stms_coupons";
	$discount_id = intval($discount_id);
	if ( !$coupons = $wpdb->get_results("SELECT * FROM {$table} WHERE `discount_id` = {$discount_id}") ) return false;
	return $coupons;
}

function sdisc_get_coupon( $coupon_id = 0, $code = '' ) {
	global $wpdb;
	if ( empty($code) && !is_numeric($coupon_id) ) {
		$code = $coupon_id;
		$coupon_id = 0;
	}
	
	if ( $coupon_id > 0 ) {
		$field = 'ID';
		$value = $coupon_id;
	} else {
		$field = 'code';
		$value = $code;
	}
	
	$table = "{$wpdb->prefix}stms_coupons";
	if ( !$coupon = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$table} WHERE {$field} = %s", $value)) ) return false;
	return $coupon;
}

function sdisc_save_coupon( $args, $coupon_id = 0 ) {
	global $wpdb;
	
	$defaults = array(
		'discount_id' => 0,
		'coupon_limit' => 10,
		'exp' => '',
		'exp_mode' => 'never',
	);
	$args = wp_parse_args( $args, $defaults );
	extract($args, EXTR_SKIP);
	
	$coupon_id = intval($coupon_id);
	if ( $coupon_id )
		$update = true;
	else 
		$update = false;
	
	$data = array(
		'discount_id' => $discount_id,
		'coupon_limit' => $coupon_limit,
		'exp' => trim($exp),
		'exp_mode' => $exp_mode
	);
	
	if ( $update ) {
		$wpdb->update("{$wpdb->prefix}stms_coupons", $data, array('ID' => $coupon_id));
	} else {
		$data['code'] = sdisc_generate_coupon();
		$data['coupon_used'] = 0;
		$wpdb->insert("{$wpdb->prefix}stms_coupons", $data);
		$coupon_id = $wpdb->insert_id;
	}
	return $coupon_id;
}

function sdisc_generate_coupon() {
	$code = md5(time() . stms_generate_secret());
	$code = strtoupper(substr($code, 0, 8));
	if ( sdisc_coupon_exists($code) )
		$code = sdisc_generate_coupon();
	return $code;
}

function sdisc_coupon_exists( $code ) {
	global $wpdb;
	$count = $wpdb->get_var("SELECT COUNT(*) FROM `{$wpdb->prefix}stms_coupons` WHERE `code` = '{$code}'");
	if ( $count > 0 ) return true;
	return false;
}

function sdisc_table_data( $per_page = 10 ) {
	global $wpdb;
	
	$stms = get_option('stms_settings');
	$data_start = ( stms_isset($_GET['paged'], 1) > 1 ) ? ($_GET['paged']-1) * $per_page : 0;
	$results = sdisc_get_discounts($data_start, $per_page);
	
	$data = array();
	if ( $results ) {
		foreach ( $results as $d ) {
			$data[] = array(
					'ID' => $d->ID,
					'title' => stms_sanitize($d->name),
					'product' => stms_get_productname($d->product_id),
					'paysys' => stms_getpaymentname($d->paysys),
					'amount' => ceil($d->amount) . (( $d->type == 'percent' ) ? '%' : ' ' . stms_isset($stms['global']['currency'], 'USD')),
			);
		}
	}
	
	return $data;	
}

add_action('insta_payment_clicked', 'sdisc_drop_id', 10, 2);
function sdisc_drop_id( $product_id, $processor ) {
	if ( isset($_GET['disc_id']) ) {
		@setcookie('__insta_discid', $_GET['disc_id'], 0, SITECOOKIEPATH);
	}
}

add_filter('insta_total_checkout', 'sdisc_total_checkout', 10, 4);
function sdisc_total_checkout( $content, $price, $currency, $product_id ) {
	$discount_id = stms_isset($_COOKIE['__insta_discid'], '');
	$amount = stms_isset($_COOKIE['__insta_discamount_' . $discount_id], '');
	
	if ( empty($discount_id) || empty($amount) || !($discount = sdisc_get_discount($discount_id)) )
		return $content;
	
	if ( $discount->product_id != $product_id )
		return $content;
	
	$total = $price - $amount;
	return number_format($total, 2);
}

add_filter('insta_total_cart', 'sdisc_total_cart', 10, 4);
function sdisc_total_cart( $content, $price, $currency, $product_id ) {
	$discount_id = stms_isset($_COOKIE['__insta_discid'], '');
	$amount = stms_isset($_COOKIE['__insta_discamount_' . $discount_id], '');
	
	if ( empty($discount_id) || empty($amount) || !($discount = sdisc_get_discount($discount_id)) )
		return $content;
	
	if ( $discount->product_id != $product_id )
		return $content;
	
	$total = $price - $amount;
	
	$content = '';
	$content .= '<small>SubTotal: ' . number_format($price, 2) . ' ' . $currency . '</small><br />';
	$content .= '<small>Discount: -' . number_format($amount, 2) . ' ' . $currency . '</small><br />';
	$content .= '<strong>Total: <span style="color:#008900">' . number_format($total, 2) . ' ' . $currency . '</span></strong>';
	
	return $content;
}

if ( !is_admin() ) add_action('template_redirect', 'sdisc_form_handler');
function sdisc_form_handler() {
	if ( isset($_POST['action']) && $_POST['action'] == 'insta_discount_order' ) {
		global $wpdb, $post;
		
		$stms = get_option('stms_settings');
		$discount_id = $_POST['sdiscount_id'];
		$price = $_POST['sdisc_price'];
		$cut = $_POST['sdisc_amount'];
		$type = $_POST['sdisc_mode'];
		$curr = $_POST['sdisc_curr'];
		$paysys = $_POST['spaysys'];
		$product = stms_get_product($_POST['sproduct_id']);
		$product2 = stms_get_product($_POST['sproduct_id2']);
		$code = stms_sanitize($_POST['insta_coupon'], '');
		$gateway = stms_gateway_type($paysys);

		$discounted = false;
		if ( isset($_COOKIE['__insta_discount_' . $discount_id]) ) {
			$discounted = true; // already shared on FB
			@setcookie('__insta_discid', 0, time()-84600, SITECOOKIEPATH); // remove cookie...
			@setcookie('__insta_discount_' . $discount_id, 0, time()-84600, SITECOOKIEPATH); // remove cookie...
		}
		
		$invalid = false;
		if ( !$discounted && !empty($code) ) {
			$invalid = true;
			if ( $c = sdisc_get_coupon($code) ) {
				if ( $c->coupon_used < $c->coupon_limit ) {
					$invalid = false;
					$discounted = true;
					$used = $c->coupon_used + 1;
					$wpdb->update("{$wpdb->prefix}stms_coupons", array('coupon_used' => $used), array('ID' => $c->ID));
				}
			} 
		}
		
		if ( $invalid ) {
			$url = stms_format_url($post->ID, 'coupon=invalid');
			wp_redirect($url);
			exit;
		}
		
		$disc_id = '';
		if ( $discounted ) {
			if ( $type == 'percent' )
				$amount = number_format((($price * $cut) / 100), 2);
			else
				$amount = number_format($cut, 2);
			
			@setcookie('__insta_discid', $discount_id, 0, SITECOOKIEPATH);
			@setcookie('__insta_discamount_' . $discount_id, $amount, 0, SITECOOKIEPATH);
			$disc_id = "&disc_id={$discount_id}";
		}
		
		// redirect to payment url...
		$payment_url = '';
		if ( $gateway == 'direct' ) {
			$payment_url = stms_format_url(get_bloginfo('url'), "insta_pay={$paysys}&id={$product->ID}" . $disc_id);
		} else {
			$product_id = ( $discounted ) ? $product2->ID : $product->ID;
			$settings = stms_get_paysettings($product_id);
			switch ( $paysys ) {
				case 'clickbank':
					$vendor = stms_isset($settings['clickbank']['vendor'], '');
					$item = stms_isset($settings['clickbank']['item'], 0);
					$payment_url = "http://{$item}.{$vendor}.pay.clickbank.net/";
					break;
					
				case 'dealguardian':
					$item = stms_isset($settings['dealguardian']['item'], 0);
					$payment_url = "";
					break;
					
				case 'ejunkie':
					$item = stms_isset($settings['dealguardian']['item'], 0);
					$client_id = stms_sanitize($stms['payments']['ejunkie']['id'], '', true);
					$payment_url = "http://www.e-junkie.com/ecom/gb.php?i={$item}&c=single&cl={$client_id}&custom={$product->ID}";
					break;
					
				case 'jvzoo':
					$item = stms_isset($settings['jvzoo']['item'], 0);
					$payment_url = "https://www.jvzoo.com/b/0/{$item}/2?insta_id={$product->ID}";
					break;
					
				case 'dgr':
					$item = stms_isset($settings['dgr']['item'], 0);
					$payment_url = "http://www.digiresults.com/buy/{$item}?insta_id={$product->ID}";
					break;
					
				case 'wsopro':
					$item = stms_isset($settings['wsopro']['item'], 0);
					$payment_url = "http://www.warriorplus.com/buywso/{$item}";
					break;
					
				case 'productpay':
					$item = stms_isset($settings['productpay']['item'], 0);
					$payment_url = "https://www.productpay.com/product/{$item}";
					break;
					
				case 'nanacast':
					$item = stms_isset($settings['nanacast']['item'], 0);
					$payment_url = "";
					break;
					
				case 'oneshopping':
					$item = stms_isset($settings['oneshopping']['item'], 0);
					$payment_url = stms_isset($settings['oneshopping']['payurl'], 'https://');
					break;
			}
		}
		
		wp_redirect($payment_url);
		exit;
	}	
}

add_shortcode('insta_discount', 'sdisc_shortcode_handler');
function sdisc_shortcode_handler( $atts, $content = null ) {
	extract( shortcode_atts( array(
		'id' => 0,
	), $atts ) );

	global $post;
	
	$stms = get_option("stms_settings");
	$fbappid = stms_isset($stms['integration']['fb']['appid']);
	
	$curr = ' ' . stms_isset($stms['global']['currency'], 'USD');
	$discount_id = intval($id);
	if ( !$d = sdisc_get_discount($discount_id) )
		return 'ERROR: Discount ID: "' . $discount_id . '" not found.';
	
	$sets = maybe_unserialize($d->settings);
	
	$width = ' style="width:' . stms_isset($sets['box_width']) . 'px"';
	$color = stms_isset($sets['box_color']);
	
	$before_text = stms_sanitize(stms_cleanup(html_entity_decode($sets['before_text']), '<strong><em><u><i><b><a><img><span><div><ul><ol><li>', false));
	$after_text = stms_sanitize(stms_cleanup(html_entity_decode($sets['after_text']), '<strong><em><u><i><b><a><img><span><div><ul><ol><li>', false));
	$button = ( stms_isset($sets['button']) == 'upload' ) ? stms_sanitize($sets['custom_button']) : STMS_URL . 'images/buttons/big-' . stms_isset($sets['button']) . '-circle.png';
	
	$pr = stms_get_product($d->product_id);
	$total = $price = (( $pr->type == 'recurr' && $pr->is_trial == 1 ) ? $pr->t_price : $pr->price);
	$disc = 0.00;
	if ( isset($_COOKIE['__insta_discount_' . $discount_id]) ) {
		$cut = ( $d->type == 'percent') ? (($price * $d->amount) / 100 ) : $d->amount;
		$disc = '-' . number_format($cut, 2);
		$total = number_format($price - $cut, 2);
	}
	
	$discount_amount = ( !isset($d->amount) ) ? 10 : ( ($d->type == 'percent') ? ceil($d->amount) : $d->amount);
	
	$html = '';
	$html .= '<div class="insta-feat-box"' . $width . '><h3 class="insta-feat-title-' . $color . '">Your Order</h3><div>';
	$html .= wptexturize(wpautop($before_text));
	
	$disp = ( isset($_COOKIE['__insta_discount_' . $discount_id]) ) ? 'block' : 'none';
	$html .= '<div class="insta-update-msg" style="margin-bottom:10px; display:' . $disp . '" id="sdisc-applied">Discount has been applied.</div>';
	
	if ( isset($_GET['coupon']) && $_GET['coupon'] == 'invalid' )
		$html .= '<div class="insta-error-msg" style="margin-bottom:10px;" id="sdisc-coupon-error">Invalid coupon code.</div>';
	
	$html .= '<table class="insta-discount-cart">';
	$html .= '<thead><tr valign="top"><th style="padding-left:10px">Product</th><th style="text-align:right; padding-right:10px">Price</th></thead></tr>';
	$html .= '<tbody>';
	$html .= '<tr valign="top">';
	$html .= '<td>' . stms_sanitize($pr->title) . '</td>';
	$html .= '<td style="text-align:right">' . stms_sanitize($price) . $curr . '</td>';
	$html .= '</tr>';
	$html .= '</tbody>';
	$html .= '<tfoot>';
	$html .= '<tr valign="top">';
	$html .= '<td style="text-align:right"><strong>SubTotal</strong><br /><strong>Discount</strong><br /><strong>Total</strong></td>';
	$html .= '<td style="text-align:right">' . stms_sanitize($price) . $curr . '<br /><span id="insta-total-discount">' . $disc . $curr . '</span><br /><span id="insta-total-price" style="font-weight:bold; color:#008900">' . $total . $curr . '</span></td>';
	$html .= '</tr>';
	$html .= '</tfoot>';
	$html .= '</table>';
	
	if ( stms_isset($d->is_share) == 1 && $fbappid != '' && !isset($_COOKIE['__insta_discount_' . $discount_id]) ) {
		$fb_label = stms_sanitize($sets['share_fbtxt']);
		$html .= '<p style="margin:0; padding:0 0 12px; text-align:center" id="sdisc-share"><button class="insta-facebook-btn" name="insta-fb-discount" id="insta-fb-discount">' . $fb_label . '</button></p>';
	}
	
	$html .= '<form name="insta_discount_frm" id="insta_discount_frm" method="post" action="' . get_permalink($post->ID) . '">';
	$html .= '<input type="hidden" name="action" id="action" value="insta_discount_order" />';
	$html .= '<input type="hidden" name="sdiscount_id" id="sdiscount_id" value="' . $discount_id . '" />';
	$html .= '<input type="hidden" name="sdisc_price" id="sdisc_price" value="' . stms_isset($price) . '" />';
	$html .= '<input type="hidden" name="sdisc_amount" id="sdisc_amount" value="' . stms_isset($discount_amount) . '" />';
	$html .= '<input type="hidden" name="sdisc_mode" id="sdisc_mode" value="' . stms_isset($d->type) . '" />';
	$html .= '<input type="hidden" name="sdisc_curr" id="sdisc_curr" value="' . stms_isset($stms['global']['currency'], 'USD') . '" />';
	$html .= '<input type="hidden" name="spaysys" id="spaysys" value="' . stms_isset($d->paysys) . '" />';
	$html .= '<input type="hidden" name="sproduct_id" id="sproduct_id" value="' . stms_isset($d->product_id) . '" />';
	$html .= '<input type="hidden" name="sproduct_id2" id="sproduct_id2" value="' . stms_isset($d->product_id2) . '" />';
	
	$html .= '<div style="margin:0 0 10px; text-align:center">';
	if ( stms_isset($d->is_coupon) == 1 && !isset($_COOKIE['__insta_discount_' . $discount_id]) ) {
		$html .= '<div id="sdisc-coupon"><strong>Coupon Code: </strong><input type="text" name="insta_coupon" id="insta_coupon" class="insta-disc-field" placeholder="Enter coupon here" /></div>' . "\n";
	}
	
	$html .= '<div style="margin:10px 0"><input type="image" name="insta_disc_submit" id="insta_disc_submit" src="' . $button . '" /></div>';
	$html .= '</div>';
	$html .= '</form>';
	$html .= wptexturize(wpautop($after_text));
	$html .= '</div></div>';
	
	$script = '';
	if ( stms_isset($d->is_share) == 1 && $fbappid != '' ) {
		$fb_url = ( stms_isset($sets['share_url']) != '' ) ? addslashes(stms_sanitize($sets['share_url'])) : get_permalink($post->ID);
		$fb_title = ( stms_isset($sets['share_title']) != '' ) ? addslashes(str_replace(array("\r", "\n", "\r\n"), '', strip_shortcodes(stms_sanitize($sets['share_title'])))) : addslashes(strip_shortcodes(stms_sanitize($post->post_title)));
		$fb_image = ( stms_isset($sets['share_image']) != '' ) ? stms_sanitize($viral['share_image']) : '';
		$fb_desc = ( stms_isset($sets['share_url']) != '' ) ? addslashes(str_replace(array("\r", "\n", "\r\n"), '', strip_tags(strip_shortcodes(stms_sanitize($viral['share_desc']))))) : '';
		
		$html .= '<input type="hidden" id="sfburl" value="' . $fb_url . '" />';
		$html .= '<input type="hidden" id="sfbtitle" value="' . $fb_title . '" />';
		$html .= '<input type="hidden" id="sfbimage" value="' . $fb_image . '" />';
		$html .= '<input type="hidden" id="sfbdesc" value="' . $fb_desc . '" />';
		
		$script .= '<div id="fb-root"></div>';
		$script .= '<script type="text/javascript">';
		$script .= "
			window.fbAsyncInit = function() {
		    	FB.init({
		      		appId      : '{$fbappid}',
		      		channelUrl : '" . get_permalink($post->ID) . "', 
		      		status     : true,
		      		cookie     : true,
		      		xfbml      : true
		    	});
		    	
		 ";
		 
		 $script .= sdisc_discount_fb_script();
		 $script .= "
		    };	
			
			// Load the SDK Asynchronously
		  	(function(d){
			     var js, id = 'facebook-jssdk', ref = d.getElementsByTagName('script')[0];
			     if (d.getElementById(id)) {return;}
			     js = d.createElement('script'); js.id = id; js.async = true;
			     js.src = \"//connect.facebook.net/en_US/all.js\";
			     ref.parentNode.insertBefore(js, ref);
		   	}(document));
		";
		$script .= '</script>';
		if ( !has_action('wp_footer', 'opl_facebook_js') )
			$html .= $script;
	}
	
	return $html;
}

function sdisc_discount_fb_script() {
	global $fbdata;
	
	$script = "
		jQuery(document).ready(function(){
			jQuery('#insta-fb-discount').click(function(e){
				FB.getLoginStatus(function(response) {
					if ( response.status == 'connected' ) {
						insta_fb_discount_share(jQuery);
					} else {
						insta_fb_discount_login(jQuery);
					}
				});
				e.preventDefault();
			});
		});
		
		function insta_fb_discount_login($) {
			FB.login(function(response) {
				if ( response.authResponse ) {
					if ( response.status == 'connected' ) {	
						insta_fb_discount_share($);
					}
				}
			}, {scope: 'email,publish_stream'});
		}

		function insta_fb_discount_share($) {
			var pr = parseInt(jQuery('#sdisc_price').val());
			var dc = parseInt(jQuery('#sdisc_amount').val());
			var md = jQuery('#sdisc_mode').val();
			var curr = jQuery('#sdisc_curr').val();
			var cut = dc;
			var discount = '0.00';
			var total = String(pr) + ' ' + curr;
			if ( md == 'percent' ) {
				cut = Math.abs((pr * dc) / 100);
				cut = cut.toFixed(2);
			}
			
			pr = (pr - cut).toFixed(2);
			discount = '-' + String(cut) + ' ' + curr;
			total = String(pr) + ' ' + curr;
				
			FB.api('/me/feed', 'post', {
				link: jQuery('#sfburl').val(),
				name: jQuery('#sfbtitle').val(),
				picture: jQuery('#sfbimage').val(),
				caption : '',
				description: jQuery('#sfbdesc').val(),
			}, function(response) {
				$.cookie('__insta_discount_' + jQuery('#sdiscount_id').val(), 1, { expires: 2, path: '" . SITECOOKIEPATH . "' });
				jQuery('#sdisc-applied').show();
				jQuery('#sdisc-share').hide();
				jQuery('#insta-total-discount').text(discount);
				jQuery('#insta-total-price').text(total);
				jQuery('#sdisc-coupon').hide();
				jQuery('#sdisc-coupon-error').hide();
			});
		}
	";
	return $script;
}

add_action('opl_fb_action', 'sdisc_discount_fb');
function sdisc_discount_fb() {
	echo sdisc_discount_fb_script();
}