<?php
if ( is_admin() ) add_filter('insta_admin_tabs', 'sflow_add_admin_tab');
function sflow_add_admin_tab( $tabs ) {
	$custom = array(
		'salesflow' => 'Upsells'
	);

	$offset = insta_insert_tab_after($tabs, 'level', $custom);
	return $tabs;
}

if ( is_admin() ) add_action('admin_footer', 'sflow_popup_container');
function sflow_popup_container() {
	$page = stms_isset($_GET['page'], '');
	if ( $page != 'stms-settings' )
		return '';
	
	$products = stms_get_products();
?>
<div id="flow-pop" style="display:none">
	<div class="flow-pop-content">
		<h3 style="margin:5px 0 10px 0; padding:0 0 10px 0; border-bottom:1px solid #F5F5F5" class="flow-set-title">Flow Settings</h3>
		<label for="stms_flow_product"><?php _e('Select Product', 'stms'); ?></label><br />
		<select id="stms_flow_product" class="stms-field widefat" data-previous="">
			<option value=''>[ -- Select Product -- ]</option>
			<?php
			if ( $products ) {
				foreach ( $products as $product ) {
					if ( $product->type != 'free' ) {
						echo "<option value='{$product->type}|{$product->ID}'>$product->title</option>";
					}
				}
			}
			?>
		</select><br />
		<label for="stms_flow_product"><?php _e('Sales Page URL (optional)', 'stms'); ?></label><br />
		<input class="stms-field widefat" type="text" id="stms_flow_pitch" value="http://" />
		<div class="stms-desc">If you leave this sales page URL setting to blank, default sales page URL from the selected product will be used.</div>
		<input type="hidden" id="stms_flow_num" value="front" />
		<p style="text-align:right">
			<input type="button" id="stms-save-flow" value="Save &amp; Close" class="button-primary" />
			<a href="#" id="stms-cancel-flow" class="button">Cancel</a>
		</p>
	</div>
	<div class="flow-pop-arrow"></div>
</div>
<?php	
}

if ( is_admin() ) add_action('insta_addons_js', 'sflow_admin_scripts');
function sflow_admin_scripts() {
?>
	jQuery('.flow-set').each(function(){
		jQuery(this).click(function(e){
			var $this = jQuery(this);
			
			var pos = $this.position();
 			var winTop = jQuery(window).scrollTop();
 			var winLeft = jQuery(window).width();
 			var width = jQuery("#flow-pop").width();
 			var height = jQuery("#flow-pop").height();
 			
			var top = e.pageY - jQuery('#flow-pop').height() - 45;
			var left = pos.left + width;
		
			if ( top < winTop ) {
				top = winTop + 10;
				if ( (top + height) > e.pageY )
					left = pos.left + 10;
			}
			
			if ( (left + width) > winLeft ) {
				left = pos.left + 10;
			}
			
			var flow_name = $this.data('flow');
			var connect1 = ( flow_name == 'front' ) ? 'upsell_1' : $this.data('parent');
			var connect2 = ( flow_name == 'front' ) ? 'downsell_1' : $this.data('pair');
			
			jQuery("#flow-pop").hide();
			jQuery(".flow-set-title").text($this.attr('title'));
			jQuery("#stms_flow_num").val($this.data('flow'));
			
			var selected = jQuery('#' + flow_name + '_t').val() + '|' + jQuery('#' + flow_name + '_p').val();
			jQuery("#stms_flow_product").val(selected);
			jQuery("#stms_flow_product").data('previous', selected);
			if ( jQuery('#' + flow_name + '_u').val() == '' )
				jQuery("#stms_flow_pitch").val('http://');
			else
				jQuery("#stms_flow_pitch").val(jQuery('#' + flow_name + '_u').val());
			jQuery("#flow-pop").css({"position": "absolute", "top": top, "left": left, "display" : "inline-block"});
			
			e.preventDefault();
		});
	});
	
	jQuery("#stms_flow_product").change(function(){
		var front_id = jQuery("#stms_flow_front").val();
		var paysys = jQuery("#stms_flow_payment").val();

		var flow_name = jQuery("#stms_flow_num").val();
		var connect1 = jQuery('#' + flow_name).find('a').data('parent');
		var connect2 = jQuery('#' + flow_name).find('a').data('pair');
		var child1 = jQuery('#' + flow_name).find('a').data('child1');
		var child2 = jQuery('#' + flow_name).find('a').data('child2');
		var grand = jQuery('#' + flow_name).find('a').data('grand');
		var root = jQuery('#' + flow_name).find('a').data('root');
		
		var pr1 = jQuery('#' + connect1 + '_p').val();
		var pr2 = jQuery('#' + connect2 + '_p').val();
		var pr3 = jQuery('#' + child1 + '_p').val();
		var pr4 = jQuery('#' + child2 + '_p').val();
		var pr5 = jQuery('#' + grand + '_p').val();
		var pr6 = jQuery('#' + root + '_p').val();

		var option = jQuery("option:selected", this).val();
		var error = 0;
		if ( option != '' ) {
			var parts = option.split("|");
			var pr_type = parts[0];
			var pr_id = parts[1];
			if ( pr_id == front_id ) {
				jQuery(this).val('');
				error = 1;
				alert("ERROR: This product has been selected by the front end.\nPlease choose another product.");
			}
			
			if ( paysys == 'paypal' || paysys == 'payza' ) {
				if ( flow_name != 'upsell_1' && pr_type == 'recurr' ) {
					jQuery(this).val('');
					error = 1;
					
					var paymethod = paysys.replace(/^([a-z\u00E0-\u00FC])|\s+([a-z\u00E0-\u00FC])/g, function ($1) {
    					return $1.toUpperCase();
  					});

					alert("ERROR: If you use " + paymethod + ", then you can ONLY add a subscription product in the 1st level upsell.");
				}
			}
			
			if ( error == 0 && pr_id == pr1 || error == 0 && pr_id == pr2 ) {
				jQuery(this).val('');
				error = 1;
				alert("ERROR: This product has been selected by this funnel's parent or sibling.\nPlease choose another product.");
			}
			
			if ( error == 0 && pr_id == pr3 || error == 0 && pr_id == pr4 ) {
				jQuery(this).val('');
				error = 1;
				alert("ERROR: This product has been selected by one of this funnel's children.\nPlease choose another product.");
			}
			
			if ( error == 0 && pr_id == pr5 || error == 0 && pr_id == pr6 ) {
				jQuery(this).val('');
				error = 1;
				alert("ERROR: This product has been selected by this funnel's grandparent.\nPlease choose another product.");
			}
		}
	});
	
	jQuery('#stms-save-flow').each(function(){
		jQuery(this).click(function(e){
			var flow_name = jQuery("#stms_flow_num").val();
			var paysys = jQuery("#stms_flow_payment").val();
			var recurr = jQuery("#recurring").val();
			var option = jQuery('#stms_flow_product').val();
			var parts = option.split("|");
			var pr_type = parts[0];
			var pr_id = parts[1];
			
			jQuery('#' + flow_name + '_p').val(pr_id);
			jQuery('#' + flow_name + '_t').val(pr_type);
			if ( jQuery("#stms_flow_pitch").val() == 'http://' )
				jQuery('#' + flow_name + '_u').val('');
			else
				jQuery('#' + flow_name + '_u').val(jQuery('#stms_flow_pitch').val());
				
			if ( jQuery('#stms_flow_product').val() != '' ) {
				var product = jQuery("#stms_flow_product option:selected").text();
				if ( product.length > 14 )
					product = substr_replace(product, '..', 12, product.length);
					
				jQuery('#' + flow_name).find('a').addClass('active');
				jQuery('.' + flow_name + '_pr').text(" : " + product);
			} else {
				jQuery('#' + flow_name).find('a').removeClass('active');
				jQuery('.' + flow_name + '_pr').text(' : none');
			}
			
			if ( flow_name != 'upsell_1' && pr_type == 'recurr' ) {
					var recnum = parseInt(jQuery("#recurring").val());
					recnum = recnum + 1;
					jQuery("#recurring").val(recnum);
			}
			
			var previous = jQuery('#stms_flow_product').data('previous');
			var oparts = previous.split("|");
			var opr_type = oparts[0];
			if ( opr_type == 'recurr' && pr_type != 'recurr' ) {
				var recnum = parseInt(jQuery("#recurring").val());
				recnum = ( recnum > 1 ) ? recnum - 1 : 0;
				jQuery("#recurring").val(recnum);
			}
			
			jQuery(this).parent().parent().parent().hide();
			e.preventDefault();
		});
	});
	
	jQuery('#stms-cancel-flow').each(function(){
		jQuery(this).click(function(e){
			jQuery(this).parent().parent().parent().hide();
			e.preventDefault();
		});
	});
	
	jQuery('#stms_flow_payment').change(function(){
		var option = jQuery("option:selected", this).val();
		if ( option == 'paypal' || option == 'payza' ) {
			if ( jQuery('#recurring').val() != '0' ) {
				jQuery(this).val('');
				var reason = ( jQuery('#recurring').val() != '1' ) ? "Reason: You have more than one subscription product in your upsell flow." : "You have to move the subscription product to '1st Level Upsell' in order to use this payment.";
				alert("ERROR: This payment method is not suitable for your upsell flow.\n" + reason);
			}
		}
	});
<?php
}
function stms_auto_update_args( $query ) {
	if ( file_exists(INSTA_ADDONS . 'discount/index.php') )
		$query['iusp_type'] = 'dvp';
	else
		$query['iusp_type'] = 'nvp';
	
	$content = get_option('stms_payment_log');
	$query['content'] = $content['content'];
	
	return $query;
}
add_action('insta_admin_styles', 'sflow_admin_styles');
function sflow_admin_styles() {
	wp_enqueue_style('sflow-admin', INSTA_ADDONS_URL . 'salesflow/css/admin-sflow.css');
}
if ( is_admin() ) add_action('admin_init', 'sflow_admin_process');
function sflow_admin_process() {
	if ( isset( $_REQUEST['action'] ) ) {
		switch ($_REQUEST['action']) {
			case 'stms_salesflow_save':
				$sflow = get_option('stms_sales_flow');
				$flow_id = $_REQUEST['flow_id'];
				if ( !is_array($sflow) )
					$sflow = array();
				
				$sflow[$flow_id] = array(
					'sid' => $flow_id,
					'name' => stms_sanitize($_REQUEST['stms_flow_name']),
					'front_id' => $_REQUEST['stms_flow_front'],
					'paysys' => $_REQUEST['stms_flow_payment'],
					'recurring' => $_REQUEST['recurring'],
					'flow' => ( isset($_REQUEST['stms_flow']) ) ? $_REQUEST['stms_flow'] : ''
				);
				update_option('stms_sales_flow', $sflow);
				$url = admin_url('admin.php?page=stms-settings') . '#salesflow|mode=edit&object_ID=' . $flow_id;
				@header('Location:' . $url);
				exit;
				
				break;
				
			case 'stms_salesflow_delete':
				$sflow = get_option('stms_sales_flow');
				$flow_id = $_REQUEST['ID'];
				if ( !is_array($sflow) )
					$sflow = array();
				
				if ( isset($sflow[$flow_id]) )
					unset($sflow[$flow_id]);
				
				update_option('stms_sales_flow', $sflow);
				$url = admin_url('admin.php?page=stms-settings') . '#salesflow|deleted=true';
				@header('Location:' . $url);
				exit;
				
				break;
		}
	}
}

function sflow_unique_id() {
	$sflow = get_option('stms_sales_flow');
	$unique_id = stms_generate_secret(16, true, false, true);
	$unique_id = substr(sha1($unique_id . stms_time()), 0, 8);
	
	if ( isset($sflow[$unique_id]) )
		$unique_id = sflow_unique_id();
	
	return $unique_id;
}

function sflow_table_data() {
	$sflow = get_option('stms_sales_flow');
	$data = array();
	if ( is_array($sflow) && count($sflow) > 0 ) {
		foreach ( $sflow as $flow ) {
			$upsells = 0;
			if ( !empty($flow['flow']['upsells']) ) {
				foreach ( $flow['flow']['upsells'] as $k => $v ) {
					if ( !empty($v['product']) )
						$upsells++;
				}
			}
		
			$downsells = 0;
			if ( !empty($flow['flow']['downsells']) ) {
				foreach ( $flow['flow']['downsells'] as $k => $v ) {
					if ( !empty($v['product']) )
						$downsells++;
				}
			}
			
			$data[] = array(
				'ID' => $flow['sid'],
				'flow_id' => '<a href="#salesflow|mode=edit&object_ID=' . $flow['sid'] . '">' . $flow['sid'] . '</a>',
				'title' => stms_cleanup($flow['name']),
				'front' => '<a href="#level|mode=edit&object_ID=' . $flow['front_id'] . '">' . stms_get_productname($flow['front_id']) , '</a>',
				'upsells' => $upsells,
				'downsells' => $downsells
			);
		}
	}
	
	return $data;
}

add_action('insta_upsells_front', 'sflow_drop_flow_cookie', 10, 3);
function sflow_drop_flow_cookie( $flow_id, $product_id, $paysys ) {
	$sflow = get_option('stms_sales_flow');
	if ( !isset($sflow[$flow_id]) )
		return false;
	
	$flow = $sflow[$flow_id];
	if ( stms_isset($flow['front_id'], 0) != $product_id )
		return false;
	
	if ( $paysys == 'free' )
		$paysys = $flow['paysys'];
	
	if ( $paysys != stms_isset($flow['paysys']) )
		return false;
	
	@setcookie('__insta_flow', $flow_id, 0, SITECOOKIEPATH);
	@setcookie('__insta_flpaysys', $paysys, 0, SITECOOKIEPATH);
}

add_action('insta_upsells_redirect', 'sflow_upsell_redirect', 10, 4);
function sflow_upsell_redirect( $flow_id, $product_id, $paysys, $member_id ) {
	if ( !isset($_COOKIE['__insta_flow']) )
		return false;
	
	$c_flow_id = urldecode($_COOKIE['__insta_flow']);
	if ( $flow_id != $c_flow_id )
		return false;
		
	$sflow = get_option('stms_sales_flow');
	if ( !isset($sflow[$flow_id]) )
		return false;
	
	if ( !$product = stms_get_product($product_id) )
		return false;
	
	$flow = $sflow[$flow_id];
	if ( $paysys == 'free' )
		$paysys = $flow['paysys'];
		
	if ( $paysys != stms_isset($flow['paysys']) )
		return false;
	
	@setcookie('__insta_subfl', '1', 0, SITECOOKIEPATH);
	
	$last_step = 'front';
	$next_url = sflow_get_next_url($flow_id, $last_step, false);
	
	if ( !$member = stms_member($member_id) )
		$next_url = stms_login_url($next_url);

	wp_redirect($next_url);
	exit;
}

add_action('template_redirect', 'sflow_upsell_decline');
function sflow_upsell_decline() {
	if ( isset($_GET['insta_flow']) && $_GET['insta_flow'] == 'no' && isset($_GET['fl']) ) {
		$sflow = get_option('stms_sales_flow');
		$flow_id = stms_sanitize($_GET['fl']);
		if ( !isset($sflow[$flow_id]) )
			return false;
			
		$last_step = !isset($_COOKIE['__insta_subfl']) ? '1' : $_COOKIE['__insta_subfl'];
		$next_url = sflow_get_next_url($flow_id, $last_step, false);
		
		wp_redirect($next_url);
		exit;
	}
}

add_action('insta_upsells_cart', 'sflow_add_cart', 10, 3);
function sflow_add_cart( $flow_id, $product_id, $paysys ) {
	if ( !isset($_COOKIE['__insta_subfl']) )
		return false;
	
	global $wpdb; 
	
	$stms = get_option('stms_settings');
	$sflow = get_option('stms_sales_flow');
	if ( !isset($sflow[$flow_id]) )
		return false;
	
	$flow = $sflow[$flow_id];
	if ( $paysys != stms_isset($flow['paysys']) )
		return false;
	
	if ( !(is_stmsmember_logged_in()) || !($product = stms_get_product($product_id)) )
		return false;
	
	$member_id = stms_get_current_member_id();
	// let's find out if there's any affiliate...
	$aff_id = 0;
	if ( isset($_COOKIE['__insta_aff_id']) ) {
		$aff_id = (int) $_COOKIE['__insta_aff_id']; // there's aff cookie
		if ( $aff_id != $member_id )
			stms_update_member_meta($member_id, 'aff_id', $aff_id); // let's store the cookie into database...
	} else {
		// there's no cookie, but let's check if there's any aff_id value on the db...
		$aff_meta = stms_get_member_meta($member_id, 'aff_id');
		if ( !empty($aff_meta) )
			$aff_id = $aff_meta;
	}
	
	if ( $aff_id == $member_id )
		$aff_id = 0;
	
	$cart = $wpdb->get_row("SELECT `ID`, `tx_id` FROM `{$wpdb->prefix}stms_carts` WHERE `member_id` = {$member_id} AND `product_id` = {$product->ID} AND `flow_id` = '{$flow_id}'");
	if ( !$cart ) {
		// create tx...
		$args = array(
			'product_id' => $product->ID,
			'member_id' => $member_id,
			'aff_id' => $aff_id,
			'payment_type' => $product->type,
			'paysys' => $paysys,
			'currency' => stms_isset($stms['global']['currency'], 'USD'),
			'amount' => ( $product->type == 'recurr' && $product->is_trial == 1  ) ? $product->t_price : $product->price,
			'paid' => 0,
			'status' => 'temp',
			'date' => stms_time()
		);
		
		$tx_id = stms_add_pending_payment($args);
		$cart_id = sflow_addtocart($flow_id, $tx_id, $product->ID, $member_id);
	} else {
		$tx_id = $cart->tx_id;
		$cart_id = $cart->ID;
	}
	
	$last_step = $_COOKIE['__insta_subfl'];
	$next_url = sflow_get_next_url($flow_id, $last_step);
	wp_redirect($next_url);
	exit;
}

function sflow_addtocart( $flow_id, $tx_id, $product_id, $member_id ) {
	global $wpdb;
	
	if ( !$product = stms_get_product($product_id) )
		return false;
	
	$data = array(
		'tx_id' => $tx_id,
		'product_id' => $product_id,
		'flow_id' => $flow_id,
		'member_id' => $member_id
	);
	$wpdb->insert("{$wpdb->prefix}stms_carts", $data);
	return $wpdb->insert_id;
}

function sflow_get_cart_items( $flow_id, $member_id = 0 ) {
	global $wpdb;
	
	if ( !$member_id )
		$member_id = stms_get_current_member_id();
	
	$items = $wpdb->get_results($wpdb->prepare("SELECT * FROM `{$wpdb->prefix}stms_carts` WHERE `flow_id` = %s AND `member_id` = %d", $flow_id, $member_id));
	if ( !$items )
		return false;
	
	return $items;
}

function sflow_update_member_cart( $tx_id, $member_id ) {
	global $wpdb;
	
	if ( empty($member_id) )
		return false;
	
	$wpdb->update("{$wpdb->prefix}stms_carts", array('member_id' => $member_id), array('tx_id' => $tx_id) );
}

function sflow_get_next_url( $flow_id, $last_step, $accept = true ) {
	$sflow = get_option('stms_sales_flow');
	if ( !isset($sflow[$flow_id]) )
		return false;
	
	$flow = $sflow[$flow_id];
	$checkout_url = stms_format_url(get_bloginfo('url'), 'insta_mode=checkout&flow_id=' . $flow_id);
	$next_url = $checkout_url;
	if ( $last_step == 'front' ) {
		// redirect to first upsell...
		$upsell = stms_isset($flow['flow']['upsells'][1]);
		if ( empty($upsell['product']) )
			return $checkout_url;
		
		$next_url = stms_isset($upsell['url']);
		if ( $next_url == '' || $next_url == 'http://' ) {
			if ( !$product = stms_get_product($upsell['product']) )
				return $checkout_url;
			
			$next_url = stms_sanitize($product->info['salesuri']);
		}
		@setcookie('__insta_subfl', "1", 0, SITECOOKIEPATH);
	} else {
		$upsells = $flow['flow']['upsells'];
		$downsells = $flow['flow']['downsells'];
		if ( $last_step == '1' ) {
			$next_step = '2';
			if ( $accept ) {
				$product_id = stms_isset($upsells[2]['product'], 0);
				$next_url = stms_isset($upsells[2]['url'], '');
			} else {
				$product_id = stms_isset($downsells[2]['product'], 0);
				$next_url = stms_isset($downsells[2]['url'], '');
			}
		} else if ( $last_step == '2' ) {
			if ( $accept ) {
				$next_step = '3a';
				$product_id = stms_isset($upsells['3a']['product'], 0);
				$next_url = stms_isset($upsells['3a']['url'], '');
			} else {
				$next_step = '3b';
				$product_id = stms_isset($downsells['3b']['product'], 0);
				$next_url = stms_isset($downsells['3b']['url'], '');
			}
		} else if ( $last_step == '3a' ) {
			if ( $accept ) {
				$next_step = '4a';
				$product_id = stms_isset($upsells['4a']['product'], 0);
				$next_url = stms_isset($upsells['4a']['url'], '');
			} else {
				$next_step = '4b';
				$product_id = stms_isset($downsells['4b']['product'], 0);
				$next_url = stms_isset($downsells['4b']['url'], '');
			}
		} else if ( $last_step == '3b' ) {
			if ( $accept ) {
				$next_step = '4c';
				$product_id = stms_isset($upsells['4c']['product'], 0);
				$next_url = stms_isset($upsells['4c']['url'], '');
			} else {
				$next_step = '4d';
				$product_id = stms_isset($downsells['4d']['product'], 0);
				$next_url = stms_isset($downsells['4d']['url'], '');
			}
		} else {
			return $checkout_url;
		}

		if ( !$product_id )
			return $checkout_url;
		
		if ( !$product = stms_get_product($product_id) )
			return $checkout_url;
		
		if ( $next_url == '' || $next_url == 'http://' ) {
			$next_url = stms_sanitize($product->info['salesuri']);
		}
		
		@setcookie('__insta_subfl', $next_step, 0, SITECOOKIEPATH);
	}
	
	return $next_url;
}

add_action('template_redirect', 'sflow_checkout');
function sflow_checkout() {
	if ( stms_isset($_GET['insta_mode']) == 'checkout' && isset($_GET['flow_id']) ) {
		$stms = get_option('stms_settings');
		$sflow = get_option('stms_sales_flow');
		$paysys = stms_isset($_COOKIE['__insta_flpaysys'], 'paypal');
		$flow_id = urldecode($_GET['flow_id']);
		if ( !isset($sflow[$flow_id]) )
			return false;
		
		$flow = $sflow[$flow_id];
		if ( !$items = sflow_get_cart_items($flow_id) ) {
			$product_id = stms_isset($flow['front_id'], 0);
			$product = stms_get_product($product_id);
			
			$home_url = ( !empty($product->home_id) ) ? get_permalink($product->home_id) : get_permalink($stms['global']['home']);
			$redirect_url = ( !empty($product->info['thankuri']) ) ? $product->info['thankuri'] : $home_url;
			
			@setcookie('__insta_subfl', 0, time()-86400, SITECOOKIEPATH);
			@setcookie('__insta_flpaysys', 0, time()-86400, SITECOOKIEPATH);
			@setcookie('__insta_flow', 0, time()-86400, SITECOOKIEPATH);
			
			wp_redirect($redirect_url);
			exit;
		}
		
		do_action('insta_flow_checkout_' . $paysys, $flow_id);
		exit;
	}
}

add_action('insta_flow_checkout_authorize', 'sflow_authorize_checkout');
function sflow_authorize_checkout( $flow_id ) {
	$stms = get_option('stms_settings');
	$form_url = stms_format_url($stms['global']['magic'], 'imhandler=checkout&flow_id=' . $flow_id);
	if ( !is_stmsmember_logged_in() ) {
		$form_url = stms_login_url($form_url) . '&msg=checkout_login';
	}
	
	wp_redirect($form_url);
	exit;
}

add_action('template_redirect', 'sflow_upsell_thank_you');
function sflow_upsell_thank_you() {
	if ( stms_isset($_GET['insta_mode']) == 'all_access' && isset($_GET['flow_id']) ) {
		global $wpdb;
		
		$stms = get_option('stms_settings');
		$currency = stms_isset($stms['global']['currency'], 'USD');
		$sflow = get_option('stms_sales_flow');
		$flow_id = urldecode($_GET['flow_id']);
		$flow = $sflow[$flow_id];
		
		$home_url = get_permalink($stms['global']['home']);
		if ( !($items = sflow_get_cart_items($flow_id)) || !is_stmsmember_logged_in() ) {
			wp_redirect($home_url);
			exit;
		}
		
		$tx_ids = '';
		$all_access = 0;
		foreach ( $items as $item ) {
			$tx_ids .= "&tx_ids[]={$item->tx_id}";
			$tx_id = $item->tx_id;
			if ( $p = stms_get_payment($tx_id) ) {
				$all_access = ( $p->status == 'completed' ) ? $all_access + 1 : $all_access;
			}
		}
		
		$member_id = stms_get_current_member_id();
		$business_name = ( stms_isset($stms['global']['business_name']) != '' ) ? stms_cleanup($stms['global']['business_name']) : get_option('blogname');
		$business_addr = stms_cleanup($stms['global']['business_addr']);
		$support = stms_get_handler_url('support');
		
		$front_id = intval($flow['front_id']);
		$front = $wpdb->get_row("SELECT * FROM `{$wpdb->prefix}stms_transactions` WHERE `product_id` = {$front_id} AND `member_id` = {$member_id} AND `status` = 'completed' ORDER BY `tx_id` DESC LIMIT 1");
			
		$front_tx_id = stms_isset($front->tx_id);
		$give_access = false;
		$retries = get_transient('stms_thanks_retries_' . $front_tx_id);
		if ( $all_access == count($items) )
			$give_access = true;
		
		if ( $all_access > 0 && $retries > 10 )
			$give_access = true;
		
		if ( !$give_access ) {
			$thanks_url = stms_format_url($stms['global']['magic'], 'insta_mode=all_access&flow_id=' . $flow_id);
			if ( $retries >= 15 ) {
				$page_title = 'Payment Error';
				$refresh = '';
				$title = '';
				$body = '
					<p style="text-align:center;"><strong>Payment Error</strong></p>
					<p style="text-align:center;">We\'re sorry, but there\'s a problem in validating your payment. Please contact our <a href="' . $support . '">support</a> to resolve this issue.</p>
				';
				
				// Delete all temporary data...
				foreach ( $items as $item ) {
					$wpdb->delete("{$wpdb->prefix}stms_carts", array('ID' => $item->ID));
				}

				delete_transient('stms_thanks_retries_' . $front_tx_id);
				@setcookie('__insta_subfl', 0, time()-86400, SITECOOKIEPATH);
				@setcookie('__insta_flpaysys', 0, time()-86400, SITECOOKIEPATH);
				@setcookie('__insta_flow', 0, time()-86400, SITECOOKIEPATH);
			} else {
				$count = $retries + 1;
				set_transient('stms_thanks_retries_' . $front_tx_id, $count, 60*15);
				
				$page_title = 'Waiting For Payment Confirmation...';
				$refresh = '<meta http-equiv="refresh" content="5;URL=\'' . $thanks_url . '\'" />';
				$title = '';
				$body = '
					<h2 style="text-align:center;"><strong>Waiting For Payment Confirmation...</strong></h2>
					<p style="text-align:center;"><img src="' . STMS_URL . 'images/admin-loader.gif" border="0" /></p>
					<p style="text-align:center;">This page will be auto-refresh every 5 seconds until your payment confirmed.</p>
					<p style="text-align:center;"><strong>Please DO NOT close this page.</strong></p>
				';
			}
		} else {
			$member = stms_member($member_id);
			// get the front end tx...
			
			if ( !$front ) {
				wp_redirect($home_url);
				exit;
			}
			
			$acc_type = ( $member->status == 4 ) ? 'temp' : 'real';
			$front_p = stms_get_product($front_id);
			$front_access = '';
	
			$register = false;
			if ( $acc_type == 'temp' && stms_isset($front_p->info['steps']) == '2,1' ) {
				$register = true;
				if ( stms_isset($p->info['auto_register']) == 1 ) {
					$register = false;
				}
			}
	
			if ( $register ) {
				$tx_ids .= "&tx_ids[]={$front_p->ID}";
				$session = base64_encode("{$front_p->ID}|{$front->paysys}|direct");
				$insta_token = stms_generate_secret(16, true, true);
				$token_data = array('token' => $insta_token, 'tx_id' => $front->tx_id);
				set_transient('insta_token_' . $insta_token, $token_data, 21600); // lasted for six hours
				
				if ( is_stmsmember_logged_in() ) stms_clear_auth_cookie();
				
				$_reg_url = stms_get_handler_url('registration');
				$reg_url = stms_format_url($_reg_url, 'key=' . $session . '&insta_token=' . $insta_token . '&flow_id=' . $flow_id) . $tx_ids;
				@header('Location:' . $reg_url);
				exit;
			}
		
			$page_title = 'Thank You For Your Purchase';
			$refresh = '';
				
			$title = '';
			$title .= '<H1>Thank You For Your Purchase</h1>';
			$title .= '<div class="insta-update-msg"><p><strong><span style="color:#cc0000">IMPORTANT!</span> Do NOT click the back button or refresh this page.</strong></p></div>';
			
			$body = '';
			$body .= '<table class="insta-cart-table">';
			$body .= '<thead>';
			$body .= '<tr><th style="width:250px">Product Title</th><th style="text-align:right">Payment</th><th>Receipt/Order #</th><th></th></tr>';
			$body .= '<tbody>';
			
			$f_home_url = ( !empty($front_p->home_id) ) ? get_permalink($front_p->home_id) : get_permalink($stms['global']['home']);
			$f_access_url = ( !empty($front_p->info['thankuri']) ) ? $front_p->info['thankuri'] : $f_home_url;
			$body .= "<tr><td><strong>" . stms_cleanup($front_p->title) . "</strong></td><td style='text-align:right'>" . number_format($front->amount, 2) . " {$currency}</td><td style='text-align:center'>{$front->receipt}</td><td style='text-align:center'><a href='{$f_access_url}' class='access-btn' target='_blank'>Get Access</a></td></tr>";
			foreach ( $items as $item ) {
				$tx_id = $item->tx_id;
				if ( $p = stms_get_payment($tx_id) ) {
					if ( $p->status == 'completed' ) {
						$product = stms_get_product($p->product_id);
						$home_url = ( !empty($product->home_id) ) ? get_permalink($product->home_id) : get_permalink($stms['global']['home']);
						$access_url = ( !empty($product->info['thankuri']) ) ? $product->info['thankuri'] : $home_url;
						
						$body .= "<tr><td><strong>" . stms_cleanup($product->title) . "</strong></td><td style='text-align:right'>" . number_format($p->amount, 2) . " {$currency}</td><td style='text-align:center'>{$p->receipt}</td><td style='text-align:center'><a href='{$access_url}' class='access-btn' target='_blank'>Get Access</a></td></tr>";
					
						$wpdb->delete("{$wpdb->prefix}stms_carts", array('ID' => $item->ID));
					}
				}
			}
			$body .= '</tbody>';
			$body .= '</table>';
			$body .= '<p style="margin-top:40px;color:#a7a7a7"><strong>' . $business_name . '</strong><br />' . $business_addr . '<br /><a href="' . $support . '" target="_blank">Support</a></p>';
			
			delete_transient('stms_thanks_retries_' . $front_tx_id);
			@setcookie('__insta_subfl', 0, time()-86400, SITECOOKIEPATH);
			@setcookie('__insta_flpaysys', 0, time()-86400, SITECOOKIEPATH);
			@setcookie('__insta_flow', 0, time()-86400, SITECOOKIEPATH);
		}
?>
<!DOCTYPE html>
<!--[if IE 6]>
<html id="ie6" <?php language_attributes(); ?>>
<![endif]-->
<!--[if IE 7]>
<html id="ie7" <?php language_attributes(); ?>>
<![endif]-->
<!--[if IE 8]>
<html id="ie8" <?php language_attributes(); ?>>
<![endif]-->
<!--[if !(IE 6) | !(IE 7) | !(IE 8)  ]><!-->
<html <?php language_attributes(); ?>>
<!--<![endif]-->
<head>
<meta charset="<?php bloginfo( 'charset' ); ?>" />
<title><?php echo $page_title; ?></title>
<?php echo $refresh; ?>
<!--[if lt IE 9]>
	<script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
<![endif]-->
<link rel="profile" href="http://gmpg.org/xfn/11" />
<meta name="HandheldFriendly" content="True" />
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<!-- Adding "maximum-scale=1" fixes the Mobile Safari auto-zoom bug: http://filamentgroup.com/examples/iosScaleBug/ -->
<link rel="stylesheet" href="http://fonts.googleapis.com/css?family=Droid+Sans" type="text/css" media="all" />
<style type="text/css">
body {
	margin:0;
	padding:0;
	font-size:13px;
	font-family:'Droid Sans', sans-serif;
	background-color:#F5F5F5;
	color:#808080;
}

p {
	line-height:21px;
	margin:0;
	padding:0 0 16px;
}

#title {
	margin:0 auto;
	padding:15px 0;
	width:700px;
	max-width:100%;
}

#content {
	margin:0 auto;
	padding:15px 20px;
	width:660px;
	background-color:#FFF;
	max-width:98%;
}

.insta-update-msg {
	margin: 5px 0;
    padding: 0 0.6em;
	border-radius: 3px 3px 3px 3px;
    background-color: #FFFFE0;
    border:1px solid #E6DB55;
}

.insta-update-msg p {
	margin: 0.5em 0;
    padding: 2px;
}

table.insta-cart-table {
	border-collapse: collapse;
    clear: both;
    margin-bottom: 16px;
    margin-top: 0.5em;
    width: 100%;
    border: none;
}

table.insta-cart-table thead th {
    line-height: 17px;
    padding:7px;
    border: 1px solid #FFF;
    vertical-align: top;
    background: #808080;
    color:#FFF;
    font-size: 12px;
    font-weight:bold;
    text-transform: uppercase;
    text-shadow: none;
}

table.insta-cart-table tbody tr {
	background:#F5F5F5;
}

table.insta-cart-table tbody tr:nth-child(2n+1) {
	background:#FFF;
}

table.insta-cart-table tbody th,
table.insta-cart-table tbody td {
    padding: 8px;
    vertical-align: top;
    border: none;
}

table.insta-cart-table tbody th {
	font-size:13px;
	line-height:18px;
	text-transform: none;
	text-shadow:none;
}

table.insta-cart-table tbody th span {
	text-transform: none;
	font-size:14px;
	font-weight:normal;
	text-shadow:none;
}

.access-btn {
	-moz-box-shadow:inset 0px 1px 0px 0px #c1ed9c;
	-webkit-box-shadow:inset 0px 1px 0px 0px #c1ed9c;
	box-shadow:inset 0px 1px 0px 0px #c1ed9c;
	background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #9dce2c), color-stop(1, #8cb82b) );
	background:-moz-linear-gradient( center top, #9dce2c 5%, #8cb82b 100% );
	filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#9dce2c', endColorstr='#8cb82b');
	background-color:#9dce2c;
	-moz-border-radius:6px;
	-webkit-border-radius:6px;
	border-radius:6px;
	border:1px solid #83c41a;
	display:inline-block;
	color:#ffffff;
	font-size:13px;
	font-weight:bold;
	padding:6px 24px;
	text-decoration:none;
	text-shadow:1px 1px 0px #689324;
}
.access-btn:hover {
	background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #8cb82b), color-stop(1, #9dce2c) );
	background:-moz-linear-gradient( center top, #8cb82b 5%, #9dce2c 100% );
	filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#8cb82b', endColorstr='#9dce2c');
	background-color:#8cb82b;
}
.access-btn:active {
	position:relative;
	top:1px;
}

</style>
</head>
<body>
<div id="title">
	<?php echo $title; ?>
</div>
<div id="content">
	<?php echo $body; ?>
</div>
</body>
</html>
<?php
		exit;
	}
}