<?php
$mode_title = ( $mode == 'edit' ) ? 'Edit Upsells' : 'Add Upsells';
$button_label = ( $mode == 'edit' ) ? 'Update' : 'Create';
$unique_id = sflow_unique_id();
$flow_id = ( isset($_GET['object_ID']) ) ? $_GET['object_ID'] : $unique_id;
$sflow = get_option('stms_sales_flow');
$flow = ( isset($sflow[$flow_id]) ) ? $sflow[$flow_id] : array();
$upsells = stms_isset($flow['flow']['upsells']);
$downsells = stms_isset($flow['flow']['downsells']);
$recurring = stms_isset($flow['recurring'], 0);

$direct_pays = stms_get_direct_payments();
?>
<div id="stms-salesflow-editor" class="stms-admin-block">
	<h2 class="stms-field-title"><?php echo $mode_title; ?></h2>
	<form name="stms_add_flow" id="stms_add_flow" method="post">
		<input type="hidden" name="action" value="stms_salesflow_save" />
		<input type="hidden" name="recurring" id="recurring" value="<?php echo $recurring; ?>" />
		<input type="hidden" name="flow_id" value="<?php echo $flow_id; ?>" />
		
		<table class="form-table">
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_flow_name"><strong><span style="color:#cc0000">*</span> <?php _e('Sales Flow Name', 'stms'); ?></strong></label></th>
				<td><input class="stms-field widefat" type="text" name="stms_flow_name" id="stms_flow_name" value="<?php echo stms_cleanup($flow['name'], ''); ?>" /></td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_flow_front"><strong><span style="color:#cc0000">*</span><?php _e('Front-End Product', 'stms'); ?></strong></label></th>
				<td>
					<select name="stms_flow_front" id="stms_flow_front" class="stms-field-member stms-field widefat">
						<option value=''>[ -- Select Product -- ]</option>
						<?php
						if ( $products ) {
							foreach ( $products as $product ) {
								$selected = ( stms_isset($flow['front_id']) == $product->ID ) ? ' selected="selected"' : '';
								echo "<option value='{$product->ID}'{$selected}>$product->title</option>";
							}
						}
						?>
					</select>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_flow_payment"><strong><span style="color:#cc0000">*</span><?php _e('Payment System', 'stms'); ?></strong></label></th>
				<td>
					<select name="stms_flow_payment" id="stms_flow_payment" class="stms-field-member stms-field widefat">
						<option value=''>[ -- Select Payment -- ]</option>
						<?php
						if ( $direct_pays ) {
							foreach ( $direct_pays as $k => $v ) {
								$selected = ( stms_isset($flow['paysys']) == $k ) ? ' selected="selected"' : '';
								echo "<option value='{$k}'{$selected}>{$v}</option>";
							}
						}
						?>
					</select>
				</td>
			</tr>
		</table>
		
		<?php if ( $mode == 'edit' ) : ?>
		<h3 style="margin-top:35px;">Your Upsells Funnel <span>(simply click on each box to add/edit product)</span></h3>
		<div id="stms-salesflow-map" class="stms-admin-block">
			<table id="flowMap">
				<tr><th>1st Level Upsell</th><th>2nd Level Upsell(s)</th><th>3rd Level Upsell(s)</th><th>4th Level Upsell(s)</th></tr>
				<tr>
					<td class="firstCol">
						<?php $txt = stms_get_productname(stms_isset($upsells[1]['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
						<div id="first-upsell"><a href="#" class="first-upsell flow-set<?php echo $active;?>" data-flow="upsell_1" title="Upsell #1 Settings">U-1<span class="upsell_1_pr"> : <?php echo $label; ?></span></a></div>
					</td>
					<td class="secondCol">
						<ul>
							<?php $txt = stms_get_productname(stms_isset($upsells['2']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="upsell-line"><div id="upsell_2"><a href="#" class="upsell flow-set<?php echo $active;?>" data-flow="upsell_2" data-parent="upsell_1" data-child1="upsell_3a" data-child2="downsell_3a" data-pair="downsell_3a" title="Upsell #2 Settings">U-2<span class="upsell_2_pr"> : <?php echo $label; ?></span></a></div></li>
							<?php $txt = stms_get_productname(stms_isset($downsells['2']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="downsell-line"><div id="downsell_2"><a href="#" class="downsell flow-set<?php echo $active;?>" data-flow="downsell_2" data-parent="upsell_1" data-pair="upsell_2" data-child1="upsell_3b" data-child2="downsell_3b" title="Downsell #2 Settings">D-2<span class="downsell_2_pr"> : <?php echo $label; ?></span></a></div></li>
						</ul>
					</td>
					<td class="thirdCol">
						<ul>
							<?php $txt = stms_get_productname(stms_isset($upsells['3a']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="upsell-line"><div id="upsell_3a"><a href="#" class="upsell flow-set<?php echo $active;?>" data-flow="upsell_3a" data-parent="upsell_2" data-pair="downsell_3a" data-grand="upsell_1" data-child1="upsell_4a" data-child2="downsell_4a" title="Upsell #3A Settings">U-3A<span class="upsell_3a_pr"> : <?php echo $label; ?></span></a></div></li>
							<?php $txt = stms_get_productname(stms_isset($downsells['3a']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="downsell-line"><div id="downsell_3a"><a href="#" class="downsell flow-set<?php echo $active;?>" data-flow="downsell_3a" data-parent="upsell_2" data-pair="upsell_3a" data-grand="upsell_1" data-child1="upsell_4b" data-child2="downsell_4b" title="Downsell #3A Settings">D-3A<span class="downsell_3a_pr"> : <?php echo $label; ?></span></a></div></li>
							<?php $txt = stms_get_productname(stms_isset($upsells['3b']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="upsell-line"><div id="upsell_3b"><a href="#" class="upsell flow-set<?php echo $active;?>" data-flow="upsell_3b" data-parent="downsell_2" data-pair="downsell_3b" data-child1="upsell_4c" data-child2="downsell_4c" title="Upsell #3B Settings">U-3B<span class="upsell_3b_pr"> : <?php echo $label; ?></span></a></div></li>
							<?php $txt = stms_get_productname(stms_isset($downsells['3b']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="downsell-line"><div id="downsell_3b"><a href="#" class="downsell flow-set<?php echo $active;?>" data-flow="downsell_3b" data-parent="downsell_2" data-pair="upsell_3b" data-child1="upsell_4d" data-child2="downsell_4d" title="Downsell #3B Settings">D-3B<span class="downsell_3b_pr"> : <?php echo $label; ?></span></a></div></li>
						</ul>
					</td>
					<td class="last fourthCol">
						<ul>
							<?php $txt = stms_get_productname(stms_isset($upsells['4a']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="upsell-line"><div id="upsell_4a"><a href="#" class="upsell flow-set<?php echo $active;?>" data-flow="upsell_4a" data-parent="upsell_3a" data-pair="downsell_4a" data-grand="upsell_2" data-root="upsell_1" title="Upsell #4A Settings">U-4A<span class="upsell_4a_pr"> : <?php echo $label; ?></span></a></div></li>
							<?php $txt = stms_get_productname(stms_isset($downsells['4a']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="downsell-line"><div id="downsell_4a"><a href="#" class="downsell flow-set<?php echo $active;?>" data-flow="downsell_4a" data-parent="upsell_3a" data-pair="upsell_4a" data-grand="upsell_2" data-root="upsell_1" title="Downsell #4A Settings">D-4A<span class="downsell_4a_pr"> : <?php echo $label; ?></span></a></div></li>
							<?php $txt = stms_get_productname(stms_isset($upsells['4b']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="upsell-line"><div id="upsell_4b"><a href="#" class="upsell flow-set<?php echo $active;?>" data-flow="upsell_4b" data-parent="downsell_3a" data-pair="downsell_4b" data-root="upsell_1" title="Upsell #4B Settings">U-4B<span class="upsell_4b_pr"> : <?php echo $label; ?></span></a></div></li>
							<?php $txt = stms_get_productname(stms_isset($downsells['4b']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="downsell-line"><div id="downsell_4b"><a href="#" class="downsell flow-set<?php echo $active;?>" data-flow="downsell_4b" data-parent="downsell_3a" data-pair="upsell_4b" data-root="upsell_1" title="Downsell #4B Settings">D-4B<span class="downsell_4b_pr"> : <?php echo $label; ?></span></a></div></li>
							<?php $txt = stms_get_productname(stms_isset($upsells['4c']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="upsell-line"><div id="upsell_4c"><a href="#" class="upsell flow-set<?php echo $active;?>" data-flow="upsell_4c" data-parent="upsell_3b" data-pair="downsell_4c" data-grand="downsell_2" title="Upsell #4C Settings">U-4C<span class="upsell_4c_pr"> : <?php echo $label; ?></span></a></div></li>
							<?php $txt = stms_get_productname(stms_isset($downsells['4c']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="downsell-line"><div id="downsell_4c"><a href="#" class="downsell flow-set<?php echo $active;?>" data-flow="downsell_4c" data-parent="upsell_3b" data-pair="upsell_4c" data-grand="downsell_2" title="Downsell #4C Settings">D-4C<span class="downsell_4c_pr"> : <?php echo $label; ?></span></a></div></li>
							<?php $txt = stms_get_productname(stms_isset($upsells['4d']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="upsell-line"><div id="upsell_4d"><a href="#" class="upsell flow-set<?php echo $active;?>" data-flow="upsell_4d" data-parent="downsell_3b" data-pair="downsell_4d" title="Upsell #4D Settings">U-4D<span class="upsell_4d_pr"> : <?php echo $label; ?></span></a></div></li>
							<?php $txt = stms_get_productname(stms_isset($downsells['4d']['product'])); $active = ( !empty($txt) ) ? ' active' : ''; $label = ( $txt == '' ) ? 'none' : (( strlen($txt) > 14 ) ? substr_replace($txt, '..', 12) : $txt ); ?>
							<li class="downsell-line"><div id="downsell_4d"><a href="#" class="downsell flow-set<?php echo $active;?>" data-flow="downsell_4d" data-parent="downsell_3b" data-pair="upsell_4d" title="Downsell #4D Settings">D-4D<span class="downsell_4d_pr"> : <?php echo $label; ?></span></a></div></li>
						</ul>
					</td>
				</tr>
			</table>
			<div style="clear:left"></div>
			<p class="stms-desc"><strong>Important:</strong> If you choose "PayPal" or "Payza," then your upsell funnel can ONLY have one subscription product. Also, you can ONLY add your subscription product to the "1st Level Upsell." This limitation is because both PayPal and Payza CANNOT process payments for multiple subscription products at once.</p>
		</div>
		
		<input type="hidden" id="upsell_1_p" name="stms_flow[upsells][1][product]" value="<?php echo stms_isset($upsells[1]['product']); ?>" />
		<input type="hidden" id="upsell_1_u" name="stms_flow[upsells][1][url]" value="<?php echo stms_isset($upsells[1]['url']); ?>" />
		<input type="hidden" id="upsell_1_t" name="stms_flow[upsells][1][type]" value="<?php echo stms_isset($upsells[1]['type'], 'onetime'); ?>" />
		
		<input type="hidden" id="upsell_2_p" name="stms_flow[upsells][2][product]" value="<?php echo stms_isset($upsells[2]['product']); ?>" />
		<input type="hidden" id="upsell_3a_p" name="stms_flow[upsells][3a][product]" value="<?php echo stms_isset($upsells['3a']['product']); ?>" />
		<input type="hidden" id="upsell_3b_p" name="stms_flow[upsells][3b][product]" value="<?php echo stms_isset($upsells['3b']['product']); ?>" />
		<input type="hidden" id="upsell_4a_p" name="stms_flow[upsells][4a][product]" value="<?php echo stms_isset($upsells['4a']['product']); ?>" />
		<input type="hidden" id="upsell_4b_p" name="stms_flow[upsells][4b][product]" value="<?php echo stms_isset($upsells['4b']['product']); ?>" />
		<input type="hidden" id="upsell_4c_p" name="stms_flow[upsells][4c][product]" value="<?php echo stms_isset($upsells['4c']['product']); ?>" />
		<input type="hidden" id="upsell_4d_p" name="stms_flow[upsells][4d][product]" value="<?php echo stms_isset($upsells['4d']['product']); ?>" />
		
		<input type="hidden" id="downsell_2_p" name="stms_flow[downsells][2][product]" value="<?php echo stms_isset($downsells[2]['product']); ?>" />
		<input type="hidden" id="downsell_3a_p" name="stms_flow[downsells][3a][product]" value="<?php echo stms_isset($downsells['3a']['product']); ?>" />
		<input type="hidden" id="downsell_3b_p" name="stms_flow[downsells][3b][product]" value="<?php echo stms_isset($downsells['3b']['product']); ?>" />
		<input type="hidden" id="downsell_4a_p" name="stms_flow[downsells][4a][product]" value="<?php echo stms_isset($downsells['4a']['product']); ?>" />
		<input type="hidden" id="downsell_4b_p" name="stms_flow[downsells][4b][product]" value="<?php echo stms_isset($downsells['4b']['product']); ?>" />
		<input type="hidden" id="downsell_4c_p" name="stms_flow[downsells][4c][product]" value="<?php echo stms_isset($downsells['4c']['product']); ?>" />
		<input type="hidden" id="downsell_4d_p" name="stms_flow[downsells][4d][product]" value="<?php echo stms_isset($downsells['4d']['product']); ?>" />
		
		<input type="hidden" id="upsell_2_u" name="stms_flow[upsells][2][url]" value="<?php echo stms_isset($upsells[2]['url']); ?>" />
		<input type="hidden" id="upsell_3a_u" name="stms_flow[upsells][3a][url]" value="<?php echo stms_isset($upsells['3a']['url']); ?>" />
		<input type="hidden" id="upsell_3b_u" name="stms_flow[upsells][3b][url]" value="<?php echo stms_isset($upsells['3b']['url']); ?>" />
		<input type="hidden" id="upsell_4a_u" name="stms_flow[upsells][4a][url]" value="<?php echo stms_isset($upsells['4a']['url']); ?>" />
		<input type="hidden" id="upsell_4b_u" name="stms_flow[upsells][4b][url]" value="<?php echo stms_isset($upsells['4b']['url']); ?>" />
		<input type="hidden" id="upsell_4c_u" name="stms_flow[upsells][4c][url]" value="<?php echo stms_isset($upsells['4c']['url']); ?>" />
		<input type="hidden" id="upsell_4d_u" name="stms_flow[upsells][4d][url]" value="<?php echo stms_isset($upsells['4d']['url']); ?>" />
		
		<input type="hidden" id="downsell_2_u" name="stms_flow[downsells][2][url]" value="<?php echo stms_isset($downsells[2]['url']); ?>" />
		<input type="hidden" id="downsell_3a_u" name="stms_flow[downsells][3a][url]" value="<?php echo stms_isset($downsells['3a']['url']); ?>" />
		<input type="hidden" id="downsell_3b_u" name="stms_flow[downsells][3b][url]" value="<?php echo stms_isset($downsells['3b']['url']); ?>" />
		<input type="hidden" id="downsell_4a_u" name="stms_flow[downsells][4a][url]" value="<?php echo stms_isset($downsells['4a']['url']); ?>" />
		<input type="hidden" id="downsell_4b_u" name="stms_flow[downsells][4b][url]" value="<?php echo stms_isset($downsells['4b']['url']); ?>" />
		<input type="hidden" id="downsell_4c_u" name="stms_flow[downsells][4c][url]" value="<?php echo stms_isset($downsells['4c']['url']); ?>" />
		<input type="hidden" id="downsell_4d_u" name="stms_flow[downsells][4d][url]" value="<?php echo stms_isset($downsells['4d']['url']); ?>" />
		
		<input type="hidden" id="upsell_2_t" name="stms_flow[upsells][2][type]" value="<?php echo stms_isset($upsells[2]['type'], 'onetime'); ?>" />
		<input type="hidden" id="upsell_3a_t" name="stms_flow[upsells][3a][type]" value="<?php echo stms_isset($upsells['3a']['type'], 'onetime'); ?>" />
		<input type="hidden" id="upsell_3b_t" name="stms_flow[upsells][3b][type]" value="<?php echo stms_isset($upsells['3b']['type'], 'onetime'); ?>" />
		<input type="hidden" id="upsell_4a_t" name="stms_flow[upsells][4a][type]" value="<?php echo stms_isset($upsells['4a']['type'], 'onetime'); ?>" />
		<input type="hidden" id="upsell_4b_t" name="stms_flow[upsells][4b][type]" value="<?php echo stms_isset($upsells['4b']['type'], 'onetime'); ?>" />
		<input type="hidden" id="upsell_4c_t" name="stms_flow[upsells][4c][type]" value="<?php echo stms_isset($upsells['4c']['type'], 'onetime'); ?>" />
		<input type="hidden" id="upsell_4d_t" name="stms_flow[upsells][4d][type]" value="<?php echo stms_isset($upsells['4d']['type'], 'onetime'); ?>" />
		
		<input type="hidden" id="downsell_2_t" name="stms_flow[downsells][2][type]" value="<?php echo stms_isset($downsells[2]['type'], 'onetime'); ?>" />
		<input type="hidden" id="downsell_3a_t" name="stms_flow[downsells][3a][type]" value="<?php echo stms_isset($downsells['3a']['type'], 'onetime'); ?>" />
		<input type="hidden" id="downsell_3b_t" name="stms_flow[downsells][3b][type]" value="<?php echo stms_isset($downsells['3b']['type'], 'onetime'); ?>" />
		<input type="hidden" id="downsell_4a_t" name="stms_flow[downsells][4a][type]" value="<?php echo stms_isset($downsells['4a']['type'], 'onetime'); ?>" />
		<input type="hidden" id="downsell_4b_t" name="stms_flow[downsells][4b][type]" value="<?php echo stms_isset($downsells['4b']['type'], 'onetime'); ?>" />
		<input type="hidden" id="downsell_4c_t" name="stms_flow[downsells][4c][type]" value="<?php echo stms_isset($downsells['4c']['type'], 'onetime'); ?>" />
		<input type="hidden" id="downsell_4d_t" name="stms_flow[downsells][4d][type]" value="<?php echo stms_isset($downsells['4d']['type'], 'onetime'); ?>" />
		
		<div class="stms-admin-block">
			<h2 class="stms-field-title">Payment Links <span class="stms-toggle" data-open="no">+</span></h2>
			<div>
				<?php 
					$fp = stms_get_product($flow['front_id']);
					$fpaysys = ( $fp->type == 'free' ) ? 'free' : $flow['paysys'];
					$base_pay_front = stms_format_url(get_bloginfo('url'), 'insta_pay=' . $fpaysys . '&id=');
					$base_pay = stms_format_url(get_bloginfo('url'), 'insta_pay=' . $flow['paysys'] . '&id=');
				?>
				<p><strong>Front-End Payment URL:</strong><br /><input type="text" class="stms-field" value="<?php echo $base_pay_front . $flow['front_id'] . '&fl=' . $flow['sid']; ?>" style="width:450px" /></p>
				<p><strong>Upsells/Downsells Payment URLs:</strong></p>
				<table cellpadding="0" cellspacing="0" border="0" >
					<?php
					if ( !empty($upsells[1]['product']) )
						echo "<tr><td style='width:100px'>Upsell 1:</td><td> <input type='text' class='stms-field' value='{$base_pay}" . $upsells[1]['product'] . "' style='width:450px' /></td></tr>";
					
					unset($upsells[1]);
					if ( $upsells ) {
						foreach ( $upsells as $k => $v ) {
							if ( !empty($v['product']) )
								echo "<tr><td style='width:100px'>Upsell " . strtoupper($k) . ":</td><td> <input type='text' class='stms-field' value='{$base_pay}" . $v['product'] . "' style='width:450px' /></td></tr>";
							
							if ( !empty($downsells[$k]['product']) )
								echo "<tr><td style='width:100px'>Downsell " . strtoupper($k) . ":</td><td> <input type='text' class='stms-field' value='{$base_pay}" . $downsells[$k]['product'] . "' style='width:450px' /></td></tr>";
						}
					}
					?>
				</table>
				<p><strong>No Thanks URL:</strong> <br /><input type="text" class="stms-field" value="<?php echo stms_format_url(get_bloginfo('url'), 'insta_flow=no&fl=') . $flow['sid']; ?>" style="width:450px" /></p>
			</div>
		</div>
		<?php endif; ?>
		
		<p style="margin-top:30px;text-align:right">
			<input type="submit" id="stms-submit-sflow" name="stms-submit-sflow" value="<?php echo $button_label; ?>" class="button-primary" />
			<a href="#salesflow" class="button">Cancel</a>
		</p>
	</form>
</div>