<?php
add_action('admin_init', 'stms_bulk_action');
function stms_bulk_action() {
	global $wpdb;
	$result = false;
	$action = ( isset($_REQUEST['action']) && $_REQUEST['action'] != '-1' ) ? $_REQUEST['action'] : stms_isset($_REQUEST['action2']);
	switch ( $action ) {
		case 'stms_bulk_discount_delete':
			$result = true;
			if ( is_array($_GET['discount']) && count($_GET['discount']) > 0 ) {
				$discount = $_GET['discount'];
				$num = count($discount);
				for ( $i = 0; $i < $num; $i++ ) {
					$wpdb->delete("{$wpdb->prefix}stms_coupons", array('discount_id' => $discount[$i]));
					$wpdb->delete("{$wpdb->prefix}stms_discounts", array('ID' => $discount[$i]));
				}
			}
			$url = admin_url('admin.php?page=stms-settings') . '#discount';
			@header('Location:' . $url);
			break;
				
		case 'stms_bulk_product_delete':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#level");
			if ( is_array($_REQUEST['level']) && count($_REQUEST['level']) > 0 ) {
				foreach ( $_REQUEST['level'] as $product_id ) {
					stms_delete_product($product_id, false);
				}
				$url .= '|products=deleted';
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_product_clone':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#level");
			if ( is_array($_REQUEST['level']) && count($_REQUEST['level']) > 0 ) {
				foreach ( $_REQUEST['level'] as $product_id ) {
					stms_duplicate_level($product_id, false);
				}
				$url .= '|products=cloned';
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_member_lock':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#members");
			if ( is_array($_REQUEST['member']) && count($_REQUEST['member']) > 0 ) {
				foreach ( $_REQUEST['member'] as $member_id ) {
					$data = array();
					$data['is_locked'] = 'yes';
					$executed = stms_update_member($member_id, $data);
				}
				
				if ( isset($executed) )
					$url .= '|locked=true';
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_member_unlock':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#members");
			if ( is_array($_REQUEST['member']) && count($_REQUEST['member']) > 0 ) {
				foreach ( $_REQUEST['member'] as $member_id ) {
					$data = array();
					$data['is_locked'] = 'no';
					$executed = stms_update_member($member_id, $data);
				}
				
				if ( isset($executed) )
					$url .= '|unlocked=true';
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_member_setaff':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#members");
			if ( is_array($_REQUEST['member']) && count($_REQUEST['member']) > 0 ) {
				foreach ( $_REQUEST['member'] as $member_id ) {
					$data = array();
					$data['is_aff'] = 1;
					$data['is_aff_pending'] = 0;
					$executed = stms_update_member($member_id, $data);
				}
				
				if ( isset($executed) )
					$url .= '|affiliate=set';
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_member_unsetaff':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#members");
			if ( is_array($_REQUEST['member']) && count($_REQUEST['member']) > 0 ) {
				foreach ( $_REQUEST['member'] as $member_id ) {
					$data = array();
					$data['is_aff'] = 0;
					$data['is_aff_pending'] = 0;
					$executed = stms_update_member($member_id, $data);
					stms_update_member_meta($member_id, 'exclusive_aff', 0);
				}
				
				if ( isset($executed) )
					$url .= '|affiliate=unset';
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_member_setaffex':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#members");
			if ( is_array($_REQUEST['member']) && count($_REQUEST['member']) > 0 ) {
				foreach ( $_REQUEST['member'] as $member_id ) {
					$data = array();
					$data['is_aff'] = 1;
					$data['is_aff_pending'] = 0;
					$executed = stms_update_member($member_id, $data);
					stms_update_member_meta($member_id, 'exclusive_aff', 1);
				}
				
				if ( isset($executed) )
					$url .= '|exaffiliate=set';
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_member_unsetaffex':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#members");
			if ( is_array($_REQUEST['member']) && count($_REQUEST['member']) > 0 ) {
				foreach ( $_REQUEST['member'] as $member_id ) {
					$data = array();
					$data['is_aff'] = 0;
					$data['is_aff_pending'] = 0;
					$executed = stms_update_member($member_id, $data);
					stms_update_member_meta($member_id, 'exclusive_aff', 0);
				}
				
				if ( isset($executed) )
					$url .= '|exaffiliate=unset';
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_member_payment':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#members");
			if ( is_array($_REQUEST['member']) && count($_REQUEST['member']) > 0 ) {
				$url .= '|mode=bulk_payment';
				foreach ( $_REQUEST['member'] as $member_id ) {
					$url .= '&ids[]=' . $member_id;
				}
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_member_delpayment':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#members");
			if ( is_array($_REQUEST['member']) && count($_REQUEST['member']) > 0 ) {
				$url .= '|mode=bulk_payment_remove';
				foreach ( $_REQUEST['member'] as $member_id ) {
					$url .= '&ids[]=' . $member_id;
				}
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_member_delete':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#members");
			if ( is_array($_REQUEST['member']) && count($_REQUEST['member']) > 0 ) {
				foreach ( $_REQUEST['member'] as $member_id ) {
					stms_delete_member($member_id, false);
				}
				$url .= '|members=deleted';
			}
			@header('Location:' . $url);
			break;
		
		case 'stms_bulk_payment_delete':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#members|mode=payments&object_ID={$_REQUEST['bulk_member_id']}");
			if ( is_array($_REQUEST['payment']) && count($_REQUEST['payment']) > 0 ) {
				foreach ( $_REQUEST['payment'] as $tx_id ) {
					stms_delete_payment($tx_id, false);
				}
				$url .= '&payments=deleted';
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_member_approve':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#members");
			if ( is_array($_REQUEST['member']) && count($_REQUEST['member']) > 0 ) {
				$success = 0;
				foreach ( $_REQUEST['member'] as $member_id ) {
					if ( $result = stms_approve_affiliate($member_id, false) )
						$success += 1;
				}
				
				if ( $success )
					$url .= '|affiliates=approved';
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_member_deny':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#members");
			if ( is_array($_REQUEST['member']) && count($_REQUEST['member']) > 0 ) {
				$success = 0;
				foreach ( $_REQUEST['member'] as $member_id ) {
					if ( $result = stms_deny_affiliate($member_id, false) )
						$success += 1;
					
				}
				
				if ( $success )
					$url .= '|affiliates=denied';
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_process_paidcomm':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#affstats|mode=payouts");
			if ( is_array($_REQUEST['payout']) && count($_REQUEST['payout']) > 0 ) {
				foreach ( $_REQUEST['payout'] as $ids ) {
					stms_paid_affiliates($ids, false);
				}
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_license_suspend':
        case 'stms_bulk_license_deactivate':
        case 'stms_bulk_license_reactivate':
        case 'stms_bulk_license_delete':
			$result = true;
			$url = admin_url("admin.php?page={$_REQUEST['page']}#licenses|mode=manage");
			$type = str_replace('stms_bulk_license_', '', $action);
			$msg = ( $type == 'suspend' ) ? $type . 'ed' : $type . 'd';
			if ( is_array($_REQUEST['license']) && count($_REQUEST['license']) > 0 ) {
				foreach ( $_REQUEST['license'] as $id ) {
					stms_license_action($id, $type, false);
				}
				$url .= '&licenses=' . $msg;
			}
			@header('Location:' . $url);
			break;
			
		case 'stms_bulk_salesflow_delete':
			$result = true;
			$sflow = get_option('stms_sales_flow');
			$url = admin_url('admin.php?page=stms-settings') . '#salesflow|deleted=true';
			if ( is_array($_REQUEST['flow']) && count($_REQUEST['flow']) > 0 ) {
				foreach ( $_REQUEST['flow'] as $id ) {
					if ( isset($sflow[$id]) )
						unset($sflow[$id]);
				}
			}
			update_option('stms_sales_flow', $sflow);
			@header('Location:' . $url);
			break;
	}
	
	if ( $result )
		exit;
}

add_action('admin_init', 'stms_admin_saves', 5);
function stms_admin_saves() {
	if ( isset($_REQUEST['action']) ) {
		$action = $_REQUEST['action'];
		switch ( $action ) {
			case 'stms_member_payment_mass':
				stms_member_payment_mass();
				break;
			case 'stms_member_delpayment_mass':
				stms_member_delpayment_mass();
				break;
			case 'stms_paypal_mass':
				stms_generate_paypalmass();
				break;
			case 'stms_payza_mass':
				stms_generate_payzamass();
				break;
			case 'stms_memberlevel_save':
				stms_save_level();
				break;
			case 'stms_memberdata_save':
				stms_admin_save_member();
				break;
			case 'stms_memberdata_delete':
				stms_delete_member( stms_isset($_REQUEST['ID']) );
				break;
			case 'stms_memberdata_affapprove':
				stms_approve_affiliate( stms_isset($_REQUEST['ID']) );
				break;
			case 'stms_memberdata_affdeny':
				stms_deny_affiliate( stms_isset($_REQUEST['ID']) );
				break;
			case 'stms_export_members':
				stms_export_members();
				break;
			case 'stms_import_members':
				stms_import_members();
				break;
			case 'stms_undo_import':
				stms_undo_import();
				break;
			case 'stms_productdata_delete':
				stms_delete_product( stms_isset($_REQUEST['ID']) );
				break;
			case 'stms_paymentdata_delete':
				stms_delete_payment( stms_isset($_REQUEST['ID']) );
				break;
			case 'stms_arlist_reload':
			case 'stms_afflist_reload':
				stms_reload_lists($_REQUEST['ar'], stms_isset($_REQUEST['object_id'], 0) );
				break;
			case 'stms_license_reactivate':
			case 'stms_license_suspend':
			case 'stms_license_deactivate':
			case 'stms_license_delete':
				$type = str_replace('stms_license_', '', $action);
				stms_license_action( stms_isset($_REQUEST['ID']), $type );
				break;
			case 'stms_process_paidcomm':
				stms_paid_affiliates( stms_isset($_REQUEST['ID']) );
				break;
			case 'stms_broadcast_emails':
				stms_broadcast_emails();
				break;
			case 'stms_login_as':
				stms_login_as( stms_isset($_REQUEST['ID']) );
				break;
			case 'stms_generate_reglink':
				stms_generate_reglink();
			case 'stms_reglink_delete':
				stms_delete_reglink($_REQUEST['key']);
				break;
			case 'stms_importmembers_towp':
				stms_importmembers_towp();
				break;
			case 'stms_change_handlerslug':
				stms_change_handlerslug();
			case 'stms_productdata_clone':
				stms_duplicate_level( stms_isset($_REQUEST['ID']) );
				break;
			default:
				// do nothing
				return;
		}
	}	
}

function stms_change_handlerslug() {
	if ( !wp_verify_nonce($_POST['_instanonce'], 'stms-admin-nonce') ) wp_die('Invalid Handler');
	$post_id = intval($_POST['slug_id']);
	$post_name = trim($_POST['slug_name']);
	$old_slug = trim($_POST['old_slug']);
	$redirect_url = admin_url('admin.php?page=stms-settings') . '#urls';
	
	$the_post = get_post($post_id);
	
	if ( $the_post && !empty($post_name) && preg_match('/^[a-zA-Z0-9_-]+$/', $post_name) && ($post_name != $old_slug) ) {
		$post = array(
  			'ID' => $post_id,
  			'post_title' => stms_sanitize($the_post->post_title),
  			'post_content' => stms_sanitize($the_post->post_content),
  			'post_name' => $post_name,
  			'post_type' => 'page',
  			'post_status' => 'publish'
  		);
		$result = wp_insert_post($post, true);
		if ( !is_wp_error($result) )
			$redirect_url .= '|handler_slug=changed';
	}
	@header('Location:' . $redirect_url);
	exit;
}

function stms_get_unsync_members() {
	global $wpdb;
	$unsync = get_transient('stms_unsync_count');
	if ( $unsync > 0 )
		return $unsync;
		
	$count = 0;
	if ( $members = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}stms_members` WHERE `status` = 1 AND `wpuser_id` = 0 ORDER BY `ID` DESC") ) {
		foreach ( $members as $member ) {
			if ( !username_exists($member->username) )
				$count++;
		}
	}
	
	if ( $users = get_users('orderby=nicename&role=subscriber') ) {
		foreach ( $users as $user ) {
			if ( !stms_username_exists($user->user_login) )
				$count++;
		}
	}
	if ( $count > 0 ) set_transient('stms_unsync_count', $count);
	return $count;
}

function stms_importmembers_towp() {
	@ignore_user_abort(true);
	@set_time_limit(0);
	if ( !wp_verify_nonce($_GET['_instanonce'], 'stms-admin-nonce') ) wp_die('Invalid Handler');
	
	global $wpdb;
	
	$e = 0;
	// Import members to WP Users...
	$stms = get_option('stms_settings');
	$sql = "SELECT * FROM `{$wpdb->prefix}stms_members` WHERE `status` = 1 AND `wpuser_id` = 0 ORDER BY `ID` DESC";
	if ( $members = $wpdb->get_results($sql) ) {
		foreach ( $members as $member ) :
			if ( !username_exists($member->username) ) :
				if ( $wpuser_id = email_exists($member->email) ) { // simply update the wpuser_id in IM
					if ( !user_can($wpuser_id, 'manage_options') ) {
						$data = array('wpuser_id' => $wpuser_id);
						$member_id = stms_update_member($member->ID, $data);
						$e++;
					}
				} else {
					$meta = stms_get_member_meta($member->ID, 'info');
					if ( !empty($meta['user_key']) ) {
						$password = stms_string_dec($meta['user_key'], AUTH_SALT);
						if ( $wpuser_id = wp_create_user($member->username, $password, $member->email) ) {
							$args = array(
									'ID' => $wpuser_id,
									'first_name' => stms_sanitize($member->first_name),
									'last_name' => stms_sanitize($member->last_name),
								);
								
							if ( !user_can($wpuser_id, 'manage_options') ) {
								$args['show_admin_bar_front'] = 'false';
								$args['role'] = 'subscriber';
								$args['user_registered'] = date("Y-m-d H:i:s", $member->date);
							}
							
							wp_update_user($args);
							
							$data = array('wpuser_id' => $wpuser_id);
							$member_id = stms_update_member($member->ID, $data);
						}
						$e++;
					} else {
						if ( $wpuser_id = stms_wpcreate_user($member->username, $member->pass, $member->email) ) {
							wp_update_user(
								array(
									'ID' => $wpuser_id,
									'first_name' => stms_sanitize($member->first_name),
									'last_name' => stms_sanitize($member->last_name),
									'show_admin_bar_front' => 'false',
									'role' => 'subscriber',
									'user_registered' => date("Y-m-d H:i:s", $member->date)
								)
							);
							$data = array('wpuser_id' => $wpuser_id);
							$member_id = stms_update_member($member->ID, $data);
							$e++;
						}
					}
				}
			endif;
		endforeach;
	}

	$i = 0;
	if ( $users = get_users('orderby=nicename') ) {
		foreach ( $users as $user ) {
			if ( !stms_username_exists($user->user_login) || !stms_email_exists($user->user_email) ) {
				$userdata = array();
				$userdata['username'] = stms_sanitize($user->user_login);
				$userdata['email'] = sanitize_email($user->user_email);
				$userdata['pass'] = trim($user->user_pass);
				$userdata['first_name'] = stms_sanitize($user->first_name);
				$userdata['last_name'] = stms_sanitize($user->last_name);
				$userdata['status'] = 1;
				$userdata['is_locked'] = 'no';
				$userdata['is_aff'] = ( stms_isset($stms['global']['manual_aff'], 0) == 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
				$userdata['is_aff_pending'] = ( stms_isset($stms['global']['manual_aff'], 0) != 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
				$userdata['wpuser_id'] = $user->ID;
				$userdata['registered'] = date("Y-m-d H:i:s", stms_time());
				$userdata['date'] = stms_time();
		
				$wpdb->insert("{$wpdb->prefix}stms_members", $userdata);
				$i++;
			}
		}
	}
	
	delete_transient('stms_unsync_count');
	@header('Location:' . admin_url('admin.php?page=stms-settings') . '#config|wpimported=' . $i . '&wpexported=' . $e);
	exit;
}

function stms_wpcreate_user( $username, $password, $email = '' ) {
	$user_login = esc_sql($username);
	$user_email = esc_sql($email);
	$user_pass = $password;

	$userdata = compact('user_login', 'user_email', 'user_pass');
	return stms_wpinsert_user($userdata);
}

function stms_wpinsert_user( $userdata ) {
	global $wpdb;

	extract( $userdata, EXTR_SKIP );

	if ( !empty($ID) )
		return false;
	
	$user_login = sanitize_user($user_login, true);
	$user_login = apply_filters('pre_user_login', $user_login);

	//Remove any non-printable chars from the login string to see if we have ended up with an empty username
	$user_login = trim($user_login);

	if ( empty($user_login) )
		return false;

	if ( !$update && username_exists( $user_login ) )
		return false;

	if ( empty($user_nicename) )
		$user_nicename = sanitize_title( $user_login );
	$user_nicename = apply_filters('pre_user_nicename', $user_nicename);

	if ( empty($user_url) )
		$user_url = '';
	$user_url = apply_filters('pre_user_url', $user_url);

	if ( empty($user_email) )
		$user_email = '';
	$user_email = apply_filters('pre_user_email', $user_email);

	if ( email_exists($user_email) )
		return false;

	if ( empty($nickname) )
		$nickname = $user_login;
	$nickname = apply_filters('pre_user_nickname', $nickname);

	if ( empty($first_name) )
		$first_name = '';
	$first_name = apply_filters('pre_user_first_name', $first_name);

	if ( empty($last_name) )
		$last_name = '';
	$last_name = apply_filters('pre_user_last_name', $last_name);

	if ( empty( $display_name ) ) {
		if ( $first_name && $last_name ) /* translators: 1: first name, 2: last name */
			$display_name = sprintf( _x( '%1$s %2$s', 'Display name based on first name and last name' ), $first_name, $last_name );
		elseif ( $first_name )
			$display_name = $first_name;
		elseif ( $last_name )
			$display_name = $last_name;
		else
			$display_name = $user_login;
	}
	$display_name = apply_filters( 'pre_user_display_name', $display_name );

	if ( empty($description) )
		$description = '';
	$description = apply_filters('pre_user_description', $description);

	if ( empty($rich_editing) )
		$rich_editing = 'true';

	if ( empty($comment_shortcuts) )
		$comment_shortcuts = 'false';

	if ( empty($admin_color) )
		$admin_color = 'fresh';
	$admin_color = preg_replace('|[^a-z0-9 _.\-@]|i', '', $admin_color);

	if ( empty($use_ssl) )
		$use_ssl = 0;

	if ( empty($user_registered) )
		$user_registered = gmdate('Y-m-d H:i:s');

	if ( empty($show_admin_bar_front) )
		$show_admin_bar_front = 'false';

	$user_nicename_check = $wpdb->get_var( $wpdb->prepare("SELECT ID FROM $wpdb->users WHERE user_nicename = %s AND user_login != %s LIMIT 1" , $user_nicename, $user_login));

	if ( $user_nicename_check ) {
		$suffix = 2;
		while ($user_nicename_check) {
			$alt_user_nicename = $user_nicename . "-$suffix";
			$user_nicename_check = $wpdb->get_var( $wpdb->prepare("SELECT ID FROM $wpdb->users WHERE user_nicename = %s AND user_login != %s LIMIT 1" , $alt_user_nicename, $user_login));
			$suffix++;
		}
		$user_nicename = $alt_user_nicename;
	}

	$data = compact( 'user_pass', 'user_email', 'user_url', 'user_nicename', 'display_name', 'user_registered' );
	$data = stripslashes_deep( $data );

	$wpdb->insert( $wpdb->users, $data + compact( 'user_login' ) );
	$user_id = (int) $wpdb->insert_id;

	$user = new WP_User( $user_id );

	foreach ( _get_additional_user_keys( $user ) as $key ) {
		if ( isset( $$key ) )
			update_user_meta( $user_id, $key, $$key );
	}

	if ( isset($role) )
		$user->set_role($role);
	elseif ( !$update )
		$user->set_role(get_option('default_role'));

	wp_cache_delete($user_id, 'users');
	wp_cache_delete($user_login, 'userlogins');

	do_action('user_register', $user_id);

	return $user_id;
}

function stms_delete_reglink( $key ) {
	if ( !is_stms_admin() )
		wp_die("ERROR: Invalid Handler.");
	
	$regs = get_option('stms_reg_links');
	if ( isset($regs[$key]) ) {
		unset($regs[$key]);
		update_option('stms_reg_links', $regs);
	}
	@header('Location:' . admin_url('admin.php?page=stms-settings') . '#tools|link=deleted');
	exit;
}

function stms_generate_reglink() {
	if ( !is_stms_admin() || !isset($_REQUEST) )
		wp_die("ERROR: Invalid Handler.");
	
	$regs = get_option('stms_reg_links');
	if ( !is_array($regs) ) 
		$regs = array();
	
	$product_id = $_REQUEST['stms_reglink_product'];
	$product = stms_get_product($product_id);
	$count = intval($_REQUEST['stms_reglink_count']);
	$expire = ( $_REQUEST['stms_reglink_expire'] == '' ) ? date("m/d/Y", stms_time()) : $_REQUEST['stms_reglink_expire'];
	$expire_mode = $_REQUEST['stms_reglink_expire_mode'];
	
	$expired = ( $expire_mode != 'never' ) ? strtotime($expire, stms_time()) : 0;
	$key = stms_time();
	$secret = stms_generate_secret(32);
	
	$regs[$key] = array(
			'key' => $key,
			'secret' => $secret,
			'expired' => $expired,
			'count' => $count,
			'used' => 0,
			'product_id' => $product_id,
			'product_title' => stms_isset($product->title, '')
		);
		
	update_option('stms_reg_links', $regs);
	@header('Location:' . admin_url('admin.php?page=stms-settings') . '#tools|link=generated');
	exit;
}

function stms_login_as( $member_id ) {
	if ( !$member = stms_member($member_id) )
		wp_die("ERROR: Cannot login as a member.");
	
	if ( !is_admin() )
		wp_die("ERROR: Cannot login as a member.");
	
	if ( !current_user_can('manage_options') )
		wp_die("ERROR: Cannot login as a member.");
	
	$stms = get_option('stms_settings');
	$profile_url = stms_get_handler_url('profile');
	$member_url = ( isset($stms['global']['home']) ) ? get_permalink($stms['global']['home']) : get_bloginfo('url');
	$redir_url = ( empty($profile_url) ) ? $member_url : $profile_url;
	
	stms_clear_auth_cookie();
	stms_set_auth_cookie($member->ID);
	wp_redirect($redir_url);
	exit;
}
function stms_paid_affiliates( $ids, $redirect = true ) {
	$redir_url = admin_url('admin.php?page=stms-settings') . '#affstats|mode=payouts';
	$ids = explode(",", $ids);
	if ( count($ids) <= 0 ) {
		if ( $redirect ) {
			@header('Location:' . $redir_url);
			exit;
		}
		return false;
	}
	global $wpdb;
	foreach ( $ids as $id ) {
		$wpdb->update("{$wpdb->prefix}stms_aff_commissions", array('status' => 1), array('ID' => $id));
	}
	
	if ( $redirect ) {
		@header('Location:' . $redir_url);
		exit;
	}
	return true;
}

function stms_broadcast_emails() {
	set_time_limit(0);
	$recipients = stms_get_recipients($_REQUEST['stms_recipients']);
	$count = ( !$recipients ) ? 0 : count($recipients);
	
	$url = admin_url('admin.php?page=stms-settings') . '#broadcast';
	if ( $count <= 0 ) {
		@header('Location:' . $url . '|submitted=false&queue=' . $count);
		exit;
	}
	
	global $wpdb;
	
	$stms = get_option('stms_settings');
	$is_queued = stms_isset($stms['emails']['is_queued'], 1);
	$from = stms_sanitize(stms_isset($stms['emails']['admin_from'])) . ' <' . sanitize_email($stms['emails']['admin_email']) . '>';
	$from = ( $from == '' ) ? stms_sanitize(get_option('blogname')) . ' <' . get_option('admin_email') . '>' : $from;
	$_subject = stms_sanitize($_REQUEST['stms_email_subject']);
	$_body = stms_sanitize($_REQUEST['stms_email_body']);
	
	// add broadcast
	$data = array(
		'subject' => $_subject,
		'body' => $_body,
		'progress' => 0,
		'status' => ( $is_queued == 1 ) ? 0 : 1,
		'date' => stms_time()
	);
	$wpdb->insert("{$wpdb->prefix}stms_broadcasts", $data);
	$broadcast_id = $wpdb->insert_id;
	$unsubscribed = get_option('stms_unsubscribed');
	if ( !is_array($unsubscribed) )
		$unsubscribed = array();
	foreach ( $recipients as $key => $val ) {
		if ( !in_array($val, $unsubscribed) ) {
			if ( $is_queued == 1 ) {
				stms_add_queue(sanitize_email($val), $key, 'broadcast', $broadcast_id);
			} else {
				// direct sending...
				$subject = stms_parse_mail_tags($_subject, '', $key);
				$body = stms_parse_mail_tags($_body, '', $key);
				
				// add email body footer...
				$hashed_email = base64_encode(sanitize_email($val));
				$unsubscribe_url = stms_format_url(get_bloginfo('url'), 'sub=' . $hashed_email . '&insta_mode=unsubscribe');
				
				$body .= "\n\n\n\n" . stms_sanitize($stms['global']['business_addr']) . "\n\n";
				$body .= "-----------------------------------\n" .
						 "Use the following link to unsubscribe:\n" .
						 $unsubscribe_url . "\n\n\n";
						 
				stms_mail(sanitize_email($val), $subject, $body, $from);
			}
		}
	}
	@header('Location:' . $url . '|submitted=true&queue=' . $count);
	exit;	
}

function stms_add_queue($email, $member_id, $type, $broadcast_id = 0, $message = '' ) {
	global $wpdb;
	$data = array(
		'broadcast_id' => $broadcast_id,
		'message' => $message,
		'type' => $type,
		'email' => $email,
		'member_id' => $member_id,
	);
	$wpdb->insert("{$wpdb->prefix}stms_email_queue", $data);
	return $wpdb->insert_id;
}

function stms_get_recipients( $type = 1 ) {
	global $wpdb;
	$recipients = false;
	$unsubscribes = get_option('stms_unsubscribes');
	if ( !is_array($unsubscribes) )
		$unsubscribes = array();
	
	switch ( $type ) {
		case 1:
			if ( !$members = $wpdb->get_results("SELECT ID, email FROM `{$wpdb->prefix}stms_members` WHERE status = 1 ORDER BY ID DESC") )
				return false;
			
			$recipients = array();
			foreach ( $members as $member ) {
				if ( !in_array($member->email, $unsubscribes) )
					$recipients[$member->ID] = $member->email;
			}
			break;
		case 2:
			if ( !isset($_REQUEST['stms_selected_recipients']) )
				return false;
				
			$product_ids = implode(",", $_REQUEST['stms_selected_recipients']);
			$sql = "SELECT m.email, m.ID, tx.member_id FROM {$wpdb->prefix}stms_members m
					INNER JOIN {$wpdb->prefix}stms_transactions tx ON (m.ID = tx.member_id AND tx.product_id IN ({$product_ids}) AND tx.status = 'completed' AND tx.paid = 1)
					WHERE m.status = 1 GROUP BY m.email ORDER BY m.ID DESC";
			
			if ( !$members = $wpdb->get_results($sql) )
				return false;
			
			$recipients = array();
			foreach ( $members as $member ) {
				if ( !in_array($member->email, $unsubscribes) )
					$recipients[$member->ID] = $member->email;
			}
			break;
			
		case 3:
			if ( !isset($_REQUEST['stms_selected_recipients2']) )
				return false;
				
			$product_ids = implode(",", $_REQUEST['stms_selected_recipients2']);
			$pre_sql = "SELECT DISTINCT member_id FROM {$wpdb->prefix}stms_transactions WHERE status = 'completed' AND paid = 1 AND product_id IN ({$product_ids})";
			$sql = "SELECT ID, email FROM {$wpdb->prefix}stms_members WHERE status = 1 AND ID NOT IN ({$pre_sql}) ORDER BY ID DESC";
					
			if ( !$members = $wpdb->get_results($sql) )
				return false;
			
			$recipients = array();
			foreach ( $members as $member ) {
				if ( !in_array($member->email, $unsubscribes) )
					$recipients[$member->ID] = $member->email;
			}
			break;
			
		case 4:
			if ( !$members = $wpdb->get_results("SELECT ID, email FROM `{$wpdb->prefix}stms_members` WHERE status = 1 AND is_aff = 1 ORDER BY ID DESC") )
				return false;
			
			$recipients = array();
			foreach ( $members as $member ) {
				if ( !in_array($member->email, $unsubscribes) )
					$recipients[$member->ID] = $member->email;
			}
			break;
		default:
			//do nothing
	}
	
	if ( is_array($recipients) )
		$recipients = array_unique($recipients);
	
	return $recipients;
}

function stms_undo_import() {
	$url = admin_url('admin.php?page=stms-settings') . '#members|mode=import';
	$step = $_REQUEST['step'];
	$key = $_REQUEST['key'];
	if ( $step == 3 ) {
		delete_transient('stms_imported_data_' . $key);
		@setcookie('__insta_import', 'two|' . $key, 0, ADMIN_COOKIE_PATH);
	} else if ( $step == 2 ) {
		delete_transient('stms_import_data_' . $key);
		@setcookie('__insta_import', 0, time()-86400, ADMIN_COOKIE_PATH);
	}
	@header('Location:' . $url);
	exit;
}

function stms_import_members() {
	@set_time_limit(0);
	
	global $wpdb;
	
	$step = $_REQUEST['import_step'];
	$key = $_REQUEST['import_key'];
	if ( $step == 'one' ) {
		if ( !function_exists('wp_handle_upload') ) require_once( ABSPATH . 'wp-admin/includes/file.php' );
		$uploadedfile = $_FILES['stms_imp_file'];
		$upload_overrides = array('test_form' => false, 'mimes' => array('csv' => 'text/csv'));
		$file = wp_handle_upload($uploadedfile, $upload_overrides);
		if ( $file ) {
		    if ( !empty($file['error']) )
				wp_die('ERROR: File is empty or the size is too big, or the file you\'re trying to upload is not a CSV file.');
			
			$arrCSV = array();
			if ( ($handle = fopen($file['file'], "r")) !== FALSE ) {
				$key = 0;
				while ( ($data = fgetcsv($handle, 0, ",")) !== FALSE ) {
		   			// Count the total keys in each row
		   			$c = count($data);
		   			for ( $x = 0; $x < $c; $x++ ) {
		   				$arrCSV[$key][] = $data[$x];
		   			}
		   			$key++;
				}
				fclose($handle);
				
				if ( count($arrCSV) <= 0 )
					wp_die("ERROR: CSV file contain no data.");
				
				set_transient('stms_import_data_' . $key, $arrCSV);
				@setcookie('__insta_import', 'two|' . $key, 0, ADMIN_COOKIE_PATH);
				
				$url = admin_url('admin.php?page=stms-settings') . '#members|mode=import';
				@header('Location:' . $url);
			} else {
				wp_die("ERROR: CSV file cannot be opened.");
			}
		} else {
		    wp_die("Upload Error!");
		}
	} else if ( $step == 'two' ) {
		$url = admin_url('admin.php?page=stms-settings') . '#members|mode=import';
		$fields = $_REQUEST['icol'];
		$mapped = false;
		foreach ( $fields as $field ) {
			if ( !empty($field) ) {
				$mapped = true;
				break;
			}
		}
		
		if ( !in_array('email', $fields) ) {
			@header('Location:' . $url . '&error=noemail');
		}
		
		if ( !$mapped ) {
			@header('Location:' . $url . '&error=unmapped');
		}
		
		$new_data = array();
		$is_username = ( !in_array('username', $fields) ) ? false : true;
		$data = get_transient('stms_import_data_' . $key);
		foreach ( $data as $dat ) {
			$member = array();
			for ( $i = 0; $i < count($dat); $i++ ) {
				if ( !empty($fields[$i]) ) {
					$member[$fields[$i]] = $dat[$i];
				}
			}
			$new_data[] = $member;
		}
		
		if ( !$is_username ) {
			for ( $i = 0; $i < count($new_data); $i++ ) {
				$first_name = ( isset($new_data[$i]['first_name']) ) ? $new_data[$i]['first_name'] : '';
				$last_name = ( isset($new_data[$i]['last_name']) ) ? $new_data[$i]['last_name'] : '';
				$new_data[$i]['username'] = stms_generate_username($new_data[$i]['email'], $first_name, $last_name);
			}
		}
		
		set_transient('stms_imported_data_' . $key, $new_data);
		@setcookie('__insta_import', 'three|' . $key, 0, ADMIN_COOKIE_PATH);
				
		@header('Location:' . $url);
	} else if ( $step == 'three' ) {
		$mode = $_REQUEST['stms_imp_mode'];
		$def_pass = $_REQUEST['stms_imp_pass'];
		$fields = $_REQUEST['icol'];
		$products = $_REQUEST['stms_imp_products'];
		$data = get_transient('stms_imported_data_' . $key);
		
		$imported = 0;
		$skipped = 0;
		$overwritten = 0;
		$updated = 0;
		foreach ( $data as $dat ) {
			$import = true;
			if ( $mode == 1 ) {
				if ( stms_username_exists($dat['username']) ) $import = false;
				if ( stms_email_exists($dat['email']) ) $import = false;
			}
			
			if ( $import ) {
				$overwrite = false;
				$password = ( isset($dat['password']) ) ? $dat['password'] : (( !empty($def_pass) ) ? $def_pass : wp_generate_password());
				$userdata = array();
				$userdata['member_id'] = 0;
				if ( ($member_id = stms_username_exists($dat['username'])) || ($member_id = stms_email_exists($dat['email'])) )
					$userdata['member_id'] = $member_id;
					
				if ( $mode == 3 && $userdata['member_id'] > 0 )
					$overwrite = true;
				
				if ( $overwrite ) { // mode 3
					$userdata['fix_username'] = $dat['username'];
					$userdata['pwd1'] = $password;
					
					$overwritten++;
				} else if ( !$overwrite && $userdata['member_id'] > 0 ) { // mode 2
					$updated++;
				} else {
					$userdata['username'] = $dat['username'];
					$userdata['pass'] = $password;
					
					$imported++;
				}
				
				$userdata['email'] = $dat['email'];
				
				if ( !empty($dat['first_name']) )
					$userdata['first_name'] = stms_sanitize($dat['first_name']);
				if ( !empty($dat['last_name']) )
					$userdata['last_name'] = stms_sanitize($dat['last_name']);
	
				if ( !empty($dat['street']) )
					$userdata['street'] = stms_sanitize($dat['street']);
				if ( !empty($dat['city']) )
					$userdata['city'] = stms_sanitize($dat['city']);
				if ( !empty($dat['state']) )
					$userdata['state'] = stms_sanitize($dat['state']);
				if ( !empty($dat['zipcode']) )
					$userdata['zipcode'] = stms_sanitize($dat['zipcode']);
				if ( !empty($dat['country']) )
					$userdata['country'] = stms_sanitize($dat['country']);
				if ( !empty($dat['phone']) )
					$userdata['phone'] = stms_sanitize($dat['phone']);
				if ( !empty($dat['company']) )
					$userdata['company'] = stms_sanitize($dat['company']);
				if ( !empty($dat['gender']) )
					$userdata['gender'] = stms_sanitize($dat['gender']);
				if ( !empty($dat['url']) )
					$userdata['url'] = stms_sanitize($dat['url']);
				
				$new_id = stms_save_member($userdata, true);
				
				if ( !empty($products) ) {
					foreach ( $products as $product_id ) {
						if ( $product = stms_get_product($product_id) ) {
							// check if member already has access
							$sql = "SELECT * FROM `{$wpdb->prefix}stms_transactions`
									WHERE `member_id` = {$new_id} AND `product_id` = {$product->ID}
									AND `paid` = 1 AND `status` = 'completed'";
									
							if ( !$payment = $wpdb->get_row($sql) ) {
								$pay_info = array(
									'product_id' => $product->ID,
									'paysys' => 'manual',
									'receipt' => 'manual',
									'amount' => 0.00,
									'start' => stms_time(),
									'expire' => stms_get_expired($product->ID, true),
									'paid' => 1
								);
								stms_manual_payment($new_id, $pay_info);
							}
						}
					}
				}
			} else {
				$skipped++;
			}
		}

		$result = array(
			'mode' => $mode,
			'imported' => $imported,
			'skipped' => $skipped,
			'updated' => $updated,
			'overwritted' => $overwritten
		);
		
		delete_transient('stms_import_data_' . $key);
		delete_transient('stms_imported_data_' . $key);
		
		set_transient('stms_import_result_' . $key, $result);
		@setcookie('__insta_import', 'four|' . $key, 0, ADMIN_COOKIE_PATH);
				
		$url = admin_url('admin.php?page=stms-settings') . '#members|mode=import';
		@header('Location:' . $url);
	}
	exit;
}
	
function stms_export_members() {
	@set_time_limit(0);
	global $wpdb;
	$_fields = ( isset($_REQUEST['stms_exp_fields']) ) ? $_REQUEST['stms_exp_fields'] : false;
	$products = ( isset($_REQUEST['stms_exp_products']) ) ? $_REQUEST['stms_exp_products'] : false;
	
	if ( empty($_fields) )
		wp_die("Export Error: Please choose at least one field to be exported.");
	
	$fields = array();
	foreach ( $_fields as $field ) {
		$fields[$field] = $field;	
	}
	
	if ( !empty($products) ) {
		$products = implode(",", $products);
		$members = $wpdb->get_results(
				"SELECT m.*, tx.status AS tx_status, tx.paid FROM {$wpdb->prefix}stms_members m
				INNER JOIN {$wpdb->prefix}stms_transactions tx ON (tx.member_id = m.ID)
				WHERE m.status = 1 AND tx.product_id IN ({$products})
				AND tx.paid = 1 AND (tx.status <> 'refunded' OR tx.status <> 'expired')
				GROUP BY m.username ORDER BY m.username ASC"
		);
	} else {
		$members = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}stms_members` WHERE `status` = 1 ORDER BY `username` ASC");
	}
	
	if ( $members ) {
		header('Content-Type: text/csv; charset=' . get_bloginfo('charset'));
		header('Content-Disposition: attachment; filename=insta_members_' . date("Ymd") . '_' . date("Hi") . '.csv');
		if ( isset($_REQUEST['stms_exp_headers']) ) {
			$file = fopen('php://output', 'a');	
			$content = array();
			if ( isset($fields['id']) ) $content[] = 'ID';
			if ( isset($fields['username']) ) $content[] = 'Username';
			if ( isset($fields['email']) ) $content[] = 'Email';
			if ( isset($fields['first_name']) ) $content[] = 'First Name';
			if ( isset($fields['last_name']) ) $content[] = 'Last Name';
			if ( isset($fields['gender']) ) $content[] = 'Gender';
			if ( isset($fields['street']) ) $content[] = 'Street Address';
			if ( isset($fields['city']) ) $content[] = 'City';
			if ( isset($fields['zipcode']) ) $content[] = 'Zip Code';
			if ( isset($fields['state']) ) $content[] = 'State/Province';
			if ( isset($fields['country']) ) $content[] = 'Country';
			if ( isset($fields['phone']) ) $content[] = 'Phone';
			if ( isset($fields['company']) ) $content[] = 'Company';
			if ( isset($fields['url']) ) $content[] = 'Site URL';
			if ( isset($fields['ref']) ) $content[] = 'Referrer';
			if ( isset($fields['ref_id']) ) $content[] = 'Referrer ID';
			if ( isset($fields['ref_name']) ) $content[] = 'Referrer Name';
			if ( isset($fields['ref_email']) ) $content[] = 'Referrer Email';
			
			$content = implode(",", $content);
			fwrite($file, $content . "\n");
		    fclose($file);
		}

		foreach ( $members as $m ) {
			$meta = maybe_unserialize($m->metadata);
			$content = array();
			if ( isset($fields['id']) ) $content[] = $m->ID;
			if ( isset($fields['username']) ) $content[] = stms_sanitize($m->username);
			if ( isset($fields['email']) ) $content[] = stms_sanitize($m->email);
			if ( isset($fields['first_name']) ) $content[] = stms_sanitize($m->first_name);
			if ( isset($fields['last_name']) ) $content[] = stms_sanitize($m->last_name);
			if ( isset($fields['gender']) ) $content[] = stms_sanitize($meta['info']['gender']);
			if ( isset($fields['street']) ) $content[] = stms_sanitize($meta['info']['street']);
			if ( isset($fields['city']) ) $content[] = stms_sanitize($meta['info']['city']);
			if ( isset($fields['zipcode']) ) $content[] = stms_sanitize($meta['info']['zipcode']);
			if ( isset($fields['state']) ) $content[] = stms_sanitize($meta['info']['state']);
			if ( isset($fields['country']) ) $content[] = stms_sanitize($meta['info']['country']);
			if ( isset($fields['phone']) ) $content[] = stms_sanitize($meta['info']['phone']);
			if ( isset($fields['company']) ) $content[] = stms_sanitize($meta['info']['company']);
			if ( isset($fields['url']) ) $content[] = stms_sanitize($meta['info']['url']);
			if ( isset($fields['ref']) ) {
				$referrer = stms_get_member_meta($m->ID, 'aff_id');
				$aff = '';
				if ( !empty($referrer) && ($ref = stms_member($referrer)) )
					$aff = $ref->username;
				
				$content[] = $aff;
			}
			
			if ( isset($fields['ref_id']) ) {
				if ( !isset($ref) ) {
					$referrer = stms_get_member_meta($m->ID, 'aff_id');
					$aff_id = '';
					if ( !empty($referrer) && ($ref = stms_member($referrer)) )
						$aff_id = $ref->ID;
				} else {
					$aff_id = ( isset($ref->ID) ) ? $ref->ID : '';
				}
				
				$content[] = $aff_id;
			}
			
			if ( isset($fields['ref_name']) ) {
				if ( !isset($ref) ) {
					$referrer = stms_get_member_meta($m->ID, 'aff_id');
					$aff_name = '';
					if ( !empty($referrer) && ($ref = stms_member($referrer)) )
						$aff_name = stms_sanitize($ref->first_name) . ' ' . stms_sanitize($ref->last_name);
				} else {
					$aff_name = stms_sanitize($ref->first_name) . ' ' . stms_sanitize($ref->last_name);
				}
				
				$content[] = $aff_name;
			}
			
			if ( isset($fields['ref_email']) ) {
				if ( !isset($ref) ) {
					$referrer = stms_get_member_meta($m->ID, 'aff_id');
					$aff_email = '';
					if ( !empty($referrer) && ($ref = stms_member($referrer)) )
						$aff_email = stms_sanitize($ref->email);
				} else {
					$aff_email = stms_sanitize($ref->email);
				}
				
				$content[] = $aff_email;
			}
			
			if ( isset($ref) ) unset($ref);
			
			$content = implode(",", $content);
		    $file = fopen('php://output', 'a');
			fwrite($file, $content . "\n");
		    fclose($file);
		}
	} else {
		wp_die("Export Error: No Members Found.");
	}
	exit;
}

function stms_approve_affiliate( $member_id, $redirect = true ) {
	$redir_url = admin_url('admin.php?page=stms-settings') . '#members';	
	if ( empty($member_id) || !$member = stms_member($member_id) ) {
		if ( $redirect ) {
			@header('Location:' . $redir_url);
			exit;
		}
		return false;
	}
	
	if ( $member->is_aff_pending != 1 ) {
		if ( $redirect ) {
			@header('Location:' . $redir_url);
			exit;
		}
		return false;
	}
	
	$data = array('is_aff' => 1, 'is_aff_pending' => 0);
	if ( $member->status == 0 ) {
		global $wpdb;
		$data['status'] = 1;
		$access_log = $wpdb->get_var("SELECT COUNT(*) FROM `{$wpdb->prefix}stms_access_log` WHERE member_id = {$member->ID}");
		$payments = stms_get_member_payments($member->ID); // check for payments
		if ( !$payments && $access_log <= 0 ) {
			$data['pass'] = wp_hash_password($member->pass);
			stms_send_signupmail($member->ID, $member->pass);
		}
	}
	$update = stms_update_member($member->ID, $data);
	stms_send_affapprovedmail($member->ID); // send approved mail
	if ( $redirect ) {
		@header('Location:' . $redir_url . '|affiliate=approved');
		exit;
	}
	return true;
}

function stms_deny_affiliate( $member_id, $redirect = true ) {
	$redir_url = admin_url('admin.php?page=stms-settings') . '#members';	
	if ( empty($member_id) || !$member = stms_member($member_id) ) {
		if ( $redirect ) {
			@header('Location:' . $redir_url);
			exit;
		}
		return false;
	}
	
	if ( $member->is_aff_pending != 1  ) {
		if ( $redirect ) {
			@header('Location:' . $redir_url);
			exit;
		}
		return false;
	}
	
	$delete = false;
	if ( $member->status == 0 ) {
		global $wpdb;
		$access_log = $wpdb->get_var("SELECT COUNT(*) FROM `{$wpdb->prefix}stms_access_log` WHERE member_id = {$member->ID}");
		$payments = stms_get_member_payments($member->ID); // check for payments
		if ( !$payments && $access_log <= 0 )
			$delete = true;
	}
	
	if ( $delete ) {
		stms_delete_member($member->ID, false);
	} else {
		$data = array('is_aff' => 0, 'is_aff_pending' => 0);
		$update = stms_update_member($member->ID, $data);
	}
	
	if ( $redirect ) {
		@header('Location:' . $redir_url . '|affiliate=denied');
		exit;
	}
	return true;
}

function stms_generate_paypalmass() {
	global $wpdb;
		
	$stms = get_option('stms_settings');
	$business_name = stms_cleanup(stms_isset($stms['global']['business_name'], get_bloginfo('blogname')));
	$min_pay = stms_isset($stms['global']['min_payout'], 10.00);
	
	// date range...
	$today = stms_time();
	$subsql = "SELECT
					GROUP_CONCAT(acm.ID) as comm_ids,
					GROUP_CONCAT(acm.tx_id) as tx_ids,
					acm.aff_id, acm.pay_date, acm.date,
						(SELECT SUM(commission) FROM {$wpdb->prefix}stms_aff_commissions
						WHERE status = 0 AND void = 0 AND aff_id = acm.aff_id
						AND pay_date <= {$today})	
					AS commissions,
						(SELECT SUM(commission) FROM {$wpdb->prefix}stms_aff_commissions
						WHERE status = 0 AND void = 1 AND aff_id = acm.aff_id)
					AS corrections
				FROM {$wpdb->prefix}stms_aff_commissions acm GROUP BY aff_id";
				
	$sql = "SELECT m.ID AS member_id, m.username, m.email, m.status,
				cm.comm_ids, cm.tx_ids, cm.pay_date, cm.date,
				IFNULL(cm.commissions, 0.00) AS commissions,
				IFNULL(cm.corrections, 0.00) AS corrections
			FROM {$wpdb->prefix}stms_members m
			INNER JOIN ({$subsql}) cm ON (cm.aff_id = m.ID)
			WHERE m.status = 1 AND m.is_aff = 1
			GROUP BY m.ID ORDER BY m.username, m.ID ASC";
	
	$results = $wpdb->get_results($sql);
	
	$filename = "paypal_aff_payouts_" . date("Y-m-d", stms_time());
	$i = 0;
	if ( $results ) {
		header('Content-Description: File Transfer');
		header('Content-disposition: attachment; filename=' . $filename);
		header('Content-type: text/plain');
		header('Content-Transfer-Encoding: binary');
		header('Pragma: public');
		header('Expires: -1');
		header('Cache-Control: public, must-revalidate, post-check=0, pre-check=0');
		foreach ( $results as $aff ) {
			$commissions = 0;
			$total = number_format($aff->commissions - $aff->corrections, 2);
			if ( $total >= 0.00 && $total >= $min_pay ) {
				$aff_ids = stms_get_member_meta($aff->member_id, 'aff_ids');
				$paypal_email = stms_isset($aff_ids['paypal'], '');
				if ( !empty($paypal_email) ) {
					$currency = stms_isset($stms['global']['currency'], 'USD');
					$unique_key = 'aff_payment-' . date("Ymd") . $i;
					echo $paypal_email . "\t" . $total . "\t" . $currency . "\t" . $unique_key . "\t" . "Affiliate payment from " . $business_name . PHP_EOL;
					$i++;
				}
			}
		}
	}
	
	exit;
}

function stms_generate_payzamass() {
	global $wpdb;
		
	$stms = get_option('stms_settings');
	$business_name = stms_cleanup(stms_isset($stms['global']['business_name'], get_bloginfo('blogname')));
	$min_pay = stms_isset($stms['global']['min_payout'], 10.00);
	
	// date range...
	$today = stms_time();
	$subsql = "SELECT
					GROUP_CONCAT(acm.ID) as comm_ids,
					GROUP_CONCAT(acm.tx_id) as tx_ids,
					acm.aff_id, acm.pay_date, acm.date,
						(SELECT SUM(commission) FROM {$wpdb->prefix}stms_aff_commissions
						WHERE status = 0 AND void = 0 AND aff_id = acm.aff_id
						AND pay_date <= {$today})	
					AS commissions,
						(SELECT SUM(commission) FROM {$wpdb->prefix}stms_aff_commissions
						WHERE status = 0 AND void = 1 AND aff_id = acm.aff_id)
					AS corrections
				FROM {$wpdb->prefix}stms_aff_commissions acm GROUP BY aff_id";
				
	$sql = "SELECT m.ID AS member_id, m.username, m.email, m.status,
				cm.comm_ids, cm.tx_ids, cm.pay_date, cm.date,
				IFNULL(cm.commissions, 0.00) AS commissions,
				IFNULL(cm.corrections, 0.00) AS corrections
			FROM {$wpdb->prefix}stms_members m
			INNER JOIN ({$subsql}) cm ON (cm.aff_id = m.ID)
			WHERE m.status = 1 AND m.is_aff = 1
			GROUP BY m.ID ORDER BY m.username, m.ID ASC";
	
	$results = $wpdb->get_results($sql);
	
	$filename = "payza_aff_payouts_" . date("Y-m-d", stms_time()) . ".csv";
	$i = 0;
	if ( $results ) {
		$arr = array();
		foreach ( $results as $aff ) {
			$commissions = 0;
			$total = number_format($aff->commissions - $aff->corrections, 2);
			if ( $total >= 0.00 && $total >= $min_pay ) {
				$aff_ids = stms_get_member_meta($aff->member_id, 'aff_ids');
				$payza_email = stms_isset($aff_ids['payza'], '');
				if ( !empty($payza_email) ) {
					$arr[] = array(
						$payza_email,
						$total,
						"Affiliate payment from" . $business_name
					);
					$i++;
				}
			}
		}
		
		if ( count($arr) > 0 ) {
			header('Content-Description: File Transfer');
			header('Content-disposition: attachment; filename=' . $filename);
			header('Content-Type: text/csv; charset=utf-8');
			header('Content-Transfer-Encoding: binary');
			header('Pragma: public');
			header('Expires: -1');
			header('Cache-Control: public, must-revalidate, post-check=0, pre-check=0');
		
			$output = fopen('php://output', 'w');
			foreach ( $arr as $ar ) {
				fputcsv($output, $ar);
			}
		} else {
			wp_die('Cannot generated mass pay file for Payza. Please make sure your affiliates has been updated their Payza email address.');
		}
	}
	
	exit;
}

function stms_admin_save_member() {
	global $wpdb;
	
	$post = $_POST['stms_member'];
	
	$userdata = array();
	
	$ID = (int) $post['member_id'];
	$old_m = stms_member($ID);
	
	$userdata['username'] = stms_sanitize($old_m->username);
	$userdata['member_id'] = (int) $post['member_id'];
	$userdata['email'] = sanitize_email($post['email']);
	$userdata['first_name'] = ( $post['first_name'] == 'First Name' ) ? '' : sanitize_text_field($post['first_name']);
	$userdata['last_name'] = ( $post['last_name'] == 'Last Name' ) ? '' : sanitize_text_field($post['last_name']);
	$userdata['status'] = 1;
	if ( isset($post['auto_lock']) )
		$userdata['is_locked'] =  trim($post['auto_lock']);
	
	if ( $post['member_id'] > 0 )
		$update = true;
	else
		$update = false;
	
	if ( isset($post['pwd1']) )
		$userdata['pwd1'] = stms_sanitize($post['pwd1']);
	if ( isset($post['password']))
		$userdata['password'] = stms_sanitize($post['password']);
	if ( isset($post['username']) )
		$userdata['username'] = trim($post['username']);
	
	
	$userdata['street'] = trim($post['street']);
	$userdata['city'] = trim($post['city']);
	$userdata['state'] = trim($post['state']);
	$userdata['zipcode'] = trim($post['zipcode']);
	$userdata['country'] = trim($post['country']);
	$userdata['title'] = trim($post['title']);
	$userdata['phone'] = trim($post['phone']);
	$userdata['company'] = trim($post['company']);
	$userdata['gender'] = trim($post['gender']);
	$userdata['is_aff'] = ( $post['aff_status'] == 'active' ) ? 1 : 0;
	$userdata['is_aff_pending'] = ( $post['aff_status'] == 'pending' ) ? 1 : 0;
	
	$member_id = stms_save_member($userdata, true);
	if ( stms_isset($post['excl_aff']) == 1 )
		stms_update_member_meta($member_id, 'exclusive_aff', 1);

	if ( isset($post['aff_payments']) && is_array($post['aff_payments']) )
		stms_update_member_meta($member_id, 'aff_ids', $post['aff_payments']);
	
	if ( $update ) {
		do_action('stms_member_manual_updated', $member_id);
		@header('Location:' . admin_url('admin.php?page=stms-settings') . '#members|mode=edit&object_ID=' . $member_id . '&member=updated');
	} else {
		if ( stms_isset($post['level']) != '' ) :
			$pay_info = array(
					'product_id' => stms_isset($post['level']),
					'paysys' => 'manual',
					'receipt' => 'manual',
					'amount' => stms_isset($post['payment']['amount']),
					'start' => stms_isset($post['payment']['start']),
					'expire' => stms_isset($post['payment']['expired']),
					'paid' => 1
				);
			$payment = stms_manual_payment($member_id, $pay_info);
		endif;
		
		if ( stms_isset($post['is_welcome_email'], 0) == 1 ) {
			stms_send_signupmail($member_id, trim($post['password']));
		}
		
		// Redirect...
		@header('Location:' . admin_url('admin.php?page=stms-settings') . '#members|mode=edit&object_ID=' . $member_id . '&member=added');
	}
	exit;
}

function stms_duplicate_level( $product_id, $redirect = true ) {
	global $wpdb;
	$table = "{$wpdb->prefix}stms_products";
	$id_field = "ID";
	$id = absint($product_id);
	$stms = get_option('stms_settings');
	$redirect_url = admin_url('admin.php?page=stms-settings') . '#level';
	
  	// load the original record into an array
  	$sql = $wpdb->prepare("SELECT * FROM `{$table}` WHERE `{$id_field}` = %d", $id);
  	$original_record = $wpdb->get_row($sql);
	if ( !$original_record ) {
		if ( $redirect ) {
			@header('Location: ' . $redirect_url);
			exit;
		}
		return false;
	}
	
  	// insert the new record and get the new auto_increment id
  	$wpdb->query("INSERT INTO {$table} (`{$id_field}`) VALUES (NULL)");
  	$newid = mysql_insert_id();

	// generate the query to update the new record with the previous values
  	$query = "UPDATE {$table} SET ";
  	foreach ( $original_record as $key => $value ) {
    	if ( $key != $id_field ) {
    		if ( $key == 'title' ) $value .= ' (duplicate)';
        	$query .= '`' . $key . '` = "' . str_replace('"', '\"', $value) . '", ';
    	}
  	}
  	$query = substr($query, 0, strlen($query)-2); # lop off the extra trailing comma
  	$query .= " WHERE {$id_field}={$newid}";
  	$wpdb->query($query);

	// check if member download has been protected exists
	$p = stms_get_product($newid);
	$member_home = $p->home_id;
	$protect = $wpdb->get_row(
		$wpdb->prepare(
			"SELECT ID FROM `{$wpdb->prefix}stms_protects`
			WHERE `product_id` = %d AND `post_id` = %d",
			$p->ID, $member_home
		)
	);
	
	$global_home = ( isset($stms['global']['home']) ) ? $stms['global']['home'] : 0;
	if ( $protect && $protect->post_id == $global_home ) {
		$wpdb->query("DELETE FROM `{$wpdb->prefix}stms_protects` WHERE `post_id` = {$global_home}");
	}
	
	if ( !$protect && $member_home != $global_home ) {
		$data = array(
			'type' => 'content',
			'product_id' => $p->ID,
			'post_id' => $member_home,
			'is_expired' => 0,
			'drip_start' => 0,
			'drip_end' => 30,
			'drip_start_mode' => 'day',
			'drip_end_mode' => 'day',
			'date' => stms_time()
		);
		$wpdb->insert("{$wpdb->prefix}stms_protects", $data);
	}
	
	if ( $redirect ) {
		$redirect_url .= "|mode=edit&object_ID={$newid}";
  		@header('Location: ' . $redirect_url);
		exit;
	}
	return true;
}

function stms_save_level() {
	global $wpdb;
	
	$stms = get_option('stms_settings');
	$post = $_POST['stms_level'];
	$data = array(
				'home_id' => ( $post['type'] == 'free' ) ? $post['free_home'] : $post['home'],
				'title' => sanitize_text_field($post['name']),
				'type' => $post['type'],
				'is_trial' => ( isset($post['is_trial']) ) ? 1 : 0,
				'price' => ( $post['type'] == 'recurr' ) ? sanitize_text_field($post['r_price']) : sanitize_text_field($post['price']),
				't_price' => sanitize_text_field($post['t_price']),
				'duration' => maybe_serialize(
								array(
									'num' => sanitize_text_field($post['r_dur']),
									'mode' => sanitize_text_field($post['r_dur_type'])
								)
							),
				't_duration' => maybe_serialize(
								array(
									'num' => sanitize_text_field($post['t_dur']),
									'mode' => sanitize_text_field($post['t_dur_type'])
								)
							),
				'rebill_times' => sanitize_text_field($post['r_times']),
				'product_status' => 1,
				'date' => stms_time()
			);
	
	$update = false;
	if ( stms_isset($post['product_id']) > 0 ) 
		$update = true;
	
	if ( $update ) {
		// Update the database
		$product_id = intval($post['product_id']);
		$wpdb->update("{$wpdb->prefix}stms_products", $data, array('ID' => $product_id)) or wp_die(mysql_error());
		$redirect_url = admin_url('admin.php?page=stms-settings') . '#level|mode=edit&object_ID=' . $product_id . '&product=updated';
	} else {
		// Add new entry to database
		$data['created'] = date("Y-m-d H:i:s");
		$wpdb->insert("{$wpdb->prefix}stms_products", $data) or wp_die(mysql_error());
		$msg = ( $result ) ? 'added' : 'add_failed';
		$product_id = $wpdb->insert_id;
		$redirect_url = admin_url('admin.php?page=stms-settings') . '#level|mode=edit&object_ID=' . $product_id . '&product=added';
	}
	
	// check if member download has been protected exists
	$member_home = ( $post['type'] == 'free' ) ? $post['free_home'] : $post['home'];
	$protect = $wpdb->get_row(
		$wpdb->prepare(
			"SELECT ID FROM `{$wpdb->prefix}stms_protects`
			WHERE `product_id` = %d AND `post_id` = %d",
			$product_id, $member_home
		)
	);
	
	$global_home = ( isset($stms['global']['home']) ) ? $stms['global']['home'] : 0;
	if ( $protect && $protect->post_id == $global_home ) {
		$wpdb->query("DELETE FROM `{$wpdb->prefix}stms_protects` WHERE `post_id` = {$global_home}");
	}
	
	if ( !$protect && $member_home != $global_home ) {
		$data = array(
			'type' => 'content',
			'product_id' => $product_id,
			'post_id' => $member_home,
			'is_expired' => 0,
			'drip_start' => 0,
			'drip_end' => 30,
			'drip_start_mode' => 'day',
			'drip_end_mode' => 'day',
			'date' => stms_time()
		);
		$wpdb->insert("{$wpdb->prefix}stms_protects", $data);
	}
				
	$metadata = array(
				'direct_pay' => $post['direct_pay'],
				'third_pay' => stms_isset($post['third_pay']),
				'thankuri' => ( $post['type'] == 'free' ) ? trim(sanitize_text_field($post['thankuri2'])) : trim(sanitize_text_field($post['thankuri'])),
				'salesuri' => ( $post['type'] == 'free' ) ? trim(sanitize_text_field($post['salesuri2'])) : trim(sanitize_text_field($post['salesuri'])),
				'refund' => trim(sanitize_text_field($post['refund'])),
				'free_confirm' => ( isset($post['free_confirm']) ) ? 1 : 0,
				'steps' => $post['steps'],
				'auto_register' => ( isset($post['auto_register']) ) ? $post['auto_register'] : 0,
				'is_webinar' => ( isset($post['is_webinar']) ) ? 1 : 0,
				'is_responder' => ( isset($post['is_responder']) ) ? 1 : 0,
				'autoresponder' => $post['autoresponder'],
				'is_twotier' => ( isset($post['is_twotier']) ) ? 1 : 0,
				'aff_comm' => ( empty($post['aff_comm']) ) ? 0 : $post['aff_comm'],
				's_aff_comm' => ( empty($post['s_aff_comm']) ) ? 0 : $post['s_aff_comm'],
				'aff_comm2' => ( empty($post['aff_comm2']) ) ? 0 : $post['aff_comm2'],
				's_aff_comm2' => ( empty($post['s_aff_comm2']) ) ? 0 : $post['s_aff_comm2'],
				'ot_expired' => ( isset($post['ot_expired']) ) ? 1 : 0,
				'ot_expnum' => ( empty($post['ot_expnum']) ) ? 1 : $post['ot_expnum'],
				'ot_exptype' => ( empty($post['ot_exptype']) ) ? 'y' : $post['ot_exptype']
			);
	
	if ( isset($post['is_responder']) && isset($post['webinar_url']) ) {
		foreach ( $post['webinar_url'] as $wburl ) {
			if ( $wburl != '' ) {
				$metadata['webinar_url'][] = $wburl;
			}
		}
	}
	
	if ( isset($post['is_responder']) && stms_isset($post['autoresponder']) != '' )
		$metadata[$post['autoresponder'] . '_list'] = $post[$post['autoresponder'] . '_list'];

	stms_update_product_meta($product_id, 'main', $metadata);
	// save pay settings...
	if ( isset($post['pay_settings']) ) {
		stms_update_product_meta($product_id, 'pay_settings', $post['pay_settings']);
		if ( is_array($post['pay_settings']) ) {
			foreach ( $post['pay_settings'] as $k => $v ) {
				$item = stms_save_third_item($product_id, stms_isset($v['item'], ''), stms_isset($v['vendor'], ''), $k);
			}
		}
	}
	
	// clean caches
	wp_cache_delete($product_id, 'stms_products');
	wp_cache_delete($post['name'], 'stms_producttitle');
	 
	@header( 'Location:' . $redirect_url );
	exit;
}

function stms_tabledata_members( $per_page = 10 ) {
	global $wpdb;
	
	$data_start = ( stms_isset($_GET['paged'], 1) > 1 ) ? ($_GET['paged']-1) * $per_page : 0;
	$trans_table = "{$wpdb->prefix}stms_transactions";
	$payment_query = "SELECT SUM(amount) AS payments FROM {$trans_table} WHERE member_id = stx.member_id AND paid = 1 AND status <> 'refunded'";
	//$tx_sql = "SELECT member_id, SUM(amount) AS payments, COUNT(amount) AS paid_count FROM {$wpdb->prefix}stms_transactions WHERE paid = 1 and status <> 'refunded' GROUP BY member_id";
	$tx_sql = "SELECT stx.member_id, stx.product_id, stx.paid, stx.status, stx.expired_date, stx.payment_type, ({$payment_query}) AS payments
		FROM {$trans_table} stx GROUP BY stx.member_id ORDER BY stx.tx_id DESC";
	$sql = "SELECT m.*, tx.member_id, tx.product_id, tx.paid,
			tx.status AS payment_status,
			tx.expired_date, tx.payment_type
			FROM {$wpdb->prefix}stms_members m
			LEFT JOIN {$trans_table} tx ON (tx.member_id = m.ID)
			WHERE m.status <> 4";
	
	$is_none = false;
	if ( isset($_REQUEST['product_id']) ) {
		if ( $_REQUEST['product_id'] == 'none' ) {
			$is_none = true;
			$sql .= " AND tx.member_id IS NULL";
		} else {
			$product_id = (int) $_REQUEST['product_id'];
			$sql .= " AND tx.product_id = {$product_id}";
		}
	}
	
	if ( !$is_none && isset($_REQUEST['py_status']) ) {
		$now = stms_time();
		switch ( $_REQUEST['py_status'] ) {	
			case 'completed':
				$sql .= " AND (tx.payment_type = 'recurr' AND tx.expired_date >= {$now} OR tx.status = 'completed')";
				break;
			case 'refunded':
				$sql .= " AND tx.status = 'refunded'";
				break;
			case 'canceled':
				$sql .= " AND tx.status = 'canceled'";
				break;
			case 'expired':
				$sql .= " AND (tx.payment_type = 'recurr' AND tx.expired_date < {$now} OR tx.status = 'expired')";
				break;
		}
	}
	
	if ( isset($_REQUEST['status']) ) {
		switch ( $_REQUEST['status'] ) {	
			case 'active':
				$sql .= " AND m.status = 1 AND m.is_locked <> 'yes'";
				break;
			case 'inactive':
				$sql .= " AND m.status = 0";
				break;
			case 'locked':
				$sql .= " AND m.is_locked = 'yes'";
				break;
		}
	}

	if ( isset($_REQUEST['aff_status']) ) {
		switch ( $_REQUEST['aff_status'] ) {
			case 'yes':
				$sql .= " AND m.is_aff = 1";
				break;
			case 'pending':
				$sql .= " AND m.is_aff_pending = 1";
				break;
			case 'no':
				$sql .= " AND m.is_aff = 0 AND m.is_aff_pending = 0";
				break;
		}
	}
	
	if ( isset($_REQUEST['s']) && $_REQUEST['s'] != '' ) {
		$s = trim(urldecode($_REQUEST['s']));
		$s = str_replace(array('+', ' '), "_", $s);
		$sql .= " AND (m.username LIKE '%{$s}%' OR m.email LIKE '%{$s}%' OR m.first_name LIKE '%{$s}%' OR m.last_name LIKE '%{$s}%')";
	}
	
	$sql .= " GROUP BY m.ID ORDER BY m.username ASC";
	
	$results = $wpdb->get_results($sql);
	$count = count($results);
	
	//stms_dump($sql);
	
	$sql .= " LIMIT {$data_start}, {$per_page}";
	$results = $wpdb->get_results($sql);
	$data = array();
	
	if ( $results ) {
		foreach ( $results as $member ) {
			$data[] = array(
				'ID' => $member->ID,
				'title' => stripslashes(esc_attr($member->username)),
				'email' => sanitize_email($member->email),
				'name' => stms_cleanup($member->first_name) . ' ' . stms_cleanup($member->last_name),
				'affiliate' => ( $member->is_aff == 1 ) ? 'Yes' : ( ($member->is_aff_pending == 1) ? '<span style="color:#000099">Pending</span>' : 'No'),
				'account' => ( $member->status == 0 ) ? '<span style="color:#808080">Inactive</span>' : ( ($member->is_locked == "yes") ? '<span style="color:#ff0000">Locked</span>' : 'Active'),
				//'payments' => $member->payments,
			);
		}
	}
	
	return array('total' => $count, 'data' => $data);
}

function stms_tabledata_levels( $per_page = 10 ) {
	global $wpdb;
	$data_start = ( stms_isset($_GET['paged'], 1) > 1 ) ? ($_GET['paged']-1) * $per_page : 0;
	$sql = "SELECT * FROM `{$wpdb->prefix}stms_products` WHERE `product_status` <> 4";
	
	if ( isset($_REQUEST['s']) && $_REQUEST['s'] != '' ) {
		$s = trim(urldecode($_REQUEST['s']));
		$s = str_replace(array('+', ' '), "_", $s);
		$sql .= " AND (`title` LIKE '%{$s}%' OR `type` LIKE '%{$s}%')";
	}
	
	$sql .= " ORDER BY ID ASC LIMIT {$data_start},{$per_page}";
	$results = $wpdb->get_results($sql);
	
	$data = array();
	if ( $results ) {
		foreach ( $results as $level ) {
			$level_type = 'One-Time';
			$level_price = $level->price;
			if ( $level->type == 'recurr' )
				$level_type = 'Subscription';
			else if ( $level->type == 'free' ) {
				$level_type = 'Free';
				$level_price = '0.00';
			}
			$dur = maybe_unserialize($level->duration);
			$period = 'Lifetime';
			$meta = maybe_unserialize($level->metadata);
			$info = ( isset($meta['main']) ) ? $meta['main'] : array();
			if ( $level->type == 'recurr' ) $period = $dur['num'] . '' . $dur['mode'];
			if ( $level->type == 'onetime' && isset($info['ot_expired']) && $info['ot_expired'] == 1 )
				 $period = $info['ot_expnum'] . '' . $info['ot_exptype'];
				 
			$data[] = array(
					'ID' => $level->ID,
					'title' => $level->title,
					'type' => $level_type,
					'price' => $level_price,
					'dur' => $period,
					'comm' => $level->aff_comm . '%'
			);
		}
	}
	
	return $data;
}

function stms_tabledata_sales() {
	global $wpdb;
	
	$data = array();
	$sql = "SELECT tx.*, m.username, m.status AS mstatus, p.title FROM {$wpdb->prefix}stms_transactions tx
			INNER JOIN {$wpdb->prefix}stms_members m ON (m.ID = tx.member_id)
			INNER JOIN {$wpdb->prefix}stms_products p ON (p.ID = tx.product_id)
			WHERE tx.status <> 'temp' AND tx.member_id > 0 AND m.status <> 4";
			
	if ( isset($_GET['range']) && $_GET['range'] != '' ) {
		switch ($_GET['range']) {
			case 'yesterday':
				$start = strtotime("yesterday", stms_time());
				$end = strtotime("+1 day", $start);
				break;
			case 'week':
				$start = strtotime("7 days ago", stms_time());
				$end = stms_time();
				break;
			case 'month':
				$start = strtotime("30 days ago", stms_time());
				$end = stms_time();
				break;
			case 'today':
				$start = strtotime("today", stms_time());
				$end = stms_time();
				break;
			case 'all':
			default:
				// do nothing...
		}
	} else if ( isset($_GET['start']) || isset($_GET['end']) ) {
		$admin_id = get_current_user_id();
		$admin = get_userdata($admin_id);

		$start = ( !empty($_GET['start']) ) ? strtotime($_GET['start'], stms_time()) : strtotime($admin->user_registered);
		$end = ( !empty($_GET['end']) ) ? strtotime($_GET['end'] . " 23:00", stms_time()) : stms_time();
		if ( $start > $end ) {
			// Ending date should be larger or equal start date... so let's reverse it...
			$_start = $end;
			$_end = $start;
			$start = $_start;
			$end = $_end;
		}
		
		if ( empty($_GET['start']) && empty($_GET['end']) )
			unset($start, $end);
	} else {
		$start = strtotime("today", stms_time());
		$end = stms_time();
		
	}
	
	if ( isset($start) && isset($end) )
		$sql .= " AND tx.date BETWEEN {$start} AND {$end}";
	
	if ( stms_isset($_GET['s']) != '' ) {
		$s = trim(urldecode($_REQUEST['s']));
		$sql .= " AND (p.title LIKE '%{$s}%' OR tx.receipt LIKE '%{$s}%' OR m.username LIKE '%{$s}%' OR tx.tx_id = '{$s}')";
	}
	
	if ( stms_isset($_GET['product_id']) > 0 )
		$sql .= " AND tx.product_id = {$_REQUEST['product_id']}";
	
	if ( stms_isset($_GET['status']) == 'unpaid' )
		$sql .= " AND tx.paid < 1";
	
	if ( stms_isset($_GET['status']) == 'paid' )
		$sql .= " AND tx.paid > 0";
		
	if ( stms_isset($_GET['status']) == 'refunded' )
		$sql .= " AND tx.status == 'refunded'";
		
	$sql .= " ORDER BY tx.tx_id DESC";
	$results = $wpdb->get_results($sql);
	if ( $results ) {
		foreach ( $results as $payment ) {
			$direct_pays = stms_get_direct_payments();
			$third_pays = stms_get_third_payments();
			$period = ( $payment->expired_date <= 0 ) ? 'Lifetime' : '<abbr title="' . date("m/d/Y", $payment->date) . '">' .  date("m/d/Y", $payment->date) . '</abbr> - <abbr title="' . date("m/d/Y", $payment->expired_date) . '">' . date("m/d/Y", $payment->expired_date) . '</abbr>';
			$paid = ( $payment->paid ) ? 'Yes' : 'No';
			$_status = $payment->status;
			if ( $payment->expired_date > 0 && $_status == 'completed' ) {
				$now = stms_time();
				$expired = $payment->expired_date;
				if ( $now > $expired )
					$_status = 'expired';
			}
			
			$_status = ( $_status == 'completed' ) ? 'active' : $_status;
			$_status = ( $_status == 'cancelled' ) ? 'canceled' : $_status;
			
			$status_color = ( $_status == 'refunded' || $_status == 'cancelled' || $_status == 'expired' ) ? '#cc0000"' : (( $_status == 'pending' ) ? '#a7a7a7"' : '#008900');
			$status = '<span style="color:' . $status_color . '">' . ucwords($_status) . '</span>';
				
			//$status = ( $payment->status == 'refunded' || $payment->status == 'cancelled' || $payment->status == 'expired' ) ? '<span style="color:#cc0000">' . ucwords($payment->status) . '</span>' : ucwords($payment->status);
			$receipt = ( $payment->receipt == 'manual' ) ? '-' : $payment->receipt;
			$amount = number_format($payment->amount, 2);
			$amount = ( $payment->status == 'refunded' ) ? '<span style="color:#cc0000">-' . ucwords($amount) . '</span>' : $amount;
			$processor = ( isset($direct_pays[$payment->paysys]) ) ? $direct_pays[$payment->paysys] : (( isset($third_pays[$payment->paysys]) ) ? $third_pays[$payment->paysys] : 'Manual');
			$data[] = array(
					'ID' => $payment->tx_id,
					'title' => $payment->username,
					'member_id' => $payment->member_id,
					'product' => stms_sanitize($payment->title),
					'date' => date("m/d/Y H:i:s", $payment->date),
					'receipt' => $receipt,
					'period' => $period,
					'paid' => $paid,
					'processor' => $processor,
					'status' => '<strong>' . $status . '</strong>',
					'amount' => '<strong>' . $amount . '</strong>'
			);
		}
	}
	
	return $data;
}

function stms_tabledata_licenselog( $per_page = 10 ) {
	global $wpdb;
	
	$data_start = ( stms_isset($_GET['paged'], 1) > 1 ) ? ($_GET['paged']-1) * $per_page : 0;
	$license = stms_get_license_by('id', $_GET['object_ID']);
	$settings = stms_get_product_meta($license->product_id, 'license');
	$mode = stms_isset($settings['usage_mode'], 'unlimited');
	$field = ( $mode == 'unlimited' ) ? 'domain' : $mode;
	$logs = stms_get_licenselog($license->ID, $field, $data_start, $per_page);
	
	$query = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}stms_license_log`
			WHERE `license_id` = {$license->ID} ORDER BY `{$field}` DESC");
	
	$count = ( $query ) ? count($query) : 0;
	$data = array();
	if ( $logs ) {
		foreach ( $logs as $log ) {
			$data[] = array(
				'ID' => $log->log_id,
				'title' => $log->domain,
				'servip' => $log->servip,
				'userip' => $log->userip,
				'act_date' => date("m/d/Y H:i:s", $log->date)
			);
		}
	}
	return array('data' => $data, 'total' => $count);
}

function stms_tabledata_accesslog( $per_page = 15 ) {
	global $wpdb;
	
	$data_start = ( stms_isset($_GET['paged'], 1) > 1 ) ? ($_GET['paged']-1) * $per_page : 0;
	$member_id = stms_isset($_GET['object_ID'], 0);
	$logs = stms_get_access_log($member_id, $data_start, $per_page);
	
	$query = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}stms_access_log`
					WHERE `member_id` = {$member_id} ORDER BY date DESC");
	
	$count = ( $query ) ? count($query) : 0;
	$data = array();
	if ( $logs ) {
		foreach ( $logs as $log ) {
			$data[] = array(
				'ID' => $log->log_id,
				'time' => date("m/d/Y g:i a", $log->date),
				'ipaddr' => $log->ip_addr,
				'title' => $log->referrer
			);
		}
	}
	return array('data' => $data, 'total' => $count);
}

function stms_get_admin_files() {
	if ( stms_log_payment() ) {
		return stms_all_files();	
	} else {
		return array('dashboard' => 'Dashboard');
	}
}

function stms_dashboard_summary( $range = 'today' ) {
	global $wpdb;
	
	switch ( $range ) {
		case 'yesterday':
			$start = strtotime("yesterday", stms_time());
			$end = strtotime("+1 day", $start);
			break;
		case 'week':
			$start = strtotime("7 days ago", stms_time());
			$end = stms_time();
			break;
		case 'today':
		default:	
			$start = strtotime("today", stms_time());
			$end = stms_time();
	}
	
	$data = array();
	// Number of sales
	$sql = "SELECT COUNT(*) FROM {$wpdb->prefix}stms_transactions
			WHERE status = 'completed' AND paid = 1
			AND date BETWEEN {$start} AND {$end} ORDER BY tx_id";
	$sales = $wpdb->get_var($sql);
	$data['sales'] = intval($sales);
	
	// Number of sales by affiliate
	$sql = "SELECT COUNT(*) FROM {$wpdb->prefix}stms_transactions
			WHERE status = 'completed' AND paid = 1 AND aff_id > 0
			AND date BETWEEN {$start} AND {$end} ORDER BY tx_id";
	$aff_sales = $wpdb->get_var($sql);
	$data['aff_sales'] = intval($aff_sales);
	
	// Total Revenue
	$sql = "SELECT SUM(amount) AS total FROM {$wpdb->prefix}stms_transactions
			WHERE status = 'completed' AND paid = 1
			AND date BETWEEN {$start} AND {$end} ORDER BY tx_id";
	$sales = $wpdb->get_var($sql);
	$data['revenue'] = number_format(intval($sales), 2);
	
	// Total Revenue by affiliate
	$sql = "SELECT SUM(amount) AS total FROM {$wpdb->prefix}stms_transactions
			WHERE status = 'completed' AND paid = 1 AND aff_id > 0
			AND date BETWEEN {$start} AND {$end} ORDER BY tx_id";
	$sales = $wpdb->get_var($sql);
	$data['aff_revenue'] = number_format(intval($sales), 2);
	return $data;
}

function stms_dashboard_sales() {
	global $wpdb;
	
	$data = array();
	$sql = "SELECT tx.*, m.username, m.status AS mstatus, p.title FROM {$wpdb->prefix}stms_transactions tx
			INNER JOIN {$wpdb->prefix}stms_members m ON (m.ID = tx.member_id)
			INNER JOIN {$wpdb->prefix}stms_products p ON (p.ID = tx.product_id)
			WHERE m.status <> 4 AND tx.amount > 0.00 AND tx.status = 'completed' AND tx.paid = 1
			ORDER BY tx.tx_id DESC LIMIT 10";
			
	if ( !$results = $wpdb->get_results($sql) ) return false;
	foreach ( $results as $payment ) {
		$amount = number_format($payment->amount, 2);
		$data[] = array(
				'ID' => $payment->tx_id,
				'username' => $payment->username,
				'member_id' => $payment->member_id,
				'product' => stms_sanitize($payment->title),
				'date' => date("m/d/Y", $payment->date),
				'amount' => '<strong>' . $amount . '</strong>'
		);
	}
	return $data;
}

function stms_dashboard_members() {
	global $wpdb;
	$sql = "SELECT * FROM {$wpdb->prefix}stms_members
			WHERE status = 1 ORDER BY ID DESC LIMIT 10";
	if ( !$members = $wpdb->get_results($sql) ) return false;
	return $members;
}

function stms_dashboard_logins() {
	global $wpdb;
	$sql = "SELECT al.*, m.username
			FROM {$wpdb->prefix}stms_access_log al
			INNER JOIN {$wpdb->prefix}stms_members m ON (m.ID = al.member_id)
			ORDER BY al.date DESC LIMIT 10";
	if ( !$logs = $wpdb->get_results($sql) ) return false;
	return $logs;
}

function stms_tabledata_affiliates() {
	global $wpdb;
	
	$stms = get_option('stms_settings');
	// Determine start and end date if use date range...
	if ( isset($_GET['range']) && $_GET['range'] != '' ) {
		switch ($_GET['range']) {
			case 'yesterday':
				$start = strtotime("yesterday", stms_time());
				$end = strtotime("+1 day", $start);
				break;
			case 'week':
				$start = strtotime("7 days ago", stms_time());
				$end = stms_time();
				break;
			case 'month':
				$start = strtotime("30 days ago", stms_time());
				$end = stms_time();
				break;
			case 'today':
				$start = strtotime("today", stms_time());
				$end = stms_time();
			case 'all':
			default:
				// do nothing...
		}
	} else if ( isset($_GET['start']) || isset($_GET['end']) ) {
		$start = ( !empty($_GET['start']) ) ? strtotime($_GET['start'], stms_time()) : stms_time();
		$end = ( !empty($_GET['end']) ) ? strtotime($_GET['end'] . " 23:59", stms_time()) : stms_time();
		if ( $start > $end ) {
			// Ending date should be larger or equal start date... so let's reverse it...
			$_start = $end;
			$_end = $start;
			$start = $_start;
			$end = $_end;
		}
		
		if ( empty($_GET['start']) && empty($_GET['end']) )
			unset($start, $end);
	} else {
		$start = strtotime("today", stms_time());
		$end = stms_time();
	}
	
	// SUB SUB SQLs
	$comm_subsql_comm = "SELECT SUM(commission) FROM {$wpdb->prefix}stms_aff_commissions
						WHERE void = 0 AND aff_id = acm.aff_id";
	$comm_subsql_corr = "SELECT SUM(commission) FROM {$wpdb->prefix}stms_aff_commissions
						WHERE void = 1 AND aff_id = acm.aff_id";
	$sales_subsql_rev = "SELECT SUM(amount) FROM {$wpdb->prefix}stms_transactions
						WHERE paid = 1 AND status <> 'refunded' AND aff_id = sl.aff_id";
	$sales_subsql_ref = "SELECT SUM(amount) FROM {$wpdb->prefix}stms_transactions
						WHERE paid = 1 AND status = 'refunded' AND aff_id = sl.aff_id";
	$sales_subsql_rev_c = "SELECT COUNT(*) FROM {$wpdb->prefix}stms_transactions
						WHERE paid = 1 AND status <> 'refunded' AND aff_id = sl.aff_id";
	$sales_subsql_ref_c = "SELECT COUNT(*) FROM {$wpdb->prefix}stms_transactions
						WHERE paid = 1 AND status = 'refunded' AND aff_id = sl.aff_id";
	
	if ( isset($_GET['product_id']) ) {
		$product_id = (int) $_GET['product_id'];
		$comm_subsql_comm .= " AND product_id = {$product_id}";
		$comm_subsql_corr .= " AND product_id = {$product_id}";
		$sales_subsql_rev .= " AND product_id = {$product_id}";
		$sales_subsql_ref .= " AND product_id = {$product_id}";
		$sales_subsql_rev_c .= " AND product_id = {$product_id}";
		$sales_subsql_ref_c .= " AND product_id = {$product_id}";
	}
	
	if ( isset($start) && isset($end) ) {
		$comm_subsql_comm .= " AND date BETWEEN {$start} AND {$end}";
		$comm_subsql_corr .= " AND date BETWEEN {$start} AND {$end}";
		$sales_subsql_rev .= " AND date BETWEEN {$start} AND {$end}";
		$sales_subsql_ref .= " AND date BETWEEN {$start} AND {$end}";
		$sales_subsql_rev_c .= " AND date BETWEEN {$start} AND {$end}";
		$sales_subsql_ref_c .= " AND date BETWEEN {$start} AND {$end}";
	}
	
	// SUB SQLs
	$comm_subsql = "SELECT acm.aff_id, ({$comm_subsql_comm}) AS commissions, ({$comm_subsql_corr}) AS corrections
					FROM {$wpdb->prefix}stms_aff_commissions acm GROUP BY acm.aff_id";
	$sales_subsql = "SELECT sl.aff_id, ({$sales_subsql_rev}) AS revenue,
						({$sales_subsql_ref}) AS refunded,
						({$sales_subsql_rev_c}) AS sales,
						({$sales_subsql_ref_c}) AS refund
					FROM {$wpdb->prefix}stms_transactions sl GROUP BY sl.aff_id";
	$clicks_subsql = "SELECT aff_id,
						COUNT(*) AS rawclicks,
						COUNT(DISTINCT ip_addr) AS clicks
					 FROM {$wpdb->prefix}stms_aff_clicks WHERE 1";
					 
	if ( isset($start) && isset($end) )
		$clicks_subsql .= " AND date BETWEEN {$start} AND {$end}";

	if ( isset($product_id) )
		$clicks_subsql .= " AND product_id = {$product_id}";
	
	$clicks_subsql .= " GROUP BY aff_id";
	
	// MAIN SQL
	$sql = "SELECT m.ID, m.username, m.email, m.status,
				IFNULL(cm.commissions, 0) as commissions,
				IFNULL(cm.corrections, 0) as corrections,
				IFNULL(tx.revenue, 0) as revenue,
				IFNULL(tx.refunded, 0) as refunded,
				IFNULL(tx.sales, 0) as sales,
				IFNULL(tx.refund, 0) as refund,
				IFNULL(c.rawclicks, 0) as rawclicks,
				IFNULL(c.clicks, 0) as clicks
			FROM {$wpdb->prefix}stms_members m
			INNER JOIN ({$comm_subsql}) cm ON (cm.aff_id = m.ID)
			INNER JOIN ({$sales_subsql}) tx ON (tx.aff_id = m.ID)
			LEFT JOIN ({$clicks_subsql}) c ON (c.aff_id = m.ID)
			WHERE m.status = 1 and m.is_aff = 1";
	
	if ( isset($_GET['s']) && $_GET['s'] != '' ) {
		$s = trim(urldecode($_GET['s']));
		$sql .= " AND (m.username LIKE '%{$s}%' OR m.first_name LIKE '%{$s}%' OR m.last_name LIKE '%{$s}%')";
	}
	
	$sql .= " GROUP BY m.ID, m.username ORDER BY m.username, m.ID ASC";
	$results = $wpdb->get_results($sql);
	$data = array();
	if ( $results ) {
		foreach ( $results as $aff ) {
			$convert = ( $aff->sales > 0 && $aff->clicks > 0 ) ? ceil(($aff->sales/$aff->clicks) * 100) : 0;
			$payout = number_format($aff->commissions - $aff->corrections, 2);
			$data[] = array(
					'ID' => $aff->ID,
					'title' => $aff->username,
					'rclick' => $aff->rawclicks,
					'uclick' => $aff->clicks,
					'sales' => $aff->sales,
					'refund' => $aff->refund,
					'convert' => $convert . '%',
					'revenue' => number_format($aff->revenue, 2),
					'refunded' => number_format($aff->refunded, 2),
					'commissions' => number_format($aff->commissions, 2),
					'corrections' => ( $aff->corrections > 0 ) ? '<span style="color:#FF0000">-' . number_format($aff->corrections, 2) . '</span>' : '-',
					'payout' => ( $payout < 0.00 ) ? '<span style="color:#FF0000"><strong>' . $payout . '</strong></span>' : '<strong>' . $payout . '</strong>'
			);
		}
	}
	
	return $data;
}

function stms_tabledata_payouts() {
	global $wpdb;
	
	$stms = get_option('stms_settings');
	$min_pay = stms_isset($stms['global']['min_payout'], 10.00);
	
	// date range...
	$today = stms_time();
	$subsql = "SELECT
					GROUP_CONCAT(acm.ID) as comm_ids,
					GROUP_CONCAT(acm.tx_id) as tx_ids,
					acm.aff_id, acm.pay_date, acm.date,
						(SELECT SUM(commission) FROM {$wpdb->prefix}stms_aff_commissions
						WHERE status = 0 AND void = 0 AND aff_id = acm.aff_id
						AND pay_date <= {$today})	
					AS commissions,
						(SELECT SUM(commission) FROM {$wpdb->prefix}stms_aff_commissions
						WHERE status = 0 AND void = 1 AND aff_id = acm.aff_id)
					AS corrections
				FROM {$wpdb->prefix}stms_aff_commissions acm GROUP BY aff_id";
				
	$sql = "SELECT m.ID, m.username, m.email, m.status,
				cm.comm_ids, cm.tx_ids, cm.pay_date, cm.date,
				IFNULL(cm.commissions, 0.00) AS commissions,
				IFNULL(cm.corrections, 0.00) AS corrections
			FROM {$wpdb->prefix}stms_members m
			INNER JOIN ({$subsql}) cm ON (cm.aff_id = m.ID)
			WHERE m.status = 1 AND m.is_aff = 1
			GROUP BY m.ID ORDER BY m.username, m.ID ASC";
	
	$data = array();
	$results = $wpdb->get_results($sql);
	if ( $results ) {
		foreach ( $results as $aff ) {
			$commissions = 0;
			$total = number_format($aff->commissions - $aff->corrections, 2);
			if ( $total >= 0.00 && $total >= $min_pay ) {
				$minus = ( $aff->corrections != 0.00 ) ? '-' : '';
				$color = ( $total <= 0.00 ) ? '#cc0000' : '#009900';
				$currency = stms_isset($stms['global']['currency'], 'USD');
				$data[] = array(
						'ID' => $aff->comm_ids,
						'member_id' => $aff->ID,
						'tx_id' => $aff->tx_ids,
						'title' => '<a href="#members|mode=affstats&object_ID=' . $aff->ID . '"><strong>' . $aff->username . '</strong></a>',
						'credit' => '<strong>' . $aff->commissions . ' ' . $currency . '</strong>',
						'debit' => ( $aff->corrections > 0.00 ) ? '<span style="color:#cc0000">' . $minus . $aff->corrections . ' ' . $currency . '</span>' : '-',
						'total' => '<span style="color:' . $color . '"><strong>' . $total . ' ' . $currency . '</strong></span>',
						'check' => ( $total > 0.00 ) ? 1 : 0,
				);
			}
		}
	}
	return $data;
}

function stms_tabledata_commissions() {
	global $wpdb;
	
	$member_id = ( isset($_GET['object_ID']) ) ? $_GET['object_ID'] : 0;
	$y = date("Y", stms_time());
	$w = date("W", stms_time());
	$week_days = stms_find_week_dates($w, $y);
	$def_start = date("m/d/Y", $week_days[0]);
	$def_end = date("m/d/Y", $week_days[6]);
	
	$start = ( isset($_GET['start']) ) ? strtotime($_GET['start'], stms_time()) : strtotime($def_start, stms_time());
	$end = ( isset($_GET['end']) ) ? strtotime($_GET['end'] . "23:59", stms_time()) : strtotime($def_end . "23:59", stms_time());
	$comms = stms_get_commissions($member_id, $start, $end);
	
	$data = array();
	if ( $comms ) {
		foreach ( $comms as $comm ) {
			$status = ( $comm->status == 0 ) ? '<strong>Unpaid</strong>' : '<strong>Paid</strong>';
			if ( $comm->void == 1 )
				$status = '<span style="color:#cc0000"><strong>Voided</strong></span>';

			$color_open = ( $comm->void == 1 ) ? '<span style="color:#cc0000">' : '';
			$color_close = ( $comm->void == 1 ) ? '</span>' : '';
			$data[] = array(
				'ID' => $comm->ID,
				'title' => $color_open . stms_sanitize($comm->title) . $color_close,
				'affiliate' => $comm->username,
				'date' => $color_open . date("m/d/Y", $comm->date) . $color_close,
				'receipt' => '<a href="' . admin_url('admin.php?page=stms-settings') . '#reports|s=' . $comm->receipt . '">' . $color_open . $comm->receipt . $color_close . '</a>',
				'credit' => ( $comm->void == 1 ) ? '<span style="color:#cc0000"><strong>-' . $comm->commission . '</strong></span>' : '<span style="color:#009900"><strong>' . $comm->commission . '</strong></span>',
				'status' => $status,
				'tier' => $color_open . $comm->tier . $color_close
			);
		}
	}
	return $data;
}

function stms_tabledata_payments() {
	global $wpdb;
	
	$id = (int) $_REQUEST['object_ID'];
	$data = array();
	$payments = stms_get_member_payments($id);
	$direct_pays = stms_get_direct_payments();
	$third_pays = stms_get_third_payments();
	
	if ( $payments ) {
		foreach ( $payments as $payment ) {
			if ( $payment->status != 'temp' ) :
				$period = ( $payment->expired_date <= 0 || $payment->payment_type == 'free' ) ? 'Lifetime' : '<abbr title="' . date("m/d/Y", $payment->date) . '">' .  date("m/d/Y", $payment->date) . '</abbr> - <abbr title="' . date("m/d/Y", $payment->expired_date) . '">' . date("m/d/Y", $payment->expired_date) . '</abbr>';
				$paid = ( $payment->paid ) ? 'Yes' : 'No';
				$_status = $payment->status;
				if ( $payment->expired_date > 0 && $_status == 'completed' ) {
					$now = stms_time();
					$expired = $payment->expired_date;
					if ( $now > $expired )
						$_status = 'expired';
				}
				
				$_status = ( $_status == 'completed' ) ? 'active' : $_status;
				$_status = ( $_status == 'cancelled' ) ? 'canceled' : $_status;
				
				$status_color = ( $_status == 'refunded' || $_status == 'canceled' || $_status == 'expired' ) ? '#cc0000"' : (( $_status == 'pending' ) ? '#a7a7a7"' : '#008900');
				$status = '<span style="color:' . $status_color . '">' . ucwords($_status) . '</span>';
				$receipt = ( $payment->receipt == 'manual' ) ? '-' : $payment->receipt;
				$amount = number_format($payment->amount, 2);
				$amount = ( $payment->status == 'refunded' ) ? '<span style="color:#cc0000">-' . ucwords($amount) . '</span>' : $amount;
				$processor = ( isset($direct_pays[$payment->paysys]) ) ? $direct_pays[$payment->paysys] : (( isset($third_pays[$payment->paysys]) ) ? $third_pays[$payment->paysys] : 'Manual');
				if ( $payment->payment_type == 'free' )
					$processor == 'Free';
				
				$data[] = array(
						'ID' => $payment->tx_id,
						'title' => stms_sanitize($payment->title),
						'receipt' => $receipt,
						'period' => $period,
						'paid' => $paid,
						'processor' => $processor,
						'status' => '<strong>' . $status . '</strong>',
						'amount' => '<strong>' . $amount . '</strong>'
				);
			endif;
		}
	}
	
	return $data;
}

function stms_tabledata_license() {
	global $wpdb;
	
	$subsql = "SELECT license_id, COUNT(license_id) AS installed FROM {$wpdb->prefix}stms_license_log GROUP BY license_id";
	$data = array();
	$sql = "SELECT lc.*, m.username, p.title,
				IFNULL(lg.installed, 0) AS installed
			FROM {$wpdb->prefix}stms_licenses lc
			LEFT JOIN ({$subsql}) lg ON (lg.license_id = lc.ID)
			LEFT JOIN {$wpdb->prefix}stms_members m ON (m.ID = lc.member_id)
			LEFT JOIN {$wpdb->prefix}stms_products p ON (p.ID = lc.product_id)
			WHERE lc.ID <> 0";
	
	if ( !empty($_REQUEST['product_id']) ) {
		$product_id = (int) $_REQUEST['product_id'];
		$sql .= " AND lc.product_id = {$product_id}";
	} 
	
	if ( !empty($_REQUEST['s']) ) {
		$s = trim(urldecode($_REQUEST['s']));
		$sql .= " AND (lc.license LIKE '%{$s}%' OR m.username LIKE '%{$s}%')";
	}
	
	if ( !empty($_GET['status']) ) {
		if ( $_GET['status'] == 'active' )
			$sql .= " AND lc.status = 1";
		else if ( $_GET['status'] == 'suspended' )
			$sql .= " AND lc.status = 2";
		else if ( $_GET['status'] == 'inactive' )
			$sql .= " AND lc.status = 0";
		else if ( $_GET['status'] == 'expired' )
			$sql .= " AND lc.status = 3";
		else if ( $_GET['status'] == 'maxed' )
			$sql .= " AND lc.status = 4";
	}
	
	$sort = 'lg.installed';
	if ( stms_isset($_GET['sort']) == 'member' ) {
		$sort = 'm.username';
	} else if ( stms_isset($_GET['sort']) == 'product' ) {
		$sort = 'p.title';
	} else if ( stms_isset($_GET['sort']) == 'installed' ) {
		$sort = 'lg.installed';
	} else if ( stms_isset($_GET['sort']) == 'license' ) {
		$sort = 'lc.ID';
	} else if ( stms_isset($_GET['sort']) == 'status' ) {
		$sort = 'lc.status';
	}
	
	$sortm = ( isset($_GET['sortm']) ) ? $_GET['sortm'] : 'DESC';
	$sql .= " ORDER BY {$sort} {$sortm}";
	$results = $wpdb->get_results($sql);
	if ( $results ) {
		foreach ( $results as $license ) {
			$status = 'Inactive';
			if ( $license->status == 1 )
				$status = '<span style="color:#009900">Active</span>';
			else if ( $license->status == 2 )
				$status = '<span style="color:#990000">Suspended</span>';
			else if ( $license->status == 3 )
				$status = '<span style="color:#FF0000">Expired</span>';
			else if ( $license->status == 4 )
				$status = '<span style="color:#F88A00">Maxed Out</span>';
			
			$data[] = array(
				'ID' => $license->ID,
				'title' => $license->license,
				'member' => $license->username,
				'installed' => $license->installed,
				'product' => stms_cleanup($license->title),
				'status' => '<strong>' . $status . '</strong>',
				'status_code' => $license->status
			);
		}
	}
	
	return $data;
}

function stms_member_delpayment_mass() {
	global $wpdb;
	if ( isset($_POST['stms_paid_members']) ) {
		foreach ( $_POST['stms_paid_members'] as $member_id ) {
			$product_id = (int) stms_isset($_POST['stms_paid_level']);
			$member_id = (int) $member_id;
			$tx_ids = $wpdb->get_col($wpdb->prepare("SELECT * FROM `{$wpdb->prefix}stms_transactions` WHERE `product_id` = %d AND `member_id` = %d", $product_id, $member_id));
			
			if ( $tx_ids ) {
				foreach ( $tx_ids as $tx_id ) {
					$removed = stms_delete_payment($tx_id, false);
				}
			}
		}
	}
	
	$url = admin_url('admin.php?page=stms-settings#members');
	if ( isset($removed) )
		$url .= '|mass_payment=deleted';
	
	@header('Location: ' . $url);
	exit;
}

function stms_member_payment_mass() {
	if ( isset($_POST['stms_pays_members']) ) {
		foreach ( $_POST['stms_pays_members'] as $member_id ) {
			$pay_info = array(
				'product_id' => stms_isset($_POST['stms_pays_level']),
				'paysys' => 'manual',
				'receipt' => 'manual',
				'amount' => stms_isset($_POST['stms_pays_amount']),
				'start' => stms_isset($_POST['stms_pays_start']),
				'expire' => stms_isset($_POST['stms_pays_expired']),
				'paid' => ( isset($_POST['stms_pays_completed']) ) ? 1 : 0
			);
			
			$payment = stms_manual_payment($member_id, $pay_info);
		}
	}
	$url = admin_url('admin.php?page=stms-settings#members');
	if ( !empty($payment) ) 
		$url .= '|mass_payment=added';
	
	@header('Location: ' . $url);
	exit;
}

function stms_manual_payment( $member_id, $payment, $tx_id = 0 ) {
	if ( empty($member_id) || !is_array($payment) )
		return false;
	
	$tx_id = (int) $tx_id;
	$product_id = stms_isset($payment['product_id']);
	$product = stms_get_product($product_id);
	if ( !$product )
		return false;
	
	$start_day = strtotime(stms_isset($payment['start']));
	$expire_day = ( $product->type == 'onetime' ) ? 0 : strtotime(stms_isset($payment['expire']));
	/*
	if ( $product->type == 'onetime' && isset($product->info['ot_expired']) && $product->info['ot_expired'] == 1 ) {
		$expire_day = strtotime(stms_isset($payment['expire']));
	}
	*/
	
	$stms = get_option('stms_settings');
	$currency = ( isset($stms['global']['currency']) ) ? $stms['global']['currency'] : 'USD';
	$args = array(
			'product_id' => stms_isset($product->ID),
			'member_id'=> $member_id,
			'payment_type' => $product->type,
			'paysys' => stms_isset($payment['paysys']),
			'receipt' => stms_isset($payment['receipt']),
			'currency' => $currency,
			'amount' => stms_isset($payment['amount']),
			'paid' => stms_isset($payment['paid']),
			'status' => ( stms_isset($payment['paid']) == 1 ) ? 'completed' : 'pending',
			'date' => $start_day,
			'expired_date' => $expire_day
		);
	
	if ( $tx_id > 0 ) {
		$paid = stms_get_payment($tx_id);
		unset($args['paysys'], $args['receipt'], $args['created'], $args['currency']);
		$args['status'] = stms_isset($payment['status']);
		if ( $payment['status'] == 'refunded' ) {
			// void affiliate commission...
			stms_void_affiliate_commission($tx_id);
		} else if ( $payment['status'] == 'cancelled' ) {
			global $wpdb;
			// we need to make sure that the last payment is also cancelled...
			$q = $wpdb->prepare(
					"SELECT `tx_id` FROM `{$wpdb->prefix}stms_transactions`
					WHERE `receipt` = %s AND `status` = %s
					ORDER BY `tx_id` DESC LIMIT 1",
					stms_isset($paid->receipt, ''), 'completed'
			);
			
			if ( $last = $wpdb->get_row($q) ) {
				if ( $last->tx_id != $tx_id ) {
					$new_data = array();
					$new_data['status'] = 'cancelled';
					stms_update_payment($last->tx_id, $new_data);
					wp_cache_delete($last->member_id, 'stms_member_payments'); // delete cache
				}
			}	
			
			if ( stms_isset($paid->paysys, '') == 'authorize' && stms_isset($paid->payment_type, 'onetime') == 'recurr' ) {
				$subscription_id = stms_isset($paid->receipt, '');
				if ( !class_exists('AuthorizeNetRequest') )
					require_once(STMS_SOURCES . 'anet_php_sdk/AuthorizeNet.php');
			
				if ( !defined('AUTHORIZENET_API_LOGIN_ID') && !defined('AUTHORIZENET_TRANSACTION_KEY') ) {
					define('AUTHORIZENET_API_LOGIN_ID', stms_sanitize($stms['payments']['authorize']['login_id'], '', true));
					define('AUTHORIZENET_TRANSACTION_KEY', stms_sanitize($stms['payments']['authorize']['trans_key'], '', true));
				}
			
				$anet_sandbox = ( stms_isset($stms['payments']['authorize']['test']) == 1 ) ? true : false;
				if ( !defined('AUTHORIZENET_SANDBOX') )
					define('AUTHORIZENET_SANDBOX', $anet_sandbox);
				
				if ( !empty($receipt) ) {
					$subscription = new AuthorizeNet_Subscription;
					$subscription->cancelSubscription($subscription_id);
				}
			}

			stms_send_cancelmail($tx_id);
		}
		$tx_id = stms_update_payment($tx_id, $args);
		wp_cache_delete($member_id, 'stms_member_payments'); // delete cache
		
		return $tx_id;
	} else {
		$tx_id = stms_add_payment($args);
		if ( $args['status'] == 'completed' && $args['paid'] == 1 )
			$license = stms_create_license( $tx_id );
		return $tx_id;
	}
}

function stms_usort_reorder( $a, $b ) {
	$orderby = ( !empty($_REQUEST['orderby']) ) ? $_REQUEST['orderby'] : 'ID'; //If no sort, default to id
	$order = ( !empty($_REQUEST['order']) ) ? $_REQUEST['order'] : 'desc'; //If no order, default to asc
	$result = strcmp($a[$orderby], $b[$orderby]); //Determine sort order
	return ( $order === 'asc' ) ? $result : -$result; //Send final sort direction to usort
}

function stms_payout_days() {
	return array(
			'1d' => '1st day',
			'2d' => '2nd day',
			'3d' => '3rd day',
			'4d' => '4th day',
			'5d' => '5th day',
			'6d' => '6th day',
			'7d' => '7th day',
			'8d' => '8th day',
			'9d' => '9th day',
			'10d' => '10th day',
			'11d' => '11th day',
			'12d' => '12th day',
			'13d' => '13th day',
			'14d' => '14th day',
			'15d' => '15th day',
			'16d' => '16th day',
			'17d' => '17th day',
			'18d' => '18th day',
			'19d' => '19th day',
			'20d' => '20th day',
			'21d' => '21th day',
			'22d' => '22th day',
			'23d' => '23th day',
			'24d' => '24th day',
			'25d' => '25th day',
			'26d' => '26th day',
			'27d' => '27th day',
			'28d' => '28th day',
			'Sunday' => 'Every Sunday',
			'Monday' => 'Every Monday',
			'Tuesday' => 'Every Tuesday',
			'Wednesday' => 'Every Wednesday',
			'Thursday' => 'Every Thursday',
			'Friday' => 'Every Friday',
			'Saturday' => 'Every Saturday'
	);	
}

function stms_get_currency() {
	return array(
				"AUD",
				"BRL",
				"CAD",
				"CHF",
				"DKK",
				"EUR",
				"GBP",
				"HKD",
				"ILS",
				"JPY",
				"MXN",
				"MYR",
				"NOK",
				"NZD",
				"PHP",
				"RUB",
				"SEK",
				"SGD",
				"TRY",
				"TWD",
				"USD"
		);
}

function stms_paginate_links( $args = '', $pos = 'top' ) {
	$defaults = array(
		'totalcount' => 0,
		'total' => 1,
		'type' => 'posts',
		'product_id' => 0
	);
	
	$args = wp_parse_args( $args, $defaults );
	extract($args, EXTR_SKIP);

	if ( $total <= 1 )
		return '';
	
	$current = ( isset($_REQUEST[$type . '_paged']) ) ? $_REQUEST[$type . '_paged'] : 1;
	$prev = ( $current > 1 ) ? $current - 1 : 1;
	$next = ( $current < $total ) ? $current + 1 : $current;
	
	$low_disable = ( $current == 1 ) ? ' disabled' : '';
	$high_disable = ( $current == $total ) ? ' disabled' : '';
	
	echo "<div class='tablenav {$pos}'>";
	echo "<div class='tablenav-pages'>";
	echo "<span class='displaying-num'>{$totalcount} items</span>";
	echo "<span class='stms-pagination-links'>";
	echo "<a class='first-page {$low_disable}' title='Go to the first page' href='#level|mode=protects&object_ID={$product_id}&protect_type={$type}'>&laquo;</a>";
	echo "<a class='prev-page {$low_disable}' title='Go to the previous page' href='#level|mode=protects&object_ID={$product_id}&{$type}_paged={$prev}&protect_type={$type}'>&lsaquo;</a>";
	echo "<span class='paging-input'><input class='current-page' title='Current page' type='text' value='{$current}' size='1' /> of <span class='total-pages'>{$total}</span></span>";
	echo "<a class='next-page {$high_disable}' title='Go to the next page' href='#level|mode=protects&object_ID={$product_id}&{$type}_paged={$next}&protect_type={$type}'>&rsaquo;</a>";
	echo "<a class='last-page {$high_disable}' title='Go to the last page' href='#level|mode=protects&object_ID={$product_id}&{$type}_paged={$total}&protect_type={$type}'>&raquo;</a>";
	echo "</span>";
	echo "</div>";
	echo "</div>";
}

function stms_get_files() {
	$files = array();
	$download_path = STMS_DOWNLOAD_PATHS;
	if ( is_dir($download_path) ) :
		if ( $file_dir = opendir($download_path) ) :
			while ( ( $file = readdir($file_dir) ) !== false ) :
				if ( $file != '.' && $file != '..' && $file != '.htaccess' )
					if ( !is_dir(STMS_DOWNLOAD_PATHS . $file) )
						$files[] = $file;
			endwhile;
		endif;
	endif;
	
	return $files;
}

function stms_get_protected_files( $product_id, $perpage = 15 ) {
	global $wpdb;
	
	$current_page = ( isset($_REQUEST['files_paged']) ) ? $_REQUEST['files_paged']: 1;
	$files = stms_get_files();
	if ( $files && count($files) > 0 ) {
		$files = array_slice($files,(($current_page - 1) * $perpage), $perpage);
		$i = 0;
		foreach ( $files as $file ) {
			$alternate = ($i%2) ? 'alternate ' : '';
			$product_id = (int) $product_id;
			$protect = $wpdb->get_row($wpdb->prepare("SELECT * FROM `{$wpdb->prefix}stms_protects` WHERE `filename` = %s AND `product_id` = %d", $file, $product_id));
			$dripmodes = array(
				'day' => 'Day(s)',
				'week' => 'Week(s)',
				'month' => 'Month(s)',
				'year' => 'Year(s)',
				'exact' => 'Exact Date (mm/dd/yyyy)'
			);
			$checked = '';
			$drip_start = 0;
			$drip_end = 30;
			$exp_checked = '';
			$readonly = ' readonly';
			$disabled = ' disabled';
			$exp_disabled = ' disabled';
			$display = " style='display:none'";
			if ( count($protect) > 0 ) {
				$checked = ' checked="checked"';
				$drip_start = ( isset($protect->drip_start) ) ? $protect->drip_start : 0;
				$drip_end = ( isset($protect->drip_end) ) ? $protect->drip_end : 30;
				$exp_checked = ( stms_isset($protect->is_expired) == 1 ) ? ' checked="checked"' : '';
				$readonly = '';
				$disabled = '';
				$exp_disabled = '';
				$display = ( stms_isset($protect->is_expired) == 1 ) ? '' : " style='display:none'";
			}

			echo "<tr class='{$alternate}iedit'>";
			echo "<th scope='row' class='check-column'>";
			echo "<input type='checkbox' class='stms_enable_protect' name='stms_file_protect[protect_id][{$i}]' value='{$file}'{$checked}>";
			echo "<input type='hidden' class='protect-removed' name='stms_file_protect[is_removed][{$i}]' value='no' />";
			echo "<input type='hidden' name='stms_file_protect[filename][{$i}]' value='{$file}' />";
			echo "</th>";
			echo "<td><strong>{$file}</strong></td>";
			echo "
			<td>
				<input type='text' class='protect-drip-start protect-date-field' name='stms_file_protect[drip_start][{$i}]' value='{$drip_start}' style='width:80px'{$readonly} />
				<select name='stms_file_protect[drip_start_mode][{$i}]' class='protect-drip-start-mode protects-date' style='width:100px'{$disabled}>
			";
			
			foreach ( $dripmodes as $k => $v ) {
				$selected = ( empty($disabled) && stms_isset($protect->drip_start_mode) == $k ) ? ' selected="selected"' : '';
				echo "<option value='{$k}'{$selected}>{$v}</option>";
			}

			echo "
				</select>
			</td>
			";
			
			echo "
			<td>
				<div class='stms-exp-val'{$display}><input class='protect-drip-end protect-date-field' type='text' name='stms_file_protect[drip_exp][{$i}]' value='{$drip_end}' style='width:80px' />
				<select name='stms_file_protect[drip_end_mode][{$i}]' class='protect-drip-end-mode protects-date' style='width:100px'>
			";
			
			foreach ( $dripmodes as $k => $v ) {
				$selected = ( empty($exp_disabled) && stms_isset($protect->drip_end_mode) == $k ) ? ' selected="selected"' : '';
				echo "<option value='{$k}'{$selected}>{$v}</option>";
			}

			echo "
				</select>
			</div>
				<label for='smts-enable-exp-{$i}'><input type='checkbox' name='stms_file_protect[drip_enable_exp][{$i}]' id='smts-enable-exp-{$i}' class='smts-enable-exp' value='1'{$exp_checked}{$exp_disabled} /> <code>Enable Expiration</code></label>
			</td>
			";
			echo "</tr>";
			$i++;
		}
	} else {
		echo "<tr class='iedit'>";
		echo "<td colspan='4'>No file available</td>";
		echo "</tr>";
	}
}

function stms_get_protected_s3files( $product_id, $perpage = 15 ) {
	global $wpdb;
	
	$current_page = ( isset($_REQUEST['s3_files_paged']) ) ? $_REQUEST['s3_files_paged']: 1;
	$files = stms_s3_get_files();
	if ( $files && count($files) > 0 ) {
		$files = array_slice($files,(($current_page - 1) * $perpage), $perpage);
		$i = 0;
		foreach ( $files as $file ) {
			$alternate = ($i%2) ? 'alternate ' : '';
			$product_id = (int) $product_id;
			$protect = $wpdb->get_row($wpdb->prepare("SELECT * FROM `{$wpdb->prefix}stms_protects` WHERE `type` = %s AND `filename` = %s AND `product_id` = %d", 's3file', $file, $product_id));
			$dripmodes = array(
				'day' => 'Day(s)',
				'week' => 'Week(s)',
				'month' => 'Month(s)',
				'year' => 'Year(s)',
				'exact' => 'Exact Date (mm/dd/yyyy)'
			);
			$checked = '';
			$drip_start = 0;
			$drip_end = 30;
			$exp_checked = '';
			$readonly = ' readonly';
			$disabled = ' disabled';
			$exp_disabled = ' disabled';
			$display = " style='display:none'";
			if ( $protect ) {
				$checked = ' checked="checked"';
				$drip_start = ( isset($protect->drip_start) ) ? $protect->drip_start : 0;
				$drip_end = ( isset($protect->drip_end) ) ? $protect->drip_end : 30;
				$exp_checked = ( stms_isset($protect->is_expired) == 1 ) ? ' checked="checked"' : '';
				$readonly = '';
				$disabled = '';
				$exp_disabled = '';
				$display = ( stms_isset($protect->is_expired) == 1 ) ? '' : " style='display:none'";
			}

			echo "<tr class='{$alternate}iedit'>";
			echo "<th scope='row' class='check-column'>";
			echo "<input type='checkbox' class='stms_enable_protect' name='stms_file_protect[protect_id][{$i}]' value='{$file}'{$checked}>";
			echo "<input type='hidden' class='protect-removed' name='stms_file_protect[is_removed][{$i}]' value='no' />";
			echo "<input type='hidden' name='stms_file_protect[filename][{$i}]' value='{$file}' />";
			echo "</th>";
			echo "<td><strong>{$file}</strong></td>";
			echo "
			<td>
				<input type='text' class='protect-drip-start protect-date-field' name='stms_file_protect[drip_start][{$i}]' value='{$drip_start}' style='width:80px'{$readonly} />
				<select name='stms_file_protect[drip_start_mode][{$i}]' class='protect-drip-start-mode protects-date' style='width:100px'{$disabled}>
			";
			
			foreach ( $dripmodes as $k => $v ) {
				$selected = ( empty($disabled) && stms_isset($protect->drip_start_mode) == $k ) ? ' selected="selected"' : '';
				echo "<option value='{$k}'{$selected}>{$v}</option>";
			}

			echo "
				</select>
			</td>
			";
			
			echo "
			<td>
				<div class='stms-exp-val'{$display}><input class='protect-drip-end protect-date-field' type='text' name='stms_file_protect[drip_exp][{$i}]' value='{$drip_end}' style='width:80px' />
				<select name='stms_file_protect[drip_end_mode][{$i}]' class='protect-drip-end-mode protects-date' style='width:100px'>
			";
			
			foreach ( $dripmodes as $k => $v ) {
				$selected = ( empty($exp_disabled) && stms_isset($protect->drip_end_mode) == $k ) ? ' selected="selected"' : '';
				echo "<option value='{$k}'{$selected}>{$v}</option>";
			}

			echo "
				</select>
			</div>
				<label for='smts-enable-exp-{$i}'><input type='checkbox' name='stms_file_protect[drip_enable_exp][{$i}]' id='smts-enable-exp-{$i}' class='smts-enable-exp' value='1'{$exp_checked}{$exp_disabled} /> <code>Enable Expiration</code></label>
			</td>
			";
			echo "</tr>";
			$i++;
		}
	} else {
		echo "<tr class='iedit'>";
		echo "<td colspan='4'>No file available</td>";
		echo "</tr>";
	}
}

function stms_get_protected_categories( $product_id = 0, $perpage = 15 ) {
	global $wpdb;
	
	$stms = get_option('stms_settings');
	$current_page = ( isset($_REQUEST['categories_paged']) ) ? $_REQUEST['categories_paged']: 1;
	$categories = get_categories( array('hide_empty' => 0 ) );
	if ( $categories && count($categories) > 0 ) {
		$categories = array_slice($categories,(($current_page - 1) * $perpage), $perpage);
		$i = 0;
		foreach ( $categories as $cat ) {
			if ( $cat->cat_ID == get_option('default_category') || $cat->cat_ID == stms_isset($stms['support']['kb_category']) )
				continue;
				
			$alternate = ($i%2) ? 'alternate ' : '';
			$product_id = (int) $product_id;
			$protect = $wpdb->get_row($wpdb->prepare("SELECT * FROM `{$wpdb->prefix}stms_protects` WHERE `type` = %s AND `cat_id` = %d AND `product_id` = %d", 'categories', $cat->cat_ID, $product_id));
			$dripmodes = array(
				'day' => 'Day(s)',
				'week' => 'Week(s)',
				'month' => 'Month(s)',
				'year' => 'Year(s)',
				'exact' => 'Exact Date (mm/dd/yyyy)'
			);
			$checked = '';
			$drip_start = 0;
			$drip_end = 30;
			$exp_checked = '';
			$readonly = ' readonly';
			$disabled = ' disabled';
			$exp_disabled = ' disabled';
			$display = " style='display:none'";
			if ( $protect ) {
				$checked = ' checked="checked"';
				$drip_start = ( isset($protect->drip_start) ) ? $protect->drip_start : 0;
				$drip_end = ( isset($protect->drip_end) ) ? $protect->drip_end : 30;
				$exp_checked = ( stms_isset($protect->is_expired) == 1 ) ? ' checked="checked"' : '';
				$readonly = '';
				$disabled = '';
				$exp_disabled = '';
				$display = ( stms_isset($protect->is_expired) == 1 ) ? '' : " style='display:none'";
			}

			echo "<tr class='{$alternate}iedit'>";
			echo "<th scope='row' class='check-column'>";
			echo "<input type='checkbox' class='stms_enable_protect' name='stms_cat_protect[protect_id][{$i}]' value='{$cat->cat_ID}'{$checked}>";
			echo "<input type='hidden' class='protect-removed' name='stms_cat_protect[is_removed][{$i}]' value='no' />";
			echo "<input type='hidden' name='stms_cat_protect[cat_id][{$i}]' value='{$cat->cat_ID}' />";
			echo "</th>";
			echo "<td><strong>{$cat->name}</strong></td>";
			echo "
			<td>
				<input type='text' class='protect-drip-start protect-date-field' name='stms_cat_protect[drip_start][{$i}]' value='{$drip_start}' style='width:80px'{$readonly} />
				<select name='stms_cat_protect[drip_start_mode][{$i}]' class='protect-drip-start-mode protects-date' style='width:100px'{$disabled}>
			";
			
			foreach ( $dripmodes as $k => $v ) {
				$selected = ( empty($disabled) && stms_isset($protect->drip_start_mode) == $k ) ? ' selected="selected"' : '';
				echo "<option value='{$k}'{$selected}>{$v}</option>";
			}

			echo "
				</select>
			</td>
			";
			
			echo "
			<td>
				<div class='stms-exp-val'{$display}><input class='protect-drip-end protect-date-field' type='text' name='stms_cat_protect[drip_exp][{$i}]' value='{$drip_end}' style='width:80px' />
				<select name='stms_cat_protect[drip_end_mode][{$i}]' class='protect-drip-end-mode protects-date' style='width:100px'>
			";
			
			foreach ( $dripmodes as $k => $v ) {
				$selected = ( empty($exp_disabled) && stms_isset($protect->drip_end_mode) == $k ) ? ' selected="selected"' : '';
				echo "<option value='{$k}'{$selected}>{$v}</option>";
			}

			echo "
				</select>
			</div>
				<label for='smts-enable-exp-{$i}'><input type='checkbox' name='stms_cat_protect[drip_enable_exp][{$i}]' id='smts-enable-exp-{$i}' class='smts-enable-exp' value='1'{$exp_checked}{$exp_disabled} /> <code>Enable Expiration</code></label>
			</td>
			";
			echo "</tr>";
			$i++;
		}
	} else {
		echo "<tr class='iedit'>";
		echo "<td colspan='4'>No category found</td>";
		echo "</tr>";
	}
}

function stms_get_protected_contents( $type = 'posts', $product_id = 0, $perpage = 15 ) {
	global $wpdb;
	
	$stms = get_option('stms_settings');
	$slugs = get_option('stms_slugs');
	$handlers = array();
	
	if ( is_array($slugs) ) {
		foreach ( $slugs as $k => $v ) {
			$handlers[] = $v;
		}
	}
	
	$offset = ( isset($_REQUEST[$type . '_paged']) ) ? $_REQUEST[$type . '_paged'] - 1 : 0;
	if ( $offset < 0 ) $offset = 0;
	$offset = $offset * $perpage;
		
	$post_args = array(
			'numberposts' => $perpage,
			'offset' => $offset,
			'post_status' => 'publish'
	);
	
	$page_args = array(
		'numberposts' => $perpage,
		'offset' => $offset,
		'post_status' => 'publish',
		'orderby' => 'date',
		'order' => 'DESC',
		'post_type' => 'page'
	);
	
	$args = ( $type == 'posts' ) ? $post_args : $page_args;
	$posts = get_posts($args);

	if ( $posts && count($posts) > 0 ) {
		$i = 0;
		foreach ( $posts as $post ) {
			if ( stms_isset($stms['global']['magic']) == $post->ID || stms_isset($stms['global']['home']) == $post->ID || in_array($post->ID, $handlers) )
				continue;
			 
			$alternate = ($i%2) ? 'alternate ' : '';
			$product_id = (int) $product_id;
			//$protect = $wpdb->get_row($wpdb->prepare("SELECT * FROM `{$wpdb->prefix}stms_protects` WHERE `post_id` = %d AND `product_id` = %d", $post->ID, $product_id));
			$lock = stms_get_contentdrip( $product_id, $post->ID );
			$dripmodes = array(
				'day' => 'Day(s)',
				'week' => 'Week(s)',
				'month' => 'Month(s)',
				'year' => 'Year(s)',
				'exact' => 'Exact Date (mm/dd/yyyy)'
			);
			
			$checked = '';
			$drip_start = 0;
			$drip_end = 30;
			$exp_checked = '';
			$readonly = ' readonly';
			$disabled = ' disabled';
			$exp_disabled = ' disabled';
			$display = " style='display:none'";
			if ( $lock && count($lock) > 0 ) {
				$checked = ' checked="checked"';
				$drip_start = ( isset($lock->drip_start) ) ? $lock->drip_start : 0;
				$drip_end = ( isset($lock->drip_end) ) ? $lock->drip_end : 30;
				$exp_checked = ( stms_isset($lock->is_expired) == 1 ) ? ' checked="checked"' : '';
				$readonly = '';
				$disabled = '';
				$exp_disabled = '';
				$display = ( stms_isset($lock->is_expired) == 1 ) ? '' : " style='display:none'";
			}

			echo "<tr class='{$alternate}iedit'>";
			echo "<th scope='row' class='check-column'>";
			echo "<input type='checkbox' class='stms_enable_protect' name='stms_post_protect[protect_id][{$i}]' value='{$post->ID}'{$checked}>";
			echo "<input type='hidden' class='protect-removed' name='stms_post_protect[is_removed][{$i}]' value='no' />";
			echo "<input type='hidden' name='stms_post_protect[post_id][{$i}]' value='{$post->ID}' />";
			echo "</th>";
			echo "<td>";
			echo "<strong>{$post->post_title}</strong></td>";
			echo "
			<td>
				<input type='text' class='protect-drip-start protect-date-field' name='stms_post_protect[drip_start][{$i}]' value='{$drip_start}' style='width:80px'{$readonly} />
				<select name='stms_post_protect[drip_start_mode][{$i}]' class='protect-drip-start-mode protects-date' style='width:100px'{$disabled}>
			";

			foreach ( $dripmodes as $k => $v ) {
				$selected = ( empty($disabled) && stms_isset($lock->drip_start_mode) == $k ) ? ' selected="selected"' : '';
				echo "<option value='{$k}'{$selected}>{$v}</option>";
			}

			echo "
				</select>
			</td>
			";
			
			echo "
			<td>
				<div class='stms-exp-val'{$display}><input class='protect-drip-end protect-date-field' type='text' name='stms_post_protect[drip_exp][{$i}]' value='{$drip_end}' style='width:80px' />
				<select name='stms_post_protect[drip_end_mode][{$i}]' class='protect-drip-end-mode protects-date' style='width:100px'>
			";
			
			foreach ( $dripmodes as $k => $v ) {
				$selected = ( empty($exp_disabled) && stms_isset($lock->drip_end_mode) == $k ) ? ' selected="selected"' : '';
				echo "<option value='{$k}'{$selected}>{$v}</option>";
			}

			echo "
				</select>
			</div>
				<label for='smts-enable-exp-{$i}'><input type='checkbox' name='stms_post_protect[drip_enable_exp][{$i}]' id='smts-enable-exp-{$i}' class='smts-enable-exp' value='1'{$exp_checked}{$exp_disabled} /> <code>Enable Expiration</code></label>
			</td>
			";
			echo "</tr>";
			$i++;
		}
	} else {
		echo "<tr class='iedit'>";
		echo "<td colspan='4'>No {$type} available</td>";
		echo "</tr>";
	}
}

function stms_get_contentdrip( $product_id, $post_id ) {
	if ( !is_numeric($post_id) || !is_numeric($product_id) )
		return false;
		
	//$cached = wp_cache_get($product_id, 'stms_protected_contents');
	//if ( isset($cached[$post_id]) )
		//return $cached[$post_id];
	
	global $wpdb;
	$protects = $wpdb->get_results($wpdb->prepare("SELECT * FROM `{$wpdb->prefix}stms_protects` WHERE `product_id` = %d AND `type` = %s", $product_id, 'content'));

	if ( !$protects || count($protects) <= 0 )
		return false;

	$data = array();
	foreach ( $protects as $protect ) {
		$data[$protect->post_id] = $protect;
	}

	wp_cache_set($product_id, $data, 'stms_protected_contents');
	return ( isset($data[$post_id]) ) ? $data[$post_id] : false;
}

function stms_products_multiselect( $id = 'product', $num_id = 0, $size = 5 ) {
	$id = $id . $num_id;
	$html = '<select name="' . $id . '" id="' . $id . '" multiple="multiple" size="' . $size . '">';	
	if ( $products = stms_get_products() ) {
		foreach ( $products as $product ) {
			$html .= "<option value='{$product->ID}'>" . stms_sanitize($product->title) . "</option>";
		}
	}
	$html .= '</select>';
	return $html;
}

function stms_dripfeed_dialog( $mode = 'page', $title = '', $num_id = 0 ) {
	$dripmodes = array(
		'day' => 'Day(s)',
		'week' => 'Week(s)',
		'month' => 'Month(s)',
		'year' => 'Year(s)',
		'exact' => 'Exact Date (mm/dd/yyyy)'
	);
			
	$html = '<input type="button" id="stms_drip_btn' . $num_id . '" class="stms-drip-btn button" value="Open Settings" data-select="content_access' . $num_id . '" />';
	$html .= '<div style="display:none"><div class="stms-drip-box" style="padding:5px 20px 15px">';
	$html .= '<h3>Drip-Feed Settings &raquo; ' . $mode . ' &raquo; ' . stms_cleanup($title) . '</h3>';
	$html .= '<table class="form-table">
				<tr valign="top">
					<th scope="row" style="text-align:right"><label><strong><span style="color:#cc0000">*</span> Choose Product</strong></label></th>
					<td>
	';
	$html .= '<select class="stms-field widefat drip-product">';
	$html .= '<option value="">[ -- Select a Product -- ]</option>';
	if ( $products = stms_get_products() ) {
		foreach ( $products as $product ) {
			$html .= "<option value='{$product->ID}'>" . stms_sanitize($product->title) . "</option>";
		}
	}
	$html .= '</select>
					</td>
					</th>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label><strong>' . $mode . ' Available In: </strong></label></th>
					<td>
	';
	$html .= '<input type="text" class="stms-field drip-start" value="0" style="width:120px" />&nbsp;&nbsp;<select class="stms-field drip-start-mode" style="width:auto">';
	if ( $dripmodes ) {
		foreach ( $dripmodes as $k => $v ) {
			$html .= "<option value='{$k}'>" . stms_sanitize($v) . "</option>";
		}
	}
	$html .= '</select>
					</td>
					</th>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label><strong>' . $mode . ' Expire In: </strong></label></th>
					<td>
	';
	$html .= '<input type="text" class="stms-field drip-expire" value="0" style="width:120px" />&nbsp;&nbsp;<select class="stms-field drip-expire-mode" style="width:auto">';
	if ( $dripmodes ) {
		foreach ( $dripmodes as $k => $v ) {
			$html .= "<option value='{$k}'>" . stms_sanitize($v) . "</option>";
		}
	}
	$html .= '</select>
					</td>
					</th>
				</tr>
			</table>
	';
	$html .= '</div></div>';
	
	return $html;
}

add_action('stms_settings_saved', 'stms_icontact_connect', 10, 2);
function stms_icontact_connect( $config, $post ) {
	if ( $config != 'integration' )
		return false;
	
	$stms = get_option('stms_settings');
	$api_key = stms_isset($stms['integration']['ic']['api_key']);
	$api_pass = stms_isset($stms['integration']['ic']['pass']);
	$username = stms_isset($stms['integration']['ic']['username']);
	
	if ( empty($api_key) || empty($api_pass) || empty($username) )
		return false;
	 
	$ic_token = get_option('stms_icontact_token');
	if ( is_array($ic_token) && count($ic_token) > 0 )
		return false;
	
	require_once(STMS_SOURCES . 'icontact.php');
	$config = array('apiKey' => trim($api_key), 'username' => trim($username), 'password' => trim($api_pass));
	
	// get account id
	$call = callResource($config, '/a', 'GET');
	$accountId = ( $call['code'] == 200 ) ? stms_isset($call['data']['accounts'][0]['accountId']) : '';
	$resource = "/a/{$accountId}/c/";
	// get client folder id
	$call = callResource($config, $resource, 'GET');
	$clientFolderId = ( $call['code'] == 200 ) ? stms_isset($call['data']['clientfolders'][0]['clientFolderId']) : '';
	
	$token = array('account_id' => $accountId, 'folder_id' => $clientFolderId);
	update_option('stms_icontact_token', $token);

	return true;
}

function stms_admin_access_log() {
	$log = get_option('stms_payment_log');
	if ( !empty($log['content']) ) return true;
	return false;
}

function stms_reload_lists( $ar, $product_id = 0 ) {
	$stms_lists = get_option('stms_ar_lists');
	if ( !is_array($stms_lists) )
		$stms_lists = array();
	
	if ( $ar == 'aweber' )
		$stms_lists['aweber'] = stms_update_aweber_lists();
	if ( $ar == 'gr' )
		$stms_lists['gr'] = stms_update_gr_lists();
	if ( $ar == 'mc' )
		$stms_lists['mc'] = stms_update_mc_lists();
	if ( $ar == 'cc' )
		$stms_lists['cc'] = stms_update_cc_lists();
	if ( $ar == 'ic' )
		$stms_lists['ic'] = stms_update_ic_lists();
	if ( $ar == 'imc' )
		$stms_lists['imc'] = stms_update_imc_lists();
	if ( $ar == 'sr' )
		$stms_lists['sr'] = stms_update_sr_lists();
	
	update_option('stms_ar_lists', $stms_lists);
	if ( $product_id )
		$url = admin_url('admin.php?page=stms-settings') . '#level|mode=edit&arlist=reloaded&object_ID=' . $product_id;
	else
		$url = admin_url('admin.php?page=stms-settings') . '#config';
	
	@header('Location:' . $url);
	exit;
}

add_action('stms_settings_saved', 'stms_update_lists', 20, 2);
function stms_update_lists( $config, $post ) {
	if ( $config != 'integration' )
		return false;
		
	$memory_limit = ( defined(WP_MEMORY_LIMIT) ) ? WP_MEMORY_LIMIT : '32M';
	$memory_limit = str_replace('M', '', $memory_limit);
	
	if ( $memory_limit > 64 || $memory_limit = -1 ) {
		$stms = get_option('stms_settings');
		$stms_lists = get_option('stms_ar_lists');
		if ( !is_array($stms_lists) )
			$stms_lists = array();
		
		if ( get_option('stms_aweber_token') !== FALSE && ( (empty($stms['integration']['aweber']['consumer_key']) || empty($stms['integration']['aweber']['secret_key'])) ) )
			delete_option('stms_aweber_token');
		
		if ( get_option('stms_constant_token') !== FALSE && ( (empty($stms['integration']['cc']['consumer_key']) || empty($stms['integration']['cc']['secret_key'])) ) )
			delete_option('stms_constant_token');
	
		if ( !isset($stms_lists['aweber']) )
			$stms_lists['aweber'] = stms_update_aweber_lists();
		if ( !isset($stms_lists['gr']) )
			$stms_lists['gr'] = stms_update_gr_lists();
		if ( !isset($stms_lists['mc']) )
			$stms_lists['mc'] = stms_update_mc_lists();
		if ( !isset($stms_lists['cc']) )
			$stms_lists['cc'] = stms_update_cc_lists();
		if ( !isset($stms_lists['ic']) )
			$stms_lists['ic'] = stms_update_ic_lists();
		if ( !isset($stms_lists['imc']) )
			$stms_lists['imc'] = stms_update_imc_lists();
		if ( $ar == 'sr' )
			$stms_lists['sr'] = stms_update_sr_lists();
		
		update_option('stms_ar_lists', $stms_lists);
	}
}

function stms_time_range( $first, $last, $step = '+1 day' ) {
	$times = array();
	$current = strtotime($first);
	$last = strtotime($last);

	while( $current <= $last ) {
		$temp = array();
		$temp[] = $current;
		$current = strtotime($step, $current);
		$temp[] = $current;
		$times[] = $temp;
	}
	return $times;
}

function stms_weekly_income() {
	global $wpdb;
	
	$first = date("Y/m/d", strtotime("7 days ago", stms_time()));
	$last = date("Y/m/d", stms_time());
	
	$lines = array();
	$times = stms_time_range($first, $last);
	foreach ( $times as $time ) {
		$earn = $wpdb->get_row(
			$wpdb->prepare(
				"SELECT SUM(amount) AS total FROM `{$wpdb->prefix}stms_transactions` 
				WHERE `status` = 'completed' AND `paid` = 1
				AND `date` BETWEEN %d AND %d",
				$time[0], $time[1]
			)
		);
		$total = ( !$earn->total ) ? 0 : $earn->total;
		$lines[] = "['" . date("M d", $time[0]) . "', {$total}]";
	}
	return implode(",", $lines);
}

function stms_weekly_signups() {
	global $wpdb;
	
	$first = date("Y/m/d", strtotime("7 days ago", stms_time()));
	$last = date("Y/m/d", stms_time());
	
	$lines = array();
	$times = stms_time_range($first, $last);
	foreach ( $times as $time ) {
		$count = $wpdb->get_var(
			$wpdb->prepare(
				"SELECT COUNT(*) FROM `{$wpdb->prefix}stms_members` 
				WHERE `status` = 1 AND `date` BETWEEN %d AND %d",
				$time[0], $time[1]
			)
		);
		$lines[] = "['" . date("M d", $time[0]) . "', {$count}]";
	}
	return implode(",", $lines);
}

add_action('admin_footer', 'stms_addons_js');
function stms_addons_js() {
	if ( isset($_GET['page']) && $_GET['page'] == 'stms-settings' ) {
?>
<script>
	function _stms_addons_js() {
		<?php do_action('insta_addons_js'); ?>
	}
</script>
<?php
	}
}

add_action('admin_footer', 'stms_jqplot');
function stms_jqplot() {
	if ( isset($_GET['page']) && $_GET['page'] == 'stms-settings' ) {
?>
<script>
	function _stms_jqplot() {
		var line1 = [<?php echo stms_weekly_income(); ?>];
		var line2 = [<?php echo stms_weekly_signups(); ?>];
		jQuery.jqplot('stms-dashboard-chart', [line1, line2], {
			series:[{
					renderer:jQuery.jqplot.BarRenderer,
					rendererOptions: {barWidth: 20},
					label:'Income',
					showLabel:true,
					color: '#89A54E',
					highlighter: {
						sizeAdjust:2.5,
						formatString: '%.2f',
					}
				},{
					xaxis:'xaxis',
					yaxis:'y2axis',
					label:'New Members',
					showLabel:true,
					color: '#4a4a4a',
					fill:true,
					fillAndStroke:true,
					fillColor: '#4a4a4a',
					fillAlpha: 0.25,
					shadow:false,
					highlighter: {
						formatString: '%d',
					}
				}
			],
			title: {
				text: 'Last 7 Days Income & New Members'
			},
			axes: {
				xaxis: {
				  renderer:jQuery.jqplot.CategoryAxisRenderer,
				  tickRenderer: jQuery.jqplot.CanvasAxisTickRenderer,
				  tickOptions: {
	                angle: 30,
	                fontBold:false,
	                fontSize:'9pt',
	              }
				},
				yaxis: {
					autoscale:true,
					padMin:0,
					tickOptions:{
						formatString:'%.2f',
					},
					labelRenderer: jQuery.jqplot.CanvasAxisLabelRenderer,
					label:'Income',
					labelOptions: {
						fontSize:'11pt',
						fontBold:true,
						textColor:'#89A54E',
					}
				},
				y2axis: {
					//tickInterval:10,
					autoscale:true,
					
					padMin:0,
					tickOptions:{
						formatString:'%d',
					},
					labelRenderer: jQuery.jqplot.CanvasAxisLabelRenderer,
					label:'New Members',
					labelOptions: {
						fontSize:'11pt',
						fontBold:true,
						textColor:'#212121',
						angle:90,
					}
				}
			},
			highlighter: {
				show:true,
				tooltipAxes:'y',
				bringSeriesToFront:false,
			},
			legend: {
				show:true,
				location:'ne',
				placement:'insideGrid'
			},
			grid: {
				drawGridlines:false,
				borderWidth:0.25,
				shadow:false,
			}
		});
	}
</script>
<?php
	}
}

function stms_admin_tabs( $control ) {
	$defaults = stms_get_admin_files();
	$admin_tabs = ( stms_log_payment() ) ? apply_filters('insta_admin_tabs', $defaults) : $defaults;
	foreach ( $admin_tabs as $key => $value ) {
		if ( $control != '' )
			$tab_selected = ( $control == $key ) ? ' stms-tab-selected' : '';
		else
			$tab_selected = ( $control == 'dashboard' ) ? ' stms-tab-selected' : '';
		echo "<li class='{$key}'><a href='#' data-tab='{$key}' class='stms-tab tab-{$key}{$tab_selected}'>{$value}</a></li>";
	}
}

function insta_insert_tab_after( &$haystack, $needle = '', $stuff ) {
	if ( !is_array($haystack) ) return $haystack;

	$new_array = array();
	for ( $i = 2; $i < func_num_args(); ++$i ) {
		$arg = func_get_arg($i);
		if ( is_array($arg) ) $new_array = array_merge($new_array, $arg);
		else $new_array[] = $arg;
	}
	
	$i = 0;
	foreach ( $haystack as $key => $value ) {
		++$i;
		if ( $key == $needle ) break;
	}
	
	$haystack = array_merge(array_slice($haystack, 0, $i, true), $new_array, array_slice($haystack, $i, null, true));

	return $i;
}

add_action('admin_init', 'stms_view_log');
function stms_view_log() {
	if ( isset($_GET['page']) && $_GET['page'] == 'stms-settings' && !empty($_GET['insta_admin_log']) ) {
		global $wpdb;
			
		$mode = $_GET['insta_admin_log'];
		if ( $mode == 'view_ipn') {
			$sql = "SELECT * FROM `{$wpdb->prefix}stms_ipn_log` ORDER BY `log_id` DESC LIMIT 30";
		} else {
			$sql = "SELECT * FROM `{$wpdb->prefix}stms_error_log` ORDER BY `log_id` DESC LIMIT 30";
		}
		
		if ( $logs = $wpdb->get_results($sql) ) {
			if ( isset($logs->postdata) )
				$logs->postdata = maybe_unserialize($logs->postdata);
			
			stms_dump($logs);
			exit;
		}
	}
}