<?php
require_once( STMS_ADMIN . 'admin-functions.php' );
require_once( STMS_ADMIN . 'admin-ajax.php' );

add_action('admin_init', 'stms_global_vars');
function stms_global_vars() {
	$GLOBALS['stms_total_affcomm'] = 0;
	$GLOBALS['stms_total_affvoid'] = 0;
}

add_action('admin_init', 'stms_unregister_conflicts', 99);
function stms_unregister_conflicts() {
	if ( isset($_GET['page']) && $_GET['page'] == 'stms-settings' ) {
		wp_deregister_script('wpas_javascript');
		wp_deregister_script('prefix-style3');
		wp_deregister_script('register');
		wp_deregister_script('amazonCustomJs');
		wp_deregister_style('prefix-style1');
		wp_deregister_style('prefix-style2');
	}
}

function stms_admin_scripts() {
	// load js for admin page
	wp_enqueue_script('jquery');
	wp_enqueue_script('jquery-ui-core');
	wp_enqueue_script('jquery-ui-datepicker');
	if ( isset($_GET['page']) && $_GET['page'] == 'stms-settings' ) {
		wp_enqueue_script('jquery-cookie', STMS_URL . 'js/jquery.cookie.js', array('jquery'));
		wp_enqueue_script('jquery-ui-widget');
		wp_enqueue_script('jquery-ui-sortable');
		wp_enqueue_script('jquery-ui-tabs');
		wp_enqueue_script('jquery-ui-accordion');
		wp_enqueue_script('ba-hashchange', STMS_URL . 'js/jquery.ba-hashchange.min.js', array('jquery'));
		wp_enqueue_script('colorbox', STMS_URL . 'js/colorbox/jquery.colorbox-min.js', array('jquery'));
		wp_enqueue_script('jquery-validation', STMS_URL . 'js/jquery.validate.js', array('jquery'));
		wp_enqueue_script('jquery-caret', STMS_URL . 'js/jquery.caret.js', array('jquery'), '1.0.0', true);
		wp_enqueue_script('jquery-qtip', STMS_URL . 'js/qtip2/jquery.qtip.min.js', array('jquery'), '2.0.1', true);
		wp_enqueue_script('jquery-multiselect', STMS_URL . 'js/multiselect/jquery.multiselect.min.js', array('jquery', 'jquery-ui-core', 'jquery-ui-widget'), '2.14', true);
		
		wp_enqueue_script('stms-admin', STMS_URL . 'js/admin.js', array('jquery'));
		wp_enqueue_script('stms-settings', STMS_URL . 'js/settings.js', array('jquery'), '1.0.0', true);
		wp_localize_script('stms-admin', 'stmsAdminURI', get_bloginfo('wpurl'));
		
		// jqplot start
		wp_enqueue_script('jqplot', STMS_URL . 'js/jqplot/jquery.jqplot.min.js', array('jquery'));
		wp_enqueue_script('jqplot-highlighter', STMS_URL . 'js/jqplot/jqplot.highlighter.min.js');
		wp_enqueue_script('jqplot-canvasTextRenderer', STMS_URL . 'js/jqplot/jqplot.canvasTextRenderer.min.js');
		wp_enqueue_script('jqplot-barRenderer', STMS_URL . 'js/jqplot/jqplot.barRenderer.min.js');
		wp_enqueue_script('jqplot-canvasAxisTickRenderer', STMS_URL . 'js/jqplot/jqplot.canvasAxisTickRenderer.min.js');
		wp_enqueue_script('jqplot-canvasAxisLabelRenderer', STMS_URL . 'js/jqplot/jqplot.canvasAxisLabelRenderer.min.js');
		wp_enqueue_script('jqplot-categoryAxisRenderer', STMS_URL . 'js/jqplot/jqplot.categoryAxisRenderer.min.js');
		
		wp_enqueue_media();
		
		do_action('insta_admin_scripts');
	} else {
		wp_enqueue_script('stms-meta', STMS_URL . 'js/admin-meta.js', array('jquery'));
	}
}

function stms_admin_styles() {
	// load css for admin page
	wp_enqueue_style('droid-sans', 'http://fonts.googleapis.com/css?family=Droid+Sans:400,700');
	wp_enqueue_style('stms-admin', STMS_URL . 'css/admin.css');
	wp_enqueue_style('jqueryui-base', STMS_URL . 'css/jqueryui/base/jquery.ui.all.css');
	if ( isset($_GET['page']) && $_GET['page'] == 'stms-settings' ) {
		wp_enqueue_style('colorbox', STMS_URL . 'js/colorbox/colorbox.css');
		wp_enqueue_style('jquery-qtip', STMS_URL . 'js/qtip2/jquery.qtip.css');
		wp_enqueue_style('jquery-multiselect', STMS_URL . 'js/multiselect/jquery.multiselect.css');
		wp_enqueue_style('jqplot', STMS_URL . 'js/jqplot/jquery.jqplot.min.css');
		
		do_action('insta_admin_styles');
	}
}

add_action('admin_menu', 'stms_add_admin');
function stms_add_admin() {
	$stms = add_menu_page('InstaMember', 'InstaMember', 'manage_options', 'stms-settings', 'stms_admin', STMS_URL . 'images/main-icon.png');

	add_action( "admin_print_scripts-$stms", 'stms_admin_scripts' );
	add_action( "admin_print_styles-$stms", 'stms_admin_styles' );

	add_action("admin_print_scripts-post.php", 'stms_admin_scripts');
	add_action("admin_print_scripts-post-new.php", 'stms_admin_scripts');
	add_action("admin_print_styles-post.php", 'stms_admin_styles');
	add_action("admin_print_styles-post-new.php", 'stms_admin_styles');
}

function stms_admin() {
	$page = ( isset($_GET['page']) ) ? $_GET['page'] : '';

	switch ( $page ) {
		case 'stms-settings':
			stms_settings();
		break;
	}
}

function stms_settings() {
	global $stms_total_affcomm, $stms_total_affvoid;
	
	require_once( STMS_CLASSES . 'stmsMemberLevel.php' );
	require_once( STMS_CLASSES . 'stmsMemberList.php' );
	require_once( STMS_CLASSES . 'stmsMemberPayments.php' );
	require_once( STMS_CLASSES . 'stmsSalesReport.php' );
	require_once( STMS_CLASSES . 'stmsAffReport.php' );
	require_once( STMS_CLASSES . 'stmsAffPayouts.php' );
	require_once( STMS_CLASSES . 'stmsLicenseUsage.php' );
	require_once( STMS_CLASSES . 'stmsLicenseLog.php' );
	require_once( STMS_CLASSES . 'stmsAccessLog.php' );
	require_once( STMS_CLASSES . 'stmsAccessContent.php' );
	require_once( STMS_CLASSES . 'stmsMemberComms.php' );
	require_once( STMS_ADMIN . 'settings.php' );
}

function stms_add_tinymce_btn() {
	// Don't bother doing this stuff if the current user lacks permissions
	if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
		return;
 
	// Add only in Rich Editor mode
	if ( get_user_option('rich_editing') == 'true') {
		add_filter('mce_external_plugins', 'stms_tinymce_js');
		if ( defined('PT_REL_SCRIPTS') || defined('PVM_PATH') || defined('OPL_BASENAME') )
			add_filter('mce_buttons', 'stms_reg_tinymce_btn');
		else
			add_filter('mce_buttons_3', 'stms_reg_tinymce_btn');
	}
}
 
function stms_reg_tinymce_btn($buttons) {
	array_unshift($buttons, "instamember");
	return $buttons;
}
 
function stms_tinymce_js($plugin_array) {
	$plugin_array['instamember'] = STMS_URL . 'js/shortcodes.js';
	return $plugin_array;
}

if ( stms_log_payment() ) {
	add_action('init', 'stms_add_tinymce_btn');
	add_action('admin_init', 'stms_add_meta_box');
}

add_action('admin_init', 'stms_admin_logger_bridge');
function stms_admin_logger_bridge() {
	if ( isset($_POST['action']) && $_POST['action'] == 'stms_instabridge_save' ) {
		$logger_key = 'nCgiCnsQITzqh8wOJu0X0xr7phInYvxV';
		$bridge_key = trim($_POST['stms_bridge_key']);
		$md5_hash = md5($bridge_key . $logger_key);
		$bridge_url = "http://insta-member.com/!/instamember_api/license/{$bridge_key}";
		$hostname = @gethostbyaddr($_SERVER['SERVER_ADDR']);
		$data = array(
			'domain' => $_SERVER['HTTP_HOST'],
			'userip' => $_SERVER['REMOTE_ADDR'],
			'servip' => ( $hostname ) ? $hostname : $_SERVER['SERVER_ADDR']
		);
			
		$muatan_lokale = ( $_SERVER['HTTP_HOST'] == 'localhost' || $_SERVER['HTTP_HOST'] == '127.0.0.1' ) ? TRUE : FALSE;
		$result = wp_remote_post($bridge_url, array(
				'method' => 'POST',
				'timeout' => 45,
				'redirection' => 5,
				'httpversion' => '1.1',
				'blocking' => true,
				'headers' => array(
					'Authorization' => 'Basic ' . base64_encode( $logger_key . ':' . $md5_hash )
				),
				'body' => $data,
				'cookies' => array()
		    )
		);

		$use_curl = false;
		if ( is_wp_error($result) ) {
			$error_message = $result->get_error_message();
			$use_curl = true;
		} else {
			$response = json_decode($result['body']);
		}
		
		if ( $use_curl && function_exists('curl_init') ) {
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $bridge_url);
			curl_setopt($ch, CURLOPT_USERPWD, "{$logger_key}:{$md5_hash}");
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
			curl_setopt($ch, CURLOPT_TIMEOUT, 90);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
			$result = curl_exec($ch);
			$response = json_decode($result);
		}
			
		if ( (isset($response->status) && $response->status == 'Success') || $muatan_lokale ) {
			$data = array(
				'content' => $bridge_key,
			);
			update_option('stms_payment_log', $data);
			$msg = 'activation=true';
		} else {
			$msg = 'activation=failed';
		}
		@header( 'Location: ' . admin_url('admin.php?page=stms-settings') . '#dashboard|' . $msg);
		exit;
	}	
}

add_action('admin_init', 'stms_show_pdf');
function stms_show_pdf() {
	if ( isset($_GET['insta_pdf']) ) {
		$expire = 43200;
		$pdf = ( $_GET['insta_pdf'] == 'salesflow' ) ? 'upsells' : $_GET['insta_pdf'];
		$local_path = INSTA_PDF_PATH . "instamember-{$pdf}.pdf";
		$local_url = INSTA_PDF_INT . "instamember-{$pdf}.pdf";
		$ext_url = INSTA_PDF_EXT . "instamember-{$pdf}.pdf";
		$pdf_url = $ext_url;
		$download = false;
		
		if ( is_writable(INSTA_PDF_PATH) && function_exists('curl_init') && function_exists('file_put_contents') )
			$download = true;
		
		if ( file_exists($local_path) ) {
			if ( filemtime($local_path) < (time() - $expire) ) {
				if ( $download )
					@unlink($local_path);
			} else {
				$pdf_url = $local_url;
				$download = false;
			}
		}
		
		if ( $download ) {
			$ch = curl_init($ext_url);
		    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		    $data = curl_exec($ch);
		    curl_close($ch);
		    @file_put_contents($local_path, $data);
			
			$pdf_url = ( file_exists($local_path) ) ? $local_url : $ext_url;
		}
		
		wp_redirect($pdf_url);
		exit;
	}
}
