<?php
$report_title = 'Today Report';
if ( stms_isset($_GET['range']) ) {
	switch ( $_GET['range'] ) {
		case 'yesterday':
			$report_title = 'Yesterday Affiliate Stats';
			break;
		case 'week':
			$report_title = 'Last 7 Days Affiliate Stats';
			break;
		case 'month':
			$report_title = 'Last 30 Days Affiliate Stats';
			break;
		case 'all':
			$report_title = 'All Time Affiliate Stats';
			break;
	}
}

if ( stms_isset($_GET['s']) != '' ) {
	$keyword = urldecode(stms_cleanup($_GET['s']));
	$report_title = 'Keyword: <span style="color:#c4581c"><strong>"' . $keyword . '"</strong></span><br />';
}

if ( isset($_GET['start']) ) {
	$def_start = strtotime($admin->user_registered, stms_time());
	if ( !isset($_GET['s']) ) $report_title = '';
	$start = ( !empty($_GET['start']) ) ? strtotime($_GET['start'], stms_time()) : $def_start;
	$end = ( !empty($_GET['end']) ) ? strtotime($_GET['end'], stms_time()) : stms_time();
	$start_date = date("F d, Y", $start);
	$end_date = ' - ' . date("F d, Y", $end);
	$periods = $start_date . $end_date;
	$report_title .= 'Period: <span style="color:#c4581c"><strong>' . $periods . '</strong></span><br />';
}

if ( stms_isset($_GET['product_id']) != '' ) {
	if ( $afprod = stms_get_product($_GET['product_id']) ) {
		$report_title .= 'Product: <span style="color:#c4581c"><strong>' . stms_cleanup($afprod->title) . '</strong></span>';
	}
}
?>
<div class="stms-admin-block">
	<h2 class="stms-field-title">Affiliates Stats</h2>
	<div id="member-edit-submenu" class="stms-desc" style="text-align:right">
		<ul id="stms-submenu">
			<li><a href="#affstats|mode=payouts"><strong>Payouts</strong></a></li>
			<li><a href="#affstats" class="stms-submenu-active"><strong>Affiliate Stats</strong></a></li>
			<li>Sub-Menu:</li>
		</ul>
		<br style="clear:right" />
	</div>

	<div class="stms-report-searchbox">
		<input type="hidden" id="stms-report-control" value="affstats" />
		<input type="hidden" id="stms-report-mode" value="<?php echo stms_isset($_GET['mode'], 'stats'); ?>" />
		<div>
			<strong>Quick Search: </strong>&nbsp;&nbsp;
			<select id="stms-search-range" class="stms-field">
				<option value=''>[ - Choose Range - ]</option>
				<?php foreach ( $ranges as $key => $val ) {
					$selected = ( !isset($_GET['start']) && stms_isset($_GET['range'], 'today') == $key ) ? ' selected="selected"' : '';
					echo "<option value='{$key}'{$selected}>{$val}</option>";
				} ?>
			</select>
		</div>
		<div>
			<strong>Start Date: </strong>&nbsp;&nbsp;
			<input type="text" id="stms-search-start" class="stms-field" value="<?php echo stms_isset($_GET['start']); ?>" style="width:90px" />&nbsp;&nbsp;
			<strong>End Date: </strong>&nbsp;&nbsp;
			<input type="text" id="stms-search-end" class="stms-field" value="<?php echo stms_isset($_GET['end']); ?>" style="width:90px" />&nbsp;&nbsp;
			<strong>Affiliate: </strong>&nbsp;&nbsp;
			<input type="text" id="stms-search-s" class="stms-field" value="<?php echo stms_cleanup($_GET['s']); ?>" style="width:200px" />&nbsp;&nbsp;
		</div>
		<div>
			<strong>Search Filter: </strong>&nbsp;&nbsp;
			<select id="stms-search-product" class="stms-field" style="width:160px">
				<option value=""> -- All Products -- </option>
				<?php
				if ( $products ) {
					foreach ( $products as $product ) {
						$selected = ( stms_isset($_GET['product_id']) == $product->ID ) ? ' selected="selected"' : '';
						echo "<option value='{$product->ID}'{$selected}>$product->title</option>";
					}
				}
				?>
			</select>&nbsp;&nbsp;
			<input type="button" id="stms-search-btn" value="Search" class="button-primary" />
		</div>
	</div>
	
	<div class="stms-admin-block">
		<h3 style="padding-bottom:0;margin-bottom:0"><?php echo $report_title; ?></h3>
		<?php
			$report = new stmsAffReport();
			$report->prepare_items();
		?>
		<form id="stms-sales-report-table" method="get">
	        <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
	        <?php $report->display(); ?>
	    </form>
	</div>
</div>