<?php
$products = stms_get_products();
$nonce = wp_create_nonce('stms-nonce');
$sent_txt = ( stms_isset($stms['emails']['is_queued'], 1) == 1 ) ? 'Broadcast email has been added to queue.' : 'Broadcast email has been sent.';
?>
<div id="stms-level-form" class="stms-admin-block">
	<h2 class="stms-field-title">Send Broadcast</h2>
	<?php if ( stms_isset($_REQUEST['submitted']) == 'true' ) : ?><div class="stms-update-msg"><p><strong><?php echo $sent_txt; ?> Number of recipients: <?php echo $_GET['queue']; ?></strong></p></div><?php endif; ?>
	<?php if ( stms_isset($_REQUEST['submitted']) == 'false' ) : ?><div class="stms-error-msg"><p><strong>Cannot send broadcast email. Number of recipients: <?php echo $_GET['queue']; ?></strong></p></div><?php endif; ?>
	<form name="stms_email_broadcast" id="stms_email_broadcast" method="post">
		<input type="hidden" name="action" value="stms_broadcast_emails" />
		<input type="hidden" name="_instanonce" value="<?php echo $nonce; ?>" />
		<table class="form-table">
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_email_recipients"><strong><span style="color:#cc0000">*</span> <?php _e('Recipients', 'stms'); ?></strong></label></th>
			<td>
				<label for="stms_recipients_1"><input type="radio" name="stms_recipients" id="stms_recipients_1" value="1" checked="checked" /> <code>All Members</code></label><br />
				<label for="stms_recipients_2"><input type="radio" name="stms_recipients" id="stms_recipients_2" value="2" /> <code>Members who have bought:</code></label><br />
				<div id="stms-segmentation" style="display:none">
					<select name="stms_selected_recipients[]" id="stms_selected_recipients" class="stms-field widefat" style="height:100px;" multiple>
					<?php if ( $products ) : $i = 0;
						foreach ( $products as $product ) {
							$selected = ( $i == 0 ) ? ' selected="selected"' : '';
							echo "<option value='{$product->ID}'{$selected}>" . stms_sanitize($product->title) . "</option>";
							$i++;
						}
					endif;
					?>
					</select>
					<div class="stms-desc">Hold <code>ctrl</code> while clicking to select multiple</div>
				</div>
				<label for="stms_recipients_3"><input type="radio" name="stms_recipients" id="stms_recipients_3" value="3" /> <code>Members who haven't bought:</code></label><br />
				<div id="stms-segmentation-2" style="display:none">
					<select name="stms_selected_recipients2[]" id="stms_selected_recipients2" class="stms-field widefat" style="height:100px;" multiple>
					<?php if ( $products ) : $i = 0;
						foreach ( $products as $product ) {
							$selected = ( $i == 0 ) ? ' selected="selected"' : '';
							echo "<option value='{$product->ID}'{$selected}>" . stms_sanitize($product->title) . "</option>";
							$i++;
						}
					endif;
					?>
					</select>
					<div class="stms-desc">Hold <code>ctrl</code> while clicking to select multiple</div>
				</div>
				<label for="stms_recipients_4"><input type="radio" name="stms_recipients" id="stms_recipients_4" value="4" /> <code>Affiliates Only</code></label><br />
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_email_subject"><strong><span style="color:#cc0000">*</span> <?php _e('Subject', 'stms'); ?></strong></label></th>
			<td><input class="stms-field widefat" type="text" name="stms_email_subject" id="stms_email_subject" value="" /></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_email_body"><strong><span style="color:#cc0000">*</span> <?php _e('Email Body', 'stms'); ?></strong></label></th>
			<td><textarea class="widefat stms-field" name="stms_email_body" id="stms_email_body" style="height:300px" /></textarea>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"></th>
			<td>
				<select id="stms_merge_tags" class="widefat stms-field">
					<option value=''>[ -- Insert Email Macro -- ]</option>
					<?php
					$tags = stms_mail_tags( 'global', false );
					$i = 0;
					foreach ( $tags as $k => $v ) {
						if ( stristr($k, 'group') ) {
							echo "<optgroup label='$v'>";
						} else if ( stristr($k, 'end') ) {
							echo "</optgroup>";
						} else {
							echo "<option value='{$k}'>{$k} - {$v}</option>";
						}
						$i++;
					}
					?>
				</select>
			</td>
		</tr>
		</table>
		<p style="text-align:right">
			<input class="button-primary" type="submit" value="Send Broadcast" />
			<a href="#" class="button" onclick="document.getElementById('stms_email_broadcast').reset(); return false;">Reset Form</a>
		</p>
	</form>
</div>