<?php
$business_name = ( stms_isset($stms['global']['business_name']) != '' ) ? stms_cleanup($stms['global']['business_name']) : get_option('blogname');
$licensing_secret = ( stms_isset($stms['global']['licensing_secret']) != '' ) ? stms_cleanup(stms_isset($stms['global']['licensing_secret']), '', false, false, true) : stms_generate_secret(32, true, true, true);
$resps = stms_available_autoresponders();
$lists = get_option('stms_ar_lists');
$unsync = stms_get_unsync_members();
?>
<div id="stms-global-settings" class="stms-admin-block">
	<form name="stms_glob_settings" id="stms_glob_settings" method="post">
	<input type="hidden" name="action" class="stms-action" value="stms_globsettings_save" />
	<input type="hidden" name="config_name" value="global" />
	
	<div id="member-edit-submenu" class="stms-desc">
		<ul id="stms-submenu">
			<li><a href="#tools"><strong>Tools</strong></a></li>
			<li><a href="#blacklist"><strong>Block Email/IP</strong></a></li>
			<li><a href="#forms"><strong>Form Editor</strong></a></li>
			<li><a href="#integration"><strong>Integration</strong></a></li>
			<li><a href="#emails"><strong>Email</strong></a></li>
			<li><a href="#payments"><strong>Payments</strong></a></li>
			<li><a href="#config" class="stms-submenu-active"><strong>General</strong></a></li>
			<li>Config Menu:</li>
		</ul>
		<br style="clear:right" />
	</div>
		
	<h2 class="stms-field-title">Basic Configuration</h2>
	<div id="stms-global-form" class="stms-admin-block">
		<?php if ( isset($_GET['wpexported']) && $_GET['wpexported'] > 0 ) : ?>
			<div class="stms-update-msg"><p><strong><?php echo $_GET['wpexported']; ?> member(s) has been exported to WordPress.</strong></p></div>
		<?php endif; ?>
		<?php if ( isset($_GET['wpimported']) && $_GET['wpimported'] > 0 ) : ?>
			<div class="stms-update-msg"><p><strong><?php echo $_GET['wpimported']; ?> WordPress user(s) has been imported to InstaMember.</strong></p></div>
		<?php endif; ?>
		
		<div class="stms-update-msg" style="display:none"><p><strong>Settings Saved.</strong></p></div>
		<p id="stms-settings-loader" style="display:none; text-align:center"><img src="<?php echo STMS_URL; ?>images/admin-loader.gif" border="0" /><br /><span class="stms-load-text">Loading data ...</span></p>
		<table class="form-table">
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_business_name"><strong><?php _e('Business Name', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_sets[business_name]" id="stms_business_name" value="<?php echo $business_name; ?>" />
				<div class="stms-desc">Please enter your business name.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_business_addr"><strong><?php _e('Business Address', 'stms'); ?></strong></label></th>
			<td>
				<textarea class="widefat stms-field" name="stms_sets[business_addr]" id="stms_business_addr" style="height:60px"><?php echo stms_sanitize($stms['global']['business_addr']); ?></textarea>
				<div class="stms-desc">Please enter your business address.</div>
			</td>
		</tr>
		</table>
	</div>
	
	<div class="stms-admin-block">
		<h2 class="stms-field-title">Membership Configuration <span class="stms-toggle" data-open="yes">-</span></h2>
		<table class="form-table">
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_sets_currency"><strong><?php _e('Currency', 'stms'); ?></strong></label></td>
			<td>
				<select name="stms_sets[currency]" id="stms_sets_currency" class="stms-field" style="width:auto">
					<?php
					if ( $currencies ) {
						foreach ( $currencies as $currency ) {
							$selected = ( stms_isset($stms['global']['currency']) == $currency ) ? ' selected="selected"' : '';
							echo "<option value='{$currency}'{$selected}>$currency</option>";
						}
					}
					?>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_sets_magic"><strong><?php _e('Membership Handler Page', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_sets[magic]" id="stms_sets_magic" class="stms-field widefat">
					<option value="">[ -- Select a handler page -- ]</option>
					<?php
					if ( $pages ) {
						foreach ( $pages as $page ) {
							if ( stms_isset($stms['global']['home']) != $page->ID ) {
								$selected = ( stms_isset($stms['global']['magic']) == $page->ID ) ? ' selected="selected"' : '';
								echo "<option value='{$page->ID}'{$selected}>$page->post_title</option>";
							}
						}
					}
					?>
				</select>
				<div class="stms-desc">Please choose a blank page that will be used as placeholder for <em>login, registration, reset password</em> and <em>edit profile</em> forms (this plugin will auto-generate all the forms). <strong>Note:</strong> InstaMember has created a blank page during activation. However, you can change the page if you wish.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_sets_home"><strong><?php _e('Membership Home Page', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_sets[home]" id="stms_sets_home" class="stms-field widefat">
					<option value="">[ -- Select a post or page -- ]</option>
					<optgroup label="Posts">
					<?php
					if ( $posts ) {
						foreach ( $posts as $post ) {
							if ( stms_isset($stms['global']['magic']) != $post->ID ) {
								$selected = ( stms_isset($stms['global']['home']) == $post->ID ) ? ' selected="selected"' : '';
								echo "<option value='{$post->ID}'{$selected}>$post->post_title</option>";
							}
						}
					}
					echo '</optgroup><optgroup label="Pages">';
					if ( $pages ) {
						foreach ( $pages as $page ) {
							if ( stms_isset($stms['global']['magic']) != $page->ID ) {
								$selected = ( stms_isset($stms['global']['home']) == $page->ID ) ? ' selected="selected"' : '';
								echo "<option value='{$page->ID}'{$selected}>$page->post_title</option>";
							}
						}
					}
					
					?>
					</optgroup>
				</select>
				<div class="stms-desc">Please choose a post/page as your membership home page. By default, members will be redirected to this page after logged in.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_after_logout"><strong><?php _e('After Logout URL', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_sets[after_logout]" id="stms_after_logout" value="<?php echo stms_isset($stms['global']['after_logout']); ?>" />
				<div class="stms-desc">Where do you want to redirect the visitors after they've logged out from the members area (must use http://)</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_non_redirect"><strong><?php _e('Non-Member Redirect URL', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_sets[non_redirect]" id="stms_non_redirect" value="<?php echo stms_isset($stms['global']['non_redirect']); ?>" />
				<div class="stms-desc">This is an optional setting only. By default, InstaMember will redirect visitors who are trying to view a protected post/page to a login page if they aren't logged in. However, if you want to take them to a custom page instead, then you can enter the URL of the page here (must use http://).</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_noauth_redirect"><strong><?php _e('Unauthorized Redirect URL', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_sets[noauth_redirect]" id="stms_noauth_redirect" value="<?php echo stms_isset($stms['global']['noauth_redirect']); ?>" />
				<div class="stms-desc">This is an optional setting only. By default, if a member trying to access a restricted page (e.g a member did not purchase your upsell, but trying to access the upsell content), InstaMember will display the "Unauthorized Access" message. However, if you want to take them to a custom page instead, then you can enter the URL of the page here (must use http://).</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_unreleased_redirect"><strong><?php _e('Unreleased Redirect URL', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_sets[unreleased_redirect]" id="stms_unreleased_redirect" value="<?php echo stms_isset($stms['global']['unreleased_redirect']); ?>" />
				<div class="stms-desc">This is an optional setting only. By default, if a member trying to access content that hasn't been available or hasn't been released (because of the drip-feed setting), InstaMember will display the "Content hasn't been released" message. However, if you want to take them to a custom page instead, then you can enter the URL of the page here (must use http://).</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_expired_redirect"><strong><?php _e('Expired Redirect URL', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_sets[expired_redirect]" id="stms_expired_redirect" value="<?php echo stms_isset($stms['global']['expired_redirect']); ?>" />
				<div class="stms-desc">This is an optional setting only. By default, if a member trying to access an expired content (because of the drip-feed setting), InstaMember will display the "Content Expired" message. However, if you want to take them to a custom page instead, then you can enter the URL of the page here (must use http://).</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right;"><label for="stms_wp_sync"><strong><?php _e('Admin Unlock Mode', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[admin_unlock]" value="0" />
				<div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[admin_unlock]" id="stms_admin_unlock" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="admin-unlocksets" value="1" <?php if ( stms_isset($stms['global']['admin_unlock'], 0) == 1 ) echo 'checked="checked"'; ?> />
				<code>Unlock Protected Content(s) When Logging In as WordPress Admin</code>
				<div class="stms-desc">If you turn on this option, then WordPress administrator(s) can view/access all protected posts, pages, and files without having to logging in as a member.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right;"><label for="stms_wp_sync"><strong><?php _e('Sync. Members with WP', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[wp_sync]" value="0" />
				<div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[wp_sync]" id="stms_wp_sync" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="wp-syncsets" value="1" <?php if ( stms_isset($stms['global']['wp_sync'], 0) == 1 ) echo 'checked="checked"'; ?> />
				<div class="stms-desc">This is an OPTIONAL feature only and most of the time, you don't need to enable this feature. If you turn on this option, InstaMember will also register your new members, including affiliates, as WordPress users too. Any member data updates applied to InstaMember will also be applied to WordPress database, and vice versa.</div>
			</td>
		</tr>
		<?php
		if ( $unsync > 0 ) {
		?>
		<tr valign="top" class="wp-syncsets">
			<th scope="row" style="text-align:right;"></th>
			<td><div class="stms-desc"><strong>Do you want to synchronize existing users/members data?</strong></div>
				<a href="<?php echo admin_url('admin.php?page=stms-settings'); ?>&action=stms_importmembers_towp&_instanonce=<?php echo wp_create_nonce('stms-admin-nonce'); ?>" class="stms-sync-btn button">Synchronize Existing Members</a>
				<div style="display:none">
					<div id="sync-box">
						<h2 style="text-align:center">Please Wait, Synchronizing Database...</h2>
						<p style="text-align:center"><img src="<?php echo STMS_URL; ?>images/admin-loader.gif" border="0" /></p>
						<p style="text-align:center">Please DO NOT close this browser until the process is completed.</p>
					</div>
				</div>
			</td>
		</tr>
		<?php } ?>
		</table>
	</div>
	
	<div class="stms-admin-block">
		<h2 class="stms-field-title">Affiliate Program Configuration <span class="stms-toggle" data-open="no">+</span></h2>
		<table class="form-table">
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Accepted Payout', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[payout][paypal]" value="0" />
				<input type="hidden" name="stms_sets[payout][payza]" value="0" />
				<p><span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[payout][paypal]" id="stms_sets_pm_paypal" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['global']['payout']['paypal']) == 1 ) echo 'checked="checked"'; ?> />
					&nbsp;&nbsp;<code>Payout with PayPal</code></p>
				<p><span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[payout][payza]" id="stms_sets_pm_payza" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['global']['payout']['payza']) == 1 ) echo 'checked="checked"'; ?> />
					&nbsp;&nbsp;<code>Payout with Payza</code></p>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_cookie_age"><strong><?php _e('Affiliate Cookie Lifetime', 'stms'); ?></strong></label></th>
			<td><input class="stms-field" type="text" name="stms_sets[cookie_age]" id="stms_cookie_age" value="<?php echo stms_isset($stms['global']['cookie_age']); ?>" style="width:100px" /> days</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_def_comm"><strong><?php _e('Default Commission', 'stms'); ?></strong></label></th>
			<td><input class="stms-field" type="text" name="stms_sets[def_comm]" id="stms_def_comm" value="<?php echo stms_isset($stms['global']['def_comm']); ?>" style="width:100px" /> %</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_min_payout"><strong><?php _e('Minimum Payout', 'stms'); ?></strong></label></th>
			<td><input class="stms-field" type="text" name="stms_sets[min_payout]" id="stms_min_payout" value="<?php echo stms_isset($stms['global']['min_payout'], 10.00); ?>" style="width:100px" /> <?php echo stms_isset($stms['global']['currency'], 'USD'); ?>
				<div class="stms-desc">Set to '0' (zero) if there's no minimum payout. Payout data won't be generated for affiliates that has commission below the minimum payout.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right;"><label for="stms_fee_applied"><strong><?php _e('Commissions After Fees', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[fee_applied]" value="0" />
				<span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[fee_applied]" id="stms_fee_applied" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['global']['fee_applied']) == 1 ) echo 'checked="checked"'; ?> />
				<div class="stms-desc">If you turn on this option, then affiliate commissions will be calculated after transaction fees are applied.<br /><strong>Important: </strong>This setting will be applied ONLY when you use PayPal or PayZa to handle the payments.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_free_aff"><strong><?php _e('Affiliate Signup Options', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[free_aff]" value="0" />
				<input type="hidden" name="stms_sets[click_aff]" value="0" />
				<input type="hidden" name="stms_sets[manual_aff]" value="0" />
				<p><span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[free_aff]" id="stms_sets_free_aff" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['global']['free_aff'], 1) == 1 ) echo 'checked="checked"'; ?> />
					&nbsp;&nbsp;<code>Allow visitors to sign up as affiliates only (without purchasing first)</code></p>
				<p><span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[click_aff]" id="stms_sets_click_aff" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['global']['click_aff'], 1) == 1 ) echo 'checked="checked"'; ?> />
					&nbsp;&nbsp;<code>Existing members have to click a link first to activate their affiliate account</code></p>
				<p><span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[manual_aff]" id="stms_sets_manual_aff" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['global']['manual_aff'], 0) == 1 ) echo 'checked="checked"'; ?> />
					&nbsp;&nbsp;<code>Manually approve new affiliates</code></p>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label style="cursor:default"><strong>Autoresponder Integration</strong></label></th>
			<td><input type="hidden" name="stms_sets[is_aff_responder]" value="0" /><div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[is_aff_responder]" id="is_aff_responder" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="responder-affsets" value="1" <?php if ( stms_isset($stms['global']['is_aff_responder']) == 1 ) echo 'checked="checked"'; ?> /></td>
		</tr>
		<tr valign="top" class="responder-affsets">
			<th scope="row" style="text-align:right"><label for="stms_aff_responder"><strong><?php _e('Autoresponder System', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_sets[aff_responder]" id="stms_aff_responder" class="stms-field widefat">
					<?php
					foreach ( $resps as $key => $value ) {
						$selected = ( stms_isset($stms['global']['aff_responder']) == $key ) ? ' selected="selected"' : '';
						echo "<option value='{$key}'{$selected}>{$value}</option>";
					}
					?>
				</select>
			</td>
		</tr>
		<tr><td colspan="2" style="padding:0;">
		<?php if ( count($resps) > 0 ) : ?>
			<table class="form-table responder-affsets">
			<?php foreach ( $resps as $key => $value ) : if ( $key != 'inf' && $key != 'custom' ) { ?>
			<tr valign="top" class="responder-aff-list responder-aff-<?php echo $key; ?>" style="display:none">
				<th scope="row" style="text-align:right"><label for="stms_<?php echo $key; ?>_aff_list"><strong> <?php _e('Select Autoresponder/Contact List', 'stms'); ?></strong></label></th>
				<td>
					<select name="stms_sets[<?php echo $key; ?>_aff_list]" id="stms_<?php echo $key; ?>_aff_list" class="stms-field" style="width:70%">
						<?php
						$my_lists = $lists[$key];
						if ( $my_lists ) :
							foreach ( $my_lists as $k => $v ) {
								$s = ( stms_isset($stms['global'][$key . '_aff_list']) == $k ) ? ' selected="selected"' : '';
								echo "<option value='{$k}'{$s}>{$v}</option>";
							}
						endif;
						?>
					</select>&nbsp;<a href="<?php echo admin_url('admin.php?page=stms-settings'); ?>&action=stms_afflist_reload&ar=<?php echo $key; ?>" class="button">Reload List</a>
				</td>
			</tr>
			<?php } else if ( $key == 'custom' ){ ?>
			<tr valign="top" class="responder-aff-list responder-aff-<?php echo $key; ?>" style="display:none">
				<th scope="row" style="text-align:right"><label for="stms_<?php echo $key; ?>_aff_list"><strong> <?php _e('Autoresponder Code (HTML)', 'stms'); ?></strong></label></th>
				<td>
					<textarea class="stms-field widefat" name="stms_sets[<?php echo $key; ?>_aff_list]" id="stms_<?php echo $key; ?>_aff_list" style="height:120px" ><?php echo esc_html(stms_sanitize($stms['global'][$key . '_aff_list'])); ?></textarea>
					<div class="stms-desc">Please copy the <strong>HTML version of the autoresponder/opt-in form code</strong> from your email marketing provider, and paste it here.</div>
				</td>
			</tr>
			<?php } else { ?>
			<tr valign="top" class="responder-aff-list responder-aff-<?php echo $key; ?>" style="display:none">
				<th scope="row" style="text-align:right"><label for="stms_<?php echo $key; ?>_aff_list"><strong> <?php _e('Campaign ID#', 'stms'); ?></strong></label></th>
				<td>
					<input class="stms-field widefat" type="text" name="stms_sets[<?php echo $key; ?>_aff_list]" id="stms_<?php echo $key; ?>_aff_list" value="<?php echo stms_sanitize($stms['global'][$key . '_aff_list']); ?>" />
					<div class="stms-desc">If you want to add new customers to one of your InfusionSoft's campaigns, then please enter the campaign ID number here.</div>
				</td>
			</tr>
			<?php } endforeach; ?>
			</table>
		<?php endif; ?>
		</td></tr>
		</table>
	</div>
	
	<div class="stms-admin-block">
		<h2 class="stms-field-title">Licensing Server Configuration <span class="stms-toggle" data-open="no">+</span></h2>
		<table class="form-table">
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_licensing_secret"><strong><?php _e('Licensing Server Secret', 'stms'); ?></strong></label></th>
			<td>
				<input class="stms-field widefat" type="text" name="stms_sets[licensing_secret]" id="stms_licensing_secret" value="<?php echo $licensing_secret; ?>" />
				<div class="stms-desc">Enter any value (alphanumeric only and no spaces please). You'll need this to validate your customers license key (please read the manual for more info).</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_licensing_server"><strong><?php _e('Licensing Server URL', 'stms'); ?></strong></label></th>
			<td>
				<input class="stms-field widefat" type="text" id="stms_licensing_server" value="<?php echo get_bloginfo('url') . '/!/instamember_api/license'; ?>" readonly />
				<div class="stms-desc">This is the API Server URL of your licensing server. You'll need this to validate your customers license key (please read the manual for more info).</div>
			</td>
		</tr>
		</table>
	</div>

	<div class="stms-admin-block">
		<h2 class="stms-field-title">Advanced Configuration <span class="stms-toggle" data-open="no">+</span></h2>
		<table class="form-table">
		<tr valign="top">
			<th scope="row" style="text-align:right"><label style="cursor:default"><strong>Account Sharing Prevention</strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[noshare_lock]" value="0" />
				<input type="hidden" name="stms_sets[noshare_admin]" value="0" />
				If an account accessed from more than &nbsp;<input class="widefat stms-field" type="text" name="stms_sets[noshare_ipcount]" id="stms_noshare_ipcount" value="<?php echo stms_isset($stms['global']['noshare_ipcount']); ?>" style="width:80px" />
				&nbsp;IP Addresses within <input class="widefat stms-field" type="text" name="stms_sets[noshare_ipcountmin]" id="stms_noshare_ipcountmin" value="<?php echo stms_isset($stms['global']['noshare_ipcountmin']); ?>" style="width:80px" /> minute(s),<br />
				then InstaMember will do the following:
				<p><span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[noshare_lock]" id="stms_noshare_lock" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['global']['noshare_lock']) == 1 ) echo 'checked="checked"'; ?> />
					&nbsp;&nbsp;<code>Lock/Disable Member Account</code></p>
				<p><span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[noshare_admin]" id="stms_noshare_admin" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['global']['noshare_admin']) == 1 ) echo 'checked="checked"'; ?> />
					&nbsp;&nbsp;<code>Notify Admin via Email</code></p>
				<!--
				<p><span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[noshare_member]" id="stms_noshare_member" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['global']['noshare_member']) == 1 ) echo 'checked="checked"'; ?> />
					&nbsp;&nbsp;<code>Notify Member via Email</code></p>
				-->
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_brute_attempt"><strong><?php _e('Brute-Force Login Limit', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_sets[brute_attempt]" id="stms_brute_attempt" value="<?php echo stms_isset($stms['global']['brute_attempt']); ?>" style="width:80px" />
				<div class="stms-desc">How many incorrect login attempts allowed before delay. When limit is reached, member will be asked to wait "X" minutes before next login attempt ("X" can be set below).</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_brute_delay"><strong><?php _e('Brute-Force Login Delay', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_sets[brute_delay]" id="stms_brute_delay" value="<?php echo stms_isset($stms['global']['brute_delay']); ?>" style="width:80px" /> minute(s)
				<div class="stms-desc">How long a member (after entered incorrect login "X" times) must wait before next login attempt.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_brute_recaptcha"><strong><?php _e('Brute-Force Login reCaptcha', 'stms'); ?></strong></th>
			<td>
				<input type="hidden" name="stms_sets[brute_recaptcha]" value="0" />
				<span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[brute_recaptcha]" id="stms_brute_recaptcha" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['global']['brute_recaptcha']) == 1 ) echo 'checked="checked"'; ?> />
				<div class="stms-desc">
					When this option is turned "On", InstaMember will also show reCaptcha on the login form <strong>after 2 unsuccessful login attempts.</strong><br />
					In order to use this feature, you have to integrate InstaMember with <a href="http://www.google.com/recaptcha" target="_blank">reCaptcha</a> first on <a href="#integration">InstaMember -> Setup/Configuration -> Integration</a>
				</div>
			</td>
		</tr>
		</table>
	</div>
	<p style="text-align:right;margin-top:40px"><input type="button" name="stms-submit-settings" id="stms-submit-settings" value="Update Settings" class="stms-ajax-save button-primary" /></p>
	</form>
</div>