<?php
$sales = stms_dashboard_sales();
$members = stms_dashboard_members();
$t_summary = stms_dashboard_summary();
$y_summary = stms_dashboard_summary('yesterday');
$w_summary = stms_dashboard_summary('week');
$logs = stms_dashboard_logins();

if ( !stms_admin_access_log() ) {
	require_once( STMS_ADMIN . 'admin-log.php');
	return true;
}

if ( !function_exists('fetch_feed') )
	include_once( ABSPATH . WPINC . '/feed.php' );

$rss = fetch_feed('http://insta-member.com/feed/');
$feed_status = false;
if ( !is_wp_error($rss) ) :
    $maxitems = $rss->get_item_quantity(2);
    $rss_items = $rss->get_items(0, $maxitems);
	$feed_status = ( $maxitems > 0 ) ? true : false;
endif;

$news = array();
if ( $feed_status ) {
	foreach ( $rss_items as $item ) {
		$content = esc_html(stms_sanitize($item->get_content()));
		$content = html_entity_decode($content);
		$content = strip_tags($content);
		$content = esc_attr($content);
		
		if ( strlen($content) > 140 )
			$content = substr_replace($content, ' [...]', 140);
		
		$news[] = array(
			'date' => $item->get_date('j F Y | g:i a'),
			'title' => esc_html($item->get_title()),
			'content' => $content,
			'url' => $item->get_permalink()
		);
	}
}
?>
<div class="stms-admin-block">
	<h2 class="stms-field-title">Welcome To InstaMember</h2>
	<?php if ( ($second_time = get_option('stms_second_time')) === FALSE ) : ?>
		<div class="stms-error-msg"><p><strong>Please go to <a href="#config">Setup/Configuration</a> to configure InstaMember for the first time.</strong></p></div>
	<?php endif; ?>
	<?php if ( get_option('stms_second_time') == 1 && count($direct_pays) <= 0 && count($third_pays) <= 0 ) : ?>
		<div class="stms-error-msg"><p><strong>Please go to <a href="#payments">Setup/Configuration >> Payments</a> to integrate InstaMember with at least one payment system.</strong></p></div>
	<?php endif; ?>
	<?php if ( get_option('stms_second_time') == 1 && !stms_get_products() ) : ?>
		<div class="stms-error-msg"><p><strong>You have no products yet. Please <a href="#level|mode=add">click here</a> to create your first product.</strong></p></div>
	<?php endif; ?>
	<div style="background-color:#F5F5F5; padding:15px">
		<div id="stms-dashboard-left" style="float:left; width:62%; max-width:62%; margin-right:3%; display:block">
			<div class="stms-admin-block"><a href="http://www.youtube.com/v/oF2qQOSHwZs?rel=0&amp;wmode=transparent&autoplay=1" id="insta-welcome-video"><img src="<?php echo STMS_URL; ?>images/member-video.png" border="0" style="max-width:100%; height:auto;" /></a></div>
		</div>
		<div id="stms-dashboard-right" style="float:left; width:35%; max-width:35%; display:block">
			<div class="stms-dashboard-links" style="margin-top:10px; background-color:#FFF">
				<h3 style="color:#666">Latest News</h3>
				<?php
					if ( $feed_status ) {
						foreach ( $news as $new ) {
							echo "<p><a href='{$new['url']}' target='_blank'><strong>{$new['title']}</strong></a><br />{$new['content']}</p>";
						}
					} else {
						echo '<p>There are no news at the moment</p>';
					}
				?>
			</div>
		</div>
		<div style="clear:left"></div>
	</div>
	<div class="stms-admin-block">
		<h2 class="stms-field-title">Summary</h2>
		<div id="stms-dashboard-left" style="float:left; width:75%; max-width:75%; margin-right:3%; display:block">
			<div id="stms-dashboard-chart" style="width: 100%; height: 300px; margin: 0 auto"></div>
		</div>
		<div id="stms-dashboard-right" style="float:left; width:22%; max-width:22%; display:block">
			<div class="stms-dashboard-links" style="margin-top:10px">
				<p><strong>Quick Links</strong></p>
				<ul id="stms-quick-links">
					<li class="quick-config"><a href="#config" style="color:#212121">Setup/Config</a></li>
					<li class="quick-product"><a href="#level|mode=add">Add Product</a></li>
					<li class="quick-member"><a href="#members|mode=add">Add Member</a></li>
					<li class="quick-sales"><a href="#reports">Sales Report</a></li>
				</ul>
			</div>
		</div>
		<div style="clear:left"></div>
	
		<h2 class="stms-field-title"></h2>
		<div style="float:left; width:32%; margin-left:2%">
			<h3>Today Summary</h2>
			<h3><span style="color:#808080;">Total Sales:</span> <strong><?php echo $t_summary['sales']; ?></strong></h3>
			<h3><span style="color:#808080;">Sales by Affiliates:</span> <strong><?php echo $t_summary['aff_sales']; ?></strong></h3>
			<h3><span style="color:#808080;">Total Revenue:</span> <strong><?php echo $t_summary['revenue'] . ' ' . $currency; ?></strong></h3>
			<h3><span style="color:#808080;">Revenue by Affiliates:</span> <strong><?php echo $t_summary['aff_revenue'] . ' ' . $currency; ?></strong></h3>
		</div>
		<div style="float:left; width:32%; margin-left:2%">
			<h3 style="color:#000099">Yesterday Summary</h2>
			<h3><span style="color:#808080;">Total Sales:</span> <strong><?php echo $y_summary['sales']; ?></strong></h3>
			<h3><span style="color:#808080;">Sales by Affiliates:</span> <strong><?php echo $y_summary['aff_sales']; ?></strong></h3>
			<h3><span style="color:#808080;">Total Revenue:</span> <strong><?php echo $y_summary['revenue'] . ' ' . $currency; ?></strong></h3>
			<h3><span style="color:#808080;">Revenue by Affiliates:</span> <strong><?php echo $y_summary['aff_revenue'] . ' ' . $currency; ?></strong></h3>
		</div>
		<div style="float:left; width:32%;">
			<h3 style="color:#009900">Last 7 Days Summary</h2>
			<h3><span style="color:#808080;">Total Sales:</span> <strong><?php echo $w_summary['sales']; ?></strong></h3>
			<h3><span style="color:#808080;">Sales by Affiliates:</span> <strong><?php echo $w_summary['aff_sales']; ?></strong></h3>
			<h3><span style="color:#808080;">Total Revenue:</span> <strong><?php echo $w_summary['revenue'] . ' ' . $currency; ?></strong></h3>
			<h3><span style="color:#808080;">Revenue by Affiliates:</span> <strong><?php echo $w_summary['aff_revenue'] . ' ' . $currency; ?></strong></h3>
		</div>
		<div style="clear:left"></div>
	</div>
	
	<div id="stms-dashboard-sales" style="float:left; margin-top:20px; width:49%; max-width:49%; margin-right:2%; display:block">
		<table cellspacing="0" class="wp-list-table widefat fixed">
			<thead>
				<tr>
					<th style="" class="manage-column column-title" id="title" scope="col" colspan="4"><strong>Recent 10 Sales</strong></th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<th class="manage-column column-date" scope="col">Date</th>
					<th class="manage-column column-username" scope="col">Username</th>
					<th class="manage-column column-product" id="title" scope="col">Product</th>
					<th style='text-align:right' class="manage-column column-amount" scope="col">Amount</th>
				</tr>
			</tfoot>
			<tbody>
				<?php
				if ( $sales ) : $i = 0;
					foreach ( $sales as $sale ) {
						$class = ( $i%2 ) ? 'alternate ' : '';
						echo "
							<tr class='{$class}iedit'>
								<td>{$sale['date']}</td>
								<td><a href='#members|mode=edit&object_ID={$sale['member_id']}'>{$sale['username']}</a></td>
								<td><a href='#level|mode=edit&object_ID={$sale['ID']}'>" . stms_sanitize($sale['product']) . "</a></td>
								<td style='text-align:right'>{$sale['amount']} " . stms_isset($stms['global']['currency'], 'USD') . "</td>
							</tr>
						";
						$i++;
					}
				else:
					echo "
						<tr class='iedit'>
							<td colspan='4'><em>No Sales</em></td>
						</tr>
					";
				endif;
				?>
			</tbody>
		</table>
	</div>
	
	<div id="stms-dashboard-members" style="float:left; margin-top:20px; width:49%; max-width:49%; display:block">
		<table cellspacing="0" class="wp-list-table widefat fixed">
			<thead>
				<tr>
					<th style="" class="manage-column column-title" id="title" scope="col" colspan="3"><strong>Recent 10 Members</strong></th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<th class="manage-column column-username" scope="col">Username</th>
					<th class="manage-column column-email" id="title" scope="col">Email</th>
					<th class="manage-column column-date" scope="col">Date</th>
				</tr>
			</tfoot>
			<tbody>
				<?php
				if ( $members ) : $i = 0;
					foreach ( $members as $member ) {
						$class = ( $i%2 ) ? 'alternate ' : '';
						echo "
							<tr class='{$class}iedit'>
								<td><a href='#members|mode=edit&object_ID={$member->ID}'>{$member->username}</a></td>
								<td>{$member->email}</td>
								<td>" . date("m/d/Y", $member->date) . "</td>
							</tr>
						";
						$i++;
					}
				else:
					echo "
						<tr class='iedit'>
							<td colspan='3'><em>No Members</em></td>
						</tr>
					";
				endif;
				?>
			</tbody>
		</table>
	</div>
	<div style="clear:left"></div>
	<div class="stms-admin-block" style="margin-top:25px">
		<h2 class="stms-field-title">Last 10 Members Login</h2>
		<table cellspacing="0" class="wp-list-table widefat fixed">
			<thead>
				<tr>
					<th class="manage-column column-date" scope="col">Date</th>
					<th class="manage-column column-username" id="title" scope="col">Username</th>
					<th class="manage-column column-ipaddress" scope="col">IP Address</th>
					<th class="manage-column column-referrer" scope="col">Referrer</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<th class="manage-column column-date" scope="col">Date</th>
					<th class="manage-column column-username" id="title" scope="col">Username</th>
					<th class="manage-column column-ipaddress" scope="col">IP Address</th>
					<th class="manage-column column-referrer" scope="col">Referrer</th>
				</tr>
			</tfoot>
			<tbody>
				<?php
				if ( $logs ) : $i = 0;
					foreach ( $logs as $log ) {
						$class = ( $i%2 ) ? 'alternate ' : '';
						echo "
							<tr class='{$class}iedit'>
								<td>" . date("m/d/Y g:i a", $log->date) . "</td>
								<td><a href='#members|mode=edit&object_ID={$log->member_id}'><strong>{$log->username}</strong></a></td>
								<td>{$log->ip_addr}</td>
								<td><a href='{$log->referrer}' target='_blank'>{$log->referrer}</a></td>
							</tr>
						";
						$i++;
					}
				else:
					echo "
						<tr class='iedit'>
							<td colspan='3'><em>No Access Log</em></td>
						</tr>
					";
				endif;
				?>
			</tbody>
		</table>
	</div>
</div>