<?php
$type = stms_isset($_REQUEST['type'], 'signup');
$fields = ( isset($stms['form_' . $type]) ) ? stms_build_form_fields($stms['form_' . $type], $type) : stms_isset($def_forms[$type]);
$options = stms_isset($stms['form_' . $type]);
?>
<div class="stms-admin-block">
	<form id="stms-form-editor" method="post">
	<input type="hidden" name="action" class="stms-action" value="stms_globsettings_save" />
	<input type="hidden" name="config_name" value="form_<?php echo $type; ?>" />
	<div id="stms-edit-form" class="stms-admin-block">
		<h2 class="stms-field-title">Edit Form</h2>
		<div class="stms-update-msg" style="display:none"><p><strong>Form Saved.</strong></p></div>
		<?php
		if ( $type == 'resetpass' ) {
			echo '<p class="stms-desc"><strong>Note:</strong> This form will be displayed after a member request to reset his password using the "Forgot Password" form</p>';
		}
		?>
		<table class="form-table">
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_form_title"><strong>Type</strong></label></th>
				<td><span class="stms-desc"><?php echo ucwords($type); ?> Form</span></td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_form_title"><strong><span style="color:#cc0000">*</span> <?php _e('Form Title', 'stms'); ?></strong></label></th>
				<td><input class="stms-field widefat" type="text" name="stms_sets[form_title]" id="stms_form_title" value="<?php echo stms_cleanup($fields['title']); ?>" /></td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_form_before_text"><strong><?php _e('Text Before Form (optional)', 'stms'); ?></strong></label></th>
				<td>
					<textarea name="stms_sets[before_text]" id="stms_form_before_text" class="stms-field widefat" style="height:100px"><?php echo stms_sanitize($fields['before_text']); ?></textarea>
					<div class="stms-desc">You can enter any content you wish before the form. All line-breaks will be automatically convert to paragraphs. Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;&lt;a&gt;&lt;img&gt;&lt;span&gt;&lt;div&gt;&lt;ul&gt;&lt;ol&gt;&lt;li&gt;</code></div>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_form_after_text"><strong><?php _e('Text After Form (optional)', 'stms'); ?></strong></label></th>
				<td>
					<textarea name="stms_sets[after_text]" id="stms_form_after_text" class="stms-field widefat" style="height:100px"><?php echo stms_sanitize($fields['after_text']); ?></textarea>
					<div class="stms-desc">You can enter any content you wish after the form. All line-breaks will be automatically convert to paragraphs. Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;&lt;a&gt;&lt;img&gt;&lt;span&gt;&lt;div&gt;&lt;ul&gt;&lt;ol&gt;&lt;li&gt;</code></div>
				</td>
			</tr>
			<?php
			switch ( $type ) {
				case 'signup':
					?>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_paymethod_label"><strong><?php _e('Payment Method Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[paymethod_label]" id="stms_paymethod_label" value="<?php echo stms_cleanup(stms_isset($fields['paymethod_label'])); ?>" />
						</td>
					</tr>
					<?php
					break;
					
				case 'forgotpass':
					?>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_email_label"><strong><?php _e('Email Field Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[email_label]" id="stms_email_label" value="<?php echo stms_cleanup(stms_isset($fields['email_label'])); ?>" />
						</td>
					</tr>
					<?php
					break;
				
				case 'profile':
					?>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_username_label"><strong><?php _e('Username Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[username_label]" id="stms_username_label" value="<?php echo stms_cleanup(stms_isset($fields['username_label'])); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_changepass_title"><strong><?php _e('Change Password Title', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[changepass_title]" id="stms_changepass_title" value="<?php echo stms_cleanup(stms_isset($fields['changepass_title'])); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_changepass_txt"><strong><?php _e('Change Password Text', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[changepass_txt]" id="stms_changepass_txt" value="<?php echo stms_cleanup(stms_isset($fields['changepass_txt'])); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_changepass_label"><strong><?php _e('New Password Field Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[changepass_label]" id="stms_changepass_label" value="<?php echo stms_cleanup(stms_isset($fields['changepass_label'])); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_changepass2_label"><strong><?php _e('Repeat Password Field Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[changepass2_label]" id="stms_changepass2_label" value="<?php echo stms_cleanup(stms_isset($fields['changepass2_label'])); ?>" />
						</td>
					</tr>
					<?php
					break;
					
				case 'login':
					?>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_username_label"><strong><?php _e('Username Field Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[username_label]" id="stms_username_label" value="<?php echo stms_cleanup(stms_isset($fields['username_label'])); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_password_label"><strong><?php _e('Password Field Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[password_label]" id="stms_password_label" value="<?php echo stms_cleanup(stms_isset($fields['password_label'])); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_remember_label"><strong><?php _e('Remember Me Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[remember_label]" id="stms_remember_label" value="<?php echo stms_cleanup(stms_isset($fields['remember_label'])); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_captcha_label"><strong><?php _e('Captcha Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[captcha_label]" id="stms_captcha_label" value="<?php echo stms_cleanup(stms_isset($fields['captcha_label'])); ?>" />
							<div class="stms-desc">This field will only appear if you have enabled the reCaptcha integration, and also enabled the "Brute-Force" prevention feature (can be found on <code>Setup/Configuration -> General -> Advanced Configuration</code>)</div>
						</td>
					</tr>
					<?php
					break;
			}
			?>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_button_label"><strong><?php _e('Button Label', 'stms'); ?></strong></label></th>
				<td><input class="stms-field widefat" type="text" name="stms_sets[button_label]" id="stms_button_label" value="<?php echo stms_cleanup(stms_isset($fields['label'])); ?>" /></td>
			</tr>
			<?php
			switch ( $type ) {
				case 'login':
					?>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_button_label2"><strong><?php _e('Button Label 2', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[button_label2]" id="stms_button_label2" value="<?php echo stms_cleanup(stms_isset($fields['button_label2'])); ?>" />
							<div class="stms-desc">This setting is for the login button label that appear on the registration page when visitors click the login link.</div>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_forgotpass_txt"><strong><?php _e('Forgot Password Link Text', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[forgotpass_txt]" id="stms_forgotpass_txt" value="<?php echo stms_cleanup(stms_isset($fields['forgotpass_txt'])); ?>" />
							<div class="stms-desc">This is the text for the forgot password link under the login form.</div>
						</td>
					</tr>
					<?php
					break;
					
				case 'forgotpass':
					?>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_back_txt"><strong><?php _e('Back to login link text', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[back_txt]" id="stms_back_txt" value="<?php echo stms_cleanup(stms_isset($fields['back_txt'])); ?>" />
							<div class="stms-desc">This is the text for the "back to login" link under the forgot password form.</div>
						</td>
					</tr>
					<?php
					break;
			}
			?>
		<?php if ( $type != 'login' && $type != 'forgotpass' && $type != 'resetpass' ) : ?>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label><strong>Form Fields</strong></label></th>
				<td>Simply drag n drop to arrange the fields order
					<ul id="stms-form-sortable" class="stms_level_sortable">
						<?php
							if ( isset($fields['active']) && is_array($fields['active'])) {
								foreach ( $fields['active'] as $active ) {
									$value = stms_isset($fields['fields'][$active]);
									$checked = ( $value[3] == 'yes' ) ? ' checked="checked"' : '';
									$disabled = ( $value[0] == 'password' || $value[2] == 'no' ) ? ' disabled' : '';
									$remove = ( $value[2] == 'yes' ) ? '<div class="stms-remove-field"><a href="#" class="del-this-field" alt="Remove" title="Remove" data-type="' . $value[0] . '"></a></div>' : '';
									echo "
										<li class='ui-state-default' style='padding-top:5px; padding-bottom:5px;'>
											<span class='ui-icon ui-icon-arrowthick-2-n-s'></span> {$value[1]} Field &nbsp;-&nbsp; 
											<input type='hidden' name='stms_sets[fields][]' value='{$value[0]}' />
											<span style='font-weight:normal'>Label:</span>&nbsp;<input type='text' name='stms_sets[labels][{$value[0]}]' value='" . stms_cleanup($value[1]) . "' />
											<input type='checkbox' name='stms_sets[required][{$value[0]}]' value='1'{$checked}{$disabled} /> <span style='font-weight:normal'>(required)</span>
											{$remove}
										</li>
									";
								}
							}
						?>
					</ul>
					<?php if ( $type == 'signup' || $type == 'affiliate' ) {
						echo '<div class="stms-desc"><strong>Note:</strong> If "Password Field" is removed, InstaMember will auto-generate password for the new member(s).</div>';
					} else if ( $type == 'profile' ) {
						echo '<div class="stms-desc"><strong>Note:</strong> "Username" and "Change Password" fields will be exists by default.</div>';
					}
					?>
				</td>
			</tr>
			<tr>
				<th scope="row"></th>
				<td>
					<div id="stms-field-adder" class="stms-admin-block" style="border:1px solid #ccc; background:#F5F5F5;padding:10px 15px">
						<p><strong>Add Field(s)</strong></p>
						<?php 
							if ( isset($fields['fields']) && is_array($fields['fields'])) {
								echo '<ul id="stms-inactive-fields">';
								foreach ( $fields['fields'] as $key => $value ) {
									$hide = ( in_array($key, $fields['active']) ) ? ' style="display:none"' : '';
									echo "<li{$hide}><a href='#' class='button stms-new-field stms-field-{$value[0]}' data-type='{$value[0]}' data-default='{$value[1]}'>$value[1]</a></li>";
								}
								echo '</ul>';
							}
						?>
						<div style="clear:left"></div>
					</div>
				</td>
			</tr>
<?php
		endif;
		switch ( $type ) {
			case 'profile':
			?>
				<tr valign="top" >
					<th scope="row" style="text-align:right"><label style="cursor:default"><strong>Show Affiliate Section</strong></label></th>
					<td>
						<input type="hidden" name="stms_sets[show_aff]" value="0" />
						<div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[show_aff]" id="stms_show_aff" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="form-aff-sets" value="1" <?php if ( stms_isset($options['show_aff'], 1) == 1 ) echo 'checked="checked"'; ?> />
					</td>
				</tr>
				<tr valign="top" class="form-aff-sets">
					<th scope="row" style="text-align:right"><label for="stms_aff_title"><?php _e('Affiliate Form Title', 'stms'); ?></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[aff_title]" id="stms_aff_title" value="<?php echo stms_cleanup(stms_isset($fields['aff_title'])); ?>" />
					</td>
				</tr>
				<tr valign="top" class="form-aff-sets">
					<th scope="row" style="text-align:right"><label for="stms_afflink_label"><?php _e('Affiliate Link Label', 'stms'); ?></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[afflink_label]" id="stms_aff_title" value="<?php echo stms_cleanup(stms_isset($fields['afflink_label'])); ?>" />
					</td>
				</tr>
				<tr valign="top" class="form-aff-sets">
					<th scope="row" style="text-align:right"><label for="stms_viewstats_txt"><?php _e('View Stats Text', 'stms'); ?></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[viewstats_txt]" id="stms_viewstats_txt" value="<?php echo stms_cleanup(stms_isset($fields['viewstats_txt'])); ?>" />
					</td>
				</tr>
				<?php if ( stms_isset($stms['global']['payout']['paypal']) == 1 ) : ?>
				<tr valign="top" class="form-aff-sets">
					<th scope="row" style="text-align:right"><label for="stms_affpaypal_label"><?php _e('PayPal Email Field Label', 'stms'); ?></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[affpaypal_label]" id="stms_affpaypal_label" value="<?php echo stms_cleanup(stms_isset($fields['affpaypal_label'])); ?>" />
					</td>
				</tr>
				<?php endif; ?>
				<?php if ( stms_isset($stms['global']['payout']['payza']) == 1 ) : ?>
				<tr valign="top" class="form-aff-sets">
					<th scope="row" style="text-align:right"><label for="stms_affpayza_label"><?php _e('Payza Email Field Label', 'stms'); ?></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[affpayza_label]" id="stms_affpayza_label" value="<?php echo stms_cleanup(stms_isset($fields['affpayza_label'])); ?>" />
					</td>
				</tr>
				<?php endif; ?>
				<tr valign="top" class="form-aff-sets">
					<th scope="row" style="text-align:right"><label for="stms_affinactive_msg"><?php _e('Affiliate Inactive Message', 'stms'); ?></label></th>
					<td>
						<textarea class="widefat stms-field" name="stms_sets[affinactive_msg]" id="stms_affinactive_msg" style="height:100px"><?php echo stms_cleanup($fields['affinactive_msg']); ?></textarea>
						<div class="stms-desc">This message will be displayed when the member is not an affiliate. To display the correct ajax affiliate activation link, please use: <code>[aff_activate_link]login text here[/aff_activate_link]</code>. All line-breaks will be automatically convert to paragraphs. Allowed HTML tags: <code>&lt;span&gt;&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;</code></div>
					</td>
				</tr>
				<tr valign="top" class="form-aff-sets">
					<th scope="row" style="text-align:right"><label for="stms_affpending_msg"><?php _e('Affiliate Pending Message', 'stms'); ?></label></th>
					<td>
						<textarea class="widefat stms-field" name="stms_sets[affpending_msg]" id="stms_affpending_msg" style="height:100px"><?php echo stms_cleanup($fields['affpending_msg']); ?></textarea>
						<div class="stms-desc">This message will be displayed when you set the affiliate approval to manual, and the member has applied to become an affiliate. All line-breaks will be automatically convert to paragraphs. Allowed HTML tags: <code>&lt;span&gt;&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;</code></div>
					</td>
				</tr>
			<?php
				break;
			case 'affiliate':
			case 'signup':
			?>
				<tr valign="top" >
					<th scope="row" style="text-align:right"><label style="cursor:default"><strong>Enable Terms &amp; Conditions</strong></label></th>
					<td>
						<input type="hidden" name="stms_sets[show_tos]" value="0" />
						<div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[show_tos]" id="stms_show_tos" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="form-tos-sets" value="1" <?php if ( stms_isset($options['show_tos']) == 1 ) echo 'checked="checked"'; ?> />
						<div class="stms-desc">By enabling this option, customers/visitors will have to agree to your "Terms &amp; Conditions" to register.</div>
					</td>
				</tr>
				<tr valign="top" class="form-tos-sets">
					<th scope="row" style="text-align:right"><label for="stms_tos_url"><?php _e('Terms & Conditions URL', 'stms'); ?></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[tos_url]" id="stms_tos_url" value="<?php echo stms_cleanup(stms_isset($options['tos_url'])); ?>" />
						<div class="stms-desc">Please enter the URL of your Terms &amp; Conditions.</div>
					</td>
				</tr>
				<tr valign="top" class="form-tos-sets">
					<th scope="row" style="text-align:right"><label for="stms_tos_url"><?php _e('Terms & Conditions Text', 'stms'); ?></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[tos_text]" id="stms_tos_text" value="<?php echo stms_cleanup(stms_isset($fields['tos_text'])); ?>" />
						<div class="stms-desc">You can use <code>[tos_link]text here[/tos_link]</code> to hyperlink the text with your TOS URL.</div>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label style="cursor:default"><strong>Enable reCaptcha</strong></label></th>
					<td>
						<input type="hidden" name="stms_sets[show_captcha]" value="0" />
						<div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[show_captcha]" id="stms_show_captcha" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="form-captcha-sets" value="1" <?php if ( stms_isset($options['show_captcha']) == 1 ) echo 'checked="checked"'; ?> />
						<div class="stms-desc">In order to use this feature, you have to integrate InstaMember with <a href="http://www.google.com/recaptcha" target="_blank">reCaptcha</a> first on <a href="#config">InstaMember -> Configuration</a>.</div>
					</td>
				</tr>
				<tr valign="top" class="form-captcha-sets">
					<th scope="row" style="text-align:right"><label for="stms_captcha_label"><?php _e('Captcha Field Label', 'stms'); ?></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[captcha_label]" id="stms_captcha_label" value="<?php echo stms_sanitize($fields['captcha_label']); ?>" />
					</td>
				</tr>
				
				<?php if ( $type != 'affiliate' ) : ?>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_affusername_info"><?php _e('Affiliate Info', 'stms'); ?></label></th>
					<td>
						<input type="hidden" name="stms_sets[affusername_info]" value="0" />
						<div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[affusername_info]" id="stms_affusername_info" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="form-affusername_info-sets" value="1" <?php if ( stms_isset($options['affusername_info'], 1) == 1 ) echo 'checked="checked"'; ?> />
						<div class="stms-desc">If this option is enabled, IM will display the affiliate's or referrer's username at the bottom of the form (only if there's an affiliate/referrer and the payment system is a direct payment).</div>
					</td>
				</tr>
				<?php endif; ?>
<?php
				break;
		}
?>
		</table>
	</div>

<?php 
	switch ( $type ) {
		case 'signup':
			if ( stms_isset($stms['payments']['is_authorize']) == 1 ) : 
?>
			<div class="stms-admin-block">
				<h2 class="stms-field-title">Authorize.Net Fields <span class="stms-toggle" data-open="no">+</span></h2>
				<table class="form-table">
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_card_title"><strong><?php _e('Form Title', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[card_title]" id="stms_card_title" value="<?php echo stms_cleanup(stms_isset($fields['card_title'])); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_cardname_label"><strong><?php _e('Card Name Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[cardname_label]" id="stms_cardname_label" value="<?php echo stms_cleanup(stms_isset($fields['cardname_label'])); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_cardnum_label"><strong><?php _e('Card Number Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[cardnum_label]" id="stms_cardnum_label" value="<?php echo stms_cleanup(stms_isset($fields['cardnum_label'])); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_cardexp_label"><strong><?php _e('Card Expire Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[cardexp_label]" id="stms_cardexp_label" value="<?php echo stms_cleanup(stms_isset($fields['cardexp_label'])); ?>" />
						</td>
					</tr>
					
					<?php if ( stms_isset($stms['payments']['authorize']['ccv']) == 1 ) : ?>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_cardccv_label"><strong><?php _e('Card Code Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[cardccv_label]" id="stms_cardccv_label" value="<?php echo stms_cleanup(stms_isset($fields['cardccv_label'])); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_cardccv_txt"><strong><?php _e('Card Code Help Text', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[cardccv_txt]" id="stms_cardccv_txt" value="<?php echo stms_cleanup(stms_isset($fields['cardccv_txt'])); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_cardccv_cnt"><strong><?php _e('Card Code Help Content', 'stms'); ?></strong></label></th>
						<td>
							<textarea class="widefat stms-field" name="stms_sets[cardccv_cnt]" id="stms_cardccv_cnt" style="height:80px"><?php echo stms_cleanup(stms_isset($fields['cardccv_cnt'])); ?></textarea>
							<div class="stms-desc">All line-breaks will be automatically convert to paragraphs. Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;</code></div>
						</td>
					</tr>
					<?php endif; ?>
					
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_upbutton_label"><strong><?php _e('Upsell Checkout Button Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[upbutton_label]" id="stms_upbutton_label" value="<?php echo stms_cleanup(stms_isset($fields['upbutton_label'])); ?>" />
						</td>
					</tr>
					
					<?php if ( stms_isset($stms['payments']['authorize']['arb']) == 1 ) : ?>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_billaddress_label"><strong><?php _e('Billing - Address Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[billaddress_label]" id="stms_billaddress_label" value="<?php echo stms_cleanup($fields['billaddress_label']); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_billcity_label"><strong><?php _e('Billing - City Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[billcity_label]" id="stms_billcity_label" value="<?php echo stms_cleanup($fields['billcity_label']); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_billstate_label"><strong><?php _e('Billing - State Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[billstate_label]" id="billstate_label" value="<?php echo stms_cleanup($fields['billstate_label']); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="billzipcode_label"><strong><?php _e('Billing - ZIP Code Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[billzipcode_label]" id="stms_billzipcode_label" value="<?php echo stms_cleanup($fields['billzipcode_label']); ?>" />
						</td>
					</tr>
					<tr valign="top">
						<th scope="row" style="text-align:right"><label for="stms_billcountry_label"><strong><?php _e('Billing - Country Label', 'stms'); ?></strong></label></th>
						<td>
							<input class="widefat stms-field" type="text" name="stms_sets[billcountry_label]" id="stms_billcountry_label" value="<?php echo stms_cleanup($fields['billcountry_label']); ?>" />
						</td>
					</tr>
					<?php endif; ?>
				</table>
			</div>
			<?php endif; ?>
			
			<div class="stms-admin-block">
				<h2 class="stms-field-title">Additional Messages <span class="stms-toggle" data-open="no">+</span></h2>
				<table class="form-table">
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_logexists_msg"><strong><?php _e('Existing Members Login', 'stms'); ?></strong></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[logexists_msg]" id="stms_logexists_msg" value="<?php echo stms_cleanup($fields['logexists_msg']); ?>" />
						<div class="stms-desc">To display the correct ajax login form link, please use: <code>[login_link]login text here[/login_link]</code>. Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;</code></div>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_backtoreg_msg"><strong><?php _e('Back To Registration Page', 'stms'); ?></strong></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[backtoreg_msg]" id="stms_backtoreg_msg" value="<?php echo stms_cleanup($fields['backtoreg_msg']); ?>" />
						<div class="stms-desc">To display the correct ajax registration form link, please use: <code>[reg_link]login text here[/reg_link]</code>. Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;</code></div>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_paysuccess_msg"><strong><?php _e('Payment Success', 'stms'); ?></strong></label></th>
					<td>
						<textarea class="widefat stms-field" name="stms_sets[paysuccess_msg]" id="stms_paysuccess_msg" style="height:80px"><?php echo stms_cleanup($fields['paysuccess_msg']); ?></textarea>
						<div class="stms-desc">To display the correct ajax login form link, please use: <code>[login_link]login text here[/login_link]</code>. All line-breaks will be automatically convert to paragraphs. Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;</code></div>
					</td>
				</tr>
				</table>
			</div>
			
			
<?php 
			break;
			
		case 'profile':
?>
			<div class="stms-admin-block">
				<h2 class="stms-field-title">Additional Messages <span class="stms-toggle" data-open="no">+</span></h2>
				<table class="form-table">
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_updated_msg"><strong><?php _e('Profile Updated', 'stms'); ?></strong></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[updated_msg]" id="stms_updated_msg" value="<?php echo stms_cleanup($fields['updated_msg']); ?>" />
						<div class="stms-desc">Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;</code></div>
					</td>
				</tr>
				</table>
			</div>
<?php
			break;
			
		case 'resetpass':
?>
			<div class="stms-admin-block">
				<h2 class="stms-field-title">Additional Messages <span class="stms-toggle" data-open="no">+</span></h2>
				<table class="form-table">
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_passreset_msg"><strong><?php _e('Password Changed Success', 'stms'); ?></strong></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[passreset_msg]" id="stms_passreset_msg" value="<?php echo stms_cleanup($fields['passreset_msg']); ?>" />
						<div class="stms-desc">Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;</code></div>
					</td>
				</tr>
				</table>
			</div>
<?php
			break;
			
		case 'login':
?>
			<div class="stms-admin-block">
				<h2 class="stms-field-title">Additional Messages <span class="stms-toggle" data-open="no">+</span></h2>
				<table class="form-table">
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_logrequired_msg"><strong><?php _e('Login Required', 'stms'); ?></strong></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[logrequired_msg]" id="stms_logrequired_msg" value="<?php echo stms_cleanup($fields['logrequired_msg']); ?>" />
						<div class="stms-desc">Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;</code></div>
					</td>
				</tr>
				</table>
			</div>
<?php
			break;
			
		case 'affiliate':
?>
			<div class="stms-admin-block">
				<h2 class="stms-field-title">Additional Messages <span class="stms-toggle" data-open="no">+</span></h2>
				<table class="form-table">
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_affactivated_msg"><strong><?php _e('Affiliate Account Activated', 'stms'); ?></strong></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[affactivated_msg]" id="stms_affactivated_msg" value="<?php echo stms_cleanup($fields['affactivated_msg']); ?>" />
						<div class="stms-desc">Please note that new affiliates will be redirected to profile page after activated. Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;</code></div>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_affreview_msg"><strong><?php _e('Affiliate Account In-Review', 'stms'); ?></strong></label></th>
					<td>
						<input class="widefat stms-field" type="text" name="stms_sets[affreview_msg]" id="stms_affreview_msg" value="<?php echo stms_cleanup($fields['affreview_msg']); ?>" />
						<div class="stms-desc">Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;</code></div>
					</td>
				</tr>
				</table>
			</div>
<?php
			break;
	}
?>
	<p style="text-align:right; margin-right:10px">
		<input type="button" name="stms-submit-formsets" id="stms-submit-formsets" value="Update Form" class="stms-ajax-save button-primary" />
		<a href="#forms" class="button">Back</a> 
	</p>
	</form>
</div>