<?php
$mailsys = array('php' => 'Default PHP Mail', 'ses' => 'Amazon SES', 'smtp' => 'SMTP');
$admin_email = stripslashes(stms_sanitize($stms['emails']['admin_email'], get_option('admin_email')));
$admin_from = stripslashes(stms_sanitize($stms['emails']['admin_from'], get_option('blogname')));
?>
<form name="stms_email_settings" id="stms_email_settings" method="post">
<input type="hidden" name="action" value="stms_emailsettings_save" />
<input type="hidden" name="config_name" value="emails" />
<input type="hidden" id="email_lastload" value="" />
<div id="stms-emails-settings" class="stms-admin-block">
	<div id="member-edit-submenu" class="stms-desc">
		<ul id="stms-submenu">
			<li><a href="#tools"><strong>Tools</strong></a></li>
			<li><a href="#blacklist"><strong>Block Email/IP</strong></a></li>
			<li><a href="#forms"><strong>Form Editor</strong></a></li>
			<li><a href="#integration"><strong>Integration</strong></a></li>
			<li><a href="#emails" class="stms-submenu-active"><strong>Email</strong></a></li>
			<li><a href="#payments"><strong>Payments</strong></a></li>
			<li><a href="#config"><strong>General</strong></a></li>
			<li>Config Menu:</li>
		</ul>
		<br style="clear:right" />
	</div>
	
	<h2 class="stms-field-title" id="stms-email-title">Email Settings</h2>
	<div class="stms-update-msg" style="display:none"><p><strong>Settings Saved.</strong></p></div>
	<table class="form-table" id="stms-email-selector">
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_admin_email"><strong><?php _e('Default Admin Email', 'stms'); ?></strong></label></th>
			<td><input class="widefat stms-field" type="text" name="stms_sets[admin_email]" id="stms_admin_email" value="<?php echo $admin_email; ?>"  /></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_admin_from"><strong><?php _e('Default Sender Name', 'stms'); ?></strong></label></th>
			<td><input class="widefat stms-field" type="text" name="stms_sets[admin_from]" id="stms_admin_from" value="<?php echo $admin_from; ?>" /></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_mailsys"><strong><?php _e('Email Delivery System', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_sets[mailsys]" id="stms_mailsys" class="stms-field widefat">
					<?php
					if ( $mailsys ) {
						foreach ( $mailsys as $key => $value ) {
							$selected = ( @$stms['emails']['mailsys'] == $key ) ? ' selected="selected"' : '';
							echo "<option value='{$key}'{$selected}>$value</option>";
						}
					}
					?>
				</select>
				<div class="stms-desc stms-aws-ses"><strong>Important: </strong>In order to use Amazon SES, make sure that you already integrate InstaMember with Amazon Web Services in <a href="#integration">Setup/Configuration -> Integration</a></div>
			</td>
		</tr>
		
		<tr valign="top" class="stms-smtp">
			<th scope="row" style="text-align:right"><label for="stms_smtp_host"><strong><?php _e('SMTP Host', 'stms'); ?></strong></label></th>
			<td><input class="widefat stms-field" type="text" name="stms_sets[smtp_host]" id="stms_smtp_host" value="<?php echo stms_sanitize($stms['emails']['smtp_host']); ?>" /></td>
		</tr>
		<tr valign="top" class="stms-smtp">
			<th scope="row" style="text-align:right"><label for="stms_smtp_host"><strong><?php _e('SMTP Port', 'stms'); ?></strong></label></th>
			<td><input class="widefat stms-field" type="text" name="stms_sets[smtp_port]" id="stms_smtp_port" value="<?php echo ( isset($stms['emails']['smtp_port']) ) ? stms_sanitize($stms['emails']['smtp_port']) : '25'; ?>" style="width:80px" /></td>
		</tr>
		<tr valign="top" class="stms-smtp">
			<th scope="row" style="text-align:right"><label for="stms_smtp_security"><strong> <?php _e('SMTP Security', 'stms'); ?></strong></label></th>
			<td>
				<select id="stms_smtp_security" name="stms_sets[smtp_security]" class="stms-field widefat">
					<option value=""<?php if ( stms_isset($stms['emails']['smtp_security']) == '' ) echo ' selected="selected"'; ?>>None</option>
					<option value="SSL"<?php if ( stms_isset($stms['emails']['smtp_security']) == 'SSL' ) echo ' selected="selected"'; ?>>SSL</option>
					<option value="TLS"<?php if ( stms_isset($stms['emails']['smtp_security']) == 'TLS' ) echo ' selected="selected"'; ?>>TLS</option>
				</select>
			</td>
		</tr>
		<tr valign="top" class="stms-smtp">
			<th scope="row" style="text-align:right"><label for="stms_smtp_username"><strong><?php _e('SMTP Username', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_sets[smtp_username]" id="stms_smtp_username" value="<?php echo stms_sanitize($stms['emails']['smtp_username']); ?>" />
				<div class="stms-desc"><strong>Note: </strong> Please leave this field blank if your SMTP server does not required authentication.</div>
			</td>
		</tr>
		<tr valign="top" class="stms-smtp">
			<th scope="row" style="text-align:right"><label for="stms_smtp_username"><strong><?php _e('SMTP Password', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="password" name="stms_sets[smtp_password]" id="stms_smtp_password" value="<?php echo stms_sanitize($stms['emails']['smtp_password']); ?>" />
				<div class="stms-desc"><strong>Note: </strong> Please leave this field blank if your SMTP server does not required authentication.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Enable Email Throttle Queue', 'stms'); ?></strong></label></th>
			<td>
				<div class="stms-help-msg">
					<p><strong>Important:</strong> If you're on a shared hosting or a low-end server, it is RECOMMENDED that you turn this option ON, unless you use a 3rd-party SMTP server, such as Amazon SES, SendGrid, PostmarkApp, etc.</p>
					<p>When this option is turned on, InstaMember will send all broadcast/bulk emails periodically to avoid your mail server from getting overloaded.</p>
				</div>
				<input type="hidden" name="stms_sets[is_queued]" value="0" />
				<input type="checkbox" name="stms_sets[is_queued]" id="stms_email_queued" data-blockname='stms-queued-sets' class='stms-toggle-checkbox stms-toggle-switch' value="1" <?php if ( stms_isset($stms['emails']['is_queued'], 1) == 1 ) echo 'checked="checked"'; ?> /><span class='stms-toggle-btn'></span>
			</td>
		</tr>
		<tr valign="top" class="stms-queued-sets">
			<th scope="row" style="text-align:right"><label for="stms_queued_count"><strong><?php _e('Email Sending Limit', 'stms'); ?></strong></label></th>
			<td><input class="widefat stms-field" type="text" name="stms_sets[queued_count]" id="stms_queued_count" value="<?php echo stms_cleanup(stms_isset($stms['emails']['queued_count'], 200)); ?>" style="width:80px" /> per hour</td>
		</tr>
		<tr valign="top" class="stms-queued-sets">
			<th scope="row" style="text-align:right"><label for="stms_queued_cron"><strong><?php _e('Cron Command', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" id="stms_queued_cron" value="<?php echo PHP_BINDIR . '/php ' . STMS_PATH . 'cron.php'; ?> &gt;/dev/null 2&gt;&1" readonly />
				<div class="stms-desc">Put the command above into your "Cron" and set it to run for EXACTLY every 15 minutes.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Notification Emails (for members)', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[send_cancel]" value="0" />
				<label for="stms_signedup_email"><input type="checkbox" id="stms_signedup_email" value="1" disabled="disabled" checked="checked" /> <code>Send Welcome Email</code></label> [ <a href="#" class="stms-edit-email" data-emailtype="signedup" data-subtitle="Edit - Welcome Email">edit template</a> ]<br />
				<label for="stms_confirm_email"><input type="checkbox" id="stms_confirm_email" value="1" disabled="disabled" checked="checked" /> <code>Send Confirmation Email</code></label> [ <a href="#" class="stms-edit-email" data-emailtype="confirm" data-subtitle="Edit - Sign Up Confirmation Email">edit template</a> ]<br />
				<label for="stms_forgot_email"><input type="checkbox" id="stms_forgot_email" value="1" disabled="disabled" checked="checked" /> <code>Send Forgot Password Email</code></label> [ <a href="#" class="stms-edit-email" data-emailtype="forgot" data-subtitle="Edit - Forgot Password Email">edit template</a> ]<br />
				<label for="stms_receipt_email"><input type="checkbox" id="stms_receipt_email" value="1" disabled="disabled" checked="checked" /> <code>Send Payment Receipt Email</code></label> [ <a href="#" class="stms-edit-email" data-emailtype="receipt" data-subtitle="Edit - Payment Receipt Email">edit template</a> ]<br />
				<label for="stms_cancel_email"><input type="checkbox" name="stms_sets[send_cancel]" id="stms_cancel_email" value="1" <?php if ( stms_isset($stms['emails']['send_cancel'], 1) == 1 ) echo 'checked="checked"'; ?> /> <code>Send Membership Cancellation Email</code></label> [ <a href="#" class="stms-edit-email" data-emailtype="cancel" data-subtitle="Edit - Membership Cancellation Email">edit template</a> ]<br />
				<!-- <label for="stms_upgraded_email"><input type="checkbox" name="stms_sets[send_upgraded]" id="stms_upgraded_email" value="1" <?php if ( stms_isset($stms['emails']['send_upgraded']) == 1 ) echo 'checked="checked"'; ?><?php if ( !isset($stms['emails']) ) echo 'checked="checked"'; ?> /> <code>Send Account Upgraded Email</code></label> [ <a href="#" class="stms-edit-email" data-emailtype="upgraded" data-subtitle="Edit - Account Upgraded Email">edit template</a> ]<br /> -->
				
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Notification Emails (for affiliates)', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[send_aff_pending]" value="0" />
				<input type="hidden" name="stms_sets[send_commission]" value="0" />
				<label for="stms_aff_approved_email"><input type="checkbox" id="stms_aff_approved_email" value="1" disabled="disabled" checked="checked" /> <code>Send Affiliate Approved Email</code></label> [ <a href="#" class="stms-edit-email" data-emailtype="aff_approved" data-subtitle="Edit - Affiliate Approved Email">edit template</a> ]<br />	
				<label for="stms_aff_pending_email"><input type="checkbox" name="stms_sets[send_aff_pending]" id="stms_aff_pending_email" value="1" <?php if ( stms_isset($stms['emails']['send_aff_pending'], 1) == 1 ) echo 'checked="checked"'; ?> /> <code>Send Affiliate Pending Email</code></label> [ <a href="#" class="stms-edit-email" data-emailtype="aff_pending" data-subtitle="Edit - Affiliate Pending Email">edit template</a> ]<br />
				<label for="stms_commission_email"><input type="checkbox" name="stms_sets[send_commission]" id="stms_commission_email" value="1" <?php if ( stms_isset($stms['emails']['send_commission'], 1) == 1 ) echo 'checked="checked"'; ?> /> <code>Send Affiliate Commission Email</code></label> [ <a href="#" class="stms-edit-email" data-emailtype="commission" data-subtitle="Edit - Affiliate Commission Email">edit template</a> ]<br />
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Notification Emails (for admin)', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[send_admin_receipt]" value="0" />
				<input type="hidden" name="stms_sets[send_admin_cancel]" value="0" />
				<input type="hidden" name="stms_sets[send_admin_commission]" value="0" />
				<label for="stms_admin_receipt_email"><input type="checkbox" name="stms_sets[send_admin_receipt]" id="stms_admin_receipt_email" value="1" <?php if ( stms_isset($stms['emails']['send_admin_receipt']) == 1 ) echo 'checked="checked"'; ?> /> <code>Send Payment Notification Email</code></label> [ <a href="#" class="stms-edit-email" data-emailtype="admin_receipt" data-subtitle="Edit - Admin :: Payment Notification Email">edit template</a> ]<br />
				<label for="stms_admin_cancel_email"><input type="checkbox" name="stms_sets[send_admin_cancel]" id="stms_admin_cancel_email" value="1" <?php if ( stms_isset($stms['emails']['send_admin_cancel']) == 1 ) echo 'checked="checked"'; ?> /> <code>Send Member Cancel Notification Email</code></label> [ <a href="#" class="stms-edit-email" data-emailtype="admin_cancel" data-subtitle="Edit - Admin :: Member Cancel Notification Email">edit template</a> ]<br />
				<label for="stms_admin_commission_email"><input type="checkbox" name="stms_sets[send_admin_commission]" id="stms_admin_commission_email" value="1" <?php if ( stms_isset($stms['emails']['send_admin_commission']) == 1 ) echo 'checked="checked"'; ?> /> <code>Send Aff. Commission Notification Email</code></label> [ <a href="#" class="stms-edit-email" data-emailtype="admin_commission" data-subtitle="Edit - Admin :: Aff. Commission Notification Email">edit template</a> ]<br />
			</td>
		</tr>
		</table>
</div>
<p style="text-align:right" class="main-emails-btn"><input type="button" name="stms-submit-emailsets" id="stms-submit-emailsets" value="Update Settings" class="stms-ajax-save button-primary" /></p>
</form>

<div class="stms-admin-block main-emails-btn" style="margin-top; 25px; padding:3px 0 10px; border:1px solid #E5E5E5">
	<table class="form-table">
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_target_email"><strong><?php _e('Send Test Email', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" id="stms_target_email" value=""  style="width:75%" placeholder="Enter email address here" />
				&nbsp;<img src="<?php echo STMS_URL; ?>images/small-loader.gif" border="0" style="display:none; vertical-align: middle" id="test-email-loader" /><a href="#" id="stms-send-testmail" class="button">Send</a>
				<div class="stms-desc">If you want to test your email delivery system, you can enter an email address and hit the "Send" button.</div>
			</td>
		</tr>
	</table>
</div>

<p id="stms-email-loader" style="display:none; text-align:center"><img src="<?php echo STMS_URL; ?>images/admin-loader.gif" border="0" /><br /><span class="stms-load-text">Loading data ...</span></p>

<div id="stms-emailsets-form" class="stms-admin-block" style="display:none">
	<h2 id="edit-email-subtitle" class="stms-field-title">Edit Email</h2>
	<p id="stms-emailsave-loader" style="display:none; text-align:center"><img src="<?php echo STMS_URL; ?>images/admin-loader.gif" border="0" /><br /><span class="stms-load-text">Saving data ...</span></p>
	<div class="stms-update-msg" style="display:none"><p><strong>Email Template Saved.</strong></p></div>
	<table class="form-table" id="stms-email-template">
		<tr valign="top" class="stms-user-email-prop">
			<th scope="row" style="text-align:right"><label for="stms_fromname"><strong><?php _e('From Name', 'stms'); ?></strong></label></th>
			<td><input class="widefat stms-field" type="text" id="stms_fromname" value="" />
			</td>
		</tr>
		<tr valign="top" class="stms-user-email-prop">
			<th scope="row" style="text-align:right"><label for="stms_frommail"><strong><?php _e('From Email', 'stms'); ?></strong></label></th>
			<td><input class="widefat stms-field" type="text" id="stms_frommail" value="" />
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_email_subject"><strong><?php _e('Email Subject', 'stms'); ?></strong></label></th>
			<td><input class="widefat stms-field" type="text" id="stms_email_subject" value="" />
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_email_body"><strong><?php _e('Email Body', 'stms'); ?></strong></label></th>
			<td><textarea class="widefat stms-field" id="stms_email_body" style="height:300px" /></textarea>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"></th>
			<td>
				<select id="stms_merge_tags" class="widefat stms-field" disabled>
					<option value=''>[ -- Insert Email Macro -- ]</option>
				</select>
			</td>
		</tr>
	</table>
	<input type="hidden" id="stms_email_save_type" value="" />
	
	<p style="text-align:right; padding-right:10px" id="stms-email-template-btn">
		<input type="button" id="stms-save-email" value="Update" class="button-primary" />
		<input type="button" id="stms-cancel-email" value="Back" class="button" />
	</p>
</div>