<?php
$license = stms_get_product_meta($object_id, 'license');

$install_usage = ( isset($license['usage']) ) ? stms_cleanup($license['usage']) : '';
$install_modes = array(
			'unlimited' => 'No Limit',
			'domain' => 'Domain Name',
			'servip' => 'Server\'s IP Address',
			'userip' => 'User\'s IP Address'
		);
		
$expire_modes = array(
			'never' => 'Never Expire',
			'day' => 'Day(s)',
			'week' => 'Week(s)',
			'month' => 'Month(s)',
			'year' => 'Year(s)'
		);
		
$license_prefix = ( isset($license['prefix']) ) ? stms_cleanup($license['prefix']) : stms_generate_secret(5, true, false, true) . '-';
$license_suffix = ( isset($license['suffix']) ) ? stms_cleanup($license['suffix']) : '-' . stms_generate_secret(4, true, false, true);
$license_length = ( isset($license['suffix']) ) ? stms_cleanup($license['length']) : 10;
?>
<div id="stms-license-table" class="stms-admin-block">
	<div id="member-edit-submenu" class="stms-desc" style="text-align:right">
		<ul id="stms-submenu">
			<li><a href="#level|mode=license&object_ID=<?php echo $object_id; ?>" class="stms-submenu-active"><strong>Licensing</strong></a></li>
			<li><a href="#level|mode=pay_button&object_ID=<?php echo $object_id; ?>"><strong>Reg/Pay Button</strong></a></li>
			<li><a href="#level|mode=protects&object_ID=<?php echo $object_id; ?>"><strong>Protect Content(s)</strong></a></li>
			<li><a href="#level|mode=edit&object_ID=<?php echo $object_id; ?>"><strong>Edit Product</strong></a></li>
			<li><a href="#level"><strong>All Products</strong></a></li>
			<li>Sub-Menu:</li>
		</ul>
		<br style="clear:right" />
	</div>
	
	<h2 class="stms-field-title">Product Licensing <span class="stms-protect-title">(product name: <strong><?php echo stripslashes(stms_isset($p->title)); ?></strong>)</span></h2>
	
	<div class="stms-update-msg" style="display:none"><p><strong>License Settings has been updated.</strong></p></div>
	<p id="stms-license-loader" style="display:none; text-align:center"><img src="<?php echo STMS_URL; ?>images/admin-loader.gif" border="0" /><br /><span class="stms-load-text">Updating Data ...</span></p>
	<form name="stms_license_settings" id="stms_license_settings" method="post">
	<input type="hidden" name="stms_license_product_id" value="<?php echo stms_isset($p->ID); ?>" />
	<table class="form-table">
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_enable_license"><strong><?php _e('Enable Product Licensing', 'stms'); ?></strong></label></th>
			<td>
				<div class="stms-toggle-btn"></div><input type="checkbox" name="stms_lic[enable]" id="stms_enable_license" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="stms-license-properties" value="1" <?php if ( stms_isset($license['enable']) == 1 ) echo 'checked="checked"'; ?> />

			</td>
		</tr>
	</table>
	
	<table class="form-table stms-license-properties">
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_license_usage"><strong><?php _e('Usage Per License', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_lic[usage]" id="stms_license_usage" value="<?php echo $install_usage; ?>" style="width:80px" />
				&nbsp;Per&nbsp;
				<select name="stms_lic[usage_mode]" id="stms_license_usage_mode">
					<?php foreach ( $install_modes as $k => $v ) {
						$selected = ( stms_isset($license['usage_mode']) == $k ) ? ' selected="selected"' : '';
						echo "<option value='{$k}'{$selected}>{$v}</option>";
					} ?>
				</select>
				<div class="stms-desc">How many times a member can use a single license key in order to activate your product.<br />
					<em>For example, if you set this setting to "10 per domain name", it means a member can use one license in 10 domain names.</em></div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_license_prefix"><strong><?php _e('License Key Prefix', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_lic[prefix]" id="stms_license_prefix" value="<?php echo $license_prefix; ?>" style="width:160px" />
				<div class="stms-desc">All generated license key for this product will begin with this prefix. Leave this blank if you don't want to add a prefix.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_license_suffix"><strong><?php _e('License Key Suffix', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_lic[suffix]" id="stms_license_suffix" value="<?php echo $license_suffix; ?>" style="width:160px" />
				<div class="stms-desc">All generated license key for this product will end with this suffix. Leave this blank if you don't want to add a suffix.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_license_length"><strong><?php _e('License String Length', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_lic[length]" id="stms_license_length" value="<?php echo $license_length; ?>" style="width:80px" />
				<div class="stms-desc">Total characters of the license key string.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_license_expire"><strong><?php _e('Expire In', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_lic[expire]" id="stms_license_expire" value="<?php echo stms_cleanup($license['expire']); ?>" style="width:80px" />
				<select name="stms_lic[expire_mode]" id="stms_license_expire_mode" style="width:auto">
					<?php foreach ( $expire_modes as $k => $v ) {
						$selected = ( stms_isset($license['expire_mode']) == $k ) ? ' selected="selected"' : '';
						echo "<option value='{$k}'{$selected}>{$v}</option>";
					} ?>
				</select>
				<div class="stms-desc">E.g. '30 Days', '6 Months', or 'Never Expire'.</div>
			</td>
		</tr>
	</table>
	</form>
	<p id="stms-license-btn" style="text-align:right;">
		<input type="button" id="stms-submit-license" name="stms-submit-license" value="Save License Settings" class="button-primary" />
		<input type="button" value="Back" class="button" onclick="window.history.back(); return false;"/>
	</p>
</div>