<?php 
$mode = stms_isset($_GET['mode'], 'manage');
$object_id = stms_isset($_GET['object_ID'], 0);

$exp_modes = array(
	'never' => 'Never Expire',
	'day' => 'Day(s)',
	'week' => 'Week(s)',
	'month' => 'Month(s)',
	'year' => 'Year(s)'
);
	
if ( $mode == 'log' ) {
	$l = stms_get_license_by('id', $object_id);
	$m = stms_member($l->member_id);
	$p = stms_get_product($l->product_id);
	$s = stms_get_product_meta($p->ID, 'license');
	$res = stms_isset($s['usage'], 1);
	$mode = stms_isset($s['usage_mode'], 'unlimited');
	if ( $mode == 'unlimited' ) {
		$limit = "No Restriction (unlimited)";
	} else if ( $mode == 'domain' ) {
		$limit = "Limited to <strong>{$res} domain name(s)</strong>";
	} else if ( $mode == 'servip' ) {
		$limit = "Limited to <strong>{$res} server's IP</strong>";
	} else if ( $mode == 'userip' ) {
		$limit = "Limited to <strong>{$res} user's IP</strong>";
	}
	
	$exp = stms_isset($s['expire'], 1);
	$exp_mode = stms_isset($s['expire_mode'], 'never');
	if ( $exp_mode == 'never' ) {
		$expired = "No Expiration";
	} else {
		$expired = "Expire in <strong>{$exp} " . stms_isset($exp_modes[$exp_mode]) . "</strong> after activation";
	}
	
	$status = 'Inactive';
	if ( $l->status == 1 )
		$status = '<span style="color:#009900">Active</span>';
	else if ( $l->status == 2 )
		$status = '<span style="color:#990000">Suspended</span>';
	else if ( $l->status == 3 )
		$status = '<span style="color:#FF0000">Expired</span>';
	else if ( $l->status == 4 )
		$status = '<span style="color:#F88A00">Maxed Out</span>';
?>
<div class="stms-admin-block">
	<h2 class="stms-field-title">License Usage Details</h2>
	<table cellpadding="2" cellspacing="1" border="0" style="width:350px">
		<tr valign="top">
			<th scope="row" style="width:120px; text-align:left; font-weight:normal">License Key:</th>
			<td style="color:#000099"><strong><?php echo stms_sanitize($l->license); ?></strong></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="width:120px; text-align:left; font-weight:normal">Product:</th>
			<td><a href="#level|mode=license&object_ID=<?php echo $p->ID; ?>"><strong><?php echo stms_sanitize($p->title); ?></strong></a></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="width:120px; text-align:left; font-weight:normal">Member:</th>
			<td><a href="#members|mode=edit&object_ID=<?php echo $m->ID; ?>"><?php echo stms_sanitize($m->username); ?></a></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="width:120px; text-align:left; font-weight:normal">Restriction:</th>
			<td><em><?php echo $limit; ?></em></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="width:120px; text-align:left; font-weight:normal">Expiration:</th>
			<td><em><?php echo $expired; ?></em></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="width:120px; text-align:left; font-weight:normal">Status:</th>
			<td><strong><?php echo $status; ?></strong></td>
		</tr>
	</table>
	
	<div class="stms-admin-block">
		<?php
		$log = new stmsLicenseLog();
		$log->prepare_items();
		?>
		<form id="stms-license-log-table" method="get">
	        <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
	        <?php $log->display(); ?>
	    </form>
	</div>
</div>
<?php
} else {
?>
<div class="stms-admin-block">
	<h2 class="stms-field-title">Manage Licenses</h2>
	<form method="get" name="find_licenses">
	<div class="stms-report-searchbox">
		<input type="hidden" id="stms-report-control" value="licenses" />
		<input type="hidden" id="stms-report-mode" value="<?php echo stms_isset($_GET['mode'], 'manage'); ?>" />
		<div>
			<strong>Search: </strong>&nbsp;&nbsp;
			<input type="text" id="stms-search-s" class="stms-field" value="<?php echo stms_cleanup($_GET['s']); ?>" style="width:140px" />&nbsp;&nbsp;
			<strong>Filter: </strong>&nbsp;&nbsp;
			<select id="stms-search-product" class="stms-field" style="width:150px">
				<option value=""> -- All Products -- </option>
				<?php
				if ( $products ) {
					foreach ( $products as $product ) {
						$selected = ( stms_isset($_GET['product_id']) == $product->ID ) ? ' selected="selected"' : '';
						echo "<option value='{$product->ID}'{$selected}>$product->title</option>";
					}
				}
				?>
			</select>&nbsp;&nbsp;
			<select id="stms-search-trans" class="stms-field" style="width:140px">
				<option value=""> -- All Statuses -- </option>
				<option value="active" <?php if ( stms_isset($_GET['status']) == 'active' ) echo ' selected="selected"'; ?>>Active</option>
				<option value="suspended" <?php if ( stms_isset($_GET['status']) == 'suspended' ) echo ' selected="selected"'; ?>>Suspended</option>
				<option value="inactive" <?php if ( stms_isset($_GET['status']) == 'inactive' ) echo ' selected="selected"'; ?>>Inactive</option>
				<option value="expired" <?php if ( stms_isset($_GET['status']) == 'expired' ) echo ' selected="selected"'; ?>>Expired</option>
				<option value="maxed" <?php if ( stms_isset($_GET['status']) == 'maxed' ) echo ' selected="selected"'; ?>>Maxed Out</option>
			</select>&nbsp;&nbsp;
			<select id="stms-search-sort" class="stms-field" style="width:90px">
				<option value=""> -- Sort By -- </option>
				<option value="license" <?php if ( stms_isset($_GET['sort'], 'installed') == 'license' ) echo ' selected="selected"'; ?>>License</option>
				<option value="member" <?php if ( stms_isset($_GET['sort'], 'installed') == 'member' ) echo ' selected="selected"'; ?>>Member</option>
				<option value="product" <?php if ( stms_isset($_GET['sort'], 'installed') == 'product' ) echo ' selected="selected"'; ?>>Product</option>
				<option value="installed" <?php if ( stms_isset($_GET['sort'], 'installed') == 'installed' ) echo ' selected="selected"'; ?>>Installed</option>
				<option value="status" <?php if ( stms_isset($_GET['sort'], 'installed') == 'status' ) echo ' selected="selected"'; ?>>Status</option>
			</select>&nbsp;&nbsp;
			<select id="stms-search-sortm" class="stms-field" style="width:70px">
				<option value="ASC" <?php if ( stms_isset($_GET['sortm'], 'DESC') == 'ASC' ) echo ' selected="selected"'; ?>>ASC</option>
				<option value="DESC" <?php if ( stms_isset($_GET['sortm'], 'DESC') == 'DESC' ) echo ' selected="selected"'; ?>>DESC</option>
			</select>&nbsp;&nbsp;
			<input type="button" id="stms-search-btn" class="button-primary" value="Search" />
		</div>
	</div>
	</form>
	
	<div class="stms-admin-block">
		<?php
		$license = new stmsLicenseUsage();
		$license->prepare_items();
		?>
		<form id="stms-license-report-table" method="get">
	        <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
	        <?php $license->display(); ?>
	    </form>
	</div>
</div>
<?php } ?>