<?php
$fields = array(
	'id' => 'Member ID',
	'username' => 'Username',
	'email' => 'Email',
	'first_name' => 'First Name',
	'last_name' => 'Last Name',
	'street' => 'Street/Address',
	'city' => 'City',
	'state' => 'State/Province',
	'country' => 'Country',
	'zipcode' => 'Zip Code',
	'phone' => 'Phone',
	'company' => 'Company',
	'gender' => 'Gender',
	'url' => 'Site URL',
	'ref' => 'Referrer Username',
	'ref_id' => 'Referrer ID',
	'ref_name' => 'Referrer Name',
	'ref_email' => 'Referrer Email',
);
$def_fields = array('username', 'email', 'first_name', 'last_name');
?>
<div class="stms-admin-block">
	<form method="post" name="stms_export_members" id="stms_export_members" action="<?php echo admin_url('admin.php?page=stms-settings'); ?>">
	<h2 class="stms-field-title">Export Members To CSV</h2>
	<input type="hidden" name="action" value="stms_export_members" />
	<table class="form-table">
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_exp_fields"><strong><?php _e('Fields to Export', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_exp_fields[]" id="stms_exp_fields" class="stms-field" multiple="multiple">
					<?php
					if ( $fields ) {
						foreach ( $fields as $k => $v ) {
							$selected = ( in_array($k, $def_fields) ) ? ' selected="selected"' : '';
							echo "<option value='{$k}'{$selected}>{$v}</option>";
						}
					}
					?>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_exp_products"><strong><?php _e('Members to Export', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_exp_products[]" id="stms_exp_products" class="stms-field" multiple="multiple">
					<?php
					if ( $products ) {
						foreach ( $products as $product ) {
							$title = esc_attr(stms_sanitize($product->title));
							echo "<option value='{$product->ID}'>Members of &quot;{$title}&quot;</option>";
						}
					}
					?>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Include Headers', 'stms'); ?></strong></label></th>
			<td><span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_exp_headers" id="stms_exp_headers" class="stms-chkbox" value="1" />
			</td>
		</tr>
	</table>
	<p style="text-align:right;margin-top:40px"><input type="submit" name="stms_exp_btn" value="Export Members" class="button-primary" />&nbsp;&nbsp;<a href="#members" class="button">Back</a></p>
	</form>
</div>