<?php
$data = get_transient('stms_import_data_' . $key);
$cols = count($data[0]);

$fields = array(
	'username' => 'Username',
	'password' => 'Password',
	'email' => 'Email',
	'first_name' => 'First Name',
	'last_name' => 'Last Name',
	'street' => 'Street/Address',
	'city' => 'City',
	'state' => 'State/Province',
	'country' => 'Country',
	'zipcode' => 'Zip Code',
	'phone' => 'Phone',
	'company' => 'Company',
	'gender' => 'Gender',
	'url' => 'Site URL'
);
?>
<div class="stms-admin-block">
	<form method="post" name="stms_import_members" id="stms_import_members" enctype="multipart/form-data" action="<?php echo admin_url('admin.php?page=stms-settings'); ?>">
	<h2 class="stms-field-title">Import Members From CSV <span class="stms-payments-title">(Step 2 of 3 - Field Mapping)</span></h2>
	<?php if ( isset($_GET['error']) && $_GET['error'] == 'unmapped' ) : ?><div class="stms-error-msg"><p><strong>ERROR: No Field Selected</strong></p></div><?php endif; ?>
	<?php if ( isset($_GET['error']) && $_GET['error'] == 'noemail' ) : ?><div class="stms-error-msg"><p><strong>ERROR: No Email Field Selected</strong></p></div><?php endif; ?>
	<input type="hidden" name="action" value="stms_import_members" />
	<input type="hidden" name="import_step" value="two" />
	<input type="hidden" name="import_key" value="<?php echo $key; ?>" />
	
	<p>Please select the correct field for each column from the drop-down:</p>
	<p><label for="import_skip_first"><input type="checkbox" name="import_skip_first" id="import_skip_first" /> <code>Skip First Line/Row</code></label></p>
	<div style="width:100%; overflow-x: auto">
	<small><span style="color:#cc0000">*</span> Email field is required</small>
	<table class="wp-list-table widefat fixed" id="stms-import-table">
		<thead>
			<tr>
			<?php for ( $i = 0; $i < $cols; $i++ ) {
				echo '<th scope="col">';
				echo '<select name="icol[]" class="stms-field widefat">';
				echo "<option value=''> -- Select Field -- </option>";
				foreach ( $fields as $k => $v ) {
					echo "<option value='{$k}'>{$v}</option>";
				}
				echo '</th>';
			} ?>
			</tr>
		</thead>
		<tbody>
			<?php 
			foreach ( $data as $dat ) {
				echo '<tr>';
				for ( $i = 0; $i < count($dat); $i++ ) {
					echo '<td>';
					echo $dat[$i];
					echo '</td>';
				}
				echo '</tr>';
			}
			?>
		</tbody>
		</table>
		</div>
		<p style="text-align:right;margin-top:40px"><a href="<?php echo admin_url('admin.php?page=stms-settings'); ?>&action=stms_undo_import&step=2&key=<?php echo $key; ?>" class="button">Back</a>&nbsp;&nbsp;<input type="submit" name="stms_import_btn" value="Next" class="button-primary" /></p>
	</form>
</div>