<?php
$data = get_transient('stms_imported_data_' . $key);
$cols = count($data[0]);
$column = array();
foreach ( $data[0] as $k => $v ) {
	$column[] = $k;
}

$fields = array(
	'username' => 'Username',
	'password' => 'Password',
	'email' => 'Email',
	'first_name' => 'First Name',
	'last_name' => 'Last Name',
	'street' => 'Street/Address',
	'city' => 'City',
	'state' => 'State/Province',
	'country' => 'Country',
	'zipcode' => 'Zip Code',
	'phone' => 'Phone',
	'company' => 'Company',
	'gender' => 'Gender',
	'url' => 'Site URL'
);
?>
<div class="stms-admin-block">
	<form method="post" name="stms_final_import_members" id="stms_final_import_members" enctype="multipart/form-data" action="<?php echo admin_url('admin.php?page=stms-settings'); ?>">
	<h2 class="stms-field-title">Import Members From CSV <span class="stms-payments-title">(Step 3 of 3 - Import Options)</span></h2>
	<?php if ( isset($_GET['error']) && $_GET['error'] == 'unmapped' ) : ?><div class="stms-error-msg"><p><strong>ERROR: No Field Selected</strong></p></div><?php endif; ?>
	<?php if ( isset($_GET['error']) && $_GET['error'] == 'noemail' ) : ?><div class="stms-error-msg"><p><strong>ERROR: No Email Field Selected</strong></p></div><?php endif; ?>
	<input type="hidden" name="action" value="stms_import_members" />
	<input type="hidden" name="import_step" value="three" />
	<input type="hidden" name="import_key" value="<?php echo $key; ?>" />
	
	
	<div class="stms-admin-block" style="overflow-x: auto">
		<table class="wp-list-table widefat fixed" id="stms-import-table">
			<thead>
				<tr>
				<?php for ( $i = 0; $i < $cols; $i++ ) {
					echo '<th scope="col">';
					echo $fields[$column[$i]];
					echo '<input type="hidden" name="icol[]" value="' . $column[$i] . '" />';
					echo '</th>';
				} ?>
				</tr>
			</thead>
			<tbody>
				<?php 
				foreach ( $data as $dat ) {
					echo '<tr>';
					for ( $i = 0; $i < count($dat); $i++ ) {
						echo '<td>';
						echo $dat[$column[$i]];
						echo '</td>';
					}
					echo '</tr>';
				}
				?>
			</tbody>
			</table>
		</div>
		<table class="form-table">
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_imp_mode"><strong><?php _e('Import Mode', 'stms'); ?></strong></label></th>
				<td>
					<select name="stms_imp_mode" id="stms_imp_mode" class="stms-field">
						<option value='1'>If username/email is Exist, do NOT import the data</option>";
						<option value='2'>If username/email is Exist, update the existing member but do NOT change the username &amp; password</option>";
						<option value='2'>If username/email is Exist, replace/overwrite the existing member data</option>";
					</select>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_imp_pass"><strong><?php _e('Default Password', 'stms'); ?></strong></label></th>
				<td>
					<input type="text" name="stms_imp_pass" id="stms_imp_pass" class="stms-field widefat" style="width:200px" />
					<div class="stms-desc">You can set the default password, or leave this blank if you want InstaMember to generate random passwords for each member (will not be applied if the imported data contains passwords for each member).</div>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_exp_products"><strong><?php _e('Product Access', 'stms'); ?></strong></label></th>
				<td>
					<select name="stms_imp_products[]" id="stms_imp_products" class="stms-field" multiple="multiple">
						<?php
						if ( $products ) {
							foreach ( $products as $product ) {
								$title = esc_attr(stms_sanitize($product->title));
								echo "<option value='{$product->ID}'>{$title}</option>";
							}
						}
						?>
					</select>
				</td>
			</tr>
		</table>
		<p style="text-align:right;margin-top:40px"><a href="<?php echo admin_url('admin.php?page=stms-settings'); ?>&action=stms_undo_import&step=3&key=<?php echo $key; ?>" class="last-import-back button">Back</a>&nbsp;&nbsp;<input type="submit" name="stms_do_import" id="stms_do_import" value="Import Now" class="button-primary" /></p>
	</form>
</div>