<?php
$pay_form_title = ( stms_isset($_GET['payment_mode']) == 'edit' ) ? 'Edit Payment' : 'Add New Payment';
$pay_button_label = ( stms_isset($_GET['payment_mode']) == 'edit' ) ? 'Update Payment' : 'Add Payment';
$pay = ( stms_isset($_GET['payment_mode']) == 'edit' ) ? stms_get_payment($_GET['payment_id']) : false;
$pay_id = ( stms_isset($_GET['payment_mode']) == 'edit' && isset($_GET['payment_id']) ) ? $pay->tx_id : 0;
$start_date = ( isset($pay->date) ) ? date("m/d/Y", $pay->date) : date("m/d/Y", stms_time());
$expired_date = ( stms_isset($pay->expired_date) > 0 ) ? date("m/d/Y", $pay->expired_date) : date("m/d/Y", strtotime('+30 days'));
$pay_amount = ( isset($pay->amount) ) ? $pay->amount : 0.00;
$pay_checked = ( stms_isset($pay->status) == 'completed' && stms_isset($pay->paid) == 1 ) ? ' checked="checked"' : ( (!isset($pay->status)) ? ' checked="checked"' : '' );
$payment_status = array( 'completed' => 'Active', 'pending' => 'Pending', 'expired' => 'Expired', 'cancelled' => 'Canceled', 'refunded' => 'Refunded' );
$is_pay_paid = intval(stms_isset($pay->paid));

$lic = false;
if ( stms_isset($_GET['payment_mode']) == 'edit' ) {
	// check if there's any license for this...
	$lic = stms_get_license_by('tx_id', $pay_id);
	$license_id = stms_isset($lic->ID);
	$license_key = stms_isset($lic->license);
}
?>
<div id="stms-member-payments-area" class="stms-admin-block">
	<?php if ( stms_isset($_GET['payment_mode']) != 'edit' ) : ?>
	<div id="member-edit-submenu" class="stms-desc">
		<ul id="stms-submenu">
			<li><a href="<?php echo admin_url('admin.php?page=stms-settings'); ?>&action=stms_login_as&ID=<?php echo $object_id; ?>" target="_blank"><strong>Login as '<?php echo stms_sanitize($m->username); ?>'</strong></a></li>
			<li><a href="#members|mode=accesslog&object_ID=<?php echo $object_id; ?>"><strong>Access Log</strong></a></li>
			<?php if ( $m->is_aff == 1 ) : ?><li><a href="#members|mode=affstats&object_ID=<?php echo $object_id; ?>"><strong>Affiliate Stats</strong></a></li><?php endif; ?>
			<li><a href="#members|mode=payments&object_ID=<?php echo $object_id; ?>" class="stms-submenu-active"><strong>Payments/Subscriptions</strong></a></li>
			<li><a href="#members|mode=edit&object_ID=<?php echo $object_id; ?>"><strong>Edit Member</strong></a></li>
			<li><a href="#members"><strong>All Members</strong></a></li>
			<li>Sub-Menu:</li>
		</ul>
		<br style="clear:right" />
	</div>
	
	<div id="stms-payment-added-msg" class="stms-update-msg" style="display:none"><p><strong>Payment has been added.</strong></p></div>
	
	<h2 class="stms-field-title">Payment History <span class="stms-payments-title">(username: <strong><?php echo stms_isset($m->username); ?></strong>)</span></h2>
	<div id="stms-member-payments-table" class="stms-admin-block">
	<?php
		$pay_table = new stmsMemberPayments();
		$pay_table->prepare_items();
	?>
		<form id="stms-payments-table" method="get">
			<input type="hidden" name="bulk_member_id" value="<?php echo $object_id; ?>" />
	        <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
	        <?php $pay_table->display(); ?>
	    </form>
	</div>
	<?php endif; ?>
	<p id="stms-member-payment-loader" style="display:none; text-align:center"><img src="<?php echo STMS_URL; ?>images/admin-loader.gif" border="0" /><br /><span class="stms-load-text">Saving Payment Data ...</span></p>
	<div id="stms-manual-payment-form" class="stms-admin-block">
		<h2 class="stms-field-title"><?php echo $pay_form_title; ?></h2>
		
		<div class="stms-admin-block">
			<form id="stms_member_manual_payment" method="post">
			<input type="hidden" name="stms_payment_id" id="stms_payment_id" value="<?php echo $pay_id; ?>" />
			<table class="form-table">
				<?php if ( stms_isset($_GET['payment_mode']) == 'edit' ) : ?>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label><strong><?php _e('Receipt', 'stms'); ?></strong></label></th>
					<td class="normal_text"><?php echo ( $pay->receipt != '' && $pay->receipt != 'manual' ) ? '<a href="' . admin_url('admin.php?page=stms-settings') . '#reports|s=' . $pay->receipt . '">' . $pay->receipt . '</a>' : 'Manual'; ?></td>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label><strong><?php _e('Member', 'stms'); ?></strong></label></th>
					<td class="normal_text">
						<?php echo '<a href="#members|mode=edit&object_ID=' . $pay->member_id . '">' . $m->username . '</a>'; 
						if ( !empty($m->first_name) )
							echo ' (' . stms_cleanup($m->first_name) . ' ' . stms_cleanup($m->last_name) . ')';
						?>
					</td>
				</tr>
				<?php if ( isset($license_key) && $license_key != '' ) : ?>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label><strong><?php _e('License Key', 'stms'); ?></strong></label></th>
					<td class="normal_text"><?php echo '<a href="#licenses|mode=log&object_ID=' . $license_id . '">' . $license_key . '</a>'; ?></td>
				</tr>
				<?php endif; ?>
				<?php endif; ?>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_pays_level"><strong><?php _e('Product', 'stms'); ?></strong></label></th>
					<td>
						<select name="stms_pays_level" id="stms_pays_level" class="stms-field widefat">
							<?php
							if ( $products ) {
								foreach ( $products as $product ) {
									$selected = ( stms_isset($pay->product_id) == $product->ID ) ? ' selected="selected"' : '';
									echo "<option value='{$product->ID}'{$selected}>" . stms_sanitize($product->title) . "</option>";
								}
							}
							?>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_pays_start"><strong><?php _e('Start Date', 'stms'); ?></strong></label></th>
					<td><input class="stms-field widefat" type="text" name="stms_pays_start" id="stms_pays_start" value="<?php echo $start_date; ?>" style="width:100px" /></td>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_pays_expired"><strong><?php _e('Expire Date', 'stms'); ?></strong></label></th>
					<td>
						<input class="stms-field widefat" type="text" name="stms_pays_expired" id="stms_pays_expired" value="<?php echo $expired_date; ?>" style="width:100px" />
						<div class="stms-desc"><strong>Note:</strong> The 'Expire Date' will be ignored if a one-time product is selected.</div>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_pays_amount"><strong><?php _e('Amount', 'stms'); ?></strong></label></th>
					<td><input class="stms-field widefat" type="text" name="stms_pays_amount" id="stms_pays_amount" value="<?php echo $pay_amount; ?>" style="width:80px" /> <?php echo stms_isset($stms['global']['currency'], 'USD'); ?></td>
				</tr>
				<?php if ( stms_isset($_GET['payment_mode']) == 'edit' ) : ?>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label for="stms_pays_status"><strong><?php _e('Payment Status', 'stms'); ?></strong></label></th>
					<td>
						<select name="stms_pays_status" id="stms_pays_status" class="stms-field">
							<?php
							if ( $payment_status ) {
								foreach ( $payment_status as $key => $val ) {
									$selected = ( stms_isset($pay->status) == $key ) ? ' selected="selected"' : '';
									echo "<option value='{$key}'{$selected}>{$val}</option>";
								}
							}
							?>
						</select>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label><strong><?php _e('Payment System', 'stms'); ?></strong></label></th>
					<td class="normal_text">
						<?php
						$paysys = ( $pay->paysys != 'manual' ) ? stms_getpaymentname($pay->paysys) : 'Manual';
						echo $paysys;
						?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label><strong><?php _e('Transaction Date', 'stms'); ?></strong></label></th>
					<td class="normal_text">
						<?php
						echo date("F d, Y, H:i", $pay->date);
						?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row" style="text-align:right"><label><strong><?php _e('Referred By', 'stms'); ?></strong></label></th>
					<td class="normal_text">
						<?php
						$aff_id = $pay->aff_id;
						$aff_data = stms_member($aff_id);
						$aff_username = ( $aff_data ) ? "<a href='#members|mode=edit&object_ID={$aff_data->ID}'>{$aff_data->username}</a>" : '<span style="color:#808080"><em>None</em></span>';
						echo $aff_username;
						if ( $aff_data && !empty($aff_data->first_name) )
							echo ' (' . stms_cleanup($aff_data->first_name) . ' ' . stms_cleanup($aff_data->last_name) . ')';
						?>
					</td>
				</tr>
				<tr valign="top">
					<th colspan="2">&nbsp;</th>
				</tr>
				
				<?php else: ?>
				<tr valign="top">
					<th scope="row" style="text-align:right"></th>
					<td><label for="stms_pays_completed"><input type="checkbox" name="stms_pays_completed" id="stms_pays_completed" value="1" checked="checked" /> Mark as completed payment</label></td>
				</tr>
				<?php endif; ?>
			</table>
			<input type="hidden" name="stms_is_paid" value="<?php echo $is_pay_paid; ?>" />
			</form>
			<p style="margin-top:10px;text-align:right">
				<a href="#" class="button-primary stms-member-manual-payment"><?php echo $pay_button_label; ?></a>
				<a href="#" class="button" onclick="window.history.back(); return false">Back</a>
			</p>
		</div>
	</div>
	<input type="hidden" id="stms_pays_member_id" value="<?php echo $object_id; ?>" />
</div>