<?php
$mode = ( stms_isset($_REQUEST['mode']) != '' ) ? $_REQUEST['mode'] : '';
$object_id = ( stms_isset($_REQUEST['object_ID']) > 0 ) ? (int) $_REQUEST['object_ID'] : 0;
$m = stms_member($object_id);
$gender = array('male', 'female');
$titles = array('mr', 'mrs', 'ms', 'miss');
$aff_ids = stms_get_member_meta($object_id, 'aff_ids');
$excl_aff = stms_get_member_meta($object_id, 'exclusive_aff');
$nonce = wp_create_nonce('stms-nonce');


switch ($mode) {
	case 'add':
	case 'edit':
		
		$mode_title = ( $mode == 'edit' ) ? 'Edit Member' : 'Add New Member';
		$readonly = ( $mode == 'edit' ) ? ' readonly' : '';
		$first_name = ( stms_isset($m->first_name) != '' ) ? stripslashes(esc_attr(stms_isset($m->first_name))) : 'First Name';
		$last_name = ( stms_isset($m->last_name) != '' ) ? stripslashes(esc_attr(stms_isset($m->last_name))) : 'Last Name';
		$fname_color = ( stms_isset($m->first_name) != '' ) ? '#212121' : '#a7a7a7';
		$lname_color = ( stms_isset($m->last_name) != '' ) ? '#212121' : '#a7a7a7';
		$old_email = ( $mode == 'edit' ) ? $m->email : '';
		$referrer = ( $mode == 'edit' ) ? stms_get_member_meta($m->ID, 'aff_id') : '';
		
		//echo stms_string_dec($m->info['user_key'], AUTH_SALT);
?>
<div id="stms-member-form" class="stms-admin-block">
	<?php if ( $mode == 'edit' ) : ?>
		<div id="member-edit-submenu" class="stms-desc">
			<ul id="stms-submenu">
				<li><a href="<?php echo admin_url('admin.php?page=stms-settings'); ?>&action=stms_login_as&ID=<?php echo $object_id; ?>" target="_blank"><strong>Login as '<?php echo stms_sanitize($m->username); ?>'</strong></a></li>
				<li><a href="#members|mode=accesslog&object_ID=<?php echo $object_id; ?>"><strong>Access Log</strong></a></li>
				<?php if ( $m->is_aff == 1 ) : ?><li><a href="#members|mode=affstats&object_ID=<?php echo $object_id; ?>"><strong>Affiliate Stats</strong></a></li><?php endif; ?>
				<li><a href="#members|mode=payments&object_ID=<?php echo $object_id; ?>"><strong>Payments/Subscriptions</strong></a></li>
				<li><a href="#members|mode=edit&object_ID=<?php echo $object_id; ?>" class="stms-submenu-active"><strong>Edit Member</strong></a></li>
				<li><a href="#members"><strong>All Members</strong></a></li>
				<li>Sub-Menu:</li>
			</ul>
			<br style="clear:right" />
		</div>
	<?php endif; ?>
		
	<h2 id="stms-member-form-title" class="stms-field-title"><?php echo $mode_title; ?></h2>
	<p id="stms-member-edit-loader" style="display:none; text-align:center"><img src="<?php echo STMS_URL; ?>images/admin-loader.gif" border="0" /><br /><span class="stms-load-text">Loading Data ...</span></p>
	<div id="stms-member-fields" class="stms-admin-block">
		
		<?php if ( stms_isset($_REQUEST['member']) == 'updated' ) : ?><div class="stms-update-msg stms-member-msg"><p><strong>Member has been updated.</strong></p></div><?php endif; ?>
		<?php if ( stms_isset($_REQUEST['member']) == 'added' ) : ?><div class="stms-update-msg stms-member-msg"><p><strong>Member has been added.</strong></p></div><?php endif; ?>	
				
		<form name="stms_add_member" id="stms_add_member" method="post">
		<input type="hidden" name="action" value="stms_memberdata_save" />
		<input type="hidden" name="stms_member[member_id]" id="stms_member_id" value="<?php echo $object_id; ?>" />
		<input type="hidden" name="stms_member[old_email]" id="stms_old_email" value="<?php echo $old_email; ?>" />
		<table class="form-table">
		<?php if ( $mode == 'add' ) : ?>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_user_name"><strong><span style="color:#cc0000">*</span> <?php _e('Username', 'stms'); ?></strong></label></th>
			<td><input class="stms-field-member stms-field widefat" type="text" name="stms_member[username]" id="stms_user_name" value="" /></td>
		</tr>
		<?php endif; ?>
		<?php if ( $mode == 'edit' ) : ?>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_user_name"><strong><span style="color:#cc0000">*</span> <?php _e('Username', 'stms'); ?></strong></label></th>
			<td><input class="stms-field-member stms-field" type="text" id="stms_member_username" style="width:40%; color:#808080" value="<?php echo stripslashes(esc_attr(stms_isset($m->username))); ?>" readonly />&nbsp;&nbsp;<span class="stms-desc">Username cannot be changed</span></td>
		</tr>
		<?php endif; ?>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_user_email"><strong><span style="color:#cc0000">*</span> <?php _e('Email Address', 'stms'); ?></strong></label></th>
			<td><input class="stms-field-member stms-field widefat" type="text" name="stms_member[email]" id="stms_user_email" value="<?php echo stripslashes(esc_attr(stms_isset($m->email))); ?>" /></td>
		</tr>
		
		<?php if ( $mode == 'add' ) : ?>
		<tr valign="top" class="stms-add-pass">
			<th scope="row" style="text-align:right"><label for="stms_user_pass"><strong><span style="color:#cc0000">*</span> <?php _e('Password', 'stms'); ?></strong></label></th>
			<td><input class="stms-field-member stms-field widefat" type="password" name="stms_member[password]" id="stms_user_pass" value="" /></td>
		</tr>
		<tr valign="top" class="stms-add-pass">
			<th scope="row" style="text-align:right"><label for="stms_user_pass2"><strong><span style="color:#cc0000">*</span> <?php _e('Confirm Password', 'stms'); ?></strong></label></th>
			<td><input class="stms-field-member stms-field widefat" type="password" name="stms_member[password2]" id="stms_user_pass2" value="" /></td>
		</tr>
		<?php endif; ?>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_title"><strong><?php _e('Title', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_member[title]" id="stms_member_title" class="stms-field-member stms-field">
					<?php
					if ( $titles ) {
						foreach ( $titles as $title ) {
							$selected = ( stms_isset($m->info['title']) == $title ) ? ' selected="selected"' : '';
							echo "<option value='{$title}'{$selected}>" . ucwords($title) . "</option>";
						}
					}
					?>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_first_name"><strong><?php _e('Full Name', 'stms'); ?></strong></label></th>
			<td>
				<input class="stms-field-member stms-field widefat" type="text" name="stms_member[first_name]" id="stms_first_name" value="<?php echo $first_name; ?>" style="width:35%; color:<?php echo $fname_color; ?>" onfocus="if(this.value=='First Name'){ this.value='';this.style.color='#212121';}" onblur="if(this.value==''){ this.value='First Name';this.style.color='#a7a7a7';}" />&nbsp;
				<input class="stms-field-member stms-field widefat" type="text" name="stms_member[last_name]" id="stms_last_name" value="<?php echo $last_name; ?>" style="width:35%; color:<?php echo $lname_color; ?>" onfocus="if(this.value=='Last Name'){ this.value='';this.style.color='#212121';}" onblur="if(this.value==''){ this.value='Last Name';this.style.color='#a7a7a7';}" />
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_street"><strong><?php _e('Street Address', 'stms'); ?></strong></label></th>
			<td><input class="stms-field-member stms-field widefat" type="text" name="stms_member[street]" id="stms_member_street" value="<?php echo stripslashes(esc_attr(stms_isset($m->info['street']))); ?>" /></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_city"><strong><?php _e('City', 'stms'); ?></strong></label></th>
			<td><input class="stms-field-member stms-field widefat" type="text" name="stms_member[city]" id="stms_member_city" value="<?php echo stripslashes(esc_attr(stms_isset($m->info['city']))); ?>" style="width:45%" /></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_state"><strong><?php _e('State', 'stms'); ?></strong></label></th>
			<td><input class="stms-field-member stms-field widefat" type="text" name="stms_member[state]" id="stms_member_state" value="<?php echo stripslashes(esc_attr(stms_isset($m->info['state']))); ?>" style="width:45%" /></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_zipcode"><strong><?php _e('ZIP Code', 'stms'); ?></strong></label></th>
			<td><input class="stms-field-member stms-field widefat" type="text" name="stms_member[zipcode]" id="stms_member_zipcode" value="<?php echo stripslashes(esc_attr(stms_isset($m->info['zipcode']))); ?>" style="width:25%; display:block;" /></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_country"><strong><?php _e('Country', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_member[country]" id="stms_member_country" class="stms-field-member stms-field widefat">
					<option value="">[ -- Select Country -- ]</option>
					<?php
					$countries = stms_world_countries();
					if ( $countries ) {
						foreach ( $countries as $key => $value ) {
							$selected = ( stms_isset($m->info['country'], '') == $key ) ? ' selected="selected"' : '';
							echo "<option value='{$key}'{$selected}>{$value}</option>";
						}
					}
					?>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_phone"><strong><?php _e('Phone', 'stms'); ?></strong></label></th>
			<td><input class="stms-field-member stms-field widefat" type="text" name="stms_member[phone]" id="stms_member_phone" value="<?php echo stms_sanitize($m->info['phone']); ?>" style="width:25%" /></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_gender"><strong><?php _e('Gender', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_member[gender]" id="stms_member_gender" class="stms-field-member stms-field">
					<?php
					if ( $gender ) {
						echo "<option value=''>[-- Select Gender --]</option>";
						foreach ( $gender as $sex ) {
							$selected = ( stms_isset($m->info['gender']) == $sex ) ? ' selected="selected"' : '';
							echo "<option value='{$sex}'{$selected}>" . ucwords($sex) . "</option>";
						}
					}
					?>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_company"><strong><?php _e('Company', 'stms'); ?></strong></label></th>
			<td><input class="stms-field-member stms-field widefat" type="text" name="stms_member[company]" id="stms_member_company" value="<?php echo stripslashes(esc_attr(stms_isset($m->info['company']))); ?>" style="width:45%" /></td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_aff_status"><strong><?php _e('Affiliate Status', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_member[aff_status]" id="stms_aff_status" class="stms-field-member stms-field">
					<?php
					$aff_statuses = array('active' => 'Active', 'pending' => 'Pending', 'inactive' => 'Inactive');
					if ( $aff_statuses ) {
						foreach ( $aff_statuses as $k => $v ) {
							$aff_status = ( isset($m->is_aff) && $m->is_aff == 1 ) ? 'active' : (( isset($m->is_aff_pending) && $m->is_aff_pending == 1 ) ? 'pending' : 'inactive');
							$selected = ( $aff_status == $k ) ? ' selected="selected"' : '';
							echo "<option value='{$k}'{$selected}>{$v}</option>";
						}
					}
					?>
				</select>
			</td>
		</tr>
		<?php
		if ( !empty($stms['global']['payout']) ) {
			foreach ( $stms['global']['payout'] as $key => $value ) {
				if ( $value == 1 ) {
					echo '<tr valign="top" class="stms-aff-sets">' . "\n";
					echo '<th scope="row" style="text-align:right"><label for="stms_aff_' . $key . '" class="for-text"><strong>' . ucwords($key) . ' Email Address</strong></label></th>' . "\n";
					echo '<td><input type="text" class="stms-field-member stms-field widefat" name="stms_member[aff_payments][' . $key . ']" id="stms_aff_' . $key . '" value="' . stms_sanitize($aff_ids[$key]) . '" style="width:250px" /></td>' . "\n";
					echo '</tr>' . "\n";
				}
			}
		}
		?>
		<tr valign="top" class="stms-aff-sets">
			<th scope="row" style="text-align:right"><label><strong>Exclusive Affiliate</strong></label></th>
			<td><span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_member[excl_aff]" id="stms_exclusive_aff" class="stms-chkbox" value="1" <?php if ( $excl_aff == 1 ) echo 'checked="checked"'; ?> /></td>
		</tr>
		<?php if ( $mode == 'edit' ) : ?>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_lock"><strong><?php _e('Lock Member Account', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_member[auto_lock]" id="stms_member_lock" class="stms-field-member stms-field">
					<?php
					$locks = array('no' => 'No', 'yes' => 'Yes', 'disable' => 'Disable Auto-Lock');
					if ( $locks ) {
						foreach ( $locks as $k => $v ) {
							$selected = ( $m->is_locked == $k ) ? ' selected="selected"' : '';
							echo "<option value='{$k}'{$selected}>{$v}</option>";
						}
					}
					?>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_lock"><strong><?php _e('Registration Date', 'stms'); ?></strong></label></th>
			<td>
				<?php echo '<code>' . date("l, F d, Y g:i a", $m->date) . '</code>'; ?>
			</td>
		</tr>
		
		<?php if ( !empty($referrer) ) : if ( $ref = stms_member($referrer) ) : ?>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_ref"><strong><?php _e('Referrer', 'stms'); ?></strong></label></th>
			<td class="normal_text">
				<?php echo "<a href='#members|mode=edit&object_ID={$ref->ID}'>{$ref->username}</a>"; ?>
			</td>
		</tr>
		<?php endif; endif; ?>
		<?php endif; ?>
		<?php if ( $mode == 'add' ) : ?>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_member_level"><strong><?php _e('Payment/Subscription', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_member[level]" id="stms_member_level" class="stms-field-member stms-field widefat">
					<option value=''>[ -- Select Product -- ]</option>
					<?php
					if ( $products ) {
						foreach ( $products as $product ) {
							echo "<option value='{$product->ID}'>$product->title</option>";
						}
					}
					?>
				</select><br />
				
				<div id="stms-member-main-payment" style="display:none; margin-top:12px">
					<strong><?php _e('Start Date', 'stms'); ?></strong>: <input class="stms-field widefat" type="text" name="stms_member[payment][start]" id="stms_payment_start" value="<?php echo date("m/d/Y"); ?>" style="width:90px" />&nbsp;&nbsp;
					<strong><?php _e('Expire Date', 'stms'); ?></strong>: <input class="stms-field widefat" type="text" name="stms_member[payment][expired]" id="stms_payment_expired" value="<?php echo date("m/d/Y", strtotime('+30 days')); ?>" style="width:90px" />&nbsp;&nbsp;
					<strong><?php _e('Amount', 'stms'); ?></strong>: <input class="stms-field widefat" type="text" name="stms_member[payment][amount]" id="stms_payment_amount" value="0" style="width:60px" /> <?php echo stms_isset($stms['global']['currency']); ?>
					<div class="stms-desc"><strong>Note:</strong> The 'Expire Date' will be ignored if a one-time product is selected.</div>
				</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"></th>
			<td>
				<label for="send_welcome_email"><input type="checkbox" name="stms_member[is_welcome_email]" id="send_welcome_email" value="1" /> Send welcome email to this member</label><br />
			</td>
		</tr>
		<?php endif; ?>
		</table>
		
		<?php if ( $mode == 'edit' ) : ?>
		<div id="stms-member-fields" class="stms-admin-block" style="margin-top:25px">
		<h2 class="stms-field-title">Change Password</h2>
		<div class="stms-desc">Simply leave this blank if you don't want to change the password.</div>
			<table class="form-table">
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_user_pwd1"><strong> <?php _e('Change Password', 'stms'); ?></strong></label></th>
				<td><input class="stms-field widefat" type="password" name="stms_member[pwd1]" id="stms_user_pwd1" value="" /></td>
			</tr>
			<tr valign="top">
				<th scope="row" style="text-align:right"><label for="stms_user_pwd2"><strong> <?php _e('Repeat Password', 'stms'); ?></strong></label></th>
				<td><input class="stms-field widefat" type="password" name="stms_member[pwd2]" id="stms_user_pwd2" value="" /></td>
			</tr>
			</table>
		</div>
		<?php endif; ?>
		
		<p style="margin-top:30px;text-align:right">
			<input type="submit" id="stms-submit-member" name="stms-submit-member" value="Save Member" class="button-primary" />
			<a href="#members" class="button">Cancel</a>
		</p>
		
		</form>
	</div>
</div>
<?php
		break;
	
	case 'accesslog':
		require_once(STMS_ADMIN . 'member-access.php');
		break;
		
	case 'payments':
		require_once(STMS_ADMIN . 'member-payments.php');
		break;
	
	case 'affstats':
		require_once(STMS_ADMIN . 'member-affstats.php');
		break;
		
	case 'export':
		require_once(STMS_ADMIN . 'member-export.php');
		break;
		
	case 'import':
		require_once(STMS_ADMIN . 'member-import.php');
		break;
		
	case 'bulk_payment':
		require_once(STMS_ADMIN . 'member-bulk-payment.php');
		break;
		
	case 'bulk_payment_remove':
		require_once(STMS_ADMIN . 'member-bulk-payment-remove.php');
		break;
		
	case 'members':
	default:
		$member_table = new stmsMemberList();
		$member_table->prepare_items();
	?>
		<div id="stms-members-table" class="stms-admin-block">
			<h2 class="stms-field-title">Manage Members <a class="add-new-h2" href="#members|mode=add">Add Member</a></h2>
			<?php if ( stms_isset($_REQUEST['member']) == 'added' ) : ?><div class="stms-update-msg stms-member-msg"><p><strong>Member has been added.</strong></p></div><?php endif; ?>
			<?php if ( stms_isset($_REQUEST['member']) == 'deleted' ) : ?><div class="stms-update-msg stms-member-msg"><p><strong>Member has been deleted.</strong></p></div><?php endif; ?>
			<?php if ( stms_isset($_REQUEST['members']) == 'deleted' ) : ?><div class="stms-update-msg stms-member-msg"><p><strong>Member(s) has been deleted.</strong></p></div><?php endif; ?>
			
			<div class="stms-report-searchbox">
				<input type="hidden" id="stms-report-control" value="members" />
				<input type="hidden" id="stms-report-mode" value="<?php echo stms_isset($_GET['mode'], 'members'); ?>" />
				<div>
					<strong>Search: </strong>&nbsp;&nbsp;
					<input type="text" id="stms-search-s" class="stms-field" value="<?php echo stms_cleanup($_GET['s']); ?>" style="width:140px" />&nbsp;&nbsp;
					<strong>Search Filter: </strong>&nbsp;&nbsp;

					<select id="stms-search-trans" class="stms-field" style="width:190px">
						<option value=""> -- Any Account Status -- </option>
						<option value="active" <?php if ( stms_isset($_GET['status']) == 'active' ) echo ' selected="selected"'; ?>>Active</option>
						<option value="inactive" <?php if ( stms_isset($_GET['status']) == 'inactive' ) echo ' selected="selected"'; ?>>Inactive</option>
						<option value="locked" <?php if ( stms_isset($_GET['status']) == 'locked' ) echo ' selected="selected"'; ?>>Locked</option>
					</select>&nbsp;&nbsp;
					
					<select id="stms-search-aff" class="stms-field" style="width:190px">
						<option value=""> -- Any Affiliate Status -- </option>
						<option value="yes" <?php if ( stms_isset($_GET['aff_status']) == 'yes' ) echo ' selected="selected"'; ?>>Affiliate Only</option>
						<option value="pending" <?php if ( stms_isset($_GET['aff_status']) == 'pending' ) echo ' selected="selected"'; ?>>Pending Affiliate</option>
						<option value="no" <?php if ( stms_isset($_GET['aff_status']) == 'no' ) echo ' selected="selected"'; ?>>Non-Affiliate</option>
					</select>&nbsp;&nbsp;
				</div>
				<div>
					<strong>Has Been Paid For: </strong>&nbsp;&nbsp;
					<select id="stms-search-product" class="stms-field" style="width:180px">
						<option value=""> -- Any Product -- </option>
						<option value="none" <?php if ( stms_isset($_GET['product_id']) == 'none' ) echo ' selected="selected"'; ?>> -- None -- </option>
						<?php 
							$prs = stms_get_products();
							if ( is_array($prs) ) {
								foreach ( $prs as $pr ) {
								?>
									<option value="<?php echo $pr->ID; ?>" <?php if ( stms_isset($_GET['product_id']) == $pr->ID ) echo ' selected="selected"'; ?>><?php echo stms_sanitize($pr->title); ?></option>
								<?php
								}
							}
						?>
					</select>&nbsp;&nbsp;
					
					<strong>Payment Status: </strong>&nbsp;&nbsp;
					<select id="stms-search-pystatus" class="stms-field" style="width:190px">
						<option value=""> -- Any Payment Status -- </option>
						<option value="completed" <?php if ( stms_isset($_GET['py_status']) == 'completed' ) echo ' selected="selected"'; ?>>Completed</option>
						<option value="refunded" <?php if ( stms_isset($_GET['py_status']) == 'refunded' ) echo ' selected="selected"'; ?>>Refunded</option>
						<option value="canceled" <?php if ( stms_isset($_GET['py_status']) == 'canceled' ) echo ' selected="selected"'; ?>>Canceled</option>
						<option value="expired" <?php if ( stms_isset($_GET['py_status']) == 'expired' ) echo ' selected="selected"'; ?>>Expired</option>
					</select>&nbsp;&nbsp;
				</div>
				<div>
					<strong>Show Per Page: </strong>&nbsp;&nbsp;
					<select id="stms-per-page" class="stms-field" style="width:180px">
						<option value="10" <?php if ( stms_isset($_GET['row_num'], 10) == 10 ) echo ' selected="selected"'; ?>>10 Members</option>
						<option value="15" <?php if ( stms_isset($_GET['row_num'], 10) == 15 ) echo ' selected="selected"'; ?>>15 Members</option>
						<option value="20" <?php if ( stms_isset($_GET['row_num'], 10) == 20 ) echo ' selected="selected"'; ?>>20 Members</option>
						<option value="30" <?php if ( stms_isset($_GET['row_num'], 10) == 30 ) echo ' selected="selected"'; ?>>30 Members</option>
						<option value="50" <?php if ( stms_isset($_GET['row_num'], 10) == 50 ) echo ' selected="selected"'; ?>>50 Members</option>
						<option value="75" <?php if ( stms_isset($_GET['row_num'], 10) == 75 ) echo ' selected="selected"'; ?>>75 Members</option>
						<option value="100" <?php if ( stms_isset($_GET['row_num'], 10) == 100 ) echo ' selected="selected"'; ?>>100 Members</option>
					</select>&nbsp;&nbsp;
					<input type="button" id="stms-search-btn" value="GO" class="button-primary" />
				</div>
			</div>
		
			<?php if ( isset($_GET['s']) && strlen($_GET['s']) > 1 ) : ?>Search results for "<?php echo trim(urldecode($_GET['s'])); ?>" <a href="<?php echo admin_url('admin.php?page=stms-settings#members'); ?>"><small>reset search</small></a><?php endif; ?>
			
			<?php
			if ( stms_isset($_GET['mass_payment']) == 'added' )
				echo '<div class="stms-update-msg stms-msg-fadeout"><p><strong>Bulk Add Payment action has been executed.</strong></p></div>';
			
			if ( stms_isset($_GET['mass_payment']) == 'deleted' )
				echo '<div class="stms-update-msg stms-msg-fadeout"><p><strong>Bulk Remove Payment action has been executed.</strong></p></div>';
			?>
			
			<form id="stms-member-table" method="get">
		        <!-- For plugins, we also need to ensure that the form posts back to our current page -->
		        <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
		        <!-- Now we can render the completed list table -->
		        <?php $member_table->display(); ?>
		    </form>
			<p style="text-align:right"><a href="#members|mode=add" class="button-primary">Add New Member</a><?php if ( $member_table->has_items() ) : ?>&nbsp;&nbsp;<a href="#members|mode=export" class="button">Export</a><?php endif; ?>&nbsp;&nbsp;<a href="#members|mode=import" class="button">Import</a></p>
		</div>
<?php
}  // switch end



