<?php if ( !defined('STMS_PATH') ) wp_die('Access Denied');
function stms_add_meta_box() {
	if ( !function_exists( 'add_meta_box' ) ) return;
	add_meta_box( 'stms-meta-box-post', 'InstaMember - Protection Settings', 'stms_meta_protection', 'post', 'normal', 'high' );
	add_meta_box( 'stms-meta-box-page', 'InstaMember - Protection Settings', 'stms_meta_protection', 'page', 'side', 'high' );
}

function stms_meta_protection( $post ) {
	$slugs = get_option('stms_slugs');
	$stms = get_option('stms_settings');
	if ( is_array($slugs) ) {
		foreach ( $slugs as $k => $v ) {
			if ( $post->ID == $v ) {
				if ( $k == 'profile' || $k == 'stats' )
					echo "<p class='stms-desc'>This profile page has been automatically protected by InstaMember.</p>";
				else
					echo "<p class='stms-desc'>This page cannot be protected because this page is a " . $k . " page.</p>";
				return;
			}
		}
	}
	
	$global_home = ( isset($stms['global']['home']) ) ? $stms['global']['home'] : 0;
	if ( $post->ID == $global_home ) {
		echo "<p class='stms-desc'>This global membership page has been automatically protected by InstaMember.</p>";
		return;
	}
	
	if ( !$products = stms_get_products() ) {
		echo "<p class='stms-desc'>No product found. " . ucwords($post->post_type) . " cannot be protected.</p>";
		return;
	}
	
	$dripmodes = array(
		'day' => 'Day(s)',
		'week' => 'Week(s)',
		'month' => 'Month(s)',
		'year' => 'Year(s)',
		'exact' => 'Exact Date (mm/dd/yyyy)'
	);
	
	echo '<input type="hidden" name="stms_meta_nonce" id="stms_meta_nonce" value="' . wp_create_nonce( plugin_basename(__FILE__) ) . '" />';
?>
<ul id="stms-meta" class="stms-protection-settings">
	<li class='stms-meta-desc'><strong>Only members that have bought at least one of the following products that can access this <?php echo $post->post_type; ?>:</strong></li>
<?php
	foreach ( $products as $product ) {
		$settings = stms_get_contentdrip($product->ID, $post->ID);
		$checked = ( $settings ) ? ' checked="checked"' : '';
		echo "<li><label for='stms_protect_{$product->ID}' style='display:inline;font-weight:normal'><input type='checkbox' name='stms_protect_product[]' id='stms_protect_{$product->ID}' value='{$product->ID}'{$checked} /> <code><span class='stms-product_name'>" . stms_cleanup($product->title) . "</span></code> <small>(<a href='#' data-productid='{$product->ID}' data-postid='{$post->ID}' class='stms-meta-drip'>drip-feed</a>)</small></label></li>";
	}
?>
</ul>
<div id="stms-post-help-menu">Help: <a href="admin.php?page=stms-settings&insta_pdf=protection" class="pdf_url" target="_blank">PDF</a> | <a href="http://www.youtube.com/watch?v=PBqEXQ9Df5Q" class="insta_video_help video_url" target="_blank">Video</a></div>

<p style="text-align:center; display:none" id="stms-meta-loader"><img src="<?php echo STMS_URL; ?>images/admin-loader.gif" border="0" /><br /><span id="stms-meta-loadtxt">Loading...</span></p>
<ul id="stms-meta" class="stms-drip-settings" style="display:none">
	<li class="drip-update-message" style="display:none"><div class="updated below-h2"><p><strong>Drip-Feed Settings Updated.</strong></p></div></li>
	<li>
		<label>Drip-feed settings for product: <code><span id="stms-drip-name" style="font-weight:normal">%product_name%</span></code></label>
		<div>
			<div class="display:inline-block; width:140px">Available In:</div> <input type="text" id="stms_drip_start" class="protect-date-field" value="" style="width:80px" />
			<select id="stms_drip_start_mode" class="protects-date">
				<?php foreach ( $dripmodes as $k => $v ) {
					echo "<option value='{$k}'>{$v}</option>";
				} ?>
			</select>
		</div>
		<div class="stms-drip-expired" style="display:none">
			<div class="display:inline-block; width:140px">Expired In:</div> <input type="text" id="stms_drip_end" class="protect-date-field protect-drip-end" value="" style="width:80px" />
			<select id="stms_drip_end_mode" class="protects-date">
				<?php foreach ( $dripmodes as $k => $v ) {
					echo "<option value='{$k}'>{$v}</option>";
				} ?>
			</select>
		</div>
		<br /><label for='stms_enable_expire' style='display:inline;font-weight:normal'><input type='checkbox' id='stms_enable_expire' value='1' /> <code>Enable Expiration</code></label>
		<p>
			<input type="hidden" id="stms_product_id" value="0" />
			<input type="hidden" id="stms_post_id" value="<?php echo $post->ID; ?>" />
			<input type="button" id="stms_apply_drip" value="Apply Settings" class="button-primary" />
			<input type="button" id="stms_cancel_drip" value="Back" class="button" />
		</p>
	</li>
<?php
}

add_action( 'save_post', 'stms_save_protection_meta' );
function stms_save_protection_meta( $post_id ) {
	$nonce = stms_isset($_POST['stms_meta_nonce']);
	if ( !wp_verify_nonce( $nonce, plugin_basename(__FILE__) ) )
		return $post_id;
    
	if ( 'page' == $_POST['post_type']  )
    	if ( !current_user_can( 'edit_page', $post_id ) ) return $post_id;
    else
      	if ( !current_user_can( 'edit_post', $post_id ) ) return $post_id;
	
	global $wpdb;
	$post_id = (int) $post_id;
	$stms = get_option('stms_settings');
	$global_home = ( isset($stms['global']['home']) ) ? $stms['global']['home'] : 0;
	
	$sql = "DELETE FROM `{$wpdb->prefix}stms_protects` WHERE `type` = 'content' AND `post_id` = {$post_id}";
	if ( isset($_POST['stms_protect_product']) ) {
		$post_ids = implode(",", $_POST['stms_protect_product']);
		$sql .= " AND `product_id` NOT IN ({$post_ids})";
		foreach ( $_POST['stms_protect_product'] as $product_id ) {
			$chk = $wpdb->get_var(
				$wpdb->prepare(
					"SELECT COUNT(*) FROM `{$wpdb->prefix}stms_protects`
					WHERE `product_id` = %d AND `post_id` = %d AND `type` = %s",
					$product_id, $post_id, 'content'
				)
			);

			if ( $chk > 0 ) {
				// do nothing... we don't want to override the drip settings...
			} else {
				$data = array(
					'type' => 'content',
					'product_id' => $product_id,
					'post_id' => $post_id,
					'is_expired' => 0,
					'drip_start' => 0,
					'drip_end' => 30,
					'drip_start_mode' => 'day',
					'drip_end_mode' => 'day',
					'date' => stms_time()
				);

				$wpdb->insert("{$wpdb->prefix}stms_protects", $data );
			}
		}
	}
	$wpdb->query($sql); // delete unprotected...
	
	$stms = get_option('stms_settings');
	$global_home = ( isset($stms['global']['home']) ) ? $stms['global']['home'] : 0;
	if ( $post_id == $global_home )
		$wpdb->query("DELETE FROM `{$wpdb->prefix}stms_protects` WHERE `post_id` = {$global_home}");
}
