<?php
$report_title = 'Today Sales';
if ( stms_isset($_GET['range']) ) {
	switch ( $_GET['range'] ) {
		case 'yesterday':
			$report_title = 'Yesterday Sales';
			break;
		case 'week':
			$report_title = 'Last 7 Days Sales';
			break;
		case 'month':
			$report_title = 'Last 30 Days Sales';
			break;
		case 'all':
			$report_title = 'All Time Sales';
			break;
	}
}

if ( stms_isset($_GET['s']) != '' ) {
	$keyword = urldecode(stms_cleanup($_GET['s']));
	$report_title = 'Keyword: <span style="color:#000099"><strong>"' . $keyword . '"</strong></span><br />';
}

if ( isset($_GET['start']) ) {
	$def_start = strtotime($admin->user_registered, stms_time());
	if ( !isset($_GET['s']) ) $report_title = '';
	$start = ( !empty($_GET['start']) ) ? strtotime($_GET['start'], stms_time()) : $def_start;
	$end = ( !empty($_GET['end']) ) ? strtotime($_GET['end'], stms_time()) : stms_time();
	$start_date = date("F d, Y", $start);
	$end_date = ' - ' . date("F d, Y", $end);
	$periods = $start_date . $end_date;
	$report_title .= 'Period: <span style="color:#000099"><strong>' . $periods . '</strong></span><br />';
}

?>
<div class="stms-admin-block">
	<h2 class="stms-field-title">Sales Report</h2>
	<div class="stms-report-searchbox">
		<input type="hidden" id="stms-report-mode" value="<?php echo stms_isset($_GET['mode'], 'sales'); ?>" />
		<div>
			<strong>Quick Search: </strong>&nbsp;&nbsp;
			<select id="stms-search-range" class="stms-field">
				<option value=''>[ - Choose Range - ]</option>
				<?php foreach ( $ranges as $key => $val ) {
					$selected = ( !isset($_GET['start']) && stms_isset($_GET['range'], 'today') == $key ) ? ' selected="selected"' : '';
					echo "<option value='{$key}'{$selected}>{$val}</option>";
				} ?>
			</select>
		</div>
		<div>
			<strong>Start Date: </strong>&nbsp;&nbsp;
			<input type="text" id="stms-search-start" class="stms-field" value="<?php echo stms_isset($_GET['start']); ?>" style="width:90px" />&nbsp;&nbsp;
			<strong>End Date: </strong>&nbsp;&nbsp;
			<input type="text" id="stms-search-end" class="stms-field" value="<?php echo stms_isset($_GET['end']); ?>" style="width:90px" />&nbsp;&nbsp;
			<strong>Keyword: </strong>&nbsp;&nbsp;
			<input type="text" id="stms-search-s" class="stms-field" value="<?php echo stms_cleanup($_GET['s']); ?>" style="width:200px" />&nbsp;&nbsp;
		</div>
		<div>
			<strong>Search Filter: </strong>&nbsp;&nbsp;
			<select id="stms-search-product" class="stms-field" style="width:200px">
				<option value=""> -- All Products -- </option>
				<?php
				if ( $products ) {
					foreach ( $products as $product ) {
						$selected = ( stms_isset($_GET['product_id']) == $product->ID ) ? ' selected="selected"' : '';
						echo "<option value='{$product->ID}'{$selected}>$product->title</option>";
					}
				}
				?>
			</select>&nbsp;&nbsp;
			<select id="stms-search-trans" class="stms-field" style="width:160px">
				<option value=""> -- All Transactions -- </option>
				<option value="paid" <?php if ( stms_isset($_GET['status']) == 'paid' ) echo ' selected="selected"'; ?>>Paid Only</option>
				<option value="unpaid" <?php if ( stms_isset($_GET['status']) == 'unpaid' ) echo ' selected="selected"'; ?>>Unpaid Only</option>
				<option value="refunded" <?php if ( stms_isset($_GET['status']) == 'refunded' ) echo ' selected="selected"'; ?>>Refunded Only</option>
			</select>&nbsp;&nbsp;
			<input type="button" id="stms-search-btn" value="Search" class="button-primary" />
		</div>
	</div>
	
	<div class="stms-admin-block">
		<h4><?php echo $report_title; ?></h4>
	<?php
		$report = new stmsSalesReport();
		$report->prepare_items();
	?>
		<form id="stms-sales-report-table" method="get">
	        <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
	        <?php $report->display(); ?>
	    </form>
	</div>
</div>