<?php
$default_welcome = 'Welcome to our support desk. Please search our knowledgebase for any known issues or you can submit a new ticket.';
$welcome_txt = stms_isset($stms['support']['welcome_txt'], $default_welcome);
$welcome_txt = stms_cleanup($welcome_txt, '<strong><em><u><i><b><a><img><span><div><ul><ol><li>');

$slugs = get_option('stms_slugs');
$_handler_url = get_permalink(stms_isset($stms['global']['magic']));
$support_url = stms_format_url($stms['global']['magic'], 'imhandler=support');

$support_id = ( isset($slugs['support']) && $slugs['support'] > 0 ) ? $slugs['support'] : 0;
$support_url = ( $support_id ) ? get_permalink($support_id) : $support_url;
$support_post = ( $support_id ) ? get_post($support_id) : 0;
$support_slug = ( $support_post ) ? $support_post->post_name : '';
$support_orig_url = ( $support_post ) ? str_replace('/' . $support_slug, '', $support_url) : $_handler_url;
?>
<form name="stms_integration_settings" id="stms_integration_settings" method="post">
<input type="hidden" name="action" class="stms-action" value="stms_supportsettings_save" />
<input type="hidden" name="config_name" value="support" />
<div id="stms-support-settings" class="stms-admin-block">
	<h2 class="stms-field-title">Support Desk Settings</h2>
	<div class="stms-update-msg" style="display:none"><p><strong>Settings Saved.</strong></p></div>
	
	<table class="form-table">
	<tr valign="top">
		<th scope="row" style="text-align:right"><label><strong><?php _e('Enable Built-In Support Desk', 'stms'); ?></strong></label></th>
		<td>
			<input type="hidden" name="stms_sets[builtin_support]" value="0" />
			<input type="checkbox" name="stms_sets[builtin_support]" id="stms_builtin_support" data-blockname='stms-builtsupport-sets' data-unblockname='stms-extsupport-sets' class='stms-toggle-checkbox stms-toggle-switch' value="1" <?php if ( stms_isset($stms['support']['builtin_support'], 1) == 1 ) echo 'checked="checked"'; ?> /><span class='stms-toggle-btn'></span>
		</td>
	</tr>
	</table>
	
	<table class="form-table stms-extsupport-sets">
		<tr valign="top" class="stms-attach-sets">
			<th scope="row" style="text-align:right"><label for="stms_support_exturl"><strong><?php _e('External Support URL', 'stms'); ?></strong></label></th>
			<td>
				<input class="stms-field widefat" type="text" name="stms_sets[exturl]" id="stms_support_exturl" value="<?php echo stms_sanitize($stms['support']['exturl']); ?>" />
			</td>
		</tr>
		<tr valign="top" class="stms-attach-sets">
			<th scope="row" style="text-align:right"><label for="stms_support_email"><strong><?php _e('Support Email', 'stms'); ?></strong></label></th>
			<td>
				<input class="stms-field widefat" type="text" name="stms_sets[email]" id="stms_support_email" value="<?php echo stms_sanitize($stms['support']['email']); ?>" />
			</td>
		</tr>
	</table>
	
	<table class="form-table stms-builtsupport-sets">
		<tr valign="top">
			<td colspan="2">
				<p class="stms-desc"><strong>Important: </strong>Support department for each of your product will be created automatically once you added the product. Options to enable "General" and "Affiliates" support departments can be found below.</p>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Your Support Desk URL', 'stms'); ?></strong></label></th>
			<td>
				<span class="stms-slug-txt"><span class="stms-slug-url"><?php echo $support_url; ?></span> <a href="#" class="button stms-edit-slug" data-slug="support">Edit</a> <a href="#" class="button stms-copy-slug" data-url="<?php echo $support_url; ?>">Copy URL</a></span>
				<span class="stms-slug-edit" style="display:none"><?php echo $support_orig_url; ?> <input type="text" class="stms-field stms-slug-name" value="<?php echo $support_slug; ?>" placeholder="e.g. support" style="width:160px" /> <a href="#" class="button stms-save-slug" data-slug="support">Save</a> <a href="#" class="stms-cancel-slug"><small>Cancel</small></a></span>
			</td>
		</tr>
		<tr valign="top" class="stms-attach-sets">
			<th scope="row" style="text-align:right"><label for="stms_support_title"><strong><?php _e('Support Desk Name', 'stms'); ?></strong></label></th>
			<td>
				<input class="stms-field widefat" type="text" name="stms_sets[title]" id="stms_support_title" value="<?php echo stripslashes(stms_isset($stms['support']['title'], get_bloginfo('name') . ' Support Desk')); ?>" />
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_support_welcome"><strong><?php _e('Welcome Text', 'stms'); ?></strong></label></th>
			<td>
				<textarea name="stms_sets[welcome_txt]" id="stms_support_welcome" class="stms-field widefat" style="height:100px"><?php echo $welcome_txt; ?></textarea>
				<div class="stms-desc">All line-breaks will be automatically convert to paragraphs. Allowed HTML tags: <code>&lt;strong&gt;&lt;em&gt;&lt;u&gt;&lt;i&gt;&lt;b&gt;&lt;a&gt;&lt;img&gt;&lt;span&gt;&lt;div&gt;&lt;ul&gt;&lt;ol&gt;&lt;li&gt;</code></div>
			</td>
		</tr>
		
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Enable General Department', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[general]" value="0" />
				<span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[general]" id="stms_support_gen" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['support']['general'], 1) == 1 ) echo 'checked="checked"'; ?> />
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Enable Affiliates Department', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[affiliates]" value="0" />
				<span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[affiliates]" id="stms_support_aff" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['support']['affiliates'], 1) == 1 ) echo 'checked="checked"'; ?> />
			</td>
		</tr>

		<?php if ( is_writable(ABSPATH . 'wp-content/uploads/') ) : ?>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Enable Attachment', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[attachment]" value="0" />
				<input type="checkbox" name="stms_sets[attachment]" id="stms_support_attach" data-blockname='stms-attach-sets' class='stms-toggle-checkbox stms-toggle-switch' value="1" <?php if ( stms_isset($stms['support']['attachment']) == 1 ) echo 'checked="checked"'; ?> /><span class='stms-toggle-btn'></span>
				<div class="stms-desc">You can choose whether to allow or disallow your visitors/members to add an attachment upon submitting a ticket.</div>
			</td>
		</tr>
		<tr valign="top" class="stms-attach-sets">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Enable Private Attachment', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[attachment_priv]" value="0" />
				<span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[attachment_priv]" id="stms_support_attach_priv" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['support']['attachment_priv']) == 1 ) echo 'checked="checked"'; ?> />
				<div class="stms-desc">If this option is enabled, then only members who are logged in that can upload attachment(s).</div>
			</td>
		</tr>
		<tr valign="top" class="stms-attach-sets">
			<th scope="row" style="text-align:right"><label for="stms_support_attach_max"><strong><?php _e('Max. Attachment Count', 'stms'); ?></strong></label></th>
			<td>
				<input class="stms-field" type="text" name="stms_sets[attachment_max]" id="stms_support_attach_max" value="<?php echo stms_isset($stms['support']['attachment_max'], 3); ?>" style="width:100px" />
				<div class="stms-desc">How many files that visitors/members can attach per ticket submission.</div>
			</td>
		</tr>
		<tr valign="top" class="stms-attach-sets">
			<th scope="row" style="text-align:right"><label for="stms_support_attach_maxsize"><strong><?php _e('Max. File Size Per Attachment', 'stms'); ?></strong></label></th>
			<td><input class="stms-field" type="text" name="stms_sets[attachment_maxsize]" id="stms_support_attach_maxsize" value="<?php echo stms_isset($stms['support']['attachment_maxsize'], 1); ?>" style="width:100px" /> MB</td>
		</tr>
		<?php endif; ?>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Enable reCaptcha', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[recaptcha]" value="0" />
				<span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[recaptcha]" id="stms_support_recaptcha" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['support']['recaptcha']) == 1 ) echo 'checked="checked"'; ?> />
				<div class="stms-desc">You may require a non-member to enter a reCaptcha code upon submitting a ticket. Please note that you MUST integrate reCaptcha with InstaMember on the <a href="#integration">Integration Setup</a> page.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Enable Private Submissions', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[priv]" value="0" />
				<span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[priv]" id="stms_support_priv" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['support']['priv']) == 1 ) echo 'checked="checked"'; ?> />
				<div class="stms-desc"><strong>Important:</strong> If this option is enabled, then ONLY MEMBERS that can submit a ticket.<br />Non-Members will not be able to submit a ticket, unless they join your membership first.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_kb_category"><strong><?php _e('Knowledge Base Category', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_sets[kb_category]" id="stms_kb_category" class="stms-field widefat">
					<option value="">[ -- Select a category -- ]</option>
					<?php
					$stms_cats = get_categories( array('hide_empty' => 0 ) );
					if ( $stms_cats ) {
						foreach ( $stms_cats as $cat ) {
							$selected = ( stms_isset($stms['support']['kb_category']) == $cat->cat_ID ) ? ' selected="selected"' : '';
							echo "<option value='{$cat->cat_ID}'{$selected}>$cat->name</option>";
						}
					}
					?>
				</select>
				<div class="stms-desc">You can turn any post into a knowledge base article. Simply choose a category, and all posts under that category will be used by InstaMember as your knowledge base. You can also create sub-categories under this category to serve as specific knowledge bases for each of your product.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Notify Submitter On Reply', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[notify]" value="0" />
				<span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[notify]" id="stms_support_notify" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['support']['notify']) == 1 ) echo 'checked="checked"'; ?> />
				<div class="stms-desc">Notify visitors/members who submitted the ticket via email each time you provide a reply/answer.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Notify Admin On New Ticket', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[admin_notify_new]" value="0" />
				<span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[admin_notify_new]" id="stms_support_admin_notify_new" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['support']['admin_notify_new']) == 1 ) echo 'checked="checked"'; ?> />
				<div class="stms-desc">If this option is enabled, you will be notify each time a new ticket is submitted.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label><strong><?php _e('Notify Admin On Reply', 'stms'); ?></strong></label></th>
			<td>
				<input type="hidden" name="stms_sets[admin_notify]" value="0" />
				<span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[admin_notify]" id="stms_support_admin_notify" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['support']['admin_notify']) == 1 ) echo 'checked="checked"'; ?> />
				<div class="stms-desc">If this option is enabled, you will be notify each time a member/visitor submit a reply.</div>
			</td>
		</tr>
		</table>
</div>
<p style="text-align:right"><input type="button" name="stms-submit-supportsets" id="stms-submit-supportsets" value="Update Settings" class="stms-ajax-save button-primary" /></p>
</form>