<?php
$regs = get_option('stms_reg_links');
$expire_modes = array(
		'never' => 'Never Expire',
		'date' => 'Exact Date',
	);
?>
<div id="stms-global-settings" class="stms-admin-block">
	<div id="member-edit-submenu" class="stms-desc">
		<ul id="stms-submenu">
			<li><a href="#tools" class="stms-submenu-active"><strong>Tools</strong></a></li>
			<li><a href="#blacklist"><strong>Block Email/IP</strong></a></li>
			<li><a href="#forms"><strong>Form Editor</strong></a></li>
			<li><a href="#integration"><strong>Integration</strong></a></li>
			<li><a href="#emails"><strong>Email</strong></a></li>
			<li><a href="#payments"><strong>Payments</strong></a></li>
			<li><a href="#config"><strong>General</strong></a></li>
			<li>Config Menu:</li>
		</ul>
		<br style="clear:right" />
	</div>
</div>

<div class="stms-admin-block">
	<form method="post" name="stms_gen_link" id="stms_gen_link" action="<?php echo admin_url('admin.php?page=stms-settings'); ?>">
	<h2 class="stms-field-title">Generate a Registration Link</h2>
	<?php if ( stms_isset($_GET['link']) == 'generated' ) : ?><div class="stms-update-msg"><p><strong>Registration link has been generated.</strong></p></div><?php endif; ?>
	<?php if ( stms_isset($_GET['link']) == 'deleted' ) : ?><div class="stms-update-msg"><p><strong>Registration link has been deleted.</strong></p></div><?php endif; ?>
	<p class="stms-desc">If you want to offer your product(s) for free for certain people (e.g. JV partners, friends, etc), then you can use the below tool to generate a special registration link for them:</p>
	<input type="hidden" name="action" value="stms_generate_reglink" />
	<table class="form-table">
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_reglink_product"><strong><?php _e('Product', 'stms'); ?></strong></label></th>
			<td>
				<select name="stms_reglink_product" id="stms_reglink_product" class="stms-field-member stms-field widefat">
					<?php
					if ( $products ) {
						foreach ( $products as $product ) {
							if ( $product->type == 'free' ) continue;
							echo "<option value='{$product->ID}'>$product->title</option>";
						}
					}
					?>
				</select>
				<div class="stms-desc">Choose a paid product that will be offered for free.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_reglink_count"><strong><?php _e('Usage Limit', 'stms'); ?></strong></label></th>
			<td><input class="widefat stms-field" type="text" name="stms_reglink_count" id="stms_reglink_count" value="9999" style="width:80px" /> times
			<div class="stms-desc">Number of times the generated registration link can be used.</div>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row" style="text-align:right"><label for="stms_reglink_expire"><strong><?php _e('Expire In', 'stms'); ?></strong></label></th>
			<td>
				<input class="widefat stms-field" type="text" name="stms_reglink_expire" id="stms_reglink_expire" value="" style="width:100px" />
				<select name="stms_reglink_expire_mode" id="stms_reglink_expire_mode" style="width:auto">
					<?php foreach ( $expire_modes as $k => $v ) {
						echo "<option value='{$k}'>{$v}</option>";
					} ?>
				</select>
				<div class="stms-desc">If you want the registration link to be expired, then choose "Exact Date" and enter the expire date (mm/dd/yy).</div>
			</td>
		</tr>
	</table>
	<p style="text-align:right;margin-top:40px"><input type="submit" name="stms_generate_reglink" value="Generate Link" class="button-primary" /></p>
	</form>
	<?php if ( is_array($regs) && count($regs) > 0 ) : ?>
	<h3>Generated Registration Link(s)</h3>
	<table class="wp-list-table widefat fixed">
		<thead>
		<tr valign="top">
			<th scope="col">Registration URL</th>
			<th scope="col" style="width:200px">Product</th>
			<th scope="col" style="width:60px; text-align:center">Used</th>
			<th scope="col" style="width:60px; text-align:center">Limit</th>
			<th scope="col" style="width:80px; text-align:center">Expired</th>
			<th scope="col" style="width:80px; text-align:center">Delete</th>
		</tr>
		</thead>
		<tbody>
			<?php foreach ( $regs as $reg ) { ?>
			<tr valign="top">
				<td><input type="text" value="<?php echo stms_format_url(get_bloginfo('url'), 'insta_mode=freg&id=' . $reg['key'] . '&code=' . $reg['secret']); ?>" class="widefat" onfocus="this.select();" /></td>
				<td><?php echo stms_sanitize($reg['product_title'], ''); ?></td>
				<td style="width:60px; text-align:center"><?php echo stms_isset($reg['used'], 0); ?></td>
				<td style="width:60px; text-align:center"><?php echo stms_isset($reg['count'], 0); ?></td>
				<td style="width:80px; text-align:center"><?php echo (( stms_isset($reg['expired']) == 0 ) ? '-' : date("m/d/Y", $reg['expired'])); ?></td>
				<td style="width:80px; text-align:center"><a href="<?php echo admin_url('admin.php?page=stms-settings&action=stms_reglink_delete&key=' . $reg['key']); ?>" onclick="return confirm('Are you sure you want to delete this registration link?')">Delete</a></td>
			</tr>
			<?php } ?>
		</tbody>
	</table>
	<?php endif; ?>
</div>
