<?php
$slugs = get_option('stms_slugs');
$blog_url = trailingslashit(get_bloginfo('url'));
$_handler_url = get_permalink(stms_isset($stms['global']['magic']));
$handler_url = stms_format_url(stms_isset($stms['global']['magic']), 'imhandler=');
$home_url = get_permalink(stms_isset($stms['global']['home']));
$login_url = $handler_url . 'login';
$logout_url = $handler_url . 'logout';
$support_url = $handler_url . 'support';
$profile_url = $handler_url . 'profile';
$order_lookup_url = $handler_url . 'order_lookup';
$registration_url = $handler_url . 'registration';
$stats_url = $handler_url . 'stats';

$show_front = get_option('show_on_front');
$front_page_id = get_option('page_on_front');

$handler_post = get_post(stms_isset($stms['global']['magic']));
$handler_slug = $handler_post->post_name;
$handler_orig_url = ( $front_page_id == $stms['global']['magic'] ) ? get_permalink($stms['global']['magic']) : str_replace('/' . $handler_slug, '', $_handler_url);

$home_post = get_post(stms_isset($stms['global']['home']));
$home_slug = $home_post->post_name;
$home_orig_url = str_replace('/' . $home_slug, '', $home_url);

// login
$login_id = ( isset($slugs['login']) && $slugs['login'] > 0 ) ? $slugs['login'] : 0;
$login_url = ( $login_id ) ? get_permalink($login_id) : $login_url;
$login_post = ( $login_id ) ? get_post($login_id) : 0;
$login_slug = ( $login_post ) ? $login_post->post_name : '';
$login_orig_url = ( $login_post ) ? str_replace('/' . $login_slug, '', $login_url) : $_handler_url;

// login
$logout_id = ( isset($slugs['logout']) && $slugs['logout'] > 0 ) ? $slugs['logout'] : 0;
$logout_url = ( $logout_id ) ? get_permalink($logout_id) : $logout_url;
$logout_post = ( $logout_id ) ? get_post($logout_id) : 0;
$logout_slug = ( $logout_post ) ? $logout_post->post_name : '';
$logout_orig_url = ( $logout_post ) ? str_replace('/' . $logout_slug, '', $logout_url) : $_handler_url;

// profile
$profile_id = ( isset($slugs['profile']) && $slugs['profile'] > 0 ) ? $slugs['profile'] : 0;
$profile_url = ( $profile_id ) ? get_permalink($profile_id) : $profile_url;
$profile_post = ( $profile_id ) ? get_post($profile_id) : 0;
$profile_slug = ( $profile_post ) ? $profile_post->post_name : '';
$profile_orig_url = ( $profile_post ) ? str_replace('/' . $profile_slug, '', $profile_url) : $_handler_url;

// support
$support_id = ( isset($slugs['support']) && $slugs['support'] > 0 ) ? $slugs['support'] : 0;
$support_url = ( $support_id ) ? get_permalink($support_id) : $support_url;
$support_post = ( $support_id ) ? get_post($support_id) : 0;
$support_slug = ( $support_post ) ? $support_post->post_name : '';
$support_orig_url = ( $support_post ) ? str_replace('/' . $support_slug, '', $support_url) : $_handler_url;

// registration
$registration_id = ( isset($slugs['registration']) && $slugs['registration'] > 0 ) ? $slugs['registration'] : 0;
$registration_url = ( $registration_id ) ? get_permalink($registration_id) : $registration_url;
$registration_post = ( $registration_id ) ? get_post($registration_id) : 0;
$registration_slug = ( $registration_post ) ? $registration_post->post_name : '';
$registration_orig_url = ( $registration_post ) ? str_replace('/' . $registration_slug, '', $registration_url) : $_handler_url;

// stats
$stats_id = ( isset($slugs['stats']) && $slugs['stats'] > 0 ) ? $slugs['stats'] : 0;
$stats_url = ( $stats_id ) ? get_permalink($stats_id) : $stats_url;
$stats_post = ( $stats_id ) ? get_post($stats_id) : 0;
$stats_slug = ( $stats_post ) ? $stats_post->post_name : '';
$stats_orig_url = ( $stats_post ) ? str_replace('/' . $stats_slug, '', $stats_url) : $_handler_url;

// order lookup
$order_lookup_id = ( isset($slugs['order_lookup']) && $slugs['order_lookup'] > 0 ) ? $slugs['order_lookup'] : 0;
$order_lookup_url = ( $order_lookup_id ) ? get_permalink($order_lookup_id) : $order_lookup_url;
$order_lookup_post = ( $order_lookup_id ) ? get_post($order_lookup_id) : 0;
$order_lookup_slug = ( $order_lookup_post ) ? $order_lookup_post->post_name : '';
$order_lookup_orig_url = ( $order_lookup_post ) ? str_replace('/' . $order_lookup_slug, '', $order_lookup_url) : $_handler_url;

?>
<div id="stms-level-form" class="stms-admin-block">
	<h2 class="stms-field-title">Membership URLs</h2>
	<?php if ( stms_isset($_GET['handler_slug']) == 'changed' ) : ?><div class="stms-help-msg"><p><strong>Change Membership Handler Page slug has been changed.</strong></p></div><?php endif; ?>
	
	<ul>
		<li style="color:#666">
			<form method="post" name="handler-slug">
			<input type="hidden" name="_instanonce" value="<?php echo wp_create_nonce('stms-admin-nonce'); ?>" />
			<input type="hidden" name="action" value="stms_change_handlerslug" />
			<input type="hidden" name="slug_id" id="stms_magic_id" value="<?php echo stms_isset($stms['global']['magic']); ?>" />
			<input type="hidden" name="old_slug" value="<?php echo $handler_slug; ?>" />
			<strong>Membership Handler Page slug:</strong><br />
			<?php echo $handler_orig_url; ?> <?php if ( $front_page_id != @$stms['global']['magic'] ) : ?> <input type="text" name="slug_name" id="slug_id" class="stms-field" value="<?php echo $handler_slug; ?>" placeholder="e.g. instamember" style="width:160px" /> <input type="submit" name="handler_slug_submit" id="handler_slug_submit" value="Change" class="button" /><?php endif; ?>
			</form>
		</li>
	</ul>
	<h3>Below is the list of URLs that can be useful for your membership site navigation:</h3>
	<ul>
		<li style="color:#666">
			<strong>Member's Home URL:</strong>
			<span class="stms-slug-txt"><span class="stms-slug-url"><a href="<?php echo $home_url; ?>" target="_blank"><?php echo $home_url; ?></a></span> <a href="#" class="button stms-edit-slug" data-slug="home">Edit</a> <a href="#" class="button stms-copy-slug" data-url="<?php echo $home_url; ?>">Copy URL</a></span>
			<span class="stms-slug-edit" style="display:none"><?php echo $home_orig_url; ?> <input type="text" class="stms-field stms-slug-name" value="<?php echo $home_slug; ?>" placeholder="e.g. member-home" style="width:160px" /> <a href="#" class="button stms-save-slug" data-slug="home">Save</a> <a href="#" class="stms-cancel-slug"><small>Cancel</small></a></span>
		</li>
		<li style="color:#666">
			<strong>Login URL:</strong>
			<span class="stms-slug-txt">
				<span class="stms-slug-url"><a href="<?php echo $login_url; ?>" target="_blank"><?php echo $login_url; ?></a></span>
				<a href="#" class="button stms-edit-slug" data-slug="login">Edit</a>
				<a href="#" class="button stms-copy-slug" data-url="<?php echo $login_url; ?>">Copy URL</a>
			</span>
			<span class="stms-slug-edit" style="display:none"><?php echo $login_orig_url; ?> <input type="text" class="stms-field stms-slug-name" value="<?php echo $login_slug; ?>" placeholder="e.g. login" style="width:160px" /> <a href="#" class="button stms-save-slug" data-slug="login">Save</a> <a href="#" class="stms-cancel-slug"><small>Cancel</small></a></span>
		</li>
		<li style="color:#666">
			<strong>Logout URL:</strong>
			<span class="stms-slug-txt">
				<span class="stms-slug-url"><a href="<?php echo $logout_url; ?>" target="_blank"><?php echo $logout_url; ?></a></span>
				<a href="#" class="button stms-edit-slug" data-slug="logout">Edit</a>
				<a href="#" class="button stms-copy-slug" data-url="<?php echo $logout_url; ?>">Copy URL</a>
			</span>
			<span class="stms-slug-edit" style="display:none"><?php echo $logout_orig_url; ?> <input type="text" class="stms-field stms-slug-name" value="<?php echo $logout_slug; ?>" placeholder="e.g. logout" style="width:160px" /> <a href="#" class="button stms-save-slug" data-slug="logout">Save</a> <a href="#" class="stms-cancel-slug"><small>Cancel</small></a></span>
		</li>
		<li style="color:#666">
			<strong>Member's Profile URL:</strong>
			<span class="stms-slug-txt"><span class="stms-slug-url"><a href="<?php echo $profile_url; ?>" target="_blank"><?php echo $profile_url; ?></a></span> <a href="#" class="button stms-edit-slug" data-slug="profile">Edit</a> <a href="#" class="button stms-copy-slug" data-url="<?php echo $profile_url; ?>">Copy URL</a></span>
			<span class="stms-slug-edit" style="display:none"><?php echo $profile_orig_url; ?> <input type="text" class="stms-field stms-slug-name" value="<?php echo $profile_slug; ?>" placeholder="e.g. profile" style="width:160px" /> <a href="#" class="button stms-save-slug" data-slug="profile">Save</a> <a href="#" class="stms-cancel-slug"><small>Cancel</small></a></span>
		</li>
		<li style="color:#666">
			<strong>Support Desk URL:</strong>
			<span class="stms-slug-txt"><span class="stms-slug-url"><a href="<?php echo $support_url; ?>" target="_blank"><?php echo $support_url; ?></a></span> <a href="#" class="button stms-edit-slug" data-slug="support">Edit</a> <a href="#" class="button stms-copy-slug" data-url="<?php echo $support_url; ?>">Copy URL</a></span>
			<span class="stms-slug-edit" style="display:none"><?php echo $support_orig_url; ?> <input type="text" class="stms-field stms-slug-name" value="<?php echo $support_slug; ?>" placeholder="e.g. support" style="width:160px" /> <a href="#" class="button stms-save-slug" data-slug="support">Save</a> <a href="#" class="stms-cancel-slug"><small>Cancel</small></a></span>
		</li>
		<li style="color:#666">
			<strong>Find Order URL:</strong>
			<span class="stms-slug-txt"><span class="stms-slug-url"><a href="<?php echo $order_lookup_url; ?>" target="_blank"><?php echo $order_lookup_url; ?></a></span> <a href="#" class="button stms-edit-slug" data-slug="support">Edit</a> <a href="#" class="button stms-copy-slug" data-url="<?php echo $order_lookup_url; ?>">Copy URL</a></span>
			<span class="stms-slug-edit" style="display:none"><?php echo $order_lookup_orig_url; ?> <input type="text" class="stms-field stms-slug-name" value="<?php echo $order_lookup_slug; ?>" placeholder="e.g. find-order" style="width:160px" /> <a href="#" class="button stms-save-slug" data-slug="order_lookup">Save</a> <a href="#" class="stms-cancel-slug"><small>Cancel</small></a></span>
		</li>
		<?php if ( stms_isset($stms['global']['free_aff'], 1) == 1 ) : ?>
			<li style="color:#666">
				<strong>Affiliate Registration URL:</strong>
				<span class="stms-slug-txt"><span class="stms-slug-url"><a href="<?php echo $registration_url; ?>" target="_blank"><?php echo $registration_url; ?></a></span> <a href="#" class="button stms-edit-slug" data-slug="registration">Edit</a> <a href="#" class="button stms-copy-slug" data-url="<?php echo $registration_url; ?>">Copy URL</a></span>
				<span class="stms-slug-edit" style="display:none"><?php echo $registration_orig_url; ?> <input type="text" class="stms-field stms-slug-name" value="<?php echo $registration_slug; ?>" placeholder="e.g. registration" style="width:160px" /> <a href="#" class="button stms-save-slug" data-slug="registration">Save</a> <a href="#" class="stms-cancel-slug"><small>Cancel</small></a></span>
			</li>
		<?php endif; ?>
		<li style="color:#666">
			<strong>Affiliate Stats URL:</strong>
			<span class="stms-slug-txt"><span class="stms-slug-url"><a href="<?php echo $stats_url; ?>" target="_blank"><?php echo $stats_url; ?></a></span> <a href="#" class="button stms-edit-slug" data-slug="stats">Edit</a> <a href="#" class="button stms-copy-slug" data-url="<?php echo $stats_url; ?>">Copy URL</a></span>
			<span class="stms-slug-edit" style="display:none"><?php echo $stats_orig_url; ?> <input type="text" class="stms-field stms-slug-name" value="<?php echo $stats_slug; ?>" placeholder="e.g. stats" style="width:160px" /> <a href="#" class="button stms-save-slug" data-slug="stats">Save</a> <a href="#" class="stms-cancel-slug"><small>Cancel</small></a></span>
		</li>
	</ul>
	<p style="color:#808080"><strong>Note:</strong> Registration or Payment URL for a specific product can be obtained from the "Products" menu (under "Reg/Pay Button").</p>
</div>