<?php
if ( !class_exists('WP_List_Table') )
    require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
    
class stmsAccessLog extends WP_List_Table {
	function __construct() {
		global $wpdb;
		// Set parent defaults
        parent::__construct( array(
            'singular'  => 'access',     // singular name of the listed records
            'plural'    => 'accesses',    // plural name of the listed records
            'ajax'      => true        // does this table support ajax?
        ));
	}
	
	function column_default($item, $column_name) {
		$value = '';
        switch ($column_name) {
            case 'time':
			case 'ipaddr':
                $value = $item[$column_name];
				break;
            default:
                return stms_dump($item); // Show the whole array for troubleshooting purposes
        }
		
		return $value;
    }
	
	function column_title($item) {
        // Build row actions
        $actions = array();
        // Return the title contents
        return sprintf('%1$s %2$s',
            $item['title'],
            $this->row_actions($actions)
        );
    }
	
	function column_cb($item) {
        return sprintf(
            '',
            /*$1%s*/ $this->_args['singular'],  //Let's simply repurpose the table's singular label
            /*$2%s*/ $item['ID']                //The value of the checkbox should be the record's id
        );
    }
	
	function get_columns() {
        $columns = array(
            'cb' => '', // Render a checkbox instead of text
            'title' => 'Referrer',
            'time'    => 'Time',
            'ipaddr'  => 'IP Address',
        );
        return $columns;
    }
	
	function get_bulk_actions() {
        $actions = array();
        return $actions;
    }
	
	function process_bulk_action() {
		// do nothing
	}
	
	function no_items() {
		echo 'No license log found.';
	}
	
	function prepare_items() {
        global $wpdb; // This is used only if making any database queries

        $per_page = 15;
        $columns = $this->get_columns();
        $hidden = array();
        $sortable = $this->get_sortable_columns();
        $this->_column_headers = array($columns, $hidden, $sortable);
        $this->process_bulk_action();
		
		$current_page = $this->get_pagenum();
        $logs = stms_tabledata_accesslog($per_page);

        $total_items = $logs['total'];
        $this->items = $logs['data'];
        $this->set_pagination_args( array(
            'total_items' => $total_items,                  // We have to calculate the total number of items
            'per_page'    => $per_page,                     // We have to determine how many items to show on a page
            'total_pages' => ceil($total_items/$per_page)   // We have to calculate the total number of pages
        ));
    }
}