<?php

class stmsBruteForce {
	var $ipaddress;
    var $brute_count;
    var $brute_delay;
    
	function __construct( $brute_count = 5, $brute_delay = 2, $ipaddress = '' ) {
		$this->brute_count = $brute_count;
        $this->brute_delay = $brute_delay;
		$this->ipaddress = $ipaddress;
	}
	
	function setLoginFailed() {
		$attempts = 1;
		$prev_data = get_transient('stms_brute_' . $this->ipaddress);
		if ( !empty($prev_data) )
			$attempts += intval(stms_isset($prev_data['attempts']));
		
		$data = array(
				'ip' => $this->ipaddress,
				'attempts' => $attempts,
				'last_attempt' => stms_time()
			);
		set_transient('stms_brute_' . $this->ipaddress, $data, 60*60*12);
	}
	
	function checkBrute() {
		$data = get_transient('stms_brute_' . $this->ipaddress);
		if ( empty($data) )
  			return false;
		
  		if ( stms_isset($data['attempts']) < $this->brute_count )
      		return false;
  			
		if ( (stms_time() - stms_isset($data['last_attempt'])) > ($this->brute_delay * 60) ) {
            delete_transient('stms_brute_' . $this->ipaddress);
            return false;
        }
		return true;
	}
}
