<?php
if ( !class_exists('WP_List_Table') )
    require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
    
class stmsLicenseUsage extends WP_List_Table {
	function __construct() {
		global $wpdb;
		// Set parent defaults
        parent::__construct( array(
            'singular'  => 'license',     // singular name of the listed records
            'plural'    => 'licenses',    // plural name of the listed records
            'ajax'      => true        // does this table support ajax?
        ));
	}
	
	function column_default($item, $column_name) {
		$value = '';
        switch ($column_name) {
			case 'member':
			case 'product':
			case 'installed':
			case 'status':
                $value = $item[$column_name];
				break;
            default:
                return stms_dump($item); // Show the whole array for troubleshooting purposes
        }
		
		return $value;
    }
	
	function column_title($item) {
        // Build row actions
        $actions = array();
		$actions['log'] = sprintf('<a href="#licenses|mode=log&object_ID=%d">Details</a>', $item['ID']);
		if ( $item['status_code'] != 1 && $item['status_code'] != 3 && $item['status_code'] != 4 ) 
			$actions['reactivate'] = sprintf('<a href="%s&ID=%s&action=stms_license_reactivate" onclick="return confirm(\'Are you sure want to reactivate this license?\');">Reactivate</a>', admin_url('admin.php?page=' . $_REQUEST['page']), $item['ID']);
		//if ( $item['status_code'] == 1 || $item['status_code'] == 2 )
			//$actions['deactivate'] = sprintf('<a href="%s&ID=%s&action=stms_license_deactivate" onclick="return confirm(\'Are you sure want to deactivate this license?\');">Deactivate</a>',  admin_url('admin.php?page=' . $_REQUEST['page']), $item['ID']);
		if ( $item['status_code'] == 1 ) 
			$actions['suspend'] = sprintf('<a href="%s&ID=%s&action=stms_license_suspend" onclick="return confirm(\'Are you sure want to suspend this license?\');">Suspend</a>',  admin_url('admin.php?page=' . $_REQUEST['page']), $item['ID']);
		
		$actions['delete'] = sprintf('<a href="%s&ID=%s&action=stms_license_delete" onclick="return confirm(\'Are you sure want to delete this license?\');">Delete</a>',  admin_url('admin.php?page=' . $_REQUEST['page']), $item['ID']);
		
        // Return the title contents
        return sprintf('%1$s %2$s',
            '<a href="#licenses|mode=log&object_ID=' . $item['ID'] . '"><strong>' . $item['title'] . '</strong></a>',
            $this->row_actions($actions)
        );
    }
	
	function column_cb($item) {
        return sprintf(
            '<input type="checkbox" name="%1$s[]" value="%2$s" />',
            /*$1%s*/ $this->_args['singular'],  //Let's simply repurpose the table's singular label
            /*$2%s*/ $item['ID']                //The value of the checkbox should be the record's id
        );
    }
	
	function get_columns() {
        $columns = array(
            'cb' => '<input type="checkbox" />', // Render a checkbox instead of text
            'title' => 'License Key',
            'member'  => 'Member',
            'product'  => 'Product',
            'installed' => 'Installed',
            'status'  => 'Status'
            
        );
        return $columns;
    }
	
	/*
	function get_sortable_columns() {
        $sortable_columns = array(
            'title' => array('title', false),     // true means it's already sorted
            'receipt'    => array('receipt', false),
            'period'    => array('period', false),
            'paid'    => array('paid', false),
            'status'    => array('status', false),
            'amount'    => array('amount', false)
        );
        return $sortable_columns;
    }
	*/
	
	function get_bulk_actions() {
        $actions = array(
            'stms_bulk_license_suspend' => 'Suspend',
            //'stms_bulk_license_deactivate' => 'Deactivate',
            'stms_bulk_license_reactivate' => 'Reactivate',
            'stms_bulk_license_delete' => 'Delete'
        );
        return $actions;
    }
	
	function process_bulk_action() {
		// Do nothing
	}
	
	function no_items() {
		echo 'No license found.';
	}
	
	function prepare_items() {
        global $wpdb; // This is used only if making any database queries

        $per_page = 15;
        $columns = $this->get_columns();
        $hidden = array();
        $sortable = $this->get_sortable_columns();
        $this->_column_headers = array($columns, $hidden, $sortable);
        $this->process_bulk_action();
        $data = stms_tabledata_license();
                
        $current_page = $this->get_pagenum();
        $total_items = count($data);
        $data = array_slice($data,(($current_page-1) * $per_page), $per_page);
        $this->items = $data;
        $this->set_pagination_args( array(
            'total_items' => $total_items,                  // We have to calculate the total number of items
            'per_page'    => $per_page,                     // We have to determine how many items to show on a page
            'total_pages' => ceil($total_items/$per_page)   // We have to calculate the total number of pages
        ));
    }
}