<?php
set_time_limit(0);
ignore_user_abort();

define('DOING_CRON', true);

$path = substr( dirname(__FILE__), 0, strpos(dirname(__FILE__), 'wp-content') );
require_once $path . 'wp-load.php';

$stms = get_option('stms_settings');
$queued_count = stms_isset($stms['emails']['queued_count'], 200);
$queued_count = ( $queued_count > 900 ) ? 900 : $queued_count;
$per_minutes = round($queued_count / 60);
$per_minutes = ( $per_minutes > 1 ) ? $per_minutes - 1 : (( $per_minutes > 60 ) ? 60 : $per_minutes);
$sleep = round((60 - ($per_minutes*2)));
$sleep = ( $sleep <= 0 ) ? 1 : $sleep;

/*
echo '<pre>';
echo '<strong>Email Delivery Settings:</strong><br />';
echo 'Emails per minutes: ' . $per_minutes . '<br />';
echo 'Sleep time per execution: ' . $sleep . '<br />';
echo 'Emails per hour: ' . ($per_minutes * 60) . '<br />';
echo 'Emails per day: ' . ($per_minutes * 60 * 24) . '<br />';
echo '</pre>';
*/

$limit = $per_minutes;
for ( $i = 0; $i < 14; $i++ ) {
	$b = $i + 1;
	$emails = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}stms_email_queue` ORDER BY ID ASC LIMIT {$limit}");
	if ( !$emails )
		die('No emails in queue.');
	
	echo '<p>Start Batch #' . $b . '</p>';
	foreach ( $emails as $email ) {
		if ( $email->broadcast_id > 0 ) {
			if ( $msg = stms_get_broadcast_email($email->broadcast_id) ) {
				$to = sanitize_email($email->email);
				$subject = stms_sanitize($msg->subject);
				$subject = stms_parse_mail_tags($subject, '', $email->member_id);
				
				$body = stms_sanitize($msg->body);
				$body = stms_parse_mail_tags($body, '', $email->member_id);
				
				// add email body footer...
				$hashed_email = base64_encode(sanitize_email($email->email));
				$unsubscribe_url = stms_format_url(get_bloginfo('url'), 'sub=' . $hashed_email . '&insta_mode=unsubscribe');
				
				$body .= "\n\n\n\n" . stms_sanitize($stms['global']['business_addr']) . "\n\n";
				$body .= "-----------------------------------\n" .
						 "Use the following link to unsubscribe:\n" .
						 $unsubscribe_url . "\n\n\n";
			
				if ( $send = stms_send_broadcast_email($to, $subject, $body) ) {
					$wpdb->delete("{$wpdb->prefix}stms_email_queue", array('ID' => $email->ID));
					echo '<p>Email sent to: ' . $email->email . '</p>';
				} else
					echo '<p>Email NOT sent to: ' . $email->email . '</p>';
				sleep(1);
			}
		}
	}
	echo '<p>End of Batch #' . $b . '</p>';
	sleep($sleep);
}

// let's clean up some log here...
$very_old_time = strtotime("30 days ago", stms_time());
$old_time = strtotime("7 days ago", stms_time());
$wpdb->query("DELETE FROM `{$wpdb->prefix}stms_access_log` WHERE `date` <= {$old_time}"); // clear old access logs
$wpdb->query("DELETE FROM `{$wpdb->prefix}stms_error_log` WHERE `date` <= {$very_old_time}"); // clear old error logs

// let's clean up old temporary data
stms_delete_old_payments();
stms_delete_old_members();

function stms_get_broadcast_email( $broadcast_id ) {
	global $wpdb;
	$ID = intval($broadcast_id);
	$email = get_transient('stms_broadcast_' . $ID);
	if ( !$email ) {
		$email = $wpdb->get_row("SELECT * FROM {$wpdb->prefix}stms_broadcasts WHERE ID = {$ID}");
		if ( !$email )
			return false;
	
		set_transient('stms_broadcast_' . $ID, $email, 60*15);
	}
	return $email;
}
