<?php
define('DOING_CRON', true);

$path = substr( dirname(__FILE__), 0, strpos(dirname(__FILE__), 'wp-content') );
require_once $path . 'wp-load.php';

if ( !class_exists('ConstantContact') )
	require_once(STMS_SOURCES . 'ctct/autoload.php');

use Ctct\Auth\CtctOAuth2;
use Ctct\Auth\SessionDataStore;
use Ctct\Exceptions\OAuth2Exception;

$stms = get_option('stms_settings');
$api_key = stms_isset($stms['integration']['cc']['consumer_key']);
$secret_key = stms_isset($stms['integration']['cc']['secret_key']);
$redirect_url = STMS_URL . 'ctct.php';

$oauth = new CTCTOauth2($api_key, $secret_key, $redirect_url);
if ( isset($_GET['code']) ) {
	try {
		$accessToken = $oauth->getAccessToken($_GET['code']);
	} catch ( OAuth2Exception $ex ) {
		delete_option('stms_constant_token');
		echo '<p style="color:#cc0000">Error: ' . $ex->getMessage() . '</p>';
		die();
	}

	$session_consumer = array('username' => $_GET['username'], 'access_token' => $accessToken );
	update_option('stms_constant_token', $session_consumer);
	
	// update constantcontact lists
	if ( function_exists('stms_update_cc_lists') ) {
		$stms_lists = get_option('stms_ar_lists');
		if ( !is_array($stms_lists) )
			$stms_lists = array();
		$stms_lists['cc'] = stms_update_cc_lists();
		update_option('stms_ar_lists', $stms_lists);
	}
}

// redirect back to integration page...
@header('Location: ' . admin_url('admin.php?page=stms-settings') . '#integration');
exit;