<?php
function stms_submit_constantcontact( $data ) {
	if ( !is_array($data) )
		return false;
	
	require_once(STMS_SOURCES . 'ctct/autoload.php');

	$stms = get_option('stms_settings');
	$token = get_option('stms_constant_token');
	
	$stms = get_option('stms_settings');
	$api_key = stms_isset($stms['integration']['cc']['consumer_key']);
	$secret_key = stms_isset($stms['integration']['cc']['secret_key']);
	
	if ( empty($data['list'])
		|| empty($token)
		|| empty($api_key)
		|| empty($secret_key)
	) {
		return false;
	}
	
	if ( !$member = stms_member($data['member_id']) ) 
		return false;
	
	$list_id = $data['list'];
	$email = sanitize_email($member->email);
	$first_name = ( !empty($member->first_name) ) ? $member->first_name : $member->username;
	$last_name = ( !empty($member->last_name) ) ? $member->last_name : '';
	$access_token = $token['access_token']['access_token'];
	// add to contact first
	$cc = new Ctct\ConstantContact($api_key);
	try {
		// check to see if a contact with the email addess already exists in the account
        $response = $cc->getContactByEmail($access_token, $email);
		// create a new contact if one does not exist
		if ( empty($response->results) ) {
			$contact = new Ctct\Components\Contacts\Contact();
            $contact->addEmail($email);
            $contact->addList($list_id);
            $contact->first_name = $first_name;
            $contact->last_name = $last_name;
			try {
            	$returnContact = $cc->addContact($access_token, $contact);
			} catch ( Ctct\Exceptions\CtctException $ex ) {
				return false;
			}
		// update the existing contact if address already existed
		} else {
		 	$contact = $response->results[0];
            $contact->addList($list_id);
            $contact->first_name = $first_name;
            $contact->last_name = $last_name;
			try {
            	$returnContact = $cc->updateContact($access_token, $contact);
			} catch ( Ctct\Exceptions\CtctException $ex ) {
				return false;
			}
		}
	} catch ( Ctct\Exceptions\CtctException $ex ) {
		return false;
	}
}

function stms_update_cc_lists() {
	require_once(STMS_SOURCES . 'ctct/autoload.php');
	
	$stms = get_option('stms_settings');
	$api_key = stms_isset($stms['integration']['cc']['consumer_key']);
	$secret_key = stms_isset($stms['integration']['cc']['secret_key']);
	$token = get_option('stms_constant_token');
	if ( empty($api_key) && empty($secret_key) || !is_array($token) )
		return false;
	
    $cc = new Ctct\ConstantContact($api_key);
	try {
    	$cc_lists = $cc->getLists($token['access_token']['access_token']);
	} catch ( Ctct\Exceptions\CtctException $ex ) {
    	return false;
	}
	
	$lists = array();
	if ( sizeof($cc_lists) <= 0 )
		return false;
	
	foreach ( $cc_lists as $list ) {
		$lists[$list->id] = $list->name;
	}
	return $lists;
}