<?php if ( !defined('STMS_PATH') ) wp_die('Access Denied');

add_action('template_redirect', 'stms_slug_handler', 5);
function stms_slug_handler() {
	if ( !is_page() )
		return;
	
	global $post;
	
	$actual_var = ( isset($_GET['imhandler']) ) ? true : false;
	
	$slugs = get_option('stms_slugs');
	if ( !is_array($slugs) || count($slugs) < 1 )
		return;
	
	$ids = array();
	$type = '';
	foreach ( $slugs as $key => $val ) {
		if ( $post->ID == $val ) {
			$type = $key;
			break;
		}
	}
	
	if ( !empty($type) ) {
		$_GET['imhandler'] = $type;
		$_REQUEST['imhandler'] = $type;
	} else if ( !$actual_var && empty($type) ) {
		unset($_GET['imhandler'], $_REQUEST['imhandler']);
	}
}

/*
add_action('template_redirect', 'protect_cats');
function protect_cats() {
	if ( is_category() ) {
		$cat = get_the_category();
		stms_dump($cat);
		exit;
	}
}
*/

add_action('template_redirect', 'stms_handler_page');
function stms_handler_page() {
	if ( !is_singular() )
		return;
	
	global $post;
	$stms = get_option('stms_settings');
	$home_url = get_permalink($stms['global']['home']);
	$login_url = stms_login_url($home_url);
	if ( !isset($_GET['imhandler']) ) {
		$handler_id = stms_isset($stms['global']['magic']);
		if ( $handler_id == $post->ID ) {
			$is_loggedin = false;
			$is_adminunlock = false;
			
			if ( is_stmsmember_logged_in() )
				$is_loggedin = true;
			
			if ( ( is_stms_admin() && stms_isset($stms['global']['admin_unlock']) == 1 ) )
				$is_adminunlock = true;
			
			if ( $is_adminunlock )
				return;
			else {
				if ( $is_loggedin ) {
					$url = $home_url;
				} else {
					$url = $login_url;
				}
				wp_redirect($url);
				exit;
			}
		}
		return;
	}
	
	if ( $_GET['imhandler'] == 'registration' ) {
		if ( isset($_GET['key']) ) {
			$session = base64_decode($_GET['key']);
			$key = explode("|", $session);
			$payment = stms_isset($key[1]);
			if ( $payment == 'authorize' ) {
				if ( !is_ssl() && stms_isset($stms['payments']['authorize']['test']) != 1 ) {
					$new_url = "https://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
					wp_redirect($new_url);
					exit;
				}
			}
		} else if ( stms_isset($stms['global']['free_aff'], 1) != 1 ) {
				wp_die('ERROR: The page you\'re looking for is not exists.');
		}
	} else if ( $_GET['imhandler'] == 'profile' || $_GET['imhandler'] == 'stats' ) {
		$proto = ( is_ssl() ) ? 'https://' : 'http://';
		$redir = $proto . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
		$login_url = stms_login_url($redir);
		if ( is_stmsmember_logged_in() ) {
			$member = stms_get_current_member();
			if ( $member->status == 4 ) {
				@stms_clear_auth_cookie();
				wp_redirect($login_url);
				exit;
			}
		} else {
			wp_redirect($login_url);
			exit;
		}
	} else if ( $_GET['imhandler'] == 'support' ) {
		$support = $stms['support'];
		$builtin = ( isset($support['builtin_support']) ) ? $support['builtin_support'] : 1;
		
		if ( $builtin != 1 ) {
			if ( !empty($support['exturl']) && filter_var($support['exturl'], FILTER_VALIDATE_URL) ) {
				wp_redirect($support['exturl']);
				exit;
			} 
			
			if ( !empty($support['email']) && filter_var($support['email'], FILTER_VALIDATE_EMAIL) ) {
				wp_die('If you have any questions regarding our products/services, you can send an email to <a href="mailto:' . $support['email'] . '">' . $support['email'] . '</a>', 'Contact Us');
			}
			
			wp_die('ERROR: Support desk or email hasn\'t been configured.');
		}
		
		$ticket_url = stms_get_handler_url('support');
		if ( stms_isset($_GET['mode']) == 'ticket' ) {
			$qry_str = ( isset($_GET['id']) ) ? '&mode=ticket&id=' . $_GET['id'] : '&mode=ticket';
			$login_url = stms_login_url($ticket_url . $qry_str);
			if ( stms_isset($support['priv'], 0) == 1 && !is_stmsmember_logged_in() && !is_stms_admin() ) {
				wp_redirect($login_url);
				exit;
			}
			
			if ( isset($_GET['id']) ) {
				$allow = true;
				if ( !$ticket = stms_get_ticket($_GET['id']) )
					$allow = false;
				
				if ( $allow ) {
					if ( !is_stms_admin() && !is_stmsmember_logged_in() ) {
						if ( $ticket->member_id > 0 ) // this is a member ticket... guest cannot seen it...
							$allow = false;
					} else if ( !is_stms_admin() && is_stmsmember_logged_in() ) {
						$current_member_id = stms_get_current_member_id();
						if ( $current_member_id != $ticket->member_id )
							$allow = false;
					}
				}
				
				// if not allowed...
				if ( !$allow ) {
					wp_redirect($ticket_url);
					exit;
				}
			}		
		}
	} else if ( $_GET['imhandler'] == 'resetpass' ) {
		$forgot_url = stms_format_url(stms_isset($stms['global']['magic']), 'imhandler=forgot');
		$email = urldecode(stms_isset($_GET['email'],''));
		$key = urldecode(stms_isset($_GET['key'], ''));
		$error = false;
		if ( !$member = stms_get_data_by('email', $email) )
			$error = true;
		
		$forgot_key = get_transient('stms_forgot_' . $member->ID);
		if ( $forgot_key != $key )
			$error = true;
		
		if ( $error ) {
			//wp_redirect($forgot_url);
			exit;
		}
	} else if ( $_GET['imhandler'] == 'checkout' ) {
		$sflow = get_option('stms_sales_flow');
		$flow_id = $_GET['flow_id'];
		$paysys = stms_isset($_COOKIE['__insta_flpaysys']);

		if ( !(isset($sflow[$flow_id])) || ($paysys != 'authorize') || !($items = sflow_get_cart_items($flow_id)) ) {
			wp_redirect($home_url);
			exit;
		}
		
		if ( !is_ssl() && stms_isset($stms['payments']['authorize']['test']) != 1 ) {
			$new_url = "https://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
			wp_redirect($new_url);
			exit;
		}
	} else if ( $_GET['imhandler'] == 'login' ) {
		if ( is_stmsmember_logged_in() ) {
			$redir = ( isset($_GET['redir']) ) ? urldecode($_GET['redir']) : '';
			$url = ( filter_var($redir, FILTER_VALIDATE_URL) ) ? $redir : $home_url;
			wp_redirect($url);
			exit;
		}
	}

	$title_filter = true;
	if ( function_exists('seo_title_tag') || has_action('wp_title', 'genesis_default_title') ) $title_filter = false;
	
	if ( $title_filter ) add_filter('wp_title', 'stms_wp_title_hooks', 99, 2);
	add_filter('the_title', 'stms_post_title_hooks', 99, 2);
	add_filter('the_content', 'stms_form_hooks', 99);
}

function stms_form_hooks($content) {
	$new_content = $content;
	if ( in_the_loop() ) {
		switch ( $_REQUEST['imhandler'] ) {
			case 'login':
				$redir = stms_isset($_REQUEST['redir']);
				$new_content = stms_login_form($redir);
				break;
			case 'registration':
				if ( isset($_REQUEST['key']) ) {
					$session = $_REQUEST['key'];
					$new_content = stms_registration_form($session);
				} else {
					$new_content = stms_affiliate_form();
				}
				break;
			case 'profile':
				$new_content = stms_profile_form();
				break;
			case 'support':
				$new_content = stms_support_desk(stms_isset($_GET['mode']));
				break;
			case 'forgot':
				$new_content = stms_forgotpass_form();
				break;
			case 'resetpass':
				$new_content = stms_resetpass_form();
				break;
			case 'stats':
				$new_content = stms_affstats_form();
				break;
			case 'checkout':
				$new_content = stms_upsell_checkout_form();
				break;
			case 'order_lookup':
				$new_content = stms_order_lookup_form();
				break;
		}
	}
	return $new_content;
}

function stms_registration_form( $session ) {
	if ( empty($session) )
		return 'ERROR: Registration Page Not Found.';
	
	$stms = get_option('stms_settings');
	$currency = stms_isset($stms['global']['currency'], 'USD');
	$defaults = stms_default_forms();
	$fields = ( isset($stms['form_signup']) ) ? stms_build_form_fields($stms['form_signup'], 'signup') : stms_isset($defaults['signup']);
	$label = ( stms_isset($stms['form_signup']['button_label']) != '' ) ? stms_cleanup($stms['form_signup']['button_label']) : $defaults['signup']['label'];
	$nonce = wp_create_nonce('stms-nonce');
	$home_url = get_bloginfo('url');
	
	$_session = $session;
	$session = base64_decode($session);
	$key = explode("|", $session);
	
	$product_id = (int) $key[0];
	$payment = stms_isset($key[1]);
	$gateway = stms_isset($key[2]);
	if ( !$product = stms_get_product($product_id) )
		return 'ERROR: Product Not Found.';
	
	$total_price = ( $product->type == 'recurr' && $product->is_trial == 1 ) ? $product->t_price : $product->price;
	
	$display_form = true;
	if ( is_stmsmember_logged_in() )
		$display_form = false;
	
	$can_access = true;
	$is_paid = false;
	$special = false;
	if ( isset($_GET['special_id']) ) {
		$regs = get_option('stms_reg_links');
		$key = trim($_GET['special_id']);
		if ( isset($regs[$key]) ) {
			$special = true;
		}
	}
	
	if ( $payment != 'free' && $payment != 'authorize' && $product->info['steps'] == '2,1' || $special ) {
		$can_access = false;
		if ( isset($_GET['insta_token']) ) {
			$token = rawurldecode($_GET['insta_token']);
			$insta_token = get_transient('insta_token_' . $token);
			if ( stms_isset($insta_token['token']) == $token ) {
				$can_access = true;
				$is_paid = true;
				$display_form = true;
			}
		}
	}

	// This form is not accessible, visitors must completed the payment first...
	if ( !$can_access ) {
		// redirect to payment system...
		$payment_url = stms_format_url(get_bloginfo('url'), "insta_pay={$gateway}&id={$product->ID}");
		@wp_safe_redirect($payment_url);
		exit;
	}
	
	if ( $payment != 'free' ) {
		$payname = stms_getpaymentname($payment);
		if ( $payname == 'Unknown' )
			return 'ERROR: Payment system not found or haven\'t been configured.';
	}
	
	$member_id = 0;
	if ( is_stmsmember_logged_in() ) {
		$member = stms_get_current_member();
		$member_id = $member->ID;
	}
	
	$redir = stms_isset($_SERVER['REQUEST_URI']);
	$form = '';
	
	if ( wp_get_theme() == 'InstaSpark' )
		$form .= '<div class="insta-form-center">' . "\n";
	
	$new_title = ( isset($stms['form_signup']['form_title']) ) ? stms_cleanup($stms['form_signup']['form_title']) : stms_isset($defaults['signup']['title']);
	if ( !isset($_GET['key']) && stms_isset($stms['global']['free_aff'], 1) == 1 )
		$new_title = ( isset($stms['form_affiliate']['form_title']) ) ? stms_cleanup($stms['form_affiliate']['form_title']) : stms_isset($defaults['affiliate']['title']);
				
	$form .= '<h2>' . $new_title . '</h2>';
	if ( !$is_paid || isset($_GET['special_id']) ) {
		$form .= '<div class="insta-reg-buy">';
		$form .= '<table class="insta-cart-table">';
		$form .= '<thead>';
		$form .= '<tr><th>Item(s)</th><th style="width:100px; text-align:right">Price (' . $currency . ')</th></tr>';
		$form .= '</thead>';
		$form .= '<tbody>';
		$total = 0;
		$_price = ( $product->type == 'recurr' && $product->is_trial == 1 ) ? $product->t_price : $product->price;
		if ( $product->type == 'free' )
			$_price = '0.00';
		$price = number_format($_price, 2);
		if ( isset($_GET['special_id']) ) $price = 0.00;
		$total += $price;
		$form .= '<tr><th scope="row">';
		$form .= '<strong>' . stms_cleanup($product->title) . '</strong>';
		$desc = $price . ' ' . $currency . '/One-Time';
		if ( $product->type == 'recurr' ) {
			$t_dur = maybe_unserialize($product->t_duration);
			$dur = maybe_unserialize($product->duration);
			$desc = '';
			if ( $product->is_trial == 1 )
				$desc .= $price . ' ' . $currency . ' for ' . $t_dur['num'] . ' ' . stms_duration_str($t_dur['num'], $t_dur['mode'], false) . ', then ';
			$desc .= $currency . ' ' . $product->price . ' every ' . $dur['num'] . ' ' . stms_duration_str($dur['num'], $dur['mode'], false);
			if ( $product->rebill_times > 0 )
				$desc .= ' (for ' . $product->rebill_times . ' times)';
			else
				$desc .= ' (until cancelled)';
		}
		
		$form .= '<br /><span style="color:#808080"><small><em>' . $desc . '</em></small></span></th>';
		$form .= '<td style="padding-bottom:8px; text-align:right"><em>' . $price . '</em></tr>' . "\n";
	
		$form .= '</tbody>';
		$form .= '</table>';
		
		if ( $product->type == 'free' )
			$total = '0.00';
		
		$total_cart = apply_filters('insta_total_cart', '<strong>Total: <span style="color:#008900">' . number_format($total, 2) . ' ' . $currency . '</span></strong>', $total_price, $currency, $product->ID);
		$form .= '<p style="text-align:right">' . $total_cart . '</p>';
		$form .= '</div>';
	}

	if ( $display_form ) {
		$backtoreg_msg = ( isset($stms['form_signup']['backtoreg_msg']) ) ? stms_sanitize($stms['form_signup']['backtoreg_msg']) : stms_isset($defaults['signup']['backtoreg_msg']);
		$backtoreg_msg = str_replace('[reg_link]', '<a href="#" id="new-purchase">', $backtoreg_msg);
		$backtoreg_msg = str_replace('[/reg_link]', '</a>', $backtoreg_msg);
			
		$form .= '<div class="insta-update-msg insta-login-purchase" style="display:none"><p>' . $backtoreg_msg . '</p></div>' . "\n\n";
		if ( $is_paid ) {
			$paysuccess_msg = ( isset($stms['form_signup']['paysuccess_msg']) ) ? stms_sanitize($stms['form_signup']['paysuccess_msg']) : stms_sanitize($defaults['signup']['paysuccess_msg']);
			$paysuccess_msg = str_replace('[login_link]', '<a href="#" id="existing-purchase">', $paysuccess_msg);
			$paysuccess_msg = str_replace('[/login_link]', '</a>', $paysuccess_msg);
			
			if ( !isset($_GET['special_id']) ) :
				$form .= '
				<div class="insta-update-msg insta-reg-buy">
				' . wpautop($paysuccess_msg) . '
				</div>' . "\n";
			endif;	
		} else {
			$exists_msg = ( isset($stms['form_signup']['logexists_msg']) ) ? stms_sanitize($stms['form_signup']['logexists_msg']) : stms_isset($defaults['signup']['logexists_msg']);
			$exists_msg = str_replace('[login_link]', '<a href="#" id="existing-purchase">', $exists_msg);
			$exists_msg = str_replace('[/login_link]', '</a>', $exists_msg);
			$form .= '<div class="insta-update-msg insta-reg-buy"><p>' . $exists_msg . '</p></div>' . "\n";
		}
	}
	
	if ( isset($_GET['auth_error']) )
		$form .= '<div class="insta-error-msg insta-reg-buy"><p><strong>ERROR: ' . base64_decode($_GET['auth_error']) . '</strong></p></div>' . "\n";
	
	if ( isset($_GET['auth_vars']) ) {
		$auth_vars = base64_decode($_GET['auth_vars']);
		$vars = json_decode($auth_vars);
	}
	
	$form .= '<div class="insta-reg-buy" style="margin-top:15px">' . wpautop(stms_sanitize($fields['before_text'])) . '</div>';
	
	$_reg_url = stms_get_handler_url('registration');
	$action_url = stms_format_url($_reg_url, 'key=' . $_session);
	if ( isset($_GET['insta_token']) )
		$action_url .= "&insta_token={$_GET['insta_token']}";
	
	if ( isset($_GET['flow_id']) )
		$action_url .= "&flow_id={$_GET['flow_id']}";
	
	if ( isset($_GET['tx_ids']) && is_array($_GET['tx_ids']) && count($_GET['tx_ids']) > 0 ) {
		$trx_ids = '';
		foreach ( $_GET['tx_ids'] as $trx_id ) {
			$trx_ids .= "&tx_ids[]={$trx_id}";
		}
		$action_url .= $trx_ids;
	}

	$total_amount = apply_filters('insta_total_checkout', $total_price, $total_price, $currency, $product->ID);
	
	$form .= '<form method="post" name="instamem-signup-form" id="instamem-signup-form" action="' . $action_url . '">' . "\n";
	$form .= '<input type="hidden" name="_instamember_action" value="register" />' . "\n";
	$form .= '<input type="hidden" name="_instamember_nonce" value="' . $nonce . '" />' . "\n";
	$form .= '<input type="hidden" name="product_id" value="' . $product_id . '" />' . "\n";
	$form .= '<input type="hidden" name="total_amount" value="' . $total_amount . '" />' . "\n";
	if ( $is_paid ) {
		$form .= '<input type="hidden" name="insta_token" value="' . stms_isset($_GET['insta_token']) . '" />' . "\n";
		$form .= '<input type="hidden" name="tx_id" value="' . stms_isset($insta_token['tx_id']) . '" />' . "\n";
		if ( isset($_GET['flow_id']) )
			$form .= '<input type="hidden" name="flow_id" value="' . stms_isset($_GET['flow_id']) . '" />' . "\n";
			
		if ( isset($_GET['tx_ids']) && is_array($_GET['tx_ids']) && count($_GET['tx_ids']) > 0 ) {
			$trx_ids = '';
			foreach ( $_GET['tx_ids'] as $trx_id ) {
				$form .= '<input type="hidden" name="tx_ids[]" value="' . $trx_id . '" />' . "\n";
			}
		}
		
		if ( isset($_GET['special_id']) )
			$form .= '<input type="hidden" name="special_id" value="' . urldecode($_GET['special_id']) . '" />' . "\n";
	}
	
	$form .= '<input type="hidden" name="payment_system" value="' . $payment . '" />' . "\n";
	$form .= '<table class="insta-form-table">';
	
	if ( $payment != 'free' && !$is_paid ) {
		$paymethod_label = ( isset($stms['form_signup']['paymethod_label']) ) ? stms_cleanup($stms['form_signup']['paymethod_label']) : $defaults['signup']['paymethod_label'];
		$pays = ( $gateway == 'direct' ) ? stms_get_direct_payments() : stms_get_third_payments();
		$form .= '<tr valign="top" class="insta-reg-buy">';
		$form .= '<th scope="row" style="text-align:right"><label><strong><span style="color:red">*</span> ' . $paymethod_label . '</strong></label></th>' . "\n";
		$form .= '<td valign="bottom">';
		if ( $payment == 'authorize' ) {
			$form .= '<strong>Credit Card</strong>';
		} else {
			$form .= '<strong>' . str_replace('Standard', '', $pays[$payment]) . '</strong>';
		}
		$form .= '</td>' . "\n";
		$form .= '</tr>';
	}

	// Main Registration Form...
	if ( $display_form )
		$form .= stms_form_mapping($fields['active'], $fields['fields']);
	
	if ( $payment == 'authorize' ) {
		if ( isset($_GET['auth_vars']) ) {
			$auth_vars = base64_decode($_GET['auth_vars']);
			$vars = (array) json_decode($auth_vars);
		}

		$card_title = ( isset($stms['form_signup']['card_title']) ) ? stms_cleanup($stms['form_signup']['card_title']) : stms_isset($defaults['signup']['card_title']);
		$cardname_label = ( isset($stms['form_signup']['cardname_label']) ) ? stms_cleanup($stms['form_signup']['cardname_label']) : stms_isset($defaults['signup']['cardname_label']);
		$cardnum_label = ( isset($stms['form_signup']['cardnum_label']) ) ? stms_cleanup($stms['form_signup']['cardnum_label']) : stms_isset($defaults['signup']['cardnum_label']);
		$cardexp_label = ( isset($stms['form_signup']['cardexp_label']) ) ? stms_cleanup($stms['form_signup']['cardexp_label']) : stms_isset($defaults['signup']['cardexp_label']);	
	
		$cards = ( isset($stms['payments']['authorize']['cards']) ) ? $stms['payments']['authorize']['cards'] : array('amex', 'visa', 'mastercard', 'discover');
		$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
		$form .= '<td colspan="2"><h3 style="margin:0; padding:10px 0 5px">' . $card_title . '</h3></td>' . "\n";
		$form .= '</tr>' . "\n";
		$form .= '<tr valign="top" class="insta-reg-buy"><th></th>' . "\n";
		$form .= '<td>';
		foreach ( $cards as $card ) {
			$form .= '<img src="' . STMS_URL . 'images/' . $card . '.png" border="0" style="margin:0;padding:0; border:none; box-shadow: none; -webkit-box-shadow: none" />';
		}
		
		$form .= '</td>';
		$form .= '</tr>' . "\n";
		$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_cardholder_name" class="for-text"><strong><span style="color:red">*</span> ' . $cardname_label . '</strong></label></th>' . "\n";
		$form .= '<td><input type="text" name="im_cardholder_name" id="im_cardholder_name" value="' . stms_isset($vars['im_cardholder_name'], '') . '" style="width:100%" autocomplete="off" /></td>' . "\n";
		$form .= '</tr>' . "\n";
		$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_cardnumber" class="for-text"><strong><span style="color:red">*</span> ' . $cardnum_label . '</strong></label></th>' . "\n";
		$form .= '<td><input type="text" name="im_cardnumber" id="im_cardnumber" value="' . stms_isset($vars['im_cardnumber'], '') . '" style="width:100%" autocomplete="off" /></td>' . "\n";
		$form .= '</tr>' . "\n";
		$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_cardnumber" class="for-text"><strong><span style="color:red">*</span> ' . $cardexp_label . '</strong></label></th>' . "\n";
		$form .= '<td>';
		$form .= '<select name="im_cardexpired_month" id="im_cardexpired_month" style="width:auto">';
		for ( $i = 1; $i < 13; $i++ ) {
			$num = str_pad($i, 2, 0, STR_PAD_LEFT);
			$selected = ( stms_isset($vars['im_cardexpired_month']) == $num ) ? ' selected="selected"' : '';
			$form .= "<option value='{$num}'{$selected}>{$num}</option>\n";
		}
		$form .= '</select>&nbsp;';
		$form .= '<select name="im_cardexpired_year" id="im_cardexpired_year" style="width:auto">';
		$this_year = date("Y");
		for ( $i = 0; $i < 25; $i++ ) {
			$num = $this_year + $i;
			$selected = ( stms_isset($vars['im_cardexpired_year']) == $num ) ? ' selected="selected"' : '';
			$form .= "<option value='{$num}'>{$num}</option>\n";
		}
		$form .= '</select>&nbsp;&nbsp;&nbsp;';
		$form .= '</td>' . "\n";
		$form .= '</tr>' . "\n";
		
		if ( stms_isset($stms['payments']['authorize']['ccv']) == 1 ) {
			$cardccv_label = ( isset($stms['form_signup']['cardccv_label']) ) ? stms_cleanup($stms['form_signup']['cardccv_label']) : stms_isset($defaults['signup']['cardccv_label']);
			$cardccv_txt = ( isset($stms['form_signup']['cardccv_txt']) ) ? stms_cleanup($stms['form_signup']['cardccv_txt']) : stms_isset($defaults['signup']['cardccv_txt']);
			$cardccv_cnt = ( isset($stms['form_signup']['cardccv_cnt']) ) ? stms_sanitize($stms['form_signup']['cardccv_cnt']) : stms_isset($defaults['signup']['cardccv_cnt']);
			$cardccv_cnt = wpautop(str_replace('"', '&quot;', $cardccv_cnt));
			
			$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
			$form .= '<th scope="row" style="text-align:right"><label for="im_cardsecurity" class="for-text"><strong><span style="color:red">*</span> ' . $cardccv_label . '</strong></label></th>' . "\n";
			$form .= '<td><input type="text" name="im_cardsecurity" id="im_cardsecurity" value="" style="width:70px" autocomplete="off" />';
			$form .= '&nbsp;&nbsp;<span class="insta-qtip" title="' . $cardccv_cnt . '">' . $cardccv_txt . '</span></td>' . "\n";
			$form .= '</tr>' . "\n";
		}
		
		if ( stms_isset($stms['payments']['authorize']['avs']) == 1 ) {
			$billaddress_label = ( isset($stms['form_signup']['billaddress_label']) ) ? stms_cleanup($stms['form_signup']['billaddress_label']) : $defaults['signup']['billaddress_label'];
			$billcity_label = ( isset($stms['form_signup']['billcity_label']) ) ? stms_cleanup($stms['form_signup']['billcity_label']) : $defaults['signup']['billcity_label'];
			$billstate_label = ( isset($stms['form_signup']['billstate_label']) ) ? stms_cleanup($stms['form_signup']['billstate_label']) : $defaults['signup']['billstate_label'];
			$billzipcode_label = ( isset($stms['form_signup']['billzipcode_label']) ) ? stms_cleanup($stms['form_signup']['billzipcode_label']) : $defaults['signup']['billzipcode_label'];
			$billcountry_label = ( isset($stms['form_signup']['billcountry_label']) ) ? stms_cleanup($stms['form_signup']['billcountry_label']) : $defaults['signup']['billcountry_label'];
		
			$countries = stms_world_countries();
			if ( is_stmsmember_logged_in() && !isset($_GET['auth_vars']) ) {
				$member = stms_member($member_id);
				$c_street = stms_sanitize($member->info['street'], '');
				$c_city = stms_sanitize($member->info['city'], '');
				$c_state = stms_sanitize($member->info['state'], '');
				$c_zip = stms_sanitize($member->info['zipcode'], '');
				$c_country = stms_sanitize($member->info['country'], 'US');
			} else {
				$c_street = stms_sanitize($vars['im_cardstreet'], '');
				$c_city = stms_sanitize($vars['im_cardcity'], '');
				$c_state = stms_sanitize($vars['im_cardstate'], '');
				$c_zip = stms_sanitize($vars['im_cardzip'], '');
				$c_country = stms_sanitize($vars['im_cardcountry'], 'US');
			}
			
			$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
			$form .= '<th scope="row" style="text-align:right"><label for="im_cardstreet" class="for-text"><strong><span style="color:red">*</span> ' . $billaddress_label . '</strong></label></th>' . "\n";
			$form .= '<td><textarea name="im_cardstreet" id="im_cardstreet" style="width:100%;height:75px">' . $c_street . '</textarea></td>' . "\n";
			$form .= '</tr>' . "\n";
			
			$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
			$form .= '<th scope="row" style="text-align:right"><label for="im_cardcity" class="for-text"><strong><span style="color:red">*</span> ' . $billcity_label . '</strong></label></th>' . "\n";
			$form .= '<td><input type="text" name="im_cardcity" id="im_cardcity" value="' . $c_city . '" style="width:40%" autocomplete="off" /></td>' . "\n";
			$form .= '</tr>' . "\n";
			
			$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
			$form .= '<th scope="row" style="text-align:right"><label for="im_cardstate" class="for-text"><strong><span style="color:red">*</span> ' . $billstate_label . '</strong></label></th>' . "\n";
			$form .= '<td><input type="text" name="im_cardstate" id="im_cardstate" value="' . $c_state . '" style="width:40%" autocomplete="off" /></td>' . "\n";
			$form .= '</tr>' . "\n";
			
			$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
			$form .= '<th scope="row" style="text-align:right"><label for="im_cardzip" class="for-text"><strong><span style="color:red">*</span> ' . $billzipcode_label . '</strong></label></th>' . "\n";
			$form .= '<td><input type="text" name="im_cardzip" id="im_cardzip" value="' . $c_zip . '" style="width:30%" autocomplete="off" /></td>' . "\n";
			$form .= '</tr>' . "\n";
			
			$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
			$form .= '<th scope="row" style="text-align:right"><label for="im_cardcountry" class="for-text"><strong><span style="color:red">*</span> ' . $billcountry_label . '</strong></label></th>' . "\n";
			$form .= '<td>' . "\n";
			$form .= '<select name="im_cardcountry" id="im_cardcountry">' . "\n";
			$form .= '<option value="">[ -- ' . $billcountry_label . ' -- ]</option>' . "\n";
		
			if ( $countries ) {
				foreach ( $countries as $key => $value ) {
					$selected = ( $c_country == $key ) ? ' selected="selected"' : '';
					$form .= "<option value='{$key}'{$selected}>{$value}</option>";
				}
			}
			$form .= '</select>' . "\n";
			$form .= '</td>' . "\n";
			$form .= '</tr>' . "\n";
		}
	}

	if ( !is_stmsmember_logged_in() && !$is_paid && stms_isset($stms['form_signup']['show_captcha']) == 1 && stms_isset($stms['integration']['recaptcha']['public']) != '' ) {
		require_once( STMS_SOURCES . '/recaptcha/recaptchalib.php');
		$captcha_label = ( isset($stms['form_signup']['captcha_label']) ) ? stms_cleanup($stms['form_signup']['captcha_label']) : $defaults['signup']['captcha_label'];
		$form .= '<tr valign="top" class="insta-reg-buy">';
		$form .= '<th scope="row" style="text-align:right"><label><strong>' . $captcha_label . '</strong></label></th>' . "\n";
		$form .= '<td>';
		$form .= recaptcha_get_html(trim($stms['integration']['recaptcha']['public']), '', is_ssl());
		$form .= '</td>';
		$form .= '</tr>';
	}
	
	if ( stms_isset($stms['form_signup']['show_tos']) == 1 && isset($stms['form_signup']['tos_url']) ) {
		$tos_url = stms_isset($stms['form_signup']['tos_url']);
		$tos_text = ( isset($stms['form_signup']['tos_text']) ) ? stms_cleanup($stms['form_signup']['tos_text']) : $defaults['signup']['tos_text'];
		$tos_text = str_replace('[tos_link]', '<a href="' . $tos_url . '" target="_blank">', $tos_text);
		$tos_text = str_replace('[/tos_link]', '</a>', $tos_text);
		
		$form .= '<tr valign="top" class="insta-reg-buy">';
		$form .= '<th scope="row" style="text-align:right"></th>' . "\n";
		$form .= '<td><input type="checkbox" name="im_tos" id="im_tos" value="1"> <label for="im_tos">' . $tos_text . '</label></td>' . "\n";
		$form .= '</tr>';
	}
	
	$form .= '<tr valign="top" class="insta-reg-buy"><th></th><td><input type="submit" name="instamem-signup" id="instamem-signup" class="button gray btn btn-primary btn_custom" value="' . $label . '" /></td></tr>';
	$form .= '</table>';
	$form .= '</form>';
	$form .= '<div class="insta-reg-buy" style="margin-top:15px">' . wpautop(stms_sanitize($fields['after_text'])) . '</div>';
	
	if ( stms_isset($fields['affusername_info'], 1) == 1 ) {
		$aff_id = 0;
		if ( isset($_COOKIE['__insta_aff_id']) ) {
			$aff_id = (int) $_COOKIE['__insta_aff_id']; // there's aff cookie
		} else {
			if ( is_stmsmember_logged_in() ) {
				$customer_id = stms_get_current_member_id();
				$aff_meta = stms_get_member_meta($customer_id, 'aff_id');
				if ( !empty($aff_meta) && $customer_id != $aff_meta )
					$aff_id = $aff_meta;
			}
		}
		
		$gate_type = stms_gateway_type($payment);
		if ( $gate_type && $aff_id && ($the_affiliate = stms_member($aff_id)) ) {
			$form .= '<div class="insta-reg-buy" style="margin-top:15px"><p>&nbsp;</p><p style="color:#a7a7a7;text-align:center"><small>[ref=' . stms_sanitize($the_affiliate->username) . ']</small></p></div>';
		}
	}
	
	if ( $display_form ) :
		$login_title = ( isset($stms['form_login']['form_title']) ) ? stms_cleanup($stms['form_login']['form_title']) : stms_isset($defaults['login']['title']);
		$username_label = ( isset($stms['form_login']['username_label']) ) ? stms_cleanup($stms['form_login']['username_label']) : stms_isset($defaults['login']['username_label']);
		$password_label = ( isset($stms['form_login']['password_label']) ) ? stms_cleanup($stms['form_login']['password_label']) : stms_isset($defaults['login']['password_label']);
		$button_label = ( isset($stms['form_login']['button_label2']) ) ? stms_cleanup($stms['form_login']['button_label2']) : $defaults['login']['button_label2'];
	
		$form .= '<div class="insta-login-purchase" style="display:none">';
		$form .= '<form method="post" name="instamem-login-purchase-form" id="instamem-login-purchase-form">' . "\n";
		$form .= '<input type="hidden" name="_instamember_action" value="login" />' . "\n";
		$form .= '<input type="hidden" name="_instamember_nonce" value="' . $nonce . '" />' . "\n";
		if ( $is_paid ) {
			$form .= '<input type="hidden" name="insta_token" value="' . stms_isset($_GET['insta_token']) . '" />' . "\n";
			$form .= '<input type="hidden" name="tx_id" value="' . stms_isset($insta_token['tx_id']) . '" />' . "\n";
			if ( isset($_GET['flow_id']) )
				$form .= '<input type="hidden" name="flow_id" value="' . stms_isset($_GET['flow_id']) . '" />' . "\n";
				
			if ( isset($_GET['tx_ids']) && is_array($_GET['tx_ids']) && count($_GET['tx_ids']) > 0 ) {
				$trx_ids = '';
				foreach ( $_GET['tx_ids'] as $trx_id ) {
					$form .= '<input type="hidden" name="tx_ids[]" value="' . $trx_id . '" />' . "\n";
				}
			}
		}
		
		$form .= '<input type="hidden" name="redir" value="' . $redir . '" />' . "\n";
		$form .= '<table class="insta-form-table">';
		$form .= '<tr valign="top">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_log_username" class="for-text"><strong>' . $username_label . '</strong></label></th>' . "\n";
		$form .= '<td><input type="text" name="im_username" value="" /></td>' . "\n";
		$form .= '</tr>' . "\n";
		$form .= '<tr valign="top">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_log_password" class="for-text"><strong>' . $password_label . '</strong></label></th>' . "\n";
		$form .= '<td><input type="password" name="im_password" value="" /></td>' . "\n";
		$form .= '</tr>' . "\n";
		
		$form .= '<tr valign="top"><th></th><td><input type="submit" name="instamem-logpurchase" id="instamem-logpurchase" class="button gray btn btn-primary btn_custom" value="' . $button_label . '" /></td></tr>';
		$form .= '</table>';
		$form .= '</form>';
		$form .= '</div>';
	endif;
	
	if ( wp_get_theme() == 'InstaSpark' )
		$form .= '</div>' . "\n";
	
	if ( $is_paid && $can_access )
		@stms_clear_auth_cookie();
	
	return $form;
}

function stms_upsell_checkout_form() {
	$stms = get_option('stms_settings');
	$defaults = stms_default_forms();
	$fields = ( isset($stms['form_signup']) ) ? stms_build_form_fields($stms['form_signup'], 'signup') : stms_isset($defaults['signup']);
	$currency = stms_isset($stms['global']['currency'], 'USD');
	$flow_id = stms_isset($_GET['flow_id']);
	$nonce = wp_create_nonce('stms-nonce');
	$home_url = get_bloginfo('url');
	
	$form = '';
	if ( !$items = sflow_get_cart_items($flow_id) )
		return 'ERROR: No items found in the shopping cart.';
		
	if ( isset($_GET['auth_error']) )
		$form .= '<div class="insta-error-msg insta-reg-buy"><p><strong>ERROR: ' . base64_decode($_GET['auth_error']) . '</strong></p></div>' . "\n";
	
	if ( isset($_GET['auth_vars']) ) {
		$auth_vars = base64_decode($_GET['auth_vars']);
		$vars = (array) json_decode($auth_vars);
	}
	
	$action_url = stms_format_url($stms['global']['magic'], 'imhandler=checkout&flow_id=' . $flow_id);
	$form .= '<form method="post" name="instamem-checkout-form" id="instamem-checkout-form" action="' . $action_url . '">' . "\n";
	$form .= '<input type="hidden" name="_instamember_action" value="upsells_checkout" />' . "\n";
	$form .= '<input type="hidden" name="_instamember_nonce" value="' . $nonce . '" />' . "\n";
	$form .= '<input type="hidden" name="insta_flow_id" value="' . $flow_id . '" />' . "\n";
	$form .= '<input type="hidden" name="member_id" value="' . stms_get_current_member_id() . '" />' . "\n";
	
	$form .= '<h3 class="insta-cart-title">Your Order</h3>';
	$form .= '<table class="insta-cart-table">';
	$form .= '<thead>';
	$form .= '<tr><th>Item(s)</th><th style="width:100px; text-align:right">Price (' . $currency . ')</th></tr>';
	$form .= '</thead>';
	$form .= '<tbody>';
	$total = 0;
	foreach ( $items as $item ) {
		$product = stms_get_product($item->product_id);
		if ( $product ) {
			$_price = ( $product->type == 'recurr' && $product->is_trial == 1 ) ? $product->t_price : $product->price;
			$price = number_format($_price, 2);
			$total += $price;
			$form .= '<tr><th scope="row">';
			$form .= '<strong>' . stms_cleanup($product->title) . '</strong>';
			$desc = $price . ' ' . $currency . '/One-Time';
			if ( $product->type == 'recurr' ) {
				$t_dur = maybe_unserialize($product->t_duration);
				$dur = maybe_unserialize($product->duration);
				$desc = '';
				if ( $product->is_trial == 1 )
					$desc .= $price . ' ' . $currency . ' for ' . $t_dur['num'] . ' ' . stms_duration_str($t_dur['num'], $t_dur['mode'], false) . ', then ';
				$desc .= $currency . ' ' . $product->price . ' every ' . $dur['num'] . ' ' . stms_duration_str($dur['num'], $dur['mode'], false);
				if ( $product->rebill_times > 0 )
					$desc .= ' (for ' . $product->rebill_times . ' times)';
				else
					$desc .= ' (until cancelled)';
			}
			
			$form .= '<br /><span style="color:#808080"><small><em>' . $desc . '</em></small></span></th>';
			$form .= '<td style="padding-bottom:8px; text-align:right"><em>' . $price . '</em></tr>' . "\n";
		}
	}
	$form .= '</tbody>';
	$form .= '</table>';
	$form .= '<p style="text-align:right"><strong>Total: <span style="color:#008900">' . number_format($total, 2) . ' ' . $currency . '</span></strong></p>';
	
	$card_title = ( isset($stms['form_signup']['card_title']) ) ? stms_cleanup($stms['form_signup']['card_title']) : stms_isset($defaults['signup']['card_title']);
	$cardname_label = ( isset($stms['form_signup']['cardname_label']) ) ? stms_cleanup($stms['form_signup']['cardname_label']) : stms_isset($defaults['signup']['cardname_label']);
	$cardnum_label = ( isset($stms['form_signup']['cardnum_label']) ) ? stms_cleanup($stms['form_signup']['cardnum_label']) : stms_isset($defaults['signup']['cardnum_label']);
	$cardexp_label = ( isset($stms['form_signup']['cardexp_label']) ) ? stms_cleanup($stms['form_signup']['cardexp_label']) : stms_isset($defaults['signup']['cardexp_label']);	
	

	$form .= '<table class="insta-form-table">';
	$form .= '<tr valign="top">' . "\n";
	$form .= '<td colspan="2"><h3 style="margin:0; padding:10px 0 5px">' . $card_title . '</h3></td>' . "\n";
	$form .= '</tr>' . "\n";
	$form .= '<tr valign="top"><th></th>' . "\n";
	$form .= '<td><img src="' . STMS_URL . 'images/cc.png" border="0" style="margin:0;padding:0; border:none; box-shadow: none; -webkit-box-shadow: none" /></td>' . "\n";
	$form .= '</tr>' . "\n";
	$form .= '<tr valign="top">' . "\n";
	$form .= '<th scope="row" style="text-align:right"><label for="im_cardholder_name" class="for-text"><strong><span style="color:red">*</span> ' . $cardname_label .'</strong></label></th>' . "\n";
	$form .= '<td><input type="text" name="im_cardholder_name" id="im_cardholder_name" value="' . stms_isset($vars['im_cardholder_name'], '') . '" style="width:100%" autocomplete="off" /></td>' . "\n";
	$form .= '</tr>' . "\n";
	$form .= '<tr valign="top">' . "\n";
	$form .= '<th scope="row" style="text-align:right"><label for="im_cardnumber" class="for-text"><strong><span style="color:red">*</span> ' . $cardnum_label .'</strong></label></th>' . "\n";
	$form .= '<td><input type="text" name="im_cardnumber" id="im_cardnumber" value="' . stms_isset($vars['im_cardnumber'], '') . '" style="width:100%" autocomplete="off" /></td>' . "\n";
	$form .= '</tr>' . "\n";
	$form .= '<tr valign="top">' . "\n";
	$form .= '<th scope="row" style="text-align:right"><label for="im_cardnumber" class="for-text"><strong><span style="color:red">*</span> ' . $cardexp_label .'</strong></label></th>' . "\n";
	$form .= '<td>';
	$form .= '<select name="im_cardexpired_month" id="im_cardexpired_month" style="width:auto">';
	for ( $i = 1; $i < 13; $i++ ) {
		$num = str_pad($i, 2, 0, STR_PAD_LEFT);
		$selected = ( stms_isset($vars['im_cardexpired_month']) == $num ) ? ' selected="selected"' : '';
		$form .= "<option value='{$num}'{$selected}>{$num}</option>\n";
	}
	$form .= '</select>&nbsp;';
	$form .= '<select name="im_cardexpired_year" id="im_cardexpired_year" style="width:auto">';
	$this_year = date("Y");
	for ( $i = 0; $i < 25; $i++ ) {
		$num = $this_year + $i;
		$selected = ( stms_isset($vars['im_cardexpired_year']) == $num ) ? ' selected="selected"' : '';
		$form .= "<option value='{$num}'>{$num}</option>\n";
	}
	$form .= '</select>&nbsp;&nbsp;&nbsp;';
	$form .= '</td>' . "\n";
	$form .= '</tr>' . "\n";
	
	if ( stms_isset($stms['payments']['authorize']['ccv']) == 1 ) {
		$cardccv_label = ( isset($stms['form_signup']['cardccv_label']) ) ? stms_cleanup($stms['form_signup']['cardccv_label']) : stms_isset($defaults['signup']['cardccv_label']);
		$cardccv_txt = ( isset($stms['form_signup']['cardccv_txt']) ) ? stms_cleanup($stms['form_signup']['cardccv_txt']) : stms_isset($defaults['signup']['cardccv_txt']);
		$cardccv_cnt = ( isset($stms['form_signup']['cardccv_cnt']) ) ? stms_sanitize($stms['form_signup']['cardccv_cnt']) : stms_isset($defaults['signup']['cardccv_cnt']);
		$cardccv_cnt = wpautop(str_replace('"', '&quot;', $cardccv_cnt));
			
		$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_cardsecurity" class="for-text"><strong><span style="color:red">*</span> ' . $cardccv_label . '</strong></label></th>' . "\n";
		$form .= '<td><input type="text" name="im_cardsecurity" id="im_cardsecurity" value="" style="width:70px" autocomplete="off" />';
		$form .= '&nbsp;&nbsp;<span class="insta-qtip" title="' . $cardccv_cnt . '">' . $cardccv_txt . '</span></td>' . "\n";
		$form .= '</tr>' . "\n";
	}

	if ( stms_isset($stms['payments']['authorize']['avs']) == 1 ) {
		$billaddress_label = ( isset($stms['form_signup']['billaddress_label']) ) ? stms_cleanup($stms['form_signup']['billaddress_label']) : $defaults['signup']['billaddress_label'];
		$billcity_label = ( isset($stms['form_signup']['billcity_label']) ) ? stms_cleanup($stms['form_signup']['billcity_label']) : $defaults['signup']['billcity_label'];
		$billstate_label = ( isset($stms['form_signup']['billstate_label']) ) ? stms_cleanup($stms['form_signup']['billstate_label']) : $defaults['signup']['billstate_label'];
		$billzipcode_label = ( isset($stms['form_signup']['billzipcode_label']) ) ? stms_cleanup($stms['form_signup']['billzipcode_label']) : $defaults['signup']['billzipcode_label'];
		$billcountry_label = ( isset($stms['form_signup']['billcountry_label']) ) ? stms_cleanup($stms['form_signup']['billcountry_label']) : $defaults['signup']['billcountry_label'];
	
		$countries = stms_world_countries();
		if ( is_stmsmember_logged_in() && !isset($_GET['auth_vars']) ) {
			$member = stms_member($member_id);
			$c_street = stms_sanitize($member->info['street'], '');
			$c_city = stms_sanitize($member->info['city'], '');
			$c_state = stms_sanitize($member->info['state'], '');
			$c_zip = stms_sanitize($member->info['zipcode'], '');
			$c_country = stms_sanitize($member->info['country'], 'US');
		} else {
			$c_street = stms_sanitize($vars['im_cardstreet'], '');
			$c_city = stms_sanitize($vars['im_cardcity'], '');
			$c_state = stms_sanitize($vars['im_cardstate'], '');
			$c_zip = stms_sanitize($vars['im_cardzip'], '');
			$c_country = stms_sanitize($vars['im_cardcountry'], 'US');
		}
		
		$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_cardstreet" class="for-text"><strong><span style="color:red">*</span> ' . $billaddress_label . '</strong></label></th>' . "\n";
		$form .= '<td><textarea name="im_cardstreet" id="im_cardstreet" style="width:100%;height:75px">' . $c_street . '</textarea></td>' . "\n";
		$form .= '</tr>' . "\n";
		
		$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_cardcity" class="for-text"><strong><span style="color:red">*</span> ' . $billcity_label . '</strong></label></th>' . "\n";
		$form .= '<td><input type="text" name="im_cardcity" id="im_cardcity" value="' . $c_city . '" style="width:40%" autocomplete="off" /></td>' . "\n";
		$form .= '</tr>' . "\n";
		
		$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_cardstate" class="for-text"><strong><span style="color:red">*</span> ' . $billstate_label . '</strong></label></th>' . "\n";
		$form .= '<td><input type="text" name="im_cardstate" id="im_cardstate" value="' . $c_state . '" style="width:40%" autocomplete="off" /></td>' . "\n";
		$form .= '</tr>' . "\n";
		
		$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_cardzip" class="for-text"><strong><span style="color:red">*</span> ' . $billzipcode_label . '</strong></label></th>' . "\n";
		$form .= '<td><input type="text" name="im_cardzip" id="im_cardzip" value="' . $c_zip . '" style="width:30%" autocomplete="off" /></td>' . "\n";
		$form .= '</tr>' . "\n";
		
		$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_cardcountry" class="for-text"><strong><span style="color:red">*</span> ' . $billcountry_label . '</strong></label></th>' . "\n";
		$form .= '<td>' . "\n";
		$form .= '<select name="im_cardcountry" id="im_cardcountry">' . "\n";
		$form .= '<option value="">[ -- ' . $billcountry_label . ' -- ]</option>' . "\n";
	
		if ( $countries ) {
			foreach ( $countries as $key => $value ) {
				$selected = ( $c_country == $key ) ? ' selected="selected"' : '';
				$form .= "<option value='{$key}'{$selected}>{$value}</option>";
			}
		}
		$form .= '</select>' . "\n";
		$form .= '</td>' . "\n";
		$form .= '</tr>' . "\n";
	}

	if ( stms_isset($stms['form_signup']['show_tos']) == 1 && isset($stms['form_signup']['tos_url']) ) {
		$tos_url = stms_isset($stms['form_signup']['tos_url']);
		$tos_text = ( isset($stms['form_signup']['tos_text']) ) ? stms_cleanup($stms['form_signup']['tos_text']) : $defaults['signup']['tos_text'];
		$tos_text = str_replace('[tos_link]', '<a href="' . $tos_url . '" target="_blank">', $tos_text);
		$tos_text = str_replace('[/tos_link]', '</a>', $tos_text);
		
		$form .= '<tr valign="top" class="insta-reg-buy">';
		$form .= '<th scope="row" style="text-align:right"></th>' . "\n";
		$form .= '<td><input type="checkbox" name="im_tos" id="im_tos" value="1"> <label for="im_tos">' . $tos_text . '</label></td>' . "\n";
		$form .= '</tr>';
	}

	$button_label = ( isset($stms['form_signup']['upbutton_label']) ) ? stms_cleanup($stms['form_signup']['upbutton_label']) : $defaults['signup']['upbutton_label'];
	
	$form .= '<tr valign="top" class="insta-reg-buy"><th></th><td><input type="submit" name="instamem-checkout" id="instamem-checkout" class="insta-order-btn" value="' . $button_label . '" /></td></tr>';
	$form .= '</table>';
	$form .= '</form>';

	return $form;
}

function stms_affiliate_form() {
	$stms = get_option('stms_settings');
	$defaults = stms_default_forms();
	$fields = ( isset($stms['form_affiliate']) ) ? stms_build_form_fields($stms['form_affiliate'], 'affiliate') : stms_isset($defaults['affiliate']);
	$label = ( stms_isset($stms['form_affiliate']['button_label']) != '' ) ? stms_cleanup($stms['form_affiliate']['button_label']) : $defaults['affiliate']['label'];
	$nonce = wp_create_nonce('stms-nonce');
	$home_url = get_bloginfo('url');
		
	$aff_id = ( isset($_COOKIE['__insta_aff_id']) ) ? intval($_COOKIE['__insta_aff_id']) : 0;
	$display_form = true;
	if ( isset($_COOKIE['__insta_aff_signedup']) )
		$display_form = false;
		
	$redir = stms_isset($_SERVER['REQUEST_URI']);
	$form = '';
	
	if ( $display_form ) {
		if ( isset($_GET['auth_error']) )
			$form .= '<div class="insta-error-msg insta-reg-buy"><p><strong>ERROR: ' . base64_decode($_GET['auth_error']) . '</strong></p></div>' . "\n";
		
		if ( isset($_GET['auth_vars']) ) {
			$auth_vars = base64_decode($_GET['auth_vars']);
			$vars = json_decode($auth_vars);
		}
		
		$form .= '<div class="insta-reg-buy" style="margin-top:15px">' . wpautop(stms_sanitize($fields['before_text'])) . '</div>';
		
		$action_url = ( is_ssl() ) ? 'https://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] : 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
		$form .= '<form method="post" name="instamem-affiliate-form" id="instamem-affiliate-form" action="' . $action_url . '">' . "\n";
		$form .= '<input type="hidden" name="_instamember_action" value="aff_register" />' . "\n";
		$form .= '<input type="hidden" name="insta_aff_id" value="' . $aff_id . '" />' . "\n\n";
		$form .= '<input type="hidden" name="_instamember_nonce" value="' . $nonce . '" />' . "\n";
	
		$form .= '<table class="insta-form-table">';
	
		// Main Registration Form...
		$form .= stms_form_mapping($fields['active'], $fields['fields']);
		
		if ( stms_isset($stms['form_affiliate']['show_captcha']) == 1 && stms_isset($stms['integration']['recaptcha']['public']) != '' ) {
			require_once( STMS_SOURCES . '/recaptcha/recaptchalib.php');
			$captcha_label = ( isset($stms['form_affiliate']['captcha_label']) ) ? stms_cleanup($stms['form_affiliate']['captcha_label']) : $defaults['affiliate']['captcha_label'];
			$form .= '<tr valign="top" class="insta-reg-buy">';
			$form .= '<th scope="row" style="text-align:right"><label><strong>' . $captcha_label . '</strong></label></th>' . "\n";
			$form .= '<td>';
			$form .= recaptcha_get_html(trim($stms['integration']['recaptcha']['public']), '', is_ssl());
			$form .= '</td>';
			$form .= '</tr>';
		}
		
		if ( stms_isset($stms['form_affiliate']['show_tos']) == 1 && isset($stms['form_affiliate']['tos_url']) ) {
			$tos_url = stms_isset($stms['form_affiliate']['tos_url']);
			$tos_text = ( isset($stms['form_affiliate']['tos_text']) ) ? stms_cleanup($stms['form_affiliate']['tos_text']) : $defaults['affiliate']['tos_text'];
			$tos_text = str_replace('[tos_link]', '<a href="' . $tos_url . '" target="_blank">', $tos_text);
			$tos_text = str_replace('[/tos_link]', '</a>', $tos_text);
			
			$form .= '<tr valign="top" class="insta-reg-buy">';
			$form .= '<th scope="row" style="text-align:right"></th>' . "\n";
			$form .= '<td><input type="checkbox" name="im_tos" id="im_tos" value="1"> <label for="im_tos">' . $tos_text . '</label></td>' . "\n";
			$form .= '</tr>';
		}
		
		$form .= '<tr valign="top" class="insta-reg-buy"><th></th><td><input type="submit" name="instamem-signup" id="instamem-signup" value="' . $label . '" class="button gray btn btn-primary btn_custom" /></td></tr>';
		$form .= '</table>';
		$form .= '</form>';
		$form .= '<div class="insta-reg-buy" style="margin-top:15px">' . wpautop(stms_sanitize($fields['after_text'])) . '</div>';
	} else {
		@setcookie('__insta_aff_signedup', 0, time()-3600, SITECOOKIEPATH);
		@setcookie('__insta_aff_signedup', 0, time()-3600, COOKIEPATH);
		$form .= '<div class="insta-update-msg"><p>' . stms_sanitize($fields['affreview_msg']) . '</p></div>';
	}
	
	return $form;
}

function stms_profile_form() {
	$stms = get_option('stms_settings');
	$nonce = wp_create_nonce('stms-nonce');
	$defaults = stms_default_forms();
	$fields = ( isset($stms['form_profile']) ) ? stms_build_form_fields($stms['form_profile'], 'profile') : stms_isset($defaults['profile']);
	$label = ( stms_isset($stms['form_profile']['button_label']) != '' ) ? stms_cleanup($stms['form_profile']['button_label']) : $defaults['profile']['label'];
	$home_url = get_bloginfo('url');
	$direct_pays = stms_get_direct_payments();
	$third_pays = stms_get_third_payments();
	$show_aff = stms_isset($stms['form_profile']['show_aff'], 1);
	
	$member = stms_get_current_member();
	$member_id = $member->ID;
	
	$new_title = ( isset($stms['form_profile']['form_title']) ) ? stms_cleanup($stms['form_profile']['form_title']) : stms_isset($defaults['profile']['title']);
	
	$form = '';
	$form .= '<h2>' . $new_title . '</h2>';
	$form .= apply_filters('stms_profile_messages', '');
	if ( isset($_GET['auth_error']) )
		$form .= '<div class="insta-error-msg"><p><strong>ERROR: ' . base64_decode($_GET['auth_error']) . '</strong></p></div>' . "\n";
	
	if ( isset($_COOKIE['__insta_aff_signedup']) ) {
		$aff_fields = ( isset($stms['form_affiliate']) ) ? stms_build_form_fields($stms['form_affiliate'], 'affiliate') : stms_isset($defaults['affiliate']);
		$cookie_val = $_COOKIE['__insta_aff_signedup'];
		@setcookie('__insta_aff_signedup', 0, time()-3600, SITECOOKIEPATH);
		@setcookie('__insta_aff_signedup', 0, time()-3600, COOKIEPATH);
		if ( $cookie_val == 2 )
			$form .= '<div class="insta-update-msg"><p>' . stms_sanitize($aff_fields['affactivated_msg']) . '</p></div>';
		else if ( $cookie_val == 3 )
			$form .= '<div class="insta-update-msg"><p>' . stms_sanitize($aff_fields['affreview_msg']) . '</p></div>';
		else
			$form .= '<div class="insta-update-msg"><p>' . stms_sanitize($aff_fields['affactivated_msg']) . '</p></div>';
	}
	
	$form .= wpautop(stripslashes(stms_isset($fields['before_text'])));
	$proto = ( is_ssl() ) ? 'https://' : 'http://';
	$action_url = $proto . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
	$form .= '<form method="post" name="instamem-profile-form" id="instamem-profile-form" action="' . $action_url . '" style="margin-bottom:16px">' . "\n";
	$form .= '<input type="hidden" name="_instamember_action" value="update_profile" />' . "\n";
	$form .= '<input type="hidden" name="_instamember_nonce" value="' . $nonce . '" />' . "\n";
	$form .= '<input type="hidden" name="insta_member_id" value="' . $member_id . '" />' . "\n\n";
	$form .= '<input type="hidden" name="insta_old_email" id="insta_old_email" value="' . sanitize_email(trim($member->email)) . '" />' . "\n\n";
	
	$vars = array(
		'email' => trim($member->email),
		'first_name' => stms_cleanup($member->first_name),
		'last_name' => stms_cleanup($member->last_name),
		'street' => stms_cleanup($member->info['street']),
		'phone' => stms_cleanup($member->info['phone']),
		'company' => stms_cleanup($member->info['company']),
		'zipcode' => stms_cleanup($member->info['zipcode']),
		'state' => stms_cleanup($member->info['state']),
		'city' => stms_cleanup($member->info['city']),
		'country' => stms_cleanup($member->info['country']),
		'title' => stms_cleanup($member->info['title']),
		'gender' => stms_cleanup($member->info['gender']),
	);
	
	$username_label = ( isset($stms['form_profile']['username_label']) ) ? stms_cleanup($stms['form_profile']['username_label']) : stms_isset($defaults['profile']['username_label']);
	$form .= '<table class="insta-form-table">';
	$form .= '<tr valign="top">' . "\n";
	$form .= '<th scope="row" style="text-align:right"><label for="im_reg_username" class="for-text"><strong>' . $username_label . '</strong></label></th>' . "\n";
	$form .= '<td><strong><span style="color:#000099">' . stms_cleanup($member->username) . '</span></strong></td>' . "\n";
	$form .= '</tr>' . "\n";
	$form .= stms_form_mapping($fields['active'], $fields['fields'], $vars);
	
	$affset = ( $direct_pays && count($direct_pays) > 0 && isset($stms['global']['payout']) && count($stms['global']['payout']) > 0 ) ? true : false;
	if ( $affset && $show_aff == 1 ) {
		$aff_title = stms_cleanup($fields['aff_title']);
		$afflink_label = stms_cleanup($fields['afflink_label']);
		$viewstats_txt = stms_cleanup($fields['viewstats_txt']);
		
		$aff_ids = stms_get_member_meta($member_id, 'aff_ids');
		$aff_url = stms_format_url(get_bloginfo('url'), 'iaff=' . $member_id);
		$stats_url = stms_get_handler_url('stats');
		$form .= '<tr valign="top">' . "\n";
		$form .= '<td colspan="2"><h3 style="margin:0; padding:10px 0 5px">' . $aff_title . '</h3></td>' . "\n";
		$form .= '</tr>' . "\n";
		
		if ( $member->is_aff == 1 ) {
			$form .= '<tr valign="top">' . "\n";
			$form .= '<th scope="row" style="text-align:right"><label class="for-text"><strong>' . $afflink_label . '</strong></label></th>' . "\n";
			$form .= '<td><a href="' . $aff_url . '" target="_blank" />' . $aff_url . '</a> <a href="' . $stats_url . '">(' . $viewstats_txt . ')</a></td>' . "\n";
			$form .= '</tr>' . "\n";
						
			if ( !empty($stms['global']['payout']) ) {
				foreach ( $stms['global']['payout'] as $key => $value ) {
					if ( $value == 1 ) {
						$affemail_label = ( isset($stms['form_profile']['aff' . $key . '_label']) ) ? stms_cleanup($stms['form_profile']['aff' . $key . '_label']) : stms_isset($defaults['profile']['aff' . $key . '_label']);
						$form .= '<tr valign="top">' . "\n";
						$form .= '<th scope="row" style="text-align:right"><label for="im_affs_' . $key . '" class="for-text"><strong><strong>' . $affemail_label . '</strong></label></th>' . "\n";
						$form .= '<td><input type="text" name="im_affs[' . $key . ']" id="im_affs_' . $key . '" value="' . stms_cleanup($aff_ids[$key]) . '" style="width:100%" /></td>' . "\n";
						$form .= '</tr>' . "\n";
					}
				}
			}
			 
		// affiliate account is in review...
		} else if ( $member->is_aff_pending == 1 ) {
			$affpending_msg = ( isset($stms['form_profile']['affpending_msg']) ) ? stms_sanitize($stms['form_profile']['affpending_msg']) : stms_isset($defaults['profile']['affpending_msg']);
			$form .= '<tr valign="top">' . "\n";
			$form .= '<td colspan="2">' . wpautop($affpending_msg) . '</td>' . "\n";
			$form .= '</tr>' . "\n";
		// affiliate account is inactive
		} else {
			$profile_url = stms_get_handler_url('profile');
			$aff_activate_url = stms_format_url($profile_url, 'action=aff_activate');
			$affinactive_msg = ( isset($stms['form_profile']['affinactive_msg']) ) ? stms_sanitize($stms['form_profile']['affinactive_msg']) : stms_isset($defaults['profile']['affinactive_msg']);
			$affinactive_msg = str_replace('[aff_activate_link]', '<a href="' . $aff_activate_url . '">', $affinactive_msg);
			$affinactive_msg = str_replace('[/aff_activate_link]', '</a>', $affinactive_msg);
			$form .= '<tr valign="top">' . "\n";
			$form .= '<td colspan="2">' . wpautop($affinactive_msg) . '</td>' . "\n";
			$form .= '</tr>' . "\n";
		}
	}

	$changepass_title = ( isset($stms['form_profile']['changepass_title']) ) ? stms_cleanup($stms['form_profile']['changepass_title']) : stms_isset($defaults['profile']['changepass_title']);
	$changepass_txt = ( isset($stms['form_profile']['changepass_txt']) ) ? stms_cleanup($stms['form_profile']['changepass_txt']) : stms_isset($defaults['profile']['changepass_txt']);
	$changepass_label = ( isset($stms['form_profile']['changepass_label']) ) ? stms_cleanup($stms['form_profile']['changepass_label']) : stms_isset($defaults['profile']['changepass_label']);
	$changepass2_label = ( isset($stms['form_profile']['changepass2_label']) ) ? stms_cleanup($stms['form_profile']['changepass2_label']) : stms_isset($defaults['profile']['changepass2_label']);
	
	$form .= '<tr valign="top">' . "\n";
	$form .= '<td colspan="2"><h3 style="margin:0; padding:10px 0 5px">' . $changepass_title . '</h3><small>' . $changepass_txt . '</small></td>' . "\n";
	$form .= '</tr>' . "\n";
	$form .= '<tr valign="top">' . "\n";
	$form .= '<th scope="row" style="text-align:right"><label for="im_ch_pass1" class="for-text"><strong>' . $changepass_label . '</strong></label></th>' . "\n";
	$form .= '<td><input type="password" name="im_ch_pass1" id="im_ch_pass1" value="" style="width:100%" /></td>' . "\n";
	$form .= '</tr>' . "\n";
	$form .= '<tr valign="top">' . "\n";
	$form .= '<th scope="row" style="text-align:right"><label for="im_ch_pass2" class="for-text"><strong>' . $changepass2_label . '</strong></label></th>' . "\n";
	$form .= '<td><input type="password" name="im_ch_pass2" id="im_ch_pass2" value="" style="width:100%" /></td>' . "\n";
	$form .= '</tr>' . "\n";
	
	$form .= '<tr valign="top"><th></th><td><input type="submit" name="instamem-signup" id="instamem-signup" class="button gray btn btn-primary btn_custom" value="' . $label . '" /></td></tr>';
	$form .= '</table>';
	$form .= '</form>';
	$form .= wpautop(stms_sanitize($fields['after_text']));
	//$form .= '<pre>' . print_r($stms, true) . '</pre>' . "\n";
	
	return $form;
}

function stms_login_form( $redir = '' ) {
	$stms = get_option('stms_settings');
	$defaults = stms_default_forms();
	$fields = ( isset($stms['form_login']) ) ? stms_build_form_fields($stms['form_login'], 'login') : stms_isset($defaults['login']);
	$nonce = wp_create_nonce('stms-nonce');
	$ipaddress = stms_retrieve_ipaddr();
	$forgotpass_url = stms_format_url($stms['global']['magic'], 'imhandler=forgot');
	$msg = stms_isset($_REQUEST['msg']);
	
	$login_title = ( isset($stms['form_login']['form_title']) ) ? stms_cleanup($stms['form_login']['form_title']) : stms_isset($defaults['login']['title']);
	$username_label = ( isset($stms['form_login']['username_label']) ) ? stms_cleanup($stms['form_login']['username_label']) : stms_isset($defaults['login']['username_label']);
	$password_label = ( isset($stms['form_login']['password_label']) ) ? stms_cleanup($stms['form_login']['password_label']) : stms_isset($defaults['login']['password_label']);
	$remember_label = ( isset($stms['form_login']['remember_label']) ) ? stms_cleanup($stms['form_login']['remember_label']) : stms_isset($defaults['login']['remember_label']);
	$captcha_label = ( isset($stms['form_login']['captcha_label']) ) ? stms_cleanup($stms['form_login']['captcha_label']) : stms_isset($defaults['login']['captcha_label']);
	$forgotpass_txt = ( isset($stms['form_login']['forgotpass_txt']) ) ? stms_cleanup($stms['form_login']['forgotpass_txt']) : stms_isset($defaults['login']['forgotpass_txt']);
	$button_label = ( isset($stms['form_login']['button_label']) ) ? stms_cleanup($stms['form_login']['button_label']) : $defaults['login']['label'];
	
	$form = '';
	if ( wp_get_theme() == 'InstaSpark' )
		$form .= '<div class="insta-login-center">' . "\n";
		
	$form .= '<form method="post" name="instamem-log-form" id="instamem-log-form">' . "\n";
	$form .= '<h3>' . $login_title . '</h3>';
	$form .= apply_filters('stms_login_messages', '', $msg);
	$form .= wpautop(stms_sanitize($fields['before_text']));
	$form .= '<input type="hidden" name="_instamember_action" value="login" />' . "\n";
	$form .= '<input type="hidden" name="_instamember_nonce" value="' . $nonce . '" />' . "\n";
	if ( isset($_GET['tx_id']) && $_GET['tx_id'] > 0 )
		$form .= '<input type="hidden" name="tx_id" value="' . $_GET['tx_id'] . '" />' . "\n";
	
	if ( isset($_GET['insta_token']) )
		$form .= '<input type="hidden" name="insta_token" value="' . rawurldecode($_GET['insta_token']) . '" />' . "\n";
	
	if ( isset($_GET['flow_id']) )
		$form .= '<input type="hidden" name="flow_id" value="' . rawurldecode($_GET['flow_id']) . '" />' . "\n";
	
	if ( isset($_GET['tx_ids']) && is_array($_GET['tx_ids']) && count($_GET['tx_ids']) > 0 ) {
		foreach ( $_GET['tx_ids'] as $trx_id ) {
			$form .= '<input type="hidden" name="tx_ids[]" value="' . $trx_id . '" />' . "\n";
		}
	}

	$form .= ( !empty($redir) ) ? '<input type="hidden" name="redir" value="' . urldecode($redir) . '" />' . "\n" : '';
	$form .= '<div style="width:235px">' . "\n";
	$form .= '<p>' . "\n";
	$form .= '<label for="im_username" class="insta-login-label">' . $username_label . '</label>' . "\n";
	$form .= '<input type="text" name="im_username" id="im_username" value="" style="width:220px; border:2px solid #c0c0c0; font-size:14px; padding:8px;" autofocus />' . "\n";
	$form .= '</p>' . "\n";
	$form .= '<p>' . "\n";
	$form .= '<label for="im_username" class="insta-login-label">' . $password_label . '</label>' . "\n";
	$form .= '<input type="password" name="im_password" id="im_password" value="" style="width:220px; border:2px solid #c0c0c0; font-size:14px; padding:8px;" />' . "\n";
	$form .= '</p>' . "\n";
	$form .= '<p>' . "\n";
	$form .= '<input type="checkbox" class="checkbox" id="rememberme" name="rememberme" value="1" style="display:inline !important" />' . "\n";
	$form .= '<label for="rememberme" style="display:inline !important">' . $remember_label . '</label>';
	$form .= '</p>' . "\n";

	if ( stms_isset($stms['integration']['recaptcha']['public']) != '' ) {
		$transient = get_transient('stms_brute_' . $ipaddress);
		if ( stms_isset($transient['attempts']) >= 2 ) {
			require_once( STMS_SOURCES . '/recaptcha/recaptchalib.php');
			$form .= '<strong>' . $captcha_label . '</strong>' . "\n";
			$form .= recaptcha_get_html(trim($stms['integration']['recaptcha']['public']), '', is_ssl());

		}
	}
	
	$form .= '<p style="margin-top:20px"><input type="submit" name="instamem-login" id="instamem-login" class="button gray btn btn-primary btn_custom" value="' . $button_label . '" /></p>' . "\n";
	$form .= '</div>' . "\n";
	$form .= '</form>' . "\n";
	$form .= wpautop(stms_sanitize($fields['after_text']));
	$form .= '<p><a href="' . $forgotpass_url . '">' . $forgotpass_txt . '</a></p>' . "\n";
	
	if ( wp_get_theme() == 'InstaSpark' )
		$form .= '</div>' . "\n";
	return $form;
}

function stms_forgotpass_form() {
	$stms = get_option('stms_settings');
	$defaults = stms_default_forms();
	$fields = ( isset($stms['form_forgotpass']) ) ? stms_build_form_fields($stms['form_forgotpass'], 'forgotpass') : stms_isset($defaults['forgotpass']);
	
	$nonce = wp_create_nonce('stms-nonce');
	$login_url = stms_login_url();
	
	$form_title = ( isset($stms['form_forgotpass']['form_title']) ) ? stms_cleanup($stms['form_forgotpass']['form_title']) : stms_isset($defaults['forgotpass']['title']);
	$email_label = ( isset($stms['form_forgotpass']['email_label']) ) ? stms_cleanup($stms['form_forgotpass']['email_label']) : stms_isset($defaults['forgotpass']['username_label']);
	$button_label = ( isset($stms['form_forgotpass']['button_label']) ) ? stms_cleanup($stms['form_forgotpass']['button_label']) : stms_isset($defaults['forgotpass']['label']);
	$back_txt = ( isset($stms['form_forgotpass']['back_txt']) ) ? stms_cleanup($stms['form_forgotpass']['back_txt']) : stms_isset($defaults['forgotpass']['back_txt']);
	
	$form = '';
	if ( wp_get_theme() == 'InstaSpark' )
		$form .= '<div class="insta-login-center">' . "\n";
		
	$form .= '<form method="post" name="instamem-log-form" id="instamem-log-form">' . "\n";
	$form .= '<h3>' . $form_title . '</h3>';
	
	if ( isset($_GET['requested']) )
		$form .= '<div class="insta-update-msg"><p><strong>Reset password instruction has been sent to your email.</strong></p></div>' . "\n";
		
	if ( isset($_GET['auth_error']) )
		$form .= '<div class="insta-error-msg"><p><strong>ERROR: ' . base64_decode($_GET['auth_error']) . '</strong></p></div>' . "\n";
	
	if ( isset($_GET['auth_vars']) ) {
		$auth_vars = base64_decode($_GET['auth_vars']);
		$vars = (array) json_decode($auth_vars);
	}

	$form .= wpautop(stms_sanitize($fields['before_text']));
	
	$form .= '<input type="hidden" name="_instamember_action" value="forgotpass" />' . "\n";
	$form .= '<input type="hidden" name="_instamember_nonce" value="' . $nonce . '" />' . "\n";
	$form .= '<div style="width:235px">' . "\n";
	$form .= '<p>' . "\n";
	$form .= '<label for="im_forgot_email" class="insta-login-label">' . $email_label . '</label>' . "\n";
	$form .= '<input type="text" name="im_forgot_email" id="im_forgot_email" value="' . stms_isset($vars['im_forgot_email'], '') . '" style="width:220px; border:2px solid #c0c0c0; font-size:14px; padding:8px;" autofocus />' . "\n";
	$form .= '</p>' . "\n";

	$form .= '<p style="margin-top:20px"><input type="submit" name="instamem-forgot" id="instamem-forgot" class="button gray btn btn-primary btn_custom" value="' . $button_label . '" /></p>' . "\n";
	$form .= '</div>' . "\n";
	$form .= '</form>' . "\n";
	
	$form .= wpautop(stms_sanitize($fields['after_text']));
	
	$form .= '<p><a href="' . $login_url . '">' . $back_txt. '</a></p>' . "\n";
	
	if ( wp_get_theme() == 'InstaSpark' )
		$form .= '</div>' . "\n";
		
	return $form;
}

function stms_resetpass_form() {
	$stms = get_option('stms_settings');
	$defaults = stms_default_forms();
	$fields = ( isset($stms['form_resetpass']) ) ? stms_build_form_fields($stms['form_resetpass'], 'resetpass') : stms_isset($defaults['resetpass']);
	$button_label = ( stms_isset($stms['form_resetpass']['button_label']) != '' ) ? stms_cleanup($stms['form_resetpass']['button_label']) : $defaults['resetpass']['label'];
	$form_title = ( stms_isset($stms['form_resetpass']['form_title']) != '' ) ? stms_cleanup($stms['form_resetpass']['form_title']) : $defaults['resetpass']['title'];
	$password_label = ( stms_isset($stms['form_resetpass']['password_label']) != '' ) ? stms_cleanup($stms['form_resetpass']['password_label']) : $defaults['resetpass']['password_label'];
	$password2_label = ( stms_isset($stms['form_resetpass']['password2_label']) != '' ) ? stms_cleanup($stms['form_resetpass']['password2_label']) : $defaults['resetpass']['password2_label'];
	$before_text = ( stms_isset($stms['form_resetpass']['before_text']) != '' ) ? stms_sanitize($stms['form_before_text']['before_text']) : $defaults['resetpass']['before_text'];
	$after_text = ( stms_isset($stms['form_resetpass']['after_text']) != '' ) ? stms_sanitize($stms['form_before_text']['after_text']) : $defaults['resetpass']['after_text'];
	
	$nonce = wp_create_nonce('stms-nonce');
	$content = '';
	
	$form = '';
	
	if ( wp_get_theme() == 'InstaSpark' )
		$form .= '<div class="insta-login-center">' . "\n";
		
	$form .= '<form method="post" name="instamem-log-form" id="instamem-log-form">' . "\n";
	$form .= '<h3>' . $form_title . '</h3>';
	
	if ( isset($_GET['auth_error']) )
		$form .= '<div class="insta-error-msg"><p><strong>ERROR: ' . base64_decode($_GET['auth_error']) . '</strong></p></div>' . "\n";
	
	$form .= '<input type="hidden" name="_instamember_action" value="resetpass" />' . "\n";
	$form .= '<input type="hidden" name="_instamember_nonce" value="' . $nonce . '" />' . "\n";
	$form .= '<input type="hidden" name="_email" value="' . urldecode($_GET['email']) . '" />' . "\n";
	$form .= '<input type="hidden" name="_key" value="' . urldecode($_GET['key']) . '" />' . "\n";
	
	$form .= wpautop($before_text);
	$form .= '<div style="width:235px">' . "\n";
	$form .= '<p>' . "\n";
	$form .= '<label for="im_reset_pass1" class="insta-login-label">' . $password_label . '</label>' . "\n";
	$form .= '<input type="password" name="im_reset_pass1" id="im_reset_pass1" value="" style="width:220px; border:2px solid #c0c0c0; font-size:14px; padding:8px;" autofocus />' . "\n";
	$form .= '</p>' . "\n";
	$form .= '<p>' . "\n";
	$form .= '<label for="im_reset_pass2" class="insta-login-label">' . $password2_label . '</label>' . "\n";
	$form .= '<input type="password" name="im_reset_pass2" id="im_reset_pass2" value="" style="width:220px; border:2px solid #c0c0c0; font-size:14px; padding:8px;" />' . "\n";
	$form .= '</p>' . "\n";
	$form .= '<p style="margin-top:20px"><input type="submit" name="instamem-reset" id="instamem-reset" value="' . $button_label . '" class="button gray btn btn-primary btn_custom" /></p>' . "\n";
	$form .= '</div>' . "\n";
	$form .= '</form>' . "\n";
	$form .= wpautop($after_text);
	
	if ( wp_get_theme() == 'InstaSpark' )
		$form .= '</div>' . "\n";
		
	return $form;
}

function stms_affstats_form() {
	
	global $wpdb;
	
	$stms = get_option('stms_settings');
	$member = stms_get_current_member();
	$months = stms_find_monthly_dates();
	$weeks = stms_find_weekly_dates();

	$y = date("Y", stms_time());
	$w = date("W", stms_time());
	$week_days = stms_find_week_dates($w, $y);
	
	$_start = date("m/d/Y", $week_days[0]);
	$_end = date("m/d/Y", $week_days[6]);
	$start = stms_isset($_GET['start'], $_start);
	$end = stms_isset($_GET['end'], $_end);
	
	$form = '';
	$form .= "
		<div style='margin:0 0 18px; padding:10px 15px 25px; background:#F5F5F5; border:1px solid #ccc; -webkit-border-radius: 5px; border-radius: 5px; '>
			<table class='insta-form-table'>
			<tr>
				<th scope='row' style='width:auto; text-align:right'><strong>Weekly Period:</strong></th>
				<td>
				<select id='insta-search-weekly' style='width:auto'>
					<option value=''>[ - Choose Weekly - ]</option>
	";

	if ( $weeks ) {
		foreach ( $weeks as $key => $val ) {
			$query = $start . '|' . $end;
			$value = stms_isset($val['start']) . '|' . stms_isset($val['end']);
			$selected = ( $query == $value ) ? ' selected="selected"' : '';
			$form .= "<option value='{$value}'{$selected}>{$val['name']}</option>";
		}
	}

	$form .= "
				</select>
				</td>
			</tr>
			<tr>
				<th scope='row' style='width:auto; text-align:right'><strong>Monthly Period:</strong></th>
				<td>
				<select id='insta-search-monthly' style='width:auto'>
					<option value=''>[ - Choose Monthly - ]</option>
	";
	
	if ( $months ) {
		foreach ( $months as $key => $val ) {
			$query = stms_isset($_GET['start'], $start) . '|' . stms_isset($_GET['end'], $end);
			$value = stms_isset($val['start']) . '|' . stms_isset($val['end']);
			$selected = ( $query == $value ) ? ' selected="selected"' : '';
			$form .= "<option value='{$value}'{$selected}>{$val['name']}</option>";
		}
	}
					
	$form .= "
				</select>
				</td>
			</tr>
			</table>
		</div>
	";
	
	$stats = stms_member_affstats( $member->ID, $start, $end );
	// $form .= '<pre>' . print_r($stats, true) . '</pre>' . "\n";

	if ( $stats ) {
		$form .= '
			<table cellpadding="0" cellspacing="0" border="0" class="display" id="insta-commissions" width="100%">
			<thead>
				<tr>
					<th>Product</th>
					<th>Clicks</th>
					<th>Sales</th>
					<th>Refund</th>
					<th>Conv%</th>
					<th>Debit</th>
					<th>Credit</th>
					<th>Comm.</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<th>Product</th>
					<th>Clicks</th>
					<th>Sales</th>
					<th>Refund</th>
					<th>Conv%</th>
					<th>Debit</th>
					<th>Credit</th>
					<th>Comm.</th>
				</tr>
			</tfoot>
			<tbody>
		';
		
		$q_start = strtotime($start, stms_time());
		$q_end = strtotime($end . " 23:59", stms_time());
		
		$g_clicks = $wpdb->get_var("SELECT COUNT(DISTINCT ip_addr) FROM `{$wpdb->prefix}stms_aff_clicks` WHERE `aff_id` = {$member->ID} AND product_id = 0 AND date BETWEEN {$q_start} AND {$q_end}");
		$g_clicks = ( $g_clicks < 1 ) ? '-' : $g_clicks;
		$form .= "
				<tr style='background-color:#F5F5F5'>
					<td><strong>Total Clicks For The Main Aff. Link (<a href='" . stms_format_url(get_bloginfo('url'), 'iaff=' . $member->ID) . "'><small>Main Aff. link</small></a>)</td>
					<td class='center'>{$g_clicks}</td>
					<td class='center'></td>
					<td class='center'></td>
					<td class='center'></td>
					<td class='center'></td>
					<td class='center'></td>
					<td class='center'></td>
				</tr>
			";
			
		$total = 0; $i = 0;
		foreach ( $stats as $stat ) {
			$style = ( $i%2 ) ? 'background-color:#F5F5F5' : 'background-color:#FFF';
			$comm = number_format($stat->commissions - $stat->corrections, 2);
			$total += $comm;
			$conv = ( $stat->sales > 0 && $stat->clicks > 0 ) ? ceil(($stat->sales/$stat->clicks) * 100) : 0;
			$conv = ( $conv > 0 ) ? $conv . '%' : '-';
			
			$clicks = ( $stat->clicks > 0 ) ? $stat->clicks : '-';
			$sales = ( $stat->sales > 0 ) ? $stat->sales : '-';
			$refund = ( $stat->refund > 0 ) ? $stat->refund : '-';
			$credit = number_format($stat->corrections, 2);
			$credit = ( $credit > 0.00 ) ? '<span style="color:#ff0000">-' . $credit . '</span>' : '-';
			$debit = number_format($stat->commissions, 2);
			$comm = ( $credit < 0.00 ) ? '<span style="color:#ff0000">' . $comm . '</span>' : $comm;
			
			$form .= "
				<tr style='{$style}'>
					<td>" . stms_cleanup($stat->title) . " (<a href='" . stms_format_url(get_bloginfo('url'), 'iaff=' . $member->ID . '&p=' . $stat->ID) . "'><small>Aff. link for this product</small></a>)</td>
					<td class='center'>{$clicks}</td>
					<td class='center'>{$sales}</td>
					<td class='center'>{$refund}</td>
					<td class='center'>{$conv}</td>
					<td class='center'>{$debit}</td>
					<td class='center'>{$credit}</td>
					<td class='center'><strong>{$comm}</strong></td>
				</tr>
			";
			$i++;
		}
		$form .= "</table>";
		
		$total = number_format($total, 2);
		$total_color = ( $total < 0.00 ) ? ' style="color:#ff0000"' : (( $total > 0.00 ) ? ' style="color:#009900"' : '');
		$form .= "<p style='text-align:right'>Total Commission: <span{$total_color}><strong>{$total} " . stms_isset($stms['global']['currency'], 'USD') . "</strong></span></p>";
	}
	return $form;
}

add_action('wp_footer', 'stms_affstats_script');
function stms_affstats_script() {
	if ( isset($_GET['imhandler']) && $_GET['imhandler'] == 'stats' ) {
		$stms = get_option('stms_settings');
		$url = stms_format_url(stms_isset($stms['global']['magic']), 'imhandler=stats');
?>
<script type="text/javascript">
jQuery(document).ready(function($){
	$('#insta-search-weekly').change(function(){
		var option = $("option:selected", this).val();
		var w = option.split("|");
		var query = '&start=' + w[0] + '&end=' + w[1];
		var url = '<?php echo $url; ?>' + query;
		window.location = url;
	});
	$('#insta-search-monthly').change(function(){
		var option = $("option:selected", this).val();
		var m = option.split("|");
		var query = '&start=' + m[0] + '&end=' + m[1];
		var url = '<?php echo $url; ?>' + query;
		window.location = url;
	});
});
</script>
<?php
	}
}

function stms_order_lookup_form() {
	$stms = get_option('stms_settings');
	$nonce = wp_create_nonce('stms-nonce');
	$ipaddress = stms_retrieve_ipaddr();
	$msg = stms_isset($_REQUEST['msg']);
	$product_id = ( isset($_GET['product_id']) ) ? $_GET['product_id'] : 0;
	$paysys = ( isset($_GET['paysys']) ) ? $_GET['paysys'] : '';
	
	$form = '';
	if ( wp_get_theme() == 'InstaSpark' )
		$form .= '<div class="insta-form-center">' . "\n";
	
	$form .= '<form method="post" name="instamem-dg-form" id="instamem-dg-form">' . "\n";
	$form .= '<h3>Claim Your Order</h3>';
	
	if ( isset($_GET['auth_error']) )
		$form .= '<div class="insta-error-msg insta-reg-buy"><p><strong>' . base64_decode($_GET['auth_error']) . '</strong></p></div>' . "\n";
	
	if ( isset($_GET['auth_vars']) ) {
		$auth_vars = base64_decode($_GET['auth_vars']);
		$vars = (array) json_decode($auth_vars);
	}
	
	if ( empty($paysys) ) 
		$form .= '<p>Please enter the email address that you used to purchase the product, and the payment system name:</p>';
	else
		$form .= '<p>Please enter the email address that you used to purchase the product:</p>';
	
	$form .= '<input type="hidden" name="_instamember_action" value="stms_order_check" />' . "\n";
	$form .= '<input type="hidden" name="_instamember_nonce" value="' . $nonce . '" />' . "\n";
	if ( !empty($paysys) ) $form .= '<input type="hidden" name="paysys" value="' . $paysys . '" />' . "\n";
	if ( !empty($product_id) ) $form .= '<input type="hidden" name="product_id" value="' . $product_id . '" />' . "\n";
	
	$form .= '<p>' . "\n";
	$form .= '<input type="text" name="im_order_email" id="im_order_email" placeholder="Enter purchase email here..." value="' . stms_isset($vars['im_order_email'], '') . '" style="width:250px; border:1px solid #c0c0c0; font-size:14px; padding:8px;" autofocus />';
	//$form .= '&nbsp;<span class="insta-qtip" title="Email address that you used to purchase the product on the payment processor. If you\'re using PayPal to purchased, please enter your PayPal email address here."><strong>[?]</strong></span>';
	$form .= '</p>' . "\n";
	
	if ( empty($paysys) ) {
		$paysystems = stms_get_pay_plugins('thirds');
		foreach ( $paysystems as $k => $v ) {
			if ( stms_isset($stms['payments']['is_' . $k]) != 1 )
				unset($paysystems[$k]);
		}
		$form .= '<p><label for="paysys">Payment System:</label><br />' . "\n";
		$form .= '<select name="paysys" id="paysys" style="width:250px; border:1px solid #c0c0c0; font-size:14px; padding:8px;" >';
		if ( count($paysystems) > 0 ) {
			foreach ( $paysystems as $k => $v ) {
				$selected = ( $k == stms_isset($vars['paysys']) ) ? ' selected="selected"' : '';
				$form .= "<option value='{$k}'{$selected}>{$v}</option>";
			}
		}
		$form .= '</select>' . "\n";
		$form .= '</p>' . "\n";
	}
	$form .= '<p>' . "\n";
	$form .= '<input type="submit" name="instamem-dg" id="instamem-dg" class="button gray" value="Continue" />' . "\n";
	$form .= '</p>' . "\n";
	
	$default_from = get_option('blogname');
	$from = ( !empty($stms['emails']['admin_from']) && !empty($stms['emails']['admin_email']) ) ? $stms['emails']['admin_from'] : $default_from;
	if ( !empty($stms['email_templates']['receipt']['fromname']) && !empty($stms['email_templates']['receipt']['frommail']) )
		$from = stms_sanitize($stms['email_templates']['receipt']['fromname']);

	$form .= '</form>' . "\n";
	
	//$form .= '<p style="color:#808080"><strong>Hint:</strong> To get direct access link to the product, please check the email address you used to purchase for a "Payment Receipt" email sent by "<em>' . esc_html(trim($from)) . '</em>"</p>' . "\n";
	//$form .= '<p style="color:#808080">If you cannot found the receipt email in your inbox, please also check your <em>SPAM/JUNK/BULK</em> email folder.</p>' . "\n";
	
	if ( wp_get_theme() == 'InstaSpark' )
		$form .= '</div>' . "\n";
		
	return $form;
}

function stms_post_title_hooks($title, $id) {
	$new_title = $title;
	if ( in_the_loop() && $id == get_the_ID() ) {
		$stms = get_option('stms_settings');
		$defaults = stms_default_forms();
		switch ( $_REQUEST['imhandler'] ) {
			case 'resetpass':
			case 'forgot':
			case 'login':
			case 'registration':
			case 'profile':
			case 'support':
			case 'order_lookup':
				$new_title = '';
				break;
			case 'stats':
				$new_title = 'Affiliate Stats';
				break;
			case 'checkout':
				$new_title = 'Secure Payment Form';
				break;
		}
	}
	
	return $new_title;
}

function stms_wp_title_hooks( $title, $sep ) {
	if ( is_feed() )
		return $title;

	$new_title = $title;
	$stms = get_option('stms_settings');
	$defaults = stms_default_forms();
	switch ( $_REQUEST['imhandler'] ) {
		case 'login':
			$wp_title = ( isset($stms['form_login']['form_title']) ) ? stms_cleanup($stms['form_login']['form_title']) : stms_isset($defaults['login']['title']);
			break;
		case 'registration':
			$wp_title = ( isset($stms['form_signup']['form_title']) ) ? stms_cleanup($stms['form_signup']['form_title']) : stms_isset($defaults['signup']['title']);
			if ( !isset($_GET['key']) && stms_isset($stms['global']['free_aff'], 1) == 1 )
				$wp_title = ( isset($stms['form_affiliate']['form_title']) ) ? stms_cleanup($stms['form_affiliate']['form_title']) : stms_isset($defaults['affiliate']['title']);
			break;
		case 'profile':
			$wp_title = ( isset($stms['form_profile']['form_title']) ) ? stms_cleanup($stms['form_profile']['form_title']) : stms_isset($defaults['profile']['title']);
			break;
		case 'support':
			$wp_title = stripslashes(stms_isset($stms['support']['title'], get_bloginfo('name') . ' Support Desk'));
			break;
		case 'forgot':
			$wp_title = 'Forgot Password Form';
			break;
		case 'resetpass':
			$wp_title = 'Reset Password Form';
			break;
		case 'stats':
			$wp_title = 'Affiliate Stats';
			break;
		case 'checkout':
			$wp_title = 'Secure Payment Form';
			break;
		case 'order_lookup':
			$wp_title = 'Order Look-Up Form';
			break;
	}
	$new_title = "{$wp_title} {$sep} " . get_bloginfo( 'name' );
	return $new_title;
}

add_filter('stms_login_messages', 'stms_display_login_message', 10, 2);
function stms_display_login_message( $content, $msg ) {
	$stms = get_option('stms_settings');
	$defaults = stms_default_forms();
	$logins = ( isset($stms['form_login']) ) ? stms_build_form_fields($stms['form_login'], 'login') : stms_isset($defaults['login']);
	$resets = ( isset($stms['form_resetpass']) ) ? stms_build_form_fields($stms['form_resetpass'], 'resetpass') : stms_isset($defaults['resetpass']);
	
	$content = $content;
	switch ( $msg ) {
		case 'password_reset':
			$content .= '<div class="insta-update-msg"><p>' . stms_sanitize($logins['passchanged_msg']) . '</p></div>';
			break;
		case 'login_failed':
			$content .= '<div class="insta-error-msg"><p><strong>ERROR: Wrong username or password.</strong></p></div>';
			break;
		case 'captcha_failed':
			$content .= '<div class="insta-error-msg"><p><strong>ERROR: You\'ve entered wrong captcha code.</strong></p></div>';
			break;
		case 'auto_locked':
			$content .= '<div class="insta-error-msg"><p><strong>ERROR: Your account has been locked by administrator.</strong></p></div>';
			break;
		case 'invalid_confirm_url':
			$content .= '<div class="insta-error-msg"><p><strong>ERROR: Invalid Confirmation URL.</strong></p></div>';
			break;
		case 'checkout_login':
			$content .= '<div class="insta-error-msg"><p><strong>Please login first to checkout.</strong></p></div>';
			break;
		case 'logged_out':
			$content .= '<div class="insta-update-msg"><p><strong>You have logged out.</strong></p></div>';
			break;
		case 'confirm_required':
			$content .= '<div class="insta-update-msg"><p><strong>We\'ve sent a confirmation email to your email address. To activate your account, please click on the link inside the email we sent you.</strong></p></div>';
			break;
		case 'temp_locked':
			$stms = get_option('stms_settings');
			$delay = stms_isset($stms['global']['brute_delay']);
			$content .= '<div class="insta-error-msg"><p><strong>ERROR: Please wait ' . $delay . ' minutes before next login attempt.</strong></p></div>';
			break;
	}

	if ( empty($msg) && isset($_GET['redir']) )
		$content .= '<div class="insta-update-msg"><p>' . stms_sanitize($logins['logrequired_msg']) . '</p></div>';
	
	return $content;
}

add_filter('stms_profile_messages', 'stms_display_profile_message', 10, 2);
function stms_display_profile_message( $content ) {
	$defaults = stms_default_forms();
	$fields = ( isset($stms['form_profile']) ) ? stms_build_form_fields($stms['form_profile'], 'profile') : stms_isset($defaults['profile']);
	
	if ( isset($_GET['updated']) && $_GET['updated'] == 'true' )
		$content .= '<div class="insta-update-msg"><p>' . stms_sanitize($fields['updated_msg']) . '</p></div>';

	return $content;
}

add_action('wp_footer', 'stms_form_scripts');
function stms_form_scripts() {
	$handler = stms_isset($_REQUEST['imhandler'], '');
	if ( $handler == 'registration' || $handler == 'profile' ) {
		$display_form = true;
		if ( $_REQUEST['imhandler'] == 'registration' && is_stmsmember_logged_in() )
			$display_form = false;
	
		if ( isset($_REQUEST['key']) ) {
			$session = base64_decode($_REQUEST['key']);
			$key = explode("|", $session);
			$product_id = (int) $key[0];
			$payment = stms_isset($key[1]);
			if ( $payment == 'authorize' )
				$display_form = true;
				
			if ( $product = stms_get_product($product_id) ) {
				if ( $product->info['steps'] == '2,1' ) {
					if ( isset($_REQUEST['insta_token']) ) {
						$insta_token = get_transient('insta_token_' . $_REQUEST['insta_token']);
						if ( stms_isset($insta_token['token']) == $_REQUEST['insta_token'] ) {
							$display_form = true;
						}
					}
				}
			}
		}

		if ( !$display_form )
			return false;
		
		$stms = get_option('stms_settings');
		$defaults = stms_default_forms();
		$type = ( $_REQUEST['imhandler'] == 'profile' ) ? 'profile' : ( (!isset($_GET['key'])) ? 'affiliate' : 'signup' );
		$fields = ( isset($stms['form_' . $type]) ) ? stms_build_form_fields($stms['form_' . $type], $type) : stms_isset($defaults[$type]);
		$label = ( stms_isset($stms['form_' . $type]['button_label']) != '' ) ? stms_cleanup($stms['form_' . $type]['button_label']) : $defaults[$type]['label'];
		//$profile_validate = ( $_REQUEST['imhandler'] == 'registration' ) ? '' : '_profile';
		
		$script = '';
		$script .= '<script type="text/javascript">' . "\n";
		$script .= 'jQuery(document).ready(function($){' . "\n";
		$script .= '
			$.validator.addMethod("alphanumeric", function(value, element) {
				return this.optional(element) || /^\w+$/i.test(value);
			}, "Letters, numbers, and underscores only please");
	
			$.validator.addMethod("password", function( value, element ) {
				var result = this.optional(element) || /^[A-Za-z0-9`~!@#$%^&*()_|+\-=?;:\'",.<>\{\}\[\]\\\/]{6,40}$/.test(value);
				if ( !result )
					element.focus();
				return result;
			}, "Password must be at least 6 characters, and maximum 40 characters. No white spaces.");
		';
		
		if ( wp_get_theme() != 'Squirrel Pro Responsive Theme' ) {
			$script .= '
				$("#instamem-' . $type . '-form").validate({
					rules: {
						im_reg_username: {
							required: true,
							alphanumeric: true,
							remote: {
								url: "' . stms_format_url(get_bloginfo('url'), 'insta_mode=ajax') . '",
								type: "post",
								data: { 
									action: "validate_username",
									member_id: function(){ return $("#insta_member_id").val(); }
								},
								beforeSend: function(xhr, settings) {
									$("#instamem-signup").val("Validating Data...").attr("disabled", "disabled");
								},
								complete: function(xhr, status) {
									$("#instamem-signup").val("' . $label . '").removeAttr("disabled");
								},
							}
						},
				';
		}
		
		if ( $type != 'profile' && wp_get_theme() != 'Squirrel Pro Responsive Theme' ) {
			$script .= '	
					im_reg_email: {
						required: true,
						email: true,
						remote: {
							url: "' . stms_format_url(get_bloginfo('url'), 'insta_mode=ajax') . '",
							type: "post",
							data: {
								action: "validate_email",
								old_email: function(){ return $("#insta_old_email").val(); }
							},
							beforeSend: function(xhr, settings) {
								$("#instamem-signup").val("Validating Data...").attr("disabled", true);
							},
							complete: function(xhr, status) {
								$("#instamem-signup").val("' . $label . '").removeAttr("disabled");
							}
						}
					},
			';
		}

		if ( $type == 'profile' ) {
			$script .= '
				im_ch_pass: {
					password: false,
				},
				im_ch_pass1: {
					password: true,
				},
				im_ch_pass2: {
					equalTo: "#im_ch_pass1"
				},
			';	
		}
		if ( stms_isset($stms['form_signup']['show_tos']) == 1 && stms_isset($stms['form_signup']['tos_url']) ) {
			$script .= '
					im_tos: {
						required: true
					},';
		}

		if ( isset($payment) && $payment == 'authorize' ) {
			$script .= '
				im_cardholder_name: {
					required: true
				},
				im_cardnumber: {
					required: true,
					digits: true
				},
				';
				
			if ( stms_isset($stms['payments']['authorize']['ccv']) == 1 ) {
				$script .= '
				im_cardsecurity: {
					required: true
				},
				';
			}
			if ( stms_isset($stms['payments']['authorize']['avs']) == 1 ) {
				$script .= '
				im_cardstreet: {
					required: true
				},
				im_cardcity: {
					required: true
				},
				im_cardstate: {
					required: true
				},
				im_cardzip: {
					required: true
				},
				im_cardcountry: {
					required: true
				},
				';
			}
		}

		foreach ( $fields['active'] as $field ) {
			switch ( $field ) {
				case 'username':
				case 'email':
					// do nothing
					break;
				case 'password':
					$script .= '
					im_reg_password: {
						required: true,
						password: true,
					},
					im_reg_password2: {
						required: true,
						equalTo: "#im_reg_password"
					},
					';
					break;
				case 'url':
					$required = ( stms_isset($fields['fields'][$field][3]) == 'yes' ) ? 'required:true,' : '';
					$script .= '
						im_reg_' . $field . ': {
							' . $required . '
							url:true
						},
					';
					break;
				default:
					if ( ( stms_isset($fields['fields'][$field][3]) == 'yes' ) ) :
					$script .= '
						im_reg_' . $field . ': {
							required: true
						},
					';
					endif;
			}
		}
		$script .= '
				},
				messages: {
					im_reg_username: {
						required: "Please enter a username",
						remote: $.format(\'Username already in use. Please choose another username\')
					},
					im_reg_email: { 
						required: "Please enter a valid email address",
						remote: $.format(\'Email already registered. Please enter a different email address\')
					},
		';
		
		if ( stms_isset($stms['form_signup']['show_tos']) == 1 && stms_isset($stms['form_signup']['tos_url']) ) {
			$script .= '
					im_tos: {
						required: "<br />You must accept our \"Terms & Conditions\" to register"
					},';
		}
		
		if ( isset($payment) && $payment == 'authorize' ) {
			$script .= '
				im_cardnumber: {
					required: "Please enter a valid credit card number",
					digits: "Please enter digits only (do not use dashes or spaces)"
				},
				';
				
			if ( stms_isset($stms['payments']['authorize']['ccv']) == 1 ) {
				$script .= '
				im_cardsecurity: {
					required: "<br />Please enter your credit card\'s security code (CVV)"
				},
				';
			}
		}
		
		foreach ( $fields['active'] as $field ) {
			switch ( $field ) {
				case 'password':
					$script .= '
					im_reg_password: { required: "Please type a password" },
					im_reg_password2: { required: " ", equalTo: "Please enter the same password as above" }
					';
					break;
			}
		}
		$script .= '
				},
				errorPlacement: function(error, element) {
					if ( element.is(":checkbox") )
						error.appendTo ( element.next() );
					else {
						error.appendTo ( element.parent() );
					}
				},
				errorClass: "insta-field-error"
			});
			
			$("#existing-purchase").click(function(e){
				$(".insta-reg-buy").hide();
				$(".insta-login-purchase").fadeIn("medium");
				e.preventDefault();
			});
			$("#new-purchase").click(function(e){
				$(".insta-login-purchase").hide();
				$(".insta-reg-buy").fadeIn("medium");
				e.preventDefault();
			});
		';
		$script .= '});' . "\n";
		$script .= '</script>' . "\n";
		
		echo $script;
	}
}

function stms_form_mapping($active, $fields, $values = array() ) {
	$prefix = '';
	if ( isset($_GET['auth_vars']) ) {
		$auth_vars = base64_decode($_GET['auth_vars']);
		$vars = (array) json_decode($auth_vars);
		$prefix = 'im_reg_';
	} else if ( count($values) > 1 ){
		$vars = $values;
	}

	$form = '';
	foreach ( $active as $field ) {
		switch ( $field ) {
			case 'email':
			case 'username':
			case 'first_name':
			case 'last_name':
			case 'url':
				$required = ( stms_isset($fields[$field][3]) == 'yes' ) ? '<span style="color:red">*</span> ' : '';
				$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
				$form .= '<th scope="row" style="text-align:right"><label for="im_reg_' . $field . '" class="for-text"><strong>' . $required . $fields[$field][1]. '</strong></label></th>' . "\n";
				$form .= '<td><input type="text" name="im_reg_' . $field . '" id="im_reg_' . $field . '" value="' . stms_cleanup(stms_isset($vars[$prefix . $field])) . '" style="width:100%" /></td>' . "\n";
				$form .= '</tr>' . "\n";
				break;
				
			case 'street':
				$required = ( stms_isset($fields[$field][3]) == 'yes' ) ? '<span style="color:red">*</span> ' : '';
				$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
				$form .= '<th scope="row" style="text-align:right"><label for="im_reg_' . $field . '" class="for-text"><strong>' . $required . $fields[$field][1]. '</strong></label></th>' . "\n";
				$form .= '<td><textarea name="im_reg_' . $field . '" id="im_reg_' . $field . '" style="width:100%;height:75px">' . stms_cleanup(stms_isset($vars[$prefix . $field])) . '</textarea></td>' . "\n";
				$form .= '</tr>' . "\n";
				break;
				
			case 'phone':
			case 'company':
			case 'zipcode':
			case 'state':
			case 'city':
			 	$width = '55%';
				if ( $field == 'zipcode' )
					$width = '30%';
				else if ( $field == 'phone' )
					$width = '40%';
				
				$required = ( stms_isset($fields[$field][3]) == 'yes' ) ? '<span style="color:red">*</span> ' : '';
				$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
				$form .= '<th scope="row" style="text-align:right"><label for="im_reg_' . $field . '" class="for-text"><strong>' . $required . $fields[$field][1]. '</strong></label></th>' . "\n";
				$form .= '<td><input type="text" name="im_reg_' . $field . '" id="im_reg_' . $field . '" value="' . stms_cleanup(stms_isset($vars[$prefix . $field])) . '" style="width:' . $width . '" /></td>' . "\n";
				$form .= '</tr>' . "\n";
				break;
				
			case 'country':
				$required = ( stms_isset($fields[$field][3]) == 'yes' ) ? '<span style="color:red">*</span> ' : '';
				$countries = stms_world_countries();
				
				$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
				$form .= '<th scope="row" style="text-align:right"><label for="im_reg_' . $field . '" class="for-text"><strong>' . $required . $fields[$field][1]. '</strong></label></th>' . "\n";
				$form .= '<td>' . "\n";
				$form .= '<select name="im_reg_' . $field . '" id="im_reg_' . $field . '">' . "\n";
				$form .= '<option value="">[ -- Select Country -- ]</option>' . "\n";
			
				if ( $countries ) {
					foreach ( $countries as $key => $value ) {
						$selected = ( stms_cleanup(stms_isset($vars[$prefix . $field])) == $key ) ? ' selected="selected"' : '';
						$form .= "<option value='{$key}'{$selected}>$value</option>";
					}
				}
				$form .= '</select>' . "\n";
				$form .= '</td>' . "\n";
				$form .= '</tr>' . "\n";
				break;
				
			case 'password':
				$required = ( stms_isset($fields[$field][3]) == 'yes' ) ? '<span style="color:red">*</span> ' : '';
				$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
				$form .= '<th scope="row" style="text-align:right"><label for="im_reg_' . $field . '" class="for-text"><strong>' . $required . $fields[$field][1]. '</strong></label></th>' . "\n";
				$form .= '<td><input type="password" class="text" name="im_reg_' . $field . '" id="im_reg_' . $field . '" value="" style="width:100%" /></td>' . "\n";
				$form .= '</tr>' . "\n";
				$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
				$form .= '<th scope="row" style="text-align:right"><label for="im_reg_' . $field . '2" class="for-text"><strong>' . $required . 'Confirm ' . $fields[$field][1]. '</strong></label></th>' . "\n";
				$form .= '<td><input type="password" class="text" name="im_reg_' . $field . '2" id="im_reg_' . $field . '2" value="" style="width:100%" /></td>' . "\n";
				$form .= '</tr>' . "\n";
				break;
				
			case 'title':
				$required = ( stms_isset($fields[$field][3]) == 'yes' ) ? '<span style="color:red">*</span> ' : '';
				$titles = array('mr', 'mrs', 'ms', 'miss');
				$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
				$form .= '<th scope="row" style="text-align:right"><label for="im_reg_' . $field . '" class="for-text"><strong>' . $required . $fields[$field][1]. '</strong></label></th>' . "\n";
				$form .= '<td>' . "\n";
				$form .= '<select name="im_reg_' . $field . '" id="im_reg_' . $field . '">' . "\n";
				foreach ( $titles as $title ) {
					$selected = ( stms_cleanup(stms_isset($vars[$prefix . $field])) == $title ) ? ' selected="selected"' : '';
					$form .= "<option value='{$title}'{$selected}>" . ucwords($title) . ".</option>\n";
				}
				$form .= '</select>' . "\n";
				$form .= '</td>' . "\n";
				$form .= '</tr>' . "\n";
				break;
				
			case 'gender':
				$required = ( stms_isset($fields[$field][3]) == 'yes' ) ? '<span style="color:red">*</span> ' : '';
				$sexes = array('male', 'female');
				$form .= '<tr valign="top" class="insta-reg-buy">' . "\n";
				$form .= '<th scope="row" style="text-align:right"><label for="im_reg_' . $field . '" class="for-text"><strong>' . $required . $fields[$field][1]. '</strong></label></th>' . "\n";
				$form .= '<td>' . "\n";
				$form .= '<select name="im_reg_' . $field . '" id="im_reg_' . $field . '">' . "\n";
				foreach ( $sexes as $sex ) {
					$selected = ( stms_cleanup(stms_isset($vars[$prefix . $field])) == $sex ) ? ' selected="selected"' : '';
					$form .= "<option value='{$sex}'{$selected}>" . ucwords($sex) . "</option>\n";
				}
				$form .= '</select>' . "\n";
				$form .= '</td>' . "\n";
				$form .= '</tr>' . "\n";
				break;
		}
	}
	return $form;
}

add_action('insta_ajax_validate_username', 'stms_validate_username_handler');
function stms_validate_username_handler() {
	$username = trim(strtolower($_REQUEST['im_reg_username']));
	$valid = 'true';
	if ( stms_username_exists($username) )
		$valid = 'false';
	echo $valid;
	die();
}

add_action('insta_ajax_validate_email', 'stms_validate_email_handler');
function stms_validate_email_handler() {
	$email = trim($_REQUEST['im_reg_email']);
	$old_email = trim($_REQUEST['old_email']);

	if ( $email == $old_email ) {
		echo 'true';
		die();
	}
	
	$valid = 'true';
	if ( stms_email_exists($email) )
		$valid = 'false';
	echo $valid;
	die();
}
