<?php if ( !defined('STMS_PATH') ) wp_die('Access Denied');

function stms_support_desk( $mode = '' ) {
	$content = '';
	switch ($mode) {
		case 'ticket':
			$content = stms_ticket_form(stms_isset($_GET['id'], 0));
			break;
		default: 
			$content = stms_ticket_front();
	}
	
	return $content;
}

function stms_ticket_front() {
	$stms = get_option('stms_settings');
	$support = stms_isset($stms['support']);
	
	$default_welcome = 'Welcome to our support desk. Please search our knowledgebase for any known issues or you can submit a new ticket.';
	$welcome_txt = stms_isset($support['welcome_txt'], $default_welcome);
	$welcome_txt = stms_cleanup($welcome_txt, '<strong><em><u><i><b><a><img><span><div><ul><ol><li>');
	$ticket_url = stms_get_handler_url('support');
	
	$content = '';
	
	$new_title = stripslashes(stms_isset($stms['support']['title'], get_bloginfo('name') . ' Support Desk'));
	$content .= '<h2>' . $new_title . '</h2>';
	
	if ( isset($_GET['im_ticket_search_email']) )
		$content .= '<div class="insta-error-msg"><p><strong>Cannot Find Ticket. Incorrect Email Address.</strong></p></div>' . "\n";
	
	$content .= wptexturize(wpautop($welcome_txt));
	
	$content .= '<h3>Knowledgebase</h3>';
	$content .= '<form method="get" id="searchform" action="' . get_bloginfo('url') . '" role="search">' . "\n";
	$content .= '<p><input type="text" name="s" id="s" value="Enter your question here..." style="width:80%" onfocus="if (this.value == \'Enter your question here...\') this.value=\'\';" onblur="if (this.value == \'\') this.value=\'Enter your question here...\';" />&nbsp;&nbsp;<input id="searchsubmit" type="submit" value="GO" /></p>' . "\n";
	
	if ( !empty($stms['support']['kb_category']) && is_numeric($stms['support']['kb_category']) ) :
		$catlist = array($stms['support']['kb_category']);
		$categories = get_categories(array('child_of' => $stms['support']['kb_category']));
		if ( $categories ) {
			foreach ( $categories as $cat ) {
				$catlist[] = $cat->cat_ID;
			}
		}
		$catlist = implode(",", $catlist);
		$content .= '<input type="hidden" name="cat" value="' . $catlist . '" />';
	endif;
	$content .= '</form>' . "\n";
	
	$content .= '<p><a href="' . stms_format_url($ticket_url, 'mode=ticket') . '">Click here</a> to submit a new ticket.</p>';
	
	$content .= '<a name="tickets"></a>';
	if ( is_stmsmember_logged_in() && !is_stms_admin() ) {
		$content .= '<h3>Your Ticket(s)</h3>';
		$content .= stms_member_tickets(stms_get_current_member_id());
	} else if ( is_stms_admin() ) {
		$content .= '<h3>Manage Ticket(s)</h3>';
		$content .= stms_admin_tickets();
	} else if ( !is_stmsmember_logged_in() && is_stmsguest_logged_in() ) {
		$content .= '<h3>Your Ticket(s)</h3>';
		$content .= stms_guest_tickets();
	} else {
		$login_url = stms_login_url($ticket_url);
		$content .= '<h3>Find Ticket(s)</h3>';
		$content .= '<p>If you already a member, you can find your ticket(s) by <a href="' . $login_url . '">login here</a>.</p>';
		
		if ( stms_isset($support['priv'],0) != 1 ) {
			$content .= '<p>If you submitted the ticket as a guest, you can search your ticket by entering the <strong>email address</strong> that you used when submitting the ticket:</p>';
			$content .= '<form method="get" name="instamem-ticket-search" id="instamem-ticket-search" action="' . $ticket_url . '">' . "\n";
			$content .= '<table class="insta-form-table">' . "\n";
			$content .= '<tr valign="top">' . "\n";
			$content .= '<th scope="row" style="text-align:right"><label for="im_ticket_search_email" class="for-text"><strong>Email Address</strong></label></th>' . "\n";
			$content .= '<td><input type="text" name="im_ticket_search_email" id="im_ticket_search_email" value="" style="width:80%" /></td>' . "\n";
			$content .= '</tr>' . "\n";
			$content .= '<tr valign="top">' . "\n";
			$content .= '<th scope="row" style="text-align:right"><label for="im_ticket_search_id" class="for-text"><strong>Ticket ID# (optional)</strong></label></th>' . "\n";
			$content .= '<td><input type="text" name="im_ticket_search_id" id="im_ticket_search_id" value="" style="width:40%" /></td>' . "\n";
			$content .= '</tr>' . "\n";
			$content .= '<tr valign="top">' . "\n";
			$content .= '<th scope="row"></th>' . "\n";
			$content .= '<td><input type="hidden" name="imhandler" value="support" /><input type="submit" id="im_ticket_submit" value="Search" /></td>' . "\n";
			$content .= '</tr>' . "\n";
			$content .= '</table>' . "\n";
			$content .= '</form>' . "\n";
		}
	}
	return $content;
}

function stms_ticket_form( $ticket_id = 0 ) {
	$stms = get_option('stms_settings');
	$support = stms_isset($stms['support']);
	$nonce = wp_create_nonce('stms-nonce');
	$ticket_url = stms_get_handler_url('support');
	$login_url = stms_login_url($ticket_url);
	$action_url = ( is_ssl() ) ? 'https://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] : 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
	$products = stms_get_products();
	$priorities = array(1 => 'low', 2 => 'normal', 3 => 'high', 4 => 'urgent');
	$ticket = stms_get_ticket($ticket_id);
	
	$form = '';
	
	$new_title = ( isset($_GET['id']) && $_GET['id'] > 0 ) ? 'Ticket #' . $_GET['id'] : 'Submit New Ticket';
	$new_title .= ( $new_title == 'Submit New Ticket' && is_stms_admin() ) ? ' For Existing Member' : '';
			
	$form .= '<h2>' . $new_title . '</h2>';		
	//$form .= '<pre>' . print_r($ticket, true) . '</pre>';
	if ( isset($_GET['added']) )
		$form .= '<div class="insta-update-msg"><p><strong>Your ticket has been submitted.</strong></p></div>' . "\n";
	
	if ( isset($_GET['updated']) )
		$form .= '<div class="insta-update-msg"><p><strong>Your ticket has been updated.</strong></p></div>' . "\n";
	
	if ( isset($_GET['attach_error']) )
		$form .= '<div class="insta-error-msg"><p><strong>Attachment Error:</strong><br /> ' . base64_decode($_GET['attach_error']) . '</p></div>' . "\n";
	
	if ( isset($_GET['auth_error']) )
		$form .= '<div class="insta-error-msg"><p><strong>ERROR: ' . base64_decode($_GET['auth_error']) . '</strong></p></div>' . "\n";
	
	if ( isset($_GET['auth_vars']) ) {
		$auth_vars = base64_decode($_GET['auth_vars']);
		$vars = (array) json_decode($auth_vars);
	}
	
	$form .= ( stms_isset($ticket->status, 1) == 1 ) ? '<form method="post" name="instamem-ticket-form" id="instamem-ticket-form" action="' . $action_url . '" enctype="multipart/form-data">' . "\n" : '';
	$form .= '<input type="hidden" name="_instamember_action" value="ticket" />' . "\n";
	$form .= '<input type="hidden" name="_instamember_nonce" value="' . $nonce . '" />' . "\n";
	$form .= '<input type="hidden" name="ticket_id" value="' . $ticket_id . '" />' . "\n";
	
	$member_id = ( !$ticket_id && is_stmsmember_logged_in() && !is_stms_admin() ) ? stms_get_current_member_id() : ( ($ticket_id && isset($ticket->member_id) ) ? $ticket->member_id : 0 );
	if ( $member_id )
		$form .= '<input type="hidden" name="member_id" value="' . $member_id . '" />' . "\n";
	
	$form .= '<table class="insta-form-table">' . "\n";
	
	if ( !$ticket_id ) {
		$guest = ( is_stmsmember_logged_in() || is_stms_admin() ) ? ' style="display:none"' : '';
		$member_adm = ( !is_stmsmember_logged_in() && is_stms_admin() ) ? '' : ' style="display:none"';
		
		$form .= '<tr valign="top"' . $member_adm . '>' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_ticket_username" class="for-text"><strong><span style="color:red">*</span> Member\'s Username</strong></label></th>' . "\n";
		$form .= '<td><input type="text" name="im_ticket_username" id="im_ticket_username" value="' . stms_isset($vars['im_ticket_username'], '') . '" style="width:100%" /><br /><small>Please enter the member\'s username. Since you\'re an administrator, the ticket will be listed under the member that you enter above.</small></td>' . "\n";
		$form .= '</tr>' . "\n";
		
		$form .= '<tr valign="top"' . $guest . '>' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_ticket_fname" class="for-text"><strong><span style="color:red">*</span> First Name</strong></label></th>' . "\n";
		$form .= '<td><input type="text" name="im_ticket_fname" id="im_ticket_fname" value="' . stms_isset($vars['im_ticket_fname'], '') . '" style="width:60%" /></td>' . "\n";
		$form .= '</tr>' . "\n";
		$form .= '<tr valign="top"' . $guest . '>' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_ticket_lname" class="for-text"><strong><span style="color:red">*</span> Last Name</strong></label></th>' . "\n";
		$form .= '<td><input type="text" name="im_ticket_lname" id="im_ticket_lname" value="' . stms_isset($vars['im_ticket_lname'], '') . '" style="width:60%" /></td>' . "\n";
		$form .= '</tr>' . "\n";
		$form .= '<tr valign="top"' . $guest . '>' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_ticket_email" class="for-text"><strong><span style="color:red">*</span> Email Address</strong></label></th>' . "\n";
		$form .= '<td><input type="text" name="im_ticket_email" id="im_ticket_email" value="' . stms_isset($vars['im_ticket_email'], '') . '" style="width:60%" /></td>' . "\n";
		$form .= '</tr>' . "\n";
		
		$form .= '<tr valign="top">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_ticket_subject" class="for-text"><strong><span style="color:red">*</span> Ticket Subject</strong></label></th>' . "\n";
		$form .= '<td><input type="text" name="im_ticket_subject" id="im_ticket_subject" value="' . stms_isset($vars['im_ticket_subject'], '') . '" style="width:100%" /><br /><small>Please enter a one-line summary for your ticket.</small></td>' . "\n";
		$form .= '</tr>' . "\n";
	} else {
		$reply = stms_get_last_reply($ticket->ID);
		if ( $ticket->member_id )
			$member = stms_member($ticket->member_id);
		
		$first_name = ( !isset($member) ) ? stms_cleanup($ticket->guest_fname) : ( (!empty($member->first_name)) ? stms_cleanup($member->first_name) : stms_cleanup($member->username) );
		$last_name = ( !isset($member) ) ? stms_cleanup($ticket->guest_lname) : stms_cleanup($member->last_name);
		$submitter = $first_name . ' ' . $last_name;
		
		$form .= '<tr valign="top">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label class="for-text"><strong>Name</strong></label></th>' . "\n";
		$form .= '<td>' . $submitter . ' <small>(submitted: ' . date("l d, Y H:i", $ticket->date) . ')</small></td>' . "\n";
		$form .= '</tr>' . "\n";
		if ( $ticket->member_id == 0 ) {
			$form .= '<tr valign="top">' . "\n";
			$form .= '<th scope="row" style="text-align:right"><label for="im_ticket_email" class="for-text"><strong>Email Address</strong></label></th>' . "\n";
			$form .= '<td>' . stms_cleanup($ticket->guest_email) . '</td>' . "\n";
			$form .= '</tr>' . "\n";
		}
		
		$t_status = ( $ticket->status == 2 ) ? 'Solved' : 'Open';
		if ( $ticket->status == 1 && !is_stms_admin() && stms_isset($reply->is_staff, 0) == 1 )
			$t_status = 'Open';
		else if ( $ticket->status == 1 && !is_stms_admin() && stms_isset($reply->is_staff, 0) == 0 )
			$t_status = 'Awaiting Response';
		else if ( $ticket->status == 1 && is_stms_admin() && stms_isset($reply->is_staff, 0) == 1 )
			$t_status = 'Awaiting Response';
		else if ( $ticket->status == 1 && is_stms_admin() && stms_isset($reply->is_staff, 0) == 0 )
			$t_status = 'Open';
		
		$form .= '<tr valign="top">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label class="for-text"><strong>Status</strong></label></th>' . "\n";
		$form .= '<td>' . $t_status . ' ';
		if ( $ticket->status == 1 ) 
			$form .= '<a href="' . stms_format_url($ticket_url, 'action=close_ticket&ticket_id=' . $ticket->ID . '&_instamember_nonce=' . $nonce) . '" onclick="return confirm(\'Are you sure you want to close this ticket?\')">(close this ticket)</a>';
		$form .= '</td>' . "\n";
		$form .= '</tr>' . "\n";
		
		$form .= '<tr valign="top">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label class="for-text"><strong>Ticket Subject</strong></label></th>' . "\n";
		$form .= '<td>' . stms_cleanup($ticket->subject) . '</td>' . "\n";
		$form .= '</tr>' . "\n";
	}

	$form .= '<tr valign="top">' . "\n";
	$form .= '<th scope="row" style="text-align:right"><label for="im_ticket_dept" class="for-text"><strong>Department</strong></label></th>' . "\n";
	$form .= '<td>' . "\n";
	$form .= '<select name="im_ticket_dept" id="im_ticket_dept" style="width:100%">' . "\n";
	if ( stms_isset($support['general']) == 1 )
		$form .= '<option value="general"' . ( stms_isset($ticket->is_general) == 1 ? ' selected="selected"' : '' ) . '>General</option>' . "\n";
		
	if ( stms_isset($support['affiliates']) == 1 )
		$form .= '<option value="affiliates"' . ( stms_isset($ticket->is_affiliates) == 1 ? ' selected="selected"' : '' ) . '>Affiliates</option>' . "\n";
		
	if ( $products ) {
		foreach ( $products as $product ) {
			$product_id = ( isset($vars['im_ticket_dept']) ) ? $vars['im_ticket_dept'] : ( ($ticket_id) ? $ticket->product_id: '');
			$selected = ( $product_id == $product->ID ) ? ' selected="selected"' : '';
			$form .= "<option value='{$product->ID}'{$selected}>{$product->title}</option>";
		}
	}

	$form .= '</select>' . "\n";
	$form .= '</td>' . "\n";
	$form .= '</tr>' . "\n";
	
	$form .= '<tr valign="top">' . "\n";
	$form .= '<th scope="row" style="text-align:right"><label for="im_ticket_priority" class="for-text"><strong>Priority</strong></label></th>' . "\n";
	$form .= '<td>' . "\n";
	$form .= '<select name="im_ticket_priority" id="im_ticket_priority">' . "\n";

	if ( $priorities ) {
		foreach ( $priorities as $key => $val ) {
			$priority = ( isset($vars['im_ticket_priority']) ) ? $vars['im_ticket_priority'] : ( ($ticket_id) ? $ticket->priority: 1);
			$selected = ( $priority == $key ) ? ' selected="selected"' : '';
			$form .= "<option value='{$key}'{$selected}>" . ucwords($val) . "</option>";
		}
	}
	$form .= '</select>' . "\n";
	$form .= '</td>' . "\n";
	$form .= '</tr>' . "\n";
	
	if ( $ticket_id ) {
		$reply = stms_get_last_reply($ticket->ID);
		$last_msg = ( isset($reply->message) ) ? stripslashes($reply->message) : stripslashes($ticket->message);
		$last_date = ( isset($reply->date) ) ? stripslashes($reply->date) : stripslashes($ticket->date);
		$last_replier = $submitter;
		if ( stms_isset($reply->is_staff) != 0 ) {
			if ( $staff = get_userdata($reply->staff_id) ) {
				$last_replier = ( !empty($staff->user_nicename) ) ? $staff->user_nicename : $staff->user_login;
			}
		}

		$form .= '<tr valign="top">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label class="for-text"><strong>Last Message</strong></label></th>' . "\n";
		$form .= '<td>' ."\n";
		$form .= wpautop(wptexturize(esc_textarea($last_msg))) ."\n";
		
		$attachments = stms_get_attachments($ticket->ID, stms_isset($reply->reply_id, 0));
		if ( $attachments ) {
			$form .= '<ul id="insta-attach">' ."\n";
			foreach ( $attachments as $attach ) {
				$sign = ( $attach->file_size >= 1048576 ) ? 'MB' : 'KB';
				$size = ( $sign == 'KB' ) ? ceil($attach->file_size * 0.000976562) : ceil($attach->file_size * 1048576);
				$form .= '<li><a href="' . stms_format_url(get_bloginfo('url'), 'insta_mode=attach&file=' . $attach->file_name) . '">' . $attach->file_name . '</a>&nbsp;&nbsp;<small>(' . $size . ' ' . $sign . ')</small></li>' ."\n";
			}
			$form .= '</ul>' ."\n";
		
		}
		$last_by = ( isset($reply->message) ) ? 'Last reply by' : 'Submitted by';
		$form .= '<p><small>' . $last_by . ' <strong>' . $last_replier . '</strong>: ' . date("l d, Y H:i", $last_date) . '</small></p>' . "\n";
		$form .= '</td>' . "\n";
		$form .= '</tr>' . "\n";
	}
	
	if ( stms_isset($ticket->status, 1) == 1 ) {
		$desc_label = ( $ticket_id ) ? 'Reply' : '<span style="color:red">*</span> Description';
		$desc_info = ( $ticket_id ) ? '' : '<br /><small>Describe your problem, including details such as how to reproduce it.</small>';
		$form .= '<tr valign="top">' . "\n";
		$form .= '<th scope="row" style="text-align:right"><label for="im_ticket_desc" class="for-text"><strong>' . $desc_label . '</strong></label></th>' . "\n";
		$form .= '<td><textarea name="im_ticket_desc" id="im_ticket_desc" style="width:100%;height:95px"></textarea>' . $desc_info . '</td>' . "\n";
		$form .= '</tr>' . "\n";
	
	
		if ( is_writable(ABSPATH . 'wp-content/uploads/') && stms_isset($support['attachment']) == 1 && stms_isset($support['attachment_max']) > 0 ) {
			$attach = true;
			if ( stms_isset($support['attachment_priv']) == 1 && !is_stmsmember_logged_in() && !is_stms_admin() )
				$attach = false;
			
			if ( $attach ) {
				$form .= '<tr valign="top">' . "\n";
				$form .= '<th scope="row" style="text-align:right"><label class="for-text">Attachment(s)</label></th>' . "\n";
				$form .= '<td>' . "\n";
				for ( $i = 0; $i < $support['attachment_max']; $i++ ) {
					$form .= '<input type="file" name="im_ticket_attach[]" value="" style="width:100%; margin-bottom:7px" /><br />' . "\n";
				}
				$form .= '<em>Maximum file size per attachment: <strong>' . stms_isset($support['attachment_maxsize']) . 'MB</strong></em></td>' . "\n";
				$form .= '</tr>' . "\n";
			}
		}
	
	
		if ( !is_stms_admin() && !is_stmsmember_logged_in() && stms_isset($support['recaptcha']) == 1 && stms_isset($stms['integration']['recaptcha']['public']) != '' ) {
			require_once( STMS_SOURCES . '/recaptcha/recaptchalib.php');
			$form .= '<tr valign="top">';
			$form .= '<th scope="row" style="text-align:right"><label><strong>Enter Captcha:</strong></label></th>' . "\n";
			$form .= '<td>';
			$form .= recaptcha_get_html(trim($stms['integration']['recaptcha']['public']), '', is_ssl());
			$form .= '</td>';
			$form .= '</tr>';
		}
		
		$form .= '<tr valign="top"><th></th><td><input type="submit" name="instamem-ticket" id="instamem-ticket" value="Submit" /></td></tr>';
	}
	$form .= '</table>';
	$form .= '<p style="text-align:right"><a href="' . $ticket_url . '">Back to support home</a></p>';
	
	$form .= ( stms_isset($ticket->status, 1) == 1 ) ? '</form>' : '';
	
	if ( $ticket_id ) {
		$form .= '<h3>Ticket History</h3>';
		$form .= '<div style="margin:10px 0; padding:15px; background-color: #F0F0F0">';
		$form .= wpautop(wptexturize(esc_textarea(stripslashes($ticket->message)))) ."\n";
		
		$attachments = stms_get_attachments($ticket->ID);
		if ( $attachments ) {
			$form .= '<ul id="insta-attach">' ."\n";
			foreach ( $attachments as $attach ) {
				$sign = ( $attach->file_size >= 1048576 ) ? 'MB' : 'KB';
				$size = ( $sign == 'KB' ) ? ceil($attach->file_size * 0.000976562) : ceil($attach->file_size * 1048576);
				$form .= '<li><a href="' . stms_format_url(get_bloginfo('url'), 'insta_mode=attach&file=' . $attach->file_name) . '">' . $attach->file_name . '</a>&nbsp;&nbsp;<small>(' . $size . ' ' . $sign . ')</small></li>' ."\n";
			}
			$form .= '</ul>' ."\n";
		}
		$form .= '<p style="color:#808080">Posted By: <strong>' . $submitter . '</strong> - ' . date("l d, Y H:i", $ticket->date) . '</p>';
		$form .= '</div>';
		
		$replies = stms_get_replies($ticket_id);
		if ( $replies ) {
			foreach ( $replies as $reply ) {
				$replier = $submitter;
				$background = '#F0F0F0';
				if ( stms_isset($reply->is_staff) != 0 ) {
					$staff = ( !isset($staff) ) ? get_userdata($reply->staff_id) : $staff;
					$replier = ( !empty($staff->user_nicename) ) ? $staff->user_nicename : $staff->user_login;
					$background = '#F2FCE0';
				}
				
				$form .= '<div style="margin:10px 0; padding:15px; background-color: ' . $background . '">';
				$form .= wpautop(wptexturize(esc_textarea(stripslashes($reply->message)))) ."\n";
				
				$attachments = stms_get_attachments($ticket->ID, $reply->reply_id);
				if ( $attachments ) {
					$form .= '<ul id="insta-attach">' ."\n";
					foreach ( $attachments as $attach ) {
						$sign = ( $attach->file_size >= 1048576 ) ? 'MB' : 'KB';
						$size = ( $sign == 'KB' ) ? ceil($attach->file_size * 0.000976562) : ceil($attach->file_size * 1048576);
						$form .= '<li><a href="' . stms_format_url(get_bloginfo('url'), 'insta_mode=attach&file=' . $attach->file_name) . '">' . $attach->file_name . '</a>&nbsp;&nbsp;<small>(' . $size . ' ' . $sign . ')</small></li>' ."\n";
					}
					$form .= '</ul>' ."\n";
				}
				$form .= '<p style="color:#808080">Posted By: <strong>' . $replier . '</strong> - ' . date("l d, Y H:i", $reply->date) . '</p>';
				$form .= '</div>';
			}
		}
		$form .= '<p style="text-align:right"><a href="' . $ticket_url . '">Back to support home</a></p>';
	}

	return $form;
}

function is_stmsguest_logged_in() {
	if ( isset($_COOKIE['__insta_guest']) ) return true;
	return false;
}

add_action('template_redirect', 'stms_search_tickets');
function stms_search_tickets() {
	if ( isset($_GET['imhandler']) && $_GET['imhandler'] == 'support' ) {
		$stms = get_option('stms_settings');
		$support = stms_isset($stms['support']);
		$ticket_url = stms_get_handler_url('support');
		if ( stms_isset($support['priv']) == 1 ) 
			return false;
		
		if ( isset($_GET['im_ticket_search_email']) ) {
			$email = rawurldecode($_GET['im_ticket_search_email']);
			if ( $tickets = stms_get_tickets_by('guest_email', $email) ) {
				@setcookie('__insta_guest', $email, time()+3600, SITECOOKIEPATH);
				if ( SITECOOKIEPATH != COOKIEPATH )
					@setcookie('__insta_guest', $email, time()+3600, COOKIEPATH);
				
				if ( stms_isset($_GET['im_ticket_search_id']) != '' && is_numeric($_GET['im_ticket_search_id'])  ) {
					$ticket_id = (int) $_GET['im_ticket_search_id'];
					if ( $ticket = stms_get_ticket($ticket_id) ) {
						if ( $ticket->guest_email == $email ) {
							wp_redirect(stms_format_url($ticket_url, 'mode=ticket&id=' . $ticket->ID));
							exit;
						}
					}
				}
				
				@header('Location:' . $ticket_url . '#tickets');
				exit;
			}
		}
	}
}

add_action('wp_footer', 'stms_ticket_scripts');
function stms_ticket_scripts() {
	if ( isset($_GET['imhandler']) && $_GET['imhandler'] == 'support' ) {
		if ( is_stms_admin() || is_stmsmember_logged_in() ) {
?>
<script type="text/javascript">
jQuery(document).ready(function($) {
	$('#insta-ticket-lists').dataTable();
});
</script>
<?php
		}
	}
}

function stms_tickets_table($tickets) {
	if ( !is_array($tickets) || count($tickets) <= 0 )
		return false;	

	$stms = get_option('stms_settings');
	$ticket_url = stms_get_handler_url('support');
	$priorities = array(1 => 'low', 2 => 'normal', 3 => 'high', 4 => 'urgent');
	$content = '';
	$content .= '
		<table cellpadding="0" cellspacing="0" border="0" class="display" id="insta-ticket-lists" width="100%">
		<thead>
			<tr>
				<th>ID#</th>
				<th>Subject</th>
				<th>Priority</th>
				<th>Dept.</th>
				<th>Status</th>
			</tr>
		</thead>
		<tbody>
	';
	
	$i = 0;
	foreach ( $tickets as $ticket ) {
		$class = ( $i%2 ) ? 'odd' : 'event';
		$reply = stms_get_last_reply($ticket->ID);
		$t_status = ( $ticket->status == 2 ) ? 'Solved' : 'Open';
		if ( $ticket->status == 1 && !is_stms_admin() && stms_isset($reply->is_staff, 0) == 1 )
			$t_status = 'Open';
		else if ( $ticket->status == 1 && !is_stms_admin() && stms_isset($reply->is_staff, 0) == 0 )
			$t_status = 'Pending';
		else if ( $ticket->status == 1 && is_stms_admin() && stms_isset($reply->is_staff, 0) == 1 )
			$t_status = 'Pending';
		else if ( $ticket->status == 1 && is_stms_admin() && stms_isset($reply->is_staff, 0) == 0 )
			$t_status = 'Open';
			
		$dept = 'General';
		if ( $ticket->is_affiliates == 1 )
			$dept = 'Affiliates';
		else if ( $ticket->is_general == 1 )
			$dept = 'General';
		else {
			$product = stms_get_product($ticket->product_id);
			$dept = stms_cleanup($product->title);	
		}
		
		$content .= "
			<tr class='{$class}'>
				<td class='center'>{$ticket->ID}</td>
				<td><a href='" . stms_format_url($ticket_url, 'mode=ticket&id=' . $ticket->ID) . "'>" . stms_cleanup($ticket->subject) . "</a></td>
				<td>" . ucwords($priorities[$ticket->priority]) . "</td>
				<td class='center'>{$dept}</td>
				<td class='center'>{$t_status}</td>
			</tr>
		";
		$i++;
	}
	$content .= '
		</tbody>
		<tfoot>
			<tr>
				<th>ID#</th>
				<th>Subject</th>
				<th>Priority</th>
				<th>Dept.</th>
				<th>Status</th>
			</tr>
		</tfoot>
		</table>
	';
	return $content;
}

function stms_admin_tickets() {
	if ( !$tickets = stms_get_tickets() )
		return false;
	
	$content = stms_tickets_table($tickets);
	return $content;
}

function stms_member_tickets($member_id) {
	if ( !$tickets = stms_get_tickets_by('member_id', $member_id) )
		return false;
	
	$content = stms_tickets_table($tickets);
	return $content;
}

function stms_guest_tickets() {
	if ( !isset($_COOKIE['__insta_guest']) )
		return false;
		
	$email = rawurldecode($_COOKIE['__insta_guest']);
	if ( !$tickets = stms_get_tickets_by('guest_email', $email) )
		return false;
	
	$content = stms_tickets_table($tickets);
	return $content;
}

add_action('template_redirect', 'stms_close_ticket');
function stms_close_ticket() {
	if ( isset($_GET['action']) && $_GET['action'] == 'close_ticket' && stms_isset($_GET['ticket_id']) > 0 ) {
		if ( !wp_verify_nonce($_GET['_instamember_nonce'], 'stms-nonce') ) return;
		if ( !$ticket = stms_get_ticket($_GET['ticket_id']) ) return;
		$close = stms_update_ticket($_GET['ticket_id'], array('status' => 2));
		$stms = get_option('stms_settings');
		$support_url = stms_get_handler_url('support');
		$ticket_url = stms_format_url($support_url, 'mode=ticket&id=' . $_GET['ticket_id']);
		wp_redirect($ticket_url);
		exit;
	}
}

add_action('template_redirect', 'stms_save_ticket');
function stms_save_ticket() {
	if ( isset($_POST['_instamember_action']) && $_POST['_instamember_action'] == 'ticket' ) {
		if ( !wp_verify_nonce($_POST['_instamember_nonce'], 'stms-nonce') ) wp_die('Invalid Handler');
	
		$stms = get_option('stms_settings');
		$errors = 0;
		$auth_vars = base64_encode(json_encode($_POST));
		
		// Are we updating?
		$update = false;
		if ( $_POST['ticket_id'] > 0 )
			$update = true;
			
		// PHP validation here, including captcha...
		// validate recaptcha...
		if ( isset($_POST['recaptcha_challenge_field']) && isset($_POST['recaptcha_response_field']) ) {
			require_once( STMS_SOURCES . '/recaptcha/recaptchalib.php');
			$privatekey = trim(stms_isset($stms['integration']['recaptcha']['private']));
			$resp = recaptcha_check_answer($privatekey, $_SERVER["REMOTE_ADDR"], $_POST['recaptcha_challenge_field'], $_POST['recaptcha_response_field']);
			if ( !$resp->is_valid ) {
				$auth_error = base64_encode('You\'ve entered wrong captcha code.');
				$errors = 1;
		  	}
		}
		
		if ( !$update && empty($_POST['im_ticket_subject']) ) {
			$errors = 1;
			$auth_error = base64_encode('Ticket subject is empty.');
		}

		if ( !$update && empty($_POST['im_ticket_desc']) ) {
			$errors = 1;
			$auth_error = base64_encode('Ticket description/reply/message is empty.');
		}

		if ( !$update && !isset($_POST['member_id']) && !is_stms_admin() ) {
			if ( empty($_POST['im_ticket_email']) || !filter_var($_POST['im_ticket_email'], FILTER_VALIDATE_EMAIL) ) {
				$errors = 1;
				$auth_error = base64_encode('Invalid email address.');
			}
			
			if ( empty($_POST['im_ticket_fname']) ) {
				$errors = 1;
				$auth_error = base64_encode('First name is empty.');
			}

			if ( empty($_POST['im_ticket_lname']) ) {
				$errors = 1;
				$auth_error = base64_encode('Last name is empty.');
			}
		}
		
		if ( !$update && !is_stmsmember_logged_in() && is_stms_admin() ) {
			if ( !$adm_member = stms_get_data_by('login', trim($_POST['im_ticket_username'])) ) {
				$errors = 1;
				$auth_error = base64_encode('Cannot found member with username "' . trim($_POST['im_ticket_username']) . '".');
			}
			
			if ( empty($_POST['im_ticket_username']) ) {
				$errors = 1;
				$auth_error = base64_encode('Please enter the member\'s username.');
			}
			
			$_POST['member_id'] = $adm_member->ID;
		}
		
		$ticket_id = (int) $_POST['ticket_id'];
		$ticket_qry = ( $update ) ? '&id=' . $ticket_id : '';
		$support_url = stms_get_handler_url('support');
		$ticket_url = stms_format_url($support_url, 'mode=ticket' . $ticket_qry);
		if ( $errors ) {
			$error_url = $ticket_url . "&auth_error={$auth_error}&auth_vars={$auth_vars}";
			wp_redirect($error_url);
			exit;
		}
		
		$reply_id = 0;
		if ( $update ) {
			if ( !empty($_POST['im_ticket_desc']) ) {
				$reply = trim($_POST['im_ticket_desc']);
				$reply_id = stms_add_reply($ticket_id, $_POST);
			}
			
			$ticket = stms_get_ticket($ticket_id);
			$count = stms_isset($ticket->replies, 0) + 1;
			
			$data = array();
			$data['member_id'] = ( isset($_POST['member_id']) ) ? $_POST['member_id'] : 0;
			$data['is_general'] = ( $_POST['im_ticket_dept'] == 'general' ) ? 1 : 0;
			$data['is_affiliates'] = ( $_POST['im_ticket_dept'] == 'affiliates' ) ? 1 : 0;
			$data['product_id'] = ( is_numeric($_POST['im_ticket_dept']) ) ? $_POST['im_ticket_dept'] : 0;
			$data['replies'] = $count;
			$data['status'] = 1;
			
			$ticket_id = stms_update_ticket($ticket_id, $data );
			$ticket_url .= '&updated=true';
		} else {
			$ticket_id = stms_insert_ticket($_POST);
			$ticket_url .= '&added=true&id=' . $ticket_id;
		}
		
		$attach = stms_attach_files($ticket_id, $reply_id, stms_isset($_FILES));
		if ( is_string($attach) )
			$ticket_url .= '&attach_error=' . base64_encode($attach);
		
		if ( $update )
			do_action('stms_ticket_updated', $ticket_id, $reply_id);
		else
			do_action('stms_ticket_submitted', $ticket_id);
		
		wp_redirect($ticket_url);
		exit;
	}
}

function stms_insert_ticket( $post ) {
	global $wpdb;
	$data = array(
		'is_general' => ( $post['im_ticket_dept'] == 'general' ) ? 1 : 0,
		'is_affiliates' => ( $post['im_ticket_dept'] == 'affiliates' ) ? 1 : 0,
		'product_id' => ( is_numeric($post['im_ticket_dept']) ) ? $post['im_ticket_dept'] : 0,
		'member_id' => ( isset($post['member_id']) ) ? $post['member_id'] : 0,
		'subject' => trim($post['im_ticket_subject']),
		'priority' => trim($post['im_ticket_priority']),
		'message' => trim($post['im_ticket_desc']),
		'date' => stms_time(),
		'last_reply' => 0,
		'ipaddr' => stms_retrieve_ipaddr(),
		'replies' => 0,
		'status' => 1,
		'guest' => ( !isset($post['member_id']) ) ? 1 : 0,
		'guest_email' => trim(stms_isset($post['im_ticket_email'], '')),
		'guest_fname' => trim(stms_isset($post['im_ticket_fname'], '')),
		'guest_lname' => trim(stms_isset($post['im_ticket_lname'], ''))
	);
	
	$wpdb->insert("{$wpdb->prefix}stms_tickets", $data);
	$ticket_id = $wpdb->insert_id;
	
	// clean caches
	if ( isset($post['member_id']) )
		wp_cache_delete($post['member_id'], 'stms_tickets');
	else
		wp_cache_delete($post['im_ticket_email'], 'stms_tickets');
		
	wp_cache_delete('open', 'stms_admin_tickets');
		
	return $ticket_id;
}

function stms_update_ticket($ticket_id, $data = array() ) {
	if ( count($data) <= 0 )
		return false;
	
	$ID = (int) $ticket_id;
	$ticket = stms_get_ticket($ID);
	if ( !$ticket )
		return false;
	
	global $wpdb;
	$wpdb->update( "{$wpdb->prefix}stms_tickets", $data, compact('ID') );
	
	//delete caches
	$user = ( $ticket->member_id > 0 ) ? $ticket->member_id : $ticket->guest_email;
	wp_cache_delete($ID, 'stms_ticket');
	wp_cache_delete($user, 'stms_tickets');
	wp_cache_delete('all', 'stms_admin_tickets');
	if ( stms_isset($data['status'], $ticket->status) == 1 )
		wp_cache_delete('open', 'stms_admin_tickets');
	else
		wp_cache_delete('closed', 'stms_admin_tickets');
	
    return $ID;
}

add_action('stms_ticket_submitted', 'stms_notify_admin');
function stms_notify_admin( $ticket_id ) {
	$stms = get_option('stms_settings');
	$defaults = stms_default_emails();
	if ( stms_isset($stms['support']['admin_notify_new']) == 1 ) {
		$to = stms_isset($stms['emails']['admin_email'], get_option('admin_email'));
		$to = sanitize_email($to);
		$from = 'InstaMember <instabot@' . $_SERVER['HTTP_HOST'] . '>';

		$subject = $defaults['admin_support']['subject'];
		$subject = stms_parse_supportmail($ticket_id, $subject);
		
		$body = $defaults['admin_support']['body'];
		$body = stms_parse_supportmail($ticket_id, $body);
		
		stms_mail($to, $subject, $body, $from);
	}
}

add_action('stms_ticket_updated', 'stms_reply_email', 10, 2);
function stms_reply_email( $ticket_id, $reply_id ) {
	$stms = get_option('stms_settings');
	$defaults = stms_default_emails();
	$reply = stms_get_reply($reply_id);
	
	if ( stms_isset($reply->is_staff) == 1 & stms_isset($stms['support']['notify']) == 1 ) {
		$to = stms_parse_supportmail($ticket_id, '%email%');
		$from = stms_sanitize($stms['emails']['admin_from']) . ' <' . stms_sanitize($stms['emails']['admin_email']) . '>';
		$from = ( $from == '' ) ? stms_sanitize(get_option('blogname')) . ' <' . get_option('admin_email') . '>' : $from;

		$subject = $defaults['support_reply']['subject'];
		$subject = stms_parse_supportmail($ticket_id, $subject);
		
		$body = $defaults['support_reply']['body'];
		$body = stms_parse_supportmail($ticket_id, $body);
		
		stms_mail($to, $subject, $body, $from);
	}

	if ( stms_isset($reply->is_staff) != 1 && stms_isset($stms['support']['admin_notify']) == 1 ) {
		$to = stms_isset($stms['emails']['admin_email'], get_option('admin_email'));
		$to = sanitize_email($to);
		$from = 'InstaMember <instabot@' . $_SERVER['HTTP_HOST'] . '>';

		$subject = $defaults['admin_support']['subject'];
		$subject = stms_parse_supportmail($ticket_id, $subject);
		
		$body = $defaults['admin_support']['body'];
		$body = stms_parse_supportmail($ticket_id, $body);
		
		stms_mail($to, $subject, $body, $from);
	}
}

function stms_parse_supportmail( $ticket_id, $content ) {
	if ( !$ticket = stms_get_ticket($ticket_id) )
		return $content;
	
	if ( $ticket->member_id > 0 )
		$member = stms_member($ticket->member_id);

	if ( is_object($member) ) {
		$email = sanitize_email($member->email);
		$first_name = stms_sanitize($member->first_name);
		$last_name = stms_sanitize($member->last_name);
	} else {
		$email = sanitize_email($ticket->guest_email);
		$first_name = stms_sanitize($member->guest_fname);
		$last_name = stms_sanitize($member->guest_lname);
	}
	
	$stms = get_option('stms_settings');
	$support_url = stms_get_handler_url('support');
	$ticket_url = stms_format_url($support_url, 'mode=ticket&id=' . $ticket->ID);
	$business_name = stms_sanitize($stms['global']['business_name'], get_bloginfo('name'));
	$business_addr = stms_sanitize($stms['global']['business_addr'], '');
	
	$content = str_replace('%site_title%', get_bloginfo('blogname'), $content);
	$content = str_replace('%ticket_num%', $ticket->ID, $content);
	$content = str_replace('%ticket_url%', $ticket_url, $content);
	$content = str_replace('%firstname%', $first_name, $content);
	$content = str_replace('%lastname%', $last_name, $content);
	$content = str_replace('%email%', $email, $content);
	$content = str_replace('%business_name%', $business_name, $content);
	$content = str_replace('%business_address%', $business_addr, $content);
	
	return $content;
}

function stms_get_ticket( $ticket_id ) {
	if ( !$ticket_id )
		return false;

	global $wpdb;
	$ticket_id = (int) $ticket_id;
	$ticket = wp_cache_get($ticket_id, 'stms_ticket');
	if ( !$ticket ) {
	    $ticket = $wpdb->get_row("SELECT * FROM `{$wpdb->prefix}stms_tickets` WHERE `ID` = {$ticket_id}");
	
		if ( !$ticket )
			return false;
		
		wp_cache_set($ticket_id, $ticket, 'stms_ticket');
	}
	return $ticket;
}

function stms_get_tickets( $status = 'all' ) {
	global $wpdb;
	
	$tickets = wp_cache_get($status, 'stms_admin_tickets');
	if ( false !== $tickets ) return $tickets;
	
	$sql = "SELECT * FROM `{$wpdb->prefix}stms_tickets`";
	if ( $status == 'open' )
		$sql .= " WHERE `status` = 1";
	else if ( $status == 'closed' )
		$sql .= " WHERE `status` = 2";
		
	$sql .= " ORDER BY `ID`, `status` ASC";
	
	if ( !$tickets = $wpdb->get_results($sql) )
		return false;
	
	wp_cache_add($status, $tickets, 'stms_tickets');
	return $tickets;
}

function stms_get_tickets_by($field, $value) {
	global $wpdb;

	if ( 'member_id' == $field ) {
		// Make sure the value is numeric to avoid casting objects, for example,
		// to int 1.
		if ( !is_numeric($value) )
			return false;
		$value = absint($value);
	} else {
		$value = trim($value);
	}

	if ( !$value )
		return false;
	
	$tickets = wp_cache_get($value, 'stms_tickets');
	if ( false !== $tickets ) return $tickets;

	$sql = ( $field == 'guest_email' ) ? ' AND `member_id` = 0' : '';
	if ( !$tickets = $wpdb->get_results($wpdb->prepare("SELECT * FROM `{$wpdb->prefix}stms_tickets` WHERE `$field` = %s{$sql}", $value)) )
		return false;
	
	wp_cache_add($value, $tickets, 'stms_tickets');
	return $tickets;
}

function stms_add_reply($ticket_id, $post) {
	global $wpdb;
	$ticket = stms_get_ticket($ticket_id);
	if ( !$ticket )
		return false;
	
	$wp_user = 0;
	if ( !is_stmsmember_logged_in() && is_stms_admin() )
		$wp_user = ( function_exists('get_current_user_id') ) ? get_current_user_id() : 0;
		
	$data = array(
		'ticket_id' => $ticket_id,
		'is_staff' => ( $wp_user ) ? 1 : 0,
		'staff_id' => $wp_user,
		'message' => trim($post['im_ticket_desc']),
		'date' => stms_time(),
		'ipaddr' => stms_retrieve_ipaddr()
	);
	
	$wpdb->insert("{$wpdb->prefix}stms_replies", $data);
	$reply_id = $wpdb->insert_id;
	
	// clean caches
	wp_cache_delete($reply_id, 'stms_reply');
	wp_cache_delete($ticket_id, 'stms_replies');
		
	do_action('stms_reply_added', $ticket_id, $reply_id);
	return $reply_id;
}

function stms_get_last_reply($ticket_id) {
	if ( empty($ticket_id) )
		return false;

	global $wpdb;
	$ID = (int) $ticket_id;
	$reply = $wpdb->get_row("SELECT `reply_id` FROM `{$wpdb->prefix}stms_replies` WHERE `ticket_id` = {$ID} ORDER BY reply_id  DESC LIMIT 1");
	if ( !$reply )
		return false;
	
	return stms_get_reply($reply->reply_id);
}

function stms_get_reply( $reply_id ) {
	if ( empty($reply_id) )
		return false;

	global $wpdb;
	$reply_id = (int) $reply_id;
	$reply = wp_cache_get($reply_id, 'stms_reply');
	if ( !$reply ) {
	    $reply = $wpdb->get_row("SELECT * FROM `{$wpdb->prefix}stms_replies` WHERE `reply_id` = {$reply_id}");
	
		if ( !$reply )
			return false;
		
		wp_cache_set($reply_id, $reply, 'stms_reply');
	}
	return $reply;
}

function stms_get_replies($ticket_id) {
	if ( empty($ticket_id) )
		return false;

	global $wpdb;
	$ID = (int) $ticket_id;
	$replies = wp_cache_get($ID, 'stms_replies');
	if ( !$replies ) {
	    $replies = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}stms_replies` WHERE `ticket_id` = {$ID} ORDER BY reply_id ASC");
	
		if ( !$replies )
			return false;
		
		wp_cache_set($ID, $replies, 'stms_replies');
	}
	return $replies;
}

function stms_get_attachments( $ticket_id, $reply_id = 0 ) {
	global $wpdb;
	$ticket_id = (int) $ticket_id;
	$reply_id = (int) $reply_id;
	$files = wp_cache_get($ticket_id . $reply_id, 'stms_attachments');
	if ( !$files ) {
	    $files = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}stms_attachments` WHERE `ticket_id` = {$ticket_id} AND `reply_id` = {$reply_id}");
	
		if ( !$files )
			return false;
		
		wp_cache_set($ticket_id . $reply_id, $files, 'stms_attachments');
	}
	return $files;
}

function stms_attach_files( $ticket_id, $reply_id, $files ) {
	global $wpdb;
	
	if ( !isset($files['im_ticket_attach']) )
		return false;
	
	$stms = get_option('stms_settings');
	$support = stms_isset($stms['support']);
	$max_size = stms_isset($support['attachment_maxsize']) * 1048576;
	$local_path = ABSPATH . 'wp-content/uploads/';
	if ( !is_dir($local_path) || !is_writable($local_path) )
		return 'Upload directory is not writable or not exists.';
	
	$allowed_files = array(
 		"pdf" => "application/pdf",
		"zip" => "application/zip",
		"rar" => "application/rar",
		"doc" => "application/msword",
		"docx"=> "application/msword",
		"xls" => "application/vnd.ms-excel",
		"xlsx"=> "application/vnd.ms-excel",
		"ppt" => "application/vnd.ms-powerpoint",
		"swf" => "application/x-shockwave-flash",
		"mmap"=> "application/mmap",
		"mp3" => "audio/mpeg",
		"wav" => "audio/x-wav",
		"gif" => "image/gif",
		"png" => "image/png",
		"jpeg"=> "image/jpg",
		"jpg" => "image/jpg",
		"txt" => "text/plain",
		"php" => "text/php",
		"html" => "text/html",
		"js" => "text/javascript",
		"css" => "text/style",
		"flv" => "video/x-flv",
		"mp4" => "video/mpeg",
		"mpeg"=> "video/mpeg",
		"mpg" => "video/mpeg",
		"mov" => "video/quicktime",
		"avi" => "video/x-msvideo",
		"wmv" => "video/x-ms-wmv"
 	);
	
	$errors = '';
	foreach ( $files['im_ticket_attach']['tmp_name'] as $key => $tmp_name ) {
		if ( stms_isset($files['im_ticket_attach']['error'][$key]) == 4 )
			continue;
		
		$file_name = $files['im_ticket_attach']['name'][$key];
		$file_size = $files['im_ticket_attach']['size'][$key];
		$file_tmp = $files['im_ticket_attach']['tmp_name'][$key];
		$file_type = $files['im_ticket_attach']['type'][$key];
		
		if ( stms_isset($files['im_ticket_attach']['error'][$key]) == 1 ) {
			$errors .= 'The uploaded file "' . $file_name . '" exceeds the maximum size allowed by the server.<br />';
			continue;
		}
		
		$parts = explode(".", $file_name);
	  	$file_ext = strtolower(end($parts));
		
		if ( $file_size > $max_size ) {
			$errors .= 'Cannot upload "' . $file_name . '". File size must be less than ' . stms_isset($support['attachment_maxsize']) . ' MB.<br />';
			continue;
		}
		
		if ( !isset($allowed_files[$file_ext]) ) {
			$errors .= 'File type "*.' . $file_ext . '" is not allowed.<br />';
			continue;
		}

		$file_path = $local_path . $file_name;
		if ( !file_exists($file_path) ) {
			if ( !move_uploaded_file($file_tmp, $file_path) ) {
				$errors .= 'There\'s a problem uploading file "' . $file_name . '".<br />';
				continue;
			}
		} else {
            $randString = md5(time() . $file_name);
	  		$file_name = strtolower($randString . '.' . $file_ext);
			$file_path = $local_path . $file_name;
			if ( !move_uploaded_file($file_tmp, $file_path) ) {
				$errors .= 'There\'s a problem uploading file "' . $file_name . '".<br />';
				continue;
			}
        }
		
		$data = array(
			'ticket_id' => $ticket_id,
			'reply_id' => $reply_id,
			'file_name' => $file_name,
			'file_size' => $file_size,
			'file_type' => $file_type,
			'date' => stms_time()
		);
		$wpdb->insert("{$wpdb->prefix}stms_attachments", $data);
	}
	if ( !empty($errors) )
		return $errors;
	
	return true;
}

add_action('init', 'stms_download_attachment', 5);
function stms_download_attachment() {
	if ( isset($_GET['insta_mode']) && $_GET['insta_mode'] == 'attach' ) {
		
		/*
		@apache_setenv('no-gzip', 1);
		if( ini_get('zlib.output_compression') )
			@ini_set('zlib.output_compression', 'Off');
		*/
		
		$file_name = rawurldecode($_GET['file']);
		$file_path = ABSPATH . 'wp-content/uploads/' . $file_name;
		if ( !file_exists($file_path) )
			wp_die('ERROR: File has been deleted.');
	
	 	$stms = get_option('stms_settings');
		
		$path_info = pathinfo($file_path);
		$file_name  = $path_info['basename'];
		$file_ext   = $path_info['extension'];
		
		if ( is_file($file_path) ) {
			$file_size = filesize($file_path);
			$file = @fopen($file_path, 'rb');
			
			if ( $file ) {
				// set the headers, prevent caching
				header("Pragma: public");
				header("Expires: -1");
				header("Cache-Control: public, must-revalidate, post-check=0, pre-check=0");
				header("Content-Disposition: attachment; filename=\"$file_name\"");
	
				$known_mime_types = array(
			 		"pdf" => "application/pdf",
					"zip" => "application/zip",
					"rar" => "application/rar",
					"doc" => "application/msword",
					"docx"=> "application/msword",
					"xls" => "application/vnd.ms-excel",
					"xlsx"=> "application/vnd.ms-excel",
					"ppt" => "application/vnd.ms-powerpoint",
					"swf" => "application/x-shockwave-flash",
					"mmap"=> "application/mmap",
					"mp3" => "audio/mpeg",
					"wav" => "audio/x-wav",
					"gif" => "image/gif",
					"png" => "image/png",
					"jpeg"=> "image/jpg",
					"jpg" => "image/jpg",
					"txt" => "text/plain",
					"php" => "text/php",
					"html" => "text/html",
					"js" => "text/javascript",
					"css" => "text/style",
					"flv" => "video/x-flv",
					"mp4" => "video/mpeg",
					"mpeg"=> "video/mpeg",
					"mpg" => "video/mpeg",
					"mov" => "video/quicktime",
					"avi" => "video/x-msvideo",
					"wmv" => "video/x-ms-wmv"
			 	);
		        $mime_type = isset($known_mime_types[$file_ext]) ? $known_mime_types[$file_ext] : 'application/octet-stream';
		        header("Content-Type: " . $mime_type);
	 
				if ( isset($_SERVER['HTTP_RANGE']) ) {
					list($size_unit, $range_orig) = explode('=', $_SERVER['HTTP_RANGE'], 2);
					if ($size_unit == 'bytes') {
						list($range, $extra_ranges) = explode(',', $range_orig, 2);
					} else {
						$range = '';
						header('HTTP/1.1 416 Requested Range Not Satisfiable');
						exit;
					}
				} else {
					$range = '';
				}
	 
				list($seek_start, $seek_end) = explode('-', $range, 2);
		 
				$seek_end   = (empty($seek_end)) ? ($file_size - 1) : min(abs(intval($seek_end)),($file_size - 1));
				$seek_start = (empty($seek_start) || $seek_end < abs(intval($seek_start))) ? 0 : max(abs(intval($seek_start)),0);
		 
				if ( $seek_start > 0 || $seek_end < ($file_size - 1) ) {
					header('HTTP/1.1 206 Partial Content');
					header('Content-Range: bytes '.$seek_start.'-'.$seek_end.'/'.$file_size);
					header('Content-Length: '.($seek_end - $seek_start + 1));
				} else {
				  header("Content-Length: $file_size");
				}
			
				header('Accept-Ranges: bytes');
	 
				set_time_limit(0);
				fseek($file, $seek_start);
	 
				while( !feof($file) ) {
					print(@fread($file, 1024*8));
					ob_flush();
					flush();
					if ( connection_status()!=0 ) {
						@fclose($file);
						exit;
					}			
				}
				@fclose($file);
				exit;
			} else {
				header("HTTP/1.0 500 Internal Server Error");
				exit;
			}
		} else {
			// file does not exist
			header("HTTP/1.0 404 Not Found");
			exit;
		}
	}
}
