<?php
class InstaMember_Login extends WP_Widget {
	function InstaMember_Login() {
		$instance = array('description' => 'Use this widget to add a member login form into the blog sidebar.' );
		parent::WP_Widget(false, 'InstaMember - Login Form', $instance);      
	}

	function widget($args, $instance) {
		extract($args);
		
		$title = ( $instance['title'] != '' ) ? $instance['title'] : 'Member Login';
		
		if ( is_stmsmember_logged_in() ) {
			$member = stms_get_current_member();
			
			if ( wp_get_theme() != 'Jarida' ) echo $before_widget;
			$display_name = ( !empty($member->first_name) ) ? stms_sanitize($member->first_name) . ' ' . stms_sanitize($member->last_name) : $member->username; 
			echo '<div style="float:left; margin-right:10px">' . get_avatar($member->email, '62') . '</div>';
			echo '<span style="font-weight:bold">Welcome, ' . $display_name . '!</span>';
			echo '<p><a href="' . stms_get_handler_url('profile') . '">Profile</a> | <a href="' . stms_get_handler_url('logout') . '">Logout</a></p>';
			echo '<div style="clear:left"></div>';
			if ( wp_get_theme() != 'Jarida' ) echo $after_widget;
		} else {
			$stms = get_option('stms_settings');
			$defaults = stms_default_forms();
			$fields = ( isset($stms['form_login']) ) ? stms_build_form_fields($stms['form_login'], 'login') : stms_isset($defaults['login']);
			
			$username_label = ( isset($stms['form_login']['username_label']) ) ? stms_cleanup($stms['form_login']['username_label']) : stms_isset($defaults['login']['username_label']);
			$password_label = ( isset($stms['form_login']['password_label']) ) ? stms_cleanup($stms['form_login']['password_label']) : stms_isset($defaults['login']['password_label']);
			$remember_label = ( isset($stms['form_login']['remember_label']) ) ? stms_cleanup($stms['form_login']['remember_label']) : stms_isset($defaults['login']['remember_label']);
			$button_label = ( isset($stms['form_login']['button_label']) ) ? stms_cleanup($stms['form_login']['button_label']) : $defaults['login']['label'];
			
			$show_form = ( isset($_REQUEST['imhandler']) && $_REQUEST['imhandler'] == 'login' ) ? false : true;
			
			if ( $show_form ) :
				if ( wp_get_theme() != 'Jarida' ) echo $before_widget;
				echo '<h2>' . $title . '</h2>';
				$nonce = wp_create_nonce('stms-nonce');
				$proto = ( is_ssl() ) ? 'https://' : 'http://';
				$redir_url = ( stms_isset($instance['redirect'], 'current') == 'current' ) ? $proto . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] : get_permalink($stms['global']['home']);
				echo '
				<form name="instamem-log-form-widget' . $widget_id . '" id="instamem-log-form-widget' . $widget_id . '" method="post">
				<input type="hidden" name="_instamember_action" value="login" />
				<input type="hidden" name="_instamember_nonce" value="' . $nonce . '" />
				';
				
				if ( isset($_GET['tx_id']) && $_GET['tx_id'] > 0 )
					echo '<input type="hidden" name="tx_id" value="' . $_GET['tx_id'] . '" />' . "\n";
		
				if ( isset($_GET['insta_token']) )
					echo '<input type="hidden" name="insta_token" value="' . rawurldecode($_GET['insta_token']) . '" />' . "\n";
			
				if ( isset($_GET['flow_id']) )
					echo '<input type="hidden" name="flow_id" value="' . rawurldecode($_GET['flow_id']) . '" />' . "\n";
			
				if ( isset($_GET['tx_ids']) && is_array($_GET['tx_ids']) && count($_GET['tx_ids']) > 0 ) {
					foreach ( $_GET['tx_ids'] as $trx_id ) {
						echo '<input type="hidden" name="tx_ids[]" value="' . $trx_id . '" />' . "\n";
					}
				}
	
				echo '<input type="hidden" name="redir" value="' . $redir_url . '" />' . "\n";
				echo '
					<div style="margin-top:10px">
					<p class="login-username" style="margin-bottom:10px">
						<label for="user_login">' . $username_label . '</label>
						<input type="text" name="im_username" id="im_username" class="input" value="" style="width:93%" />
					</p>
					<p class="login-password" style="margin-bottom:10px">
						<label for="user_pass">' . $password_label . '</label>
						<input type="password" name="im_password" id="im_password" class="input" value="" style="width:93%" />
					</p>
					
					<p class="login-remember" style="margin-bottom:10px"><label><input name="rememberme" type="checkbox" id="rememberme" value="1" /> ' . $remember_label . '</label></p>
					<p class="login-submit" style="margin-bottom:10px">
						<input type="submit" name="instamem-login-' . $widget_id . '" id="instamem-login-' . $widget_id . '" class="button-primary" value="' . $button_label . '" />
					</p>
					</div>
					</form>
				';
				if ( wp_get_theme() != 'Jarida' ) echo $after_widget;
			endif;
		}
	}

	function update($new_instance, $old_instance) {                
		return $new_instance;
	}

	function form( $instance ) {    
		$title = esc_attr(stms_isset($instance['title']));
		$redirect = esc_attr(stms_isset($instance['redirect'], 'current'));
		
		echo '
       	 	<p>
            	<label for="' . $this->get_field_id('title') . '">Title (optional):</label>
            	<input type="text" name="' . $this->get_field_name('title') . '" value="' . $title . '" class="widefat" id="' . $this->get_field_id('title') . '" />
        	</p>
        	<p>
            	<label for="' . $this->get_field_id('redirect') . '">After Login Redirect:</label>
            	<select name="' . $this->get_field_name('redirect') . '" class="widefat" id="' . $this->get_field_id('redirect') . '">
        ';
		
		
        echo '<option value="current"' . ( $redirect == 'current' ? ' selected="selected"' : '') . '>Current Page</option>';
        echo '<option value="home"' . ( $redirect == 'home' ? ' selected="selected"' : '') . '>Membership Home Page</option>';
		
		echo '
            	</select>
        	</p>
        	';

	}
}

add_action('widgets_init', 'stms_register_widget');
function stms_register_widget() {
	register_widget('InstaMember_Login');
}