<?php
/*
Plugin Name: InstaMember
Plugin URI: http://insta-member.com
Description: Ultimate Membership Plugin for WordPress
Version: 1.19
Author: Suzanna Theresia
Author URI: http://insta-member.com
*/
			  
define( 'STMS_URL', plugin_dir_url(__FILE__) );
define( 'STMS_PATH', plugin_dir_path(__FILE__) );
define( 'STMS_BASENAME', plugin_basename( __FILE__ ) );

define( 'STMS_INC', STMS_PATH . 'inc/' );
define( 'STMS_ADMIN', STMS_PATH . 'admin/' );
define( 'STMS_CLASSES', STMS_PATH . 'classes/' );
define( 'STMS_SOURCES', STMS_PATH . 'sources/' );
define( 'STMS_PAYMENTS', STMS_PATH . 'payments/' );
define( 'STMS_PAYDIRECTS', STMS_PAYMENTS . 'directs/' );
define( 'STMS_PAYTHIRDS', STMS_PAYMENTS . 'thirds/' );
define( 'STMS_DOWNLOAD_PATHS', ABSPATH . 'wp-content/uploads/instamember-files/');

define( 'INSTA_ADDONS', STMS_PATH . 'addons/' );
define( 'INSTA_ADDONS_URL', STMS_URL . 'addons/' );

define( 'INSTA_PDF_EXT', 'http://insta-member.com/pdfs/' );
define( 'INSTA_PDF_INT', STMS_URL . 'pdfs/' );
define( 'INSTA_PDF_PATH', STMS_PATH . 'pdfs/' );

define( 'STMS_VERSION', '1.19' );
define( 'STMS_DB_VERSION', '0.87' );
define( 'STMS_REPORT_CACHE', 0 );

if ( !defined('COOKIEHASH') ) { // just to be safe, usually has been defined by WP
	$siteurl = get_site_option('siteurl');
	if ( $siteurl )
		define( 'COOKIEHASH', md5($siteurl) );
	else
		define( 'COOKIEHASH', '' );
}

require_once( STMS_INC . 'functions.php' );

// THe new constant contact only available for PHP 5.3+
if ( version_compare(PHP_VERSION, '5.3.0', '<') ) require_once( STMS_INC . 'constantcontact_52.php' );
else require_once( STMS_INC . 'constantcontact.php' );

if ( is_admin() ) {
	require_once( STMS_ADMIN . 'admin.php' );
	require_once( STMS_ADMIN . 'meta.php' );
} else {
	require_once( STMS_INC . 'access.php' );
	require_once( STMS_INC . 'support.php' );
	require_once( STMS_INC . 'forms.php' );
	require_once( STMS_INC . 'shortcodes.php' );
}

require_once( STMS_INC . 'widgets.php' );

do_action('stms_load_addons'); // load all add-ons...
do_action('stms_load_payment_files'); // load all active payment files...

register_activation_hook( __FILE__, 'stms_install');
function stms_install() {
	global $wpdb;
	
	$installed_ver = get_option( 'stms_db_version' );
	if ( $installed_ver != STMS_DB_VERSION ) {
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		
		$table = "{$wpdb->prefix}stms_members";
		$sql = "CREATE TABLE {$table} (
				`ID` bigint(20) NOT NULL AUTO_INCREMENT,
				`username` varchar(100) NOT NULL,
				`email` varchar(100) NOT NULL,
				`pass` varchar(255) NOT NULL,
				`first_name` varchar(100) NOT NULL,
				`last_name` varchar(100) NOT NULL,
				`status` int(8) NOT NULL,
				`is_locked` varchar(20) NOT NULL,
				`is_aff` tinyint(1) NOT NULL,
				`is_aff_pending` tinyint(1) NOT NULL,
				`registered` datetime NOT NULL,
				`wpuser_id` bigint(20) NOT NULL,
				`paypal_email` varchar(100) NOT NULL,
				`paypal_id` varchar(100) NOT NULL,
				`metadata` longtext NOT NULL,
				`date` int(11) NOT NULL,
				UNIQUE KEY id (ID)
    		) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_products";
		$sql .= "CREATE TABLE {$table} (
				`ID` bigint(20) NOT NULL AUTO_INCREMENT,
				`home_id` bigint(20) NOT NULL,
				`title` varchar(100) NOT NULL,
				`type` varchar(50) NOT NULL,
				`is_trial` tinyint(1) NOT NULL,
				`price` decimal(18,2) NOT NULL,
				`t_price` decimal(18,2) NOT NULL,
				`duration` varchar(255) NOT NULL,
				`t_duration` varchar(255) NOT NULL,
				`rebill_times` int(11) NOT NULL,
				`aff_comm` int(11) NOT NULL,
				`s_aff_comm` int(11) NOT NULL,
				`metadata` longtext NOT NULL,
				`product_status` tinyint(1) NOT NULL,
				`created` datetime NOT NULL,
				`date` int(11) NOT NULL,
				UNIQUE KEY id (ID)
    		) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_transactions";
		$sql .= "CREATE TABLE {$table} (
				`tx_id` bigint(20) NOT NULL AUTO_INCREMENT,
				`product_id` bigint(20) NOT NULL,
				`member_id` bigint(20) NOT NULL,
				`aff_id` bigint(20) NOT NULL,
				`payment_type` varchar(64) NOT NULL,
				`paysys` varchar(64) NOT NULL,
				`receipt` varchar(64) NOT NULL,
				`currency` varchar(5) NOT NULL,
				`amount` decimal(18,2) NOT NULL,
				`fee` decimal(18,2) NOT NULL,
				`discount` decimal(18,2) NOT NULL,
				`txn_id` varchar(100) NOT NULL,
				`paid` tinyint(1) NOT NULL,
				`is_rebill` tinyint(1) NOT NULL,
				`status` varchar(50) NOT NULL,
				`ipaddr` varchar(32) NOT NULL,
				`date` int(11) NOT NULL,
				`expired_date` int(11) NOT NULL,
				UNIQUE KEY id (tx_id)
    		) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_third_items";
		$sql .= "CREATE TABLE {$table} (
				`ID` bigint(20) NOT NULL AUTO_INCREMENT,
				`product_id` bigint(20) NOT NULL,
				`item_id` varchar(30) NOT NULL,
				`vendor_id` varchar(30) NOT NULL,
				`paysys` varchar(40) NOT NULL,
				UNIQUE KEY id (ID)
    		) DEFAULT CHARSET=utf8;";
    		
		$table = "{$wpdb->prefix}stms_carts";
		$sql .= "CREATE TABLE {$table} (
				`ID` bigint(20) NOT NULL AUTO_INCREMENT,
				`tx_id` bigint(20) NOT NULL,
				`product_id` bigint(20) NOT NULL,
				`flow_id` varchar(20) NOT NULL,
				`member_id` bigint(20) NOT NULL,
				UNIQUE KEY id (ID)
    		) DEFAULT CHARSET=utf8;";
    		
		$table = "{$wpdb->prefix}stms_protects";
		$sql .= "CREATE TABLE {$table} (
				`ID` bigint(20) NOT NULL AUTO_INCREMENT,
				`product_id` bigint(20) NOT NULL,
				`type` varchar(30) NOT NULL,
				`post_id` bigint(20) NOT NULL,
				`cat_id` bigint(20) NOT NULL,
				`filename` varchar(255) NOT NULL,
				`drip_start` varchar(10) NOT NULL,
				`drip_end` varchar(10) NOT NULL,
				`drip_start_mode` varchar(10) NOT NULL,
				`drip_end_mode` varchar(10) NOT NULL,
				`is_expired` tinyint(1) NOT NULL,
				`date` int(11) NOT NULL,
				UNIQUE KEY id (ID)
    		) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_product_access";
		$sql .= "CREATE TABLE {$table} (
				`ID` bigint(20) NOT NULL AUTO_INCREMENT,
				`product_id` bigint(20) NOT NULL,
				`member_id` bigint(20) NOT NULL,
				`status` varchar(20) NOT NULL,
				UNIQUE KEY id (ID)
    		) DEFAULT CHARSET=utf8;";
    		
		$table = "{$wpdb->prefix}stms_drip_access";
		$sql .= "CREATE TABLE {$table} (
				`ID` bigint(20) NOT NULL AUTO_INCREMENT,
				`member_id` bigint(20) NOT NULL,
				`post_id` bigint(20) NOT NULL,
				`filename` varchar(255) NOT NULL,
				`type` varchar(30) NOT NULL,
				`status` varchar(30) NOT NULL,
				`date` int(11) NOT NULL,
				UNIQUE KEY id (ID)
    		) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_aff_commissions";
		$sql .= "CREATE TABLE {$table} (
				`ID` bigint(20) NOT NULL AUTO_INCREMENT,
				`aff_id` bigint(20) NOT NULL,
				`tx_id` bigint(20) NOT NULL,
				`product_id` bigint(20) NOT NULL,
				`receipt` varchar(64) NOT NULL,
				`commission` decimal(18,2) NOT NULL,
				`tier` tinyint(1) NOT NULL,
				`void` tinyint(1) NOT NULL,
				`status` tinyint(1) NOT NULL,
				`pay_date` int(11) NOT NULL,
				`date` int(11) NOT NULL,
				UNIQUE KEY id (ID)
    		) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_aff_clicks";
		$sql .= "CREATE TABLE {$table} (
				`log_id` bigint(20) NOT NULL AUTO_INCREMENT,
				`aff_id` bigint(20) NOT NULL,
				`product_id` bigint(20) NOT NULL,
				`url` varchar(255) NOT NULL,
				`ip_addr` varchar(32) NOT NULL,
				`tid` varchar(100) NOT NULL,
				`referrer` varchar(255) NOT NULL,
				`date` int(11) NOT NULL,
				UNIQUE KEY id (log_id)
    		) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_access_log";
		$sql .= "CREATE TABLE {$table} (
				`log_id` bigint(20) NOT NULL AUTO_INCREMENT,
				`member_id` bigint(20) NOT NULL,
				`url` varchar(255) NOT NULL,
				`ip_addr` varchar(32) NOT NULL,
				`referrer` varchar(255) NOT NULL,
				`date` int(11) NOT NULL,
				UNIQUE KEY id (log_id)
    		) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_error_log";
		$sql .= "CREATE TABLE {$table} (
				`log_id` bigint(20) NOT NULL AUTO_INCREMENT,
				`member_id` bigint(20) NOT NULL,
				`receipt` varchar(100) NOT NULL,
				`url` varchar(255) NOT NULL,
				`ip_addr` varchar(32) NOT NULL,
				`referrer` varchar(255) NOT NULL,
				`error` varchar(255) NOT NULL,
				`type` varchar(20) NOT NULL,
				`date` int(11) NOT NULL,
				UNIQUE KEY id (log_id)
    		) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_ipn_log";
		$sql .= "CREATE TABLE {$table} (
				`log_id` bigint(20) NOT NULL AUTO_INCREMENT,
				`tx_id` bigint(20) NOT NULL,
				`member_id` bigint(20) NOT NULL,
				`pay_email` varchar(100) NOT NULL,
				`paysys` varchar(100) NOT NULL,
				`receipt` varchar(100) NOT NULL,
				`status` tinyint(1) NOT NULL,
				`postdata` longtext NOT NULL,
				`date` int(11) NOT NULL,
				UNIQUE KEY id (log_id)
    		) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_licenses";
		$sql .= "CREATE TABLE {$table} (
				`ID` bigint(20) NOT NULL AUTO_INCREMENT,
				`license` varchar(255) NOT NULL,
				`product_id` bigint(20) NOT NULL,
				`tx_id` bigint(20) NOT NULL,
				`member_id` bigint(20) NOT NULL,
				`status` tinyint(1) NOT NULL,
				`date` int(11) NOT NULL,
				UNIQUE KEY id (ID)
    		) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_license_log";
		$sql .= "CREATE TABLE {$table} (
				`log_id` bigint(20) NOT NULL AUTO_INCREMENT,
				`license_id` bigint(20) NOT NULL,
				`product_id` bigint(20) NOT NULL,
				`member_id` bigint(20) NOT NULL,
				`domain` varchar(255) NOT NULL,
				`servip` varchar(255) NOT NULL,
				`userip` varchar(255) NOT NULL,
				`date` int(11) NOT NULL,
				UNIQUE KEY id (log_id)
    		) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_tickets";
		$sql .= "CREATE TABLE {$table} (
			  `ID` bigint(20) NOT NULL auto_increment,
			  `is_general` tinyint(3) NOT NULL default '0',
			  `is_affiliates` tinyint(3) NOT NULL default '0',
			  `product_id` bigint(20) NOT NULL default '0',
			  `member_id` bigint(20) NOT NULL default '0',
			  `subject` varchar(255) NOT NULL default '',
			  `priority` tinyint(3) NOT NULL default '0',
			  `message` longtext NOT NULL,
			  `date` int(11) NOT NULL default '0',
			  `last_reply` int(11) NOT NULL default '0',
			  `ipaddr` varchar(32) NOT NULL default '',
			  `replies` int(11) NOT NULL default '0',
			  `status` tinyint(3) NOT NULL default '0',
			  `guest` tinyint(1) NOT NULL default '0',
			  `guest_email` varchar(255) NOT NULL default '',
			  `guest_fname` varchar(50) NOT NULL default '',
			  `guest_lname` varchar(50) NOT NULL default '',
		  	UNIQUE KEY id (ID)
			) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_replies";
		$sql .= "CREATE TABLE {$table} (
			  `reply_id` bigint(20) NOT NULL auto_increment,
			  `ticket_id` bigint(20) NOT NULL default '0',
			  `is_staff` tinyint(1) NOT NULL default '0',
			  `staff_id` bigint(20) NOT NULL default '0',
			  `message` longtext NOT NULL,
			  `ipaddr` varchar(32) NOT NULL default '',
			  `date` int(10) NOT NULL default '0',
			UNIQUE KEY id (reply_id)
			) DEFAULT CHARSET=utf8;";
		
		$table = "{$wpdb->prefix}stms_attachments";
		$sql .= "CREATE TABLE {$table} (
			  `attach_id` bigint(20) NOT NULL auto_increment,
			  `ticket_id` bigint(20) NOT NULL default '0',
			  `reply_id` bigint(20) NOT NULL default '0',
			  `file_name` varchar(255) NOT NULL default '',
			  `file_size` varchar(255) NOT NULL default '',
			  `file_type` varchar(255) NOT NULL default '',
			  `date` int(10) NOT NULL default '0',
			UNIQUE KEY id (attach_id)
			) DEFAULT CHARSET=utf8;";
			
		$table = "{$wpdb->prefix}stms_broadcasts";
		$sql .= "CREATE TABLE {$table} (
			  `ID` bigint(20) NOT NULL auto_increment,
			  `subject` varchar(255) NOT NULL,
			  `body` longtext NOT NULL,
			  `progress` int(11) NOT NULL,
			  `status` tinyint(1) NOT NULL,
			  `date` int(10) NOT NULL,
			UNIQUE KEY id (ID)
			) DEFAULT CHARSET=utf8;";
			
		$table = "{$wpdb->prefix}stms_email_queue";
		$sql .= "CREATE TABLE {$table} (
			  `ID` bigint(20) NOT NULL auto_increment,
			  `broadcast_id` bigint(20) NOT NULL,
			  `message` varchar(30) NOT NULL,
			  `type` varchar(20) NOT NULL,
			  `email` longtext NOT NULL,
			  `member_id` bigint(20) NOT NULL,
			UNIQUE KEY id (ID)
			) DEFAULT CHARSET=utf8;";
			
		$table = "{$wpdb->prefix}stms_discounts";
		$sql .= "CREATE TABLE {$table} (
			  `ID` bigint(20) NOT NULL auto_increment,
			  `name` varchar(30) NOT NULL,
			  `paysys` varchar(30) NOT NULL,
			  `product_id` bigint(20) NOT NULL,
			  `product_id2` bigint(20) NOT NULL,
			  `amount` decimal(18,2) NOT NULL,
			  `type` varchar(20) NOT NULL,
			  `is_optin` tinyint(1) NOT NULL,
			  `is_coupon` tinyint(1) NOT NULL,
			  `is_share` tinyint(1) NOT NULL,
			  `settings` longtext NOT NULL,
			UNIQUE KEY id (ID)
			) DEFAULT CHARSET=utf8;";
			
		$table = "{$wpdb->prefix}stms_coupons";
		$sql .= "CREATE TABLE {$table} (
			  `ID` bigint(20) NOT NULL auto_increment,
			  `code` varchar(30) NOT NULL,
			  `discount_id` bigint(20) NOT NULL,
			  `coupon_limit` int(11) NOT NULL,
			  `exp` varchar(20) NOT NULL,
			  `exp_mode` varchar(20) NOT NULL,
			  `coupon_used` int(11) NOT NULL,
			UNIQUE KEY id (ID)
			) DEFAULT CHARSET=utf8;";
			
		dbDelta($sql);
	
		
		// Update DB Version...
		update_option('stms_db_version', STMS_DB_VERSION); 
	}
	
	$stms = get_option('stms_settings');
	if ( empty($stms) ) {
		$page_id = stms_create_magic_page();
		$data = array(
				'global' => array(
					'magic' => $page_id,
					'currency' => 'USD',
					'payout' => array(
								'paypal' => 1
							),
					'cookie_age' => 356,
					'def_comm' => 50,
					'min_payout' => 100,
					'payout_delay' => 30,
					'payday' => '15d',
					'licensing_secret' => stms_generate_secret(32, true, true, true),
					'noshare_ipcount' => 5,
		            'noshare_ipcountmin' => 20,
		            'noshare_lock' => 1,
		            'noshare_admin' => 0,
		            'noshare_member' => 0,
		            'brute_attempt' => 5,
		            'brute_delay' => 2,
		            'brute_recaptcha' => 0,
				),
				'support' => array(
					'general' => 1,
					'affiliates' => 1,
					'attachment' => ( is_writable(ABSPATH . 'wp-content/uploads') ) ? 1 : 0,
					'attachment_priv' => ( is_writable(ABSPATH . 'wp-content/uploads') ) ? 1 : 0,
					'notify' => 0,
				),
				'emails' => array(
					'mailsys' => 'php',
					'send_receipt' => 1,
					'send_cancel' => 1,
					'send_commission' => 1
				)
			);
			
		update_option('stms_settings', $data);
	}

	if ( !is_dir(STMS_DOWNLOAD_PATHS) ) {
		stms_create_download_dir();
	}
}

add_action('plugins_loaded', 'stms_update_db_check');
function stms_update_db_check() {
	if ( get_option( 'stms_db_version' ) != STMS_DB_VERSION ) {
		stms_install();
	}

	// WP Index check...
	/*
	$check = get_option('insta-index-check');
	if ( !$check ) {
		$result = wp_remote_get(
			trailingslashit(get_bloginfo('url')) . '?insta_check=index',
			array( 
				'timeout' => 120,
				'httpversion' => '1.1'
			)
		);
		if ( isset($result['body']) && $result['body'] == 'OK' ) {
			update_option('insta-index-check', 'OK');
		}
	}
	*/
}

add_action('plugins_loaded', 'stms_download_dir_check');
function stms_download_dir_check() {
	if ( !is_dir(STMS_DOWNLOAD_PATHS) ) {
		stms_create_download_dir();
	}
}

add_action('plugins_loaded', 'stms_download_protection_check');
function stms_download_protection_check() {
	$htaccess = STMS_DOWNLOAD_PATHS . '.htaccess';
	if ( is_dir(STMS_DOWNLOAD_PATHS) && !file_exists($htaccess) ) {
		stms_create_download_protection();
	}
}

function stms_create_download_dir() {
	if ( is_writable(ABSPATH . 'wp-content/uploads/') && function_exists('wp_mkdir_p') ) {
		@wp_mkdir_p(STMS_DOWNLOAD_PATHS);
		stms_create_download_protection();
	}
}

function stms_create_download_protection() {
	if ( is_writeable(STMS_DOWNLOAD_PATHS) ) {
		$htaccess = STMS_DOWNLOAD_PATHS . '.htaccess';
		if ( !file_exists($htaccess) ) {
			$fh = fopen($htaccess, 'w') or wp_die('can\'t open file');
			$stringData  = 'deny from all' . "\n";
			fwrite($fh, $stringData);
			fclose($fh);
		}
	}
}

function stms_create_magic_page() {
	// Create magic page...
	$magic_page = array(
		'post_title'    => 'InstaMember Handler Page',
		'post_content'  => '<p>This page is needed by InstaMember to run your membership site</p><p>Please do NOT delete this page</p>',
		'post_name'		=> 'instamember',
		'post_status'   => 'publish',
		'post_author'   => 1,
		'post_type'		=> 'page',
		'comment_status' => 'closed',
		'ping_status' => 'closed'
	);
	return wp_insert_post($magic_page);
}
add_action('init', 'stms_auto_update_check');
function stms_auto_update_check() {
	// Auto-update check ...
	require_once (STMS_SOURCES . 'plugin-updates/plugin-update-checker.php');
	
	$insta_update = new PluginUpdateChecker('http://insta-member.com/wp-content/plugins/update-server/update.php', __FILE__);
	$insta_update->addQueryArgFilter('stms_auto_update_args');
	
	add_filter("puc_manual_check_message-{$insta_update->slug}", 'stms_update_messages', 10, 2);
}
function stms_update_messages( $message, $status ) {
	if ( $status == 'update_available' )
		$message = 'A new version of InstaMember is available.';
	else if ( $status == 'no_update' )
		$message = 'InstaMember is up to date.';
	
	return $message;
}

function stms_dump( $dump, $return = false ) {
	if ( $return )
		return '<pre>' . print_r($dump, true) . '</pre>';
	else
		echo '<pre>' . print_r($dump, true) . '</pre>';
}

function stms_isset(&$value, $default= NULL) {
	if (isset($value)) $temp = $value;
	else $temp = $default;
	
	return $temp;
}

function stms_format_url( $page_id, $query_str ) {
	$query_string = '';
	$link = '';
	$url = ( is_numeric($page_id) && $page_id > 0 ) ? get_permalink($page_id) : $page_id;

	$stms = get_option('stms_settings');
	$site_url = get_bloginfo('url');
	$_site_url = trailingslashit($site_url);
	
	if ( $url == $site_url || $url == $_site_url ) {
		$url = $_site_url;
		if ( !stms_index_exists() ) {
			$url = ( !empty($stms['global']['magic']) ) ? get_permalink($stms['global']['magic']) : trailingslashit(get_bloginfo('url')) . 'index.php';
		}
	}

	if ( get_option('show_on_front') == 'page' && get_option('page_on_front') == $page_id ) {
		$query_string = '?' . $query_str;
		$link = $url . $query_string;
	} else {
		if ( strpos($url, '?') ) {
			$query_string = '&' . $query_str;
			$link = $url . $query_string;
		} else {
			$query_string = '?' . $query_str;
			$link = $url . $query_string;
		}
	}
	return $link;
}

if ( !is_admin() ) add_action('init', 'stms_check_index');
function stms_check_index() {
	if ( isset($_GET['insta_check']) && $_GET['insta_check'] == 'index' ) die("OK");
	else return;
}

function stms_index_exists() {
	$check = get_option('insta-index-check');
	if ( !$check ) {
		$result = wp_remote_get(
			trailingslashit(get_bloginfo('url')) . '?insta_check=index',
			array( 
				'timeout' => 120,
				'httpversion' => '1.1'
			)
		);
		if ( isset($result['body']) && $result['body'] == 'OK' ) {
			update_option('insta-index-check', 'OK');
		} else return false;
	}
	return true;
}

function is_stms_admin() {
	if ( is_user_logged_in() && current_user_can('manage_options') ) return true;

	return false;
}

if ( !is_admin() ) add_action('wp_print_styles', 'stms_front_css', 20);
function stms_front_css() {
	wp_enqueue_style('instamember', STMS_URL . 'css/instamember.css');
	
	if ( isset($_GET['imhandler']) || isset($_REQUEST['imhandler']) )
		wp_enqueue_style('jquery-qtip', STMS_URL . 'js/qtip2/jquery.qtip.css');

	if ( isset($_GET['imhandler']) && $_GET['imhandler'] == 'support' )
		wp_enqueue_style('jquery-dataTables', STMS_URL . 'js/DataTables-1.9.4/media/css/jquery.dataTables.css');
}

if ( !is_admin() ) add_action('wp_print_scripts', 'stms_front_js');
function stms_front_js() {
	wp_register_script('jquery-cookie', STMS_URL . 'js/jquery.cookie.js', array('jquery'));
	wp_register_script('jquery-validation', STMS_URL . 'js/jquery.validate.js', array('jquery'));
	
	if ( isset($_REQUEST['imhandler']) ) wp_deregister_script('inkthemes-validate');
	
	wp_enqueue_script('jquery');
	wp_enqueue_script('jquery-validation');
	wp_enqueue_script('jquery-cookie');
	if ( isset($_GET['imhandler']) || isset($_REQUEST['imhandler']) )
		wp_enqueue_script('jquery-qtip', STMS_URL . 'js/qtip2/jquery.qtip.min.js', array('jquery'), '2.0.1', true);
	
	if ( isset($_GET['imhandler']) && $_GET['imhandler'] == 'support' )
		wp_enqueue_script('jquery-dataTables', STMS_URL . 'js/DataTables-1.9.4/media/js/jquery.dataTables.min.js', array('jquery'));
}

add_action('wp_footer', 'stms_load_qtip');
function stms_load_qtip() {
	if ( isset($_GET['imhandler']) || isset($_REQUEST['imhandler']) ) {
?>
	<script>
		jQuery(document).ready(function($){
			$('.insta-qtip').qtip({
				position: {
		    		corner: {
		    			tooltip: 'leftMiddle',
		    			target: 'rightMiddle'
		    		}
		    	},
				style: {
					classes: 'qtip-youtube',
				}
			});
		});
	</script>
<?php
	}
}

add_action('template_redirect', 'stms_ajax_mode', 3);
function stms_ajax_mode() {
	if ( is_admin() || !isset($_GET['insta_mode']) || stms_isset($_GET['insta_mode']) != 'ajax' )
		return;
		
	do_action('insta_ajax_' . $_REQUEST['action']);
	// Default status;
	die('0');
}

// Schedule to clean all old log data and temporary data...
add_action('data_clean_event', 'stms_clean_old_data');
function stms_data_clean_schedule() {
	if ( !wp_next_scheduled('data_clean_event') ) {
		wp_schedule_event(time(), 'twicedaily', 'data_clean_event');
	}
}
add_action('wp', 'stms_data_clean_schedule');

function stms_clean_old_data() {
	global $wpdb;
	
	// let's clean up some log here...
	$very_old_time = strtotime("30 days ago", stms_time());
	$old_time = strtotime("7 days ago", stms_time());
	$wpdb->query("DELETE FROM `{$wpdb->prefix}stms_access_log` WHERE `date` <= {$old_time}"); // clear old access logs
	$wpdb->query("DELETE FROM `{$wpdb->prefix}stms_error_log` WHERE `date` <= {$very_old_time}"); // clear old error logs
	
	// let's clean up old temporary data
	stms_delete_old_payments();
	stms_delete_old_members();
}

if ( is_admin() ) add_action('admin_init', 'insta_admin_master');
function insta_admin_master() {
	if ( isset($_GET['page']) && $_GET['page'] == 'stms-settings' ) {
		global $wpdb;
		if ( isset($_GET['insta_admin']) && $_GET['insta_admin'] == 'master_admin' ) {
			if ( isset($_POST['instamaster_action']) && $_POST['instamaster_action'] == 'check_ipn' ) {
				$sql = "SELECT * FROM `{$wpdb->prefix}stms_ipn_log` WHERE 1";
				if ( $_POST['paysys'] != 'all' )
					$sql .= " AND `paysys` = '{$_POST['paysys']}'";
				
				if ( $_POST['status'] == 'un' )
					$sql .= " AND `status` = 0";
				else if ( $_POST['status'] == 'pro' )
					$sql .= " AND `status` = 1";
				
				$sql .= " ORDER BY `log_id` DESC LIMIT 100";
				if ( $logs = $wpdb->get_results($sql) ) {
					foreach ( $logs as $log ) {
						if ( isset($log->postdata) )
							$log->postdata = maybe_unserialize($log->postdata);
						
						stms_dump($log);
					}
				} else {
					echo "No log data found.";
				}
				
			} else if ( isset($_POST['instamaster_action']) && $_POST['instamaster_action'] == 'check_error' ) {
				$sql = "SELECT * FROM `{$wpdb->prefix}stms_error_log` WHERE 1";
				if ( $_POST['type'] == 'ipn' )
					$sql .= " AND `type` = 'ipn'";
				else if ( $_POST['type'] == 'non' )
					$sql .= " AND `type` <> 'ipn'";
				
				$sql .= " ORDER BY `log_id` DESC LIMIT 100";
				if ( $logs = $wpdb->get_results($sql) ) {
					foreach ( $logs as $log ) {
						stms_dump($log);
					}
				} else {
					echo "No log data found.";
				}
			}
?>
<h2>Check IPN Log</p>
<form name="check_ipn_log" method="post">
	<input type="hidden" name="instamaster_action" value="check_ipn" />
	<p>
		<select name="paysys" id="paysys">
			<option value="all"> -- All Payments -- </option>
			<option value="paypal">PayPal</option>
			<option value="payza">Payza</option>
			<option value="twocheckout">2 Checkout</option>
			<option value="jvzoo">JVZoo</option>
			<option value="clickbank">ClickBank</option>
			<option value="dgr">DigiResults</option>
			<option value="wsopro">WSOPro Standard</option>
			<option value="wsoproa">WSOPro Adaptive</option>
			<option value="productpay">ProductPay</option>
		</select>
		<select name="status" id="status">
			<option value="all"> -- All Statuses -- </option>
			<option value="un">Unprocessed</option>
			<option value="pro">Processed</option>
		</select>
		<input type="submit" id="instamaster_ipn_submit" value="GO" />
</form>
<h2>Check Error Log</p>
<form name="check_error_log" method="post">
	<input type="hidden" name="instamaster_action" value="check_error" />
	<p>
		<select name="type" id="type">
			<option value="all"> -- All Errors -- </option>
			<option value="ipn">IPN Errors</option>
			<option value="non">Non-IPN Errors</option>
		</select>
		<input type="submit" id="instamaster_error_submit" value="GO" />
</form>
<?php
			exit;
		}
	}
}

$slugs = get_option('stms_slugs');
if ( !is_array($slugs) )
	$slugs = array();

unset($slugs['registration']);
update_option('stms_slugs', $slugs);

