jQuery(document).ready(function($){
	$('.stms-toggle-checkbox').each(function(){
		var dis = $(this);
		$(this).click(function(e){
			var $this = $(this);
			if ( this.checked == true ) {
				$('.' + $this.data('blockname')).show();
				$this.parent().parent().find('.stms-toggle-btn').css('background-position', 'left bottom');
			} else {
				$('.' + $this.data('blockname')).hide();
				$this.parent().parent().find('.stms-toggle-btn').css('background-position', 'left top');
			}
		});
		
		if ( dis.is(":checked") ) {
			$('.' + dis.data('blockname')).show();
			dis.parent().parent().find('.stms-toggle-btn').css('background-position', 'left bottom');
		} else {
			$('.' + dis.data('blockname')).hide();
			dis.parent().parent().find('.stms-toggle-btn').css('background-position', 'left top');
		}
	});
	
	$('.stms-toggle-btn').each(function(){
		$(this).click(function(){
			var $this = $(this);
			if ( $this.parent().parent().find('.stms-toggle-switch').is(":checked") ) {
				$this.parent().parent().find('.stms-toggle-switch').removeAttr('checked');
				$('.' + $this.parent().parent().find('.stms-toggle-switch').data('blockname')).hide("medium");
				$this.css('background-position', 'left top');
			} else {
				$this.parent().parent().find('.stms-toggle-switch').attr('checked', true);
				$('.' + $this.parent().parent().find('.stms-toggle-switch').data('blockname')).show("medium");
				$this.css('background-position', 'left bottom');
			}
		});
	});
	
	$('#stms_enable_expire').click(function(){
		if ( this.checked == true )
			$('.stms-drip-expired').show();
		else
			$('.stms-drip-expired').hide();
	});
	
	$('.protects-date').each(function(){
		var dis = $(this);
		$(this).change(function(){
			var $this = $(this), option = $("option:selected", this).val(),
			currentTime = new Date(), month = currentTime.getMonth() + 1,
			day = currentTime.getDate(), year = currentTime.getFullYear(),
			num = ( $this.parent().find('.protect-drip-end').length ) ? '30' : '0';
			
			if ( option == 'exact' ) {
				$this.parent().find('.protect-date-field')
				.val(month + '/' + day + '/' + year)
				.datepicker();
			} else {
				$this.parent().find('.protect-date-field')
				.val(num)
				.datepicker("destroy");
			}
		});
		
		if ( dis.val() == 'exact' ) {
			dis.parent().find('.protect-date-field').datepicker();
		} else {
			dis.parent().find('.protect-date-field').datepicker("destroy");
		}
	});
	
	$('#stms_cancel_drip').click(function(e){
		$('.stms-drip-settings').hide();
		$('.stms-protection-settings').fadeIn("medium");
	});
	
	$('#stms_apply_drip').click(function(e){
		var $this = $(this),
		_product_id = $('#stms_product_id').val(),
		_post_id = $('#stms_post_id').val(),
		_start = $('#stms_drip_start').val(),
		_start_mode = $('#stms_drip_start_mode').val(),
		_is_expired = ( $('#stms_enable_expire').is(":checked") ) ? 1 : 0,
		_end = $('#stms_drip_end').val(),
		_end_mode = $('#stms_drip_end_mode').val();
		
		$('.stms-drip-settings').hide();
		$('#stms-meta-loadtxt').text('Saving...');
		$('#stms-meta-loader').show();
		$.post(ajaxurl, {
			action: 'stms_meta_apply_protect',
			product_id: _product_id,
			post_id: _post_id,
			start: _start,
			start_mode: _start_mode,
			is_expired: _is_expired,
			end: _end,
			end_mode: _end_mode
		}, function(response){
			$('#stms-meta-loader').hide();
			$('.stms-drip-settings').fadeIn("medium");
			if ( response == 'ok' ) {
				$('.drip-update-message').show();
				setTimeout(function(){
					$('.drip-update-message').hide();
				}, 3000)
			}
		});
	});
	
	$('.stms-meta-drip').each(function(){
		$(this).click(function(e){
			var $this = $(this),
			_product_id = $this.data('productid'),
			_post_id  = $this.data('postid');
			
			if ( $('#stms_protect_' + _product_id).is(":checked") ) {
				$('.stms-protection-settings').hide();
				$('#stms-meta-loadtxt').text('Loading...');
				$('#stms-meta-loader').show();
				$.ajax({
					  url: ajaxurl + '?callback=?&action=stms_meta_protect',
					  dataType: 'jsonp',
					  data: {
					  	product_id: _product_id,
					  	post_id: _post_id,
					  },
					  success: function(response) {
					  	$('#stms-meta-loader').hide();
					  	$('#stms-drip-name').text($this.parent().parent().find('.stms-product_name').text());
					  	$('#stms_product_id').val(_product_id);
					  	$('#stms_drip_start').val(response.start);
					  	$('#stms_drip_start_mode').val(response.start_mode);
					  	$('#stms_drip_end').val(response.end);
					  	$('#stms_drip_end_mode').val(response.end_mode);
					  	
					  	if ( response.is_expired == 1 ) {
					  		$('#stms_enable_expire').attr('checked', 'checked');
					  		$('.stms-drip-expired').show();
					  	} else {
					  		$('#stms_enable_expire').removeAttr('checked');
					  		$('.stms-drip-expired').hide();
					  	}
					  	
					  	if ( response.start_mode == 'exact' ) {
							$('#stms_drip_start').datepicker();
						} else {
							$('#stms_drip_start').datepicker("destroy");
						}
						
						if ( response.end_mode == 'exact' ) {
							$('#stms_drip_end').datepicker();
						} else {
							$('#stms_drip_end').datepicker("destroy");
						}
					  	
					  	$('.stms-drip-settings').fadeIn("medium");
					  }
				});
			} else {
				alert('Cannot open drip-feed settings. This post/page is not protected for this product.' );
			}
			
			e.preventDefault();
		});
	});
});