<?php
/*
Payment Name: Authorize.Net
Payment Key: authorize
One Time: yes
Recurring: yes
Flow Type: normal
*/

add_action('stms_global_payment_authorize', 'stms_authorize_global_settings');
function stms_authorize_global_settings($stms) {
	$authorize_secret = ( stms_isset($stms['payments']['authorize']['secret']) != '' ) ? trim($stms['payments']['authorize']['secret']) : stms_generate_secret(10, true, false, true);
?>
	<table class="form-table">
	<tr valign="top">
		<th scope="row"><label style="cursor:default"><strong>Enable Authorize.Net</strong></label></th>
		<td><div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[is_authorize]" id="stms_pay_authorize" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="authorize-paysets" value="1" <?php if ( stms_isset($stms['payments']['is_authorize']) == 1 ) echo 'checked="checked"'; ?> /></td>
	</tr>
	<tr valign="top" class="authorize-paysets">
		<th scope="row" style="text-align:right"></th>
		<td>
			<div id="authorize-notice-link"><strong>Important:</strong> <a href="#" onclick="jQuery('#authorize-notice').show('medium'); jQuery('#authorize-notice-link').hide(); return false;"><strong>CLICK HERE</strong></a> to read instructions</div>
			<div id="authorize-notice" class="stms-help-msg" style="display:none">
				<p><strong>Important #1:</strong> Before you can use <a href="http://www.authorize.net/" target="_blank">Authorize.Net</a> to accept payment, you MUST first install a <em>signed 128-bit SSL certificate</em> in your server, and your WordPress site (including admin dashboard) must be able to be accessed using the <code>https://</code> protocol.</p>
				<p><strong>Important #2:</strong> InstaMember will use Advanced Integration Method (AIM) to handle all one-time payments.</p>
				<p><strong>Important #3:</strong> InstaMember will use <a href="http://www.authorize.net/solutions/merchantsolutions/merchantservices/automatedrecurringbilling/" target="_blank">Auto-Recurring Billing (ARB)</a> to handle all subscription &amp; recurring payments. Please enable the 'ARB' option below to let InstaMember know if your Authorize.net account have the 'ARB' capability.</p>
				<p><strong>Important #4:</strong> If you require customers to enter the "Card Security Code" during purchase, please enable the feature in your Authorize.net account first and then check the CVV option below.</p>
				<p><strong>Important #5:</strong> If you have activated the "Address Verification Service" feature in your Authorize.Net account, please check the AVS option below. InstaMember will then require every customers to enter their billing address upon purchase.</p>
				<p style="text-align:right"><a href="#" onclick="jQuery('#authorize-notice').hide(); jQuery('#authorize-notice-link').show('medium'); return false;">(hide)</a></p>
			</div>
		</td>
	</tr>
	<tr valign="top" class="authorize-paysets">
		<th scope="row" style="text-align:right"><label for="stms_authorize_id"><?php _e('API Login ID', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" name="stms_sets[authorize][login_id]" id="stms_authorize_id" value="<?php echo stms_isset($stms['payments']['authorize']['login_id']); ?>" />
			<div class="stms-desc">You can obtain your API Login ID from your Authorize.net account (under <code>Account -> Settings -> Security Settings</code>)</div>
		</td>
	</tr>
	<tr valign="top" class="authorize-paysets">
		<th scope="row" style="text-align:right"><label for="stms_authorize_key"><?php _e('Transaction Key', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" name="stms_sets[authorize][trans_key]" id="stms_authorize_key" value="<?php echo stms_isset($stms['payments']['authorize']['trans_key']); ?>" />
			<div class="stms-desc">You can obtain your Transaction Key from your Authorize.net account (under <code>Account -> Settings -> Security Settings</code>)</div>
		</td>
	</tr>
	<tr valign="top" class="authorize-paysets">
		<th scope="row" style="text-align:right"><label for="stms_authorize_secret"><?php _e('MD5-Hash Value', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" name="stms_sets[authorize][secret]" id="stms_authorize_secret" value="<?php echo $authorize_secret; ?>" />
			<div class="stms-desc">Please enter this md5-hash value in your Authorize.net account (<code>Account -> Settings -> Security Settings -> MD5-Hash</code>). <strong>Important:</strong> The md5-hash value MUST be the same as in your Authorize.net account.</div>
		</td>
	</tr>
	<tr valign="top" class="authorize-paysets">
		<th scope="row" style="text-align:right"><label><?php _e('Silent Post URL', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" value="<?php echo stms_get_ipnurl('authorize'); ?>" readonly />
			<div class="stms-desc">Please enter this Silent Post URL in your Authorize.net account (under <code>Account -> Settings -> Transaction Response Settings -> Silent Post URL</code>)</div>
		</td>
	</tr>
	<tr valign="top" class="authorize-paysets">
		<th scope="row" style="text-align:right"><label for="stms_accepted_cards"><?php _e('Accepted Credit Card(s)', 'stms'); ?></label></th>
		<td>
			<select name="stms_sets[authorize][cards][]" id="stms_accepted_cards" class="stms-multiselect" multiple="multiple">
				<?php
				$cards = array(
					'amex' => 'American Express',
					'visa' => 'Visa',
					'mastercard' => 'MasterCard',
					'discover' => 'Discover Card',
					'diners' => 'Diners Club',
					'jcb' => 'JCB Card'
				);
				
				$accepted = ( isset($stms['payments']['authorize']['cards']) ) ? $stms['payments']['authorize']['cards'] : array('amex', 'visa', 'mastercard', 'discover');
				foreach ( $cards as $k => $v ) {
					$selected = ( in_array($k, $accepted) ) ? ' selected="selected"' : '';
					echo "<option value='{$k}'{$selected}>" . ucwords($v) . "</option>";
				}
				?>
			</select>
		</td>
	</tr>
	<tr valign="top" class="authorize-paysets">
		<th scope="row" style="padding-bottom:20px"></th>
		<td style="padding-bottom:20px">
			<label for="stms_authorize_arb"><input type="checkbox" name="stms_sets[authorize][arb]" id="stms_authorize_arb" value="1" <?php if ( stms_isset($stms['payments']['authorize']['arb']) == 1 ) echo 'checked="checked"'; ?> /> <code>Yes, I have Auto-Recurring Billing (ARB) activated</code></label><br />
			<label for="stms_authorize_ccv"><input type="checkbox" name="stms_sets[authorize][ccv]" id="stms_authorize_cvv" value="1" <?php if ( stms_isset($stms['payments']['authorize']['ccv']) == 1 ) echo 'checked="checked"'; ?> /> <code>Require customers to enter CVV/CVV2 code</code></label><br />
			<label for="stms_authorize_avs"><input type="checkbox" name="stms_sets[authorize][avs]" id="stms_authorize_avs" value="1" <?php if ( stms_isset($stms['payments']['authorize']['avs']) == 1 ) echo 'checked="checked"'; ?> /> <code>Require customers to enter billing address (AVS)</code></label><br />
			<label for="stms_authorize_test"><input type="checkbox" name="stms_sets[authorize][test]" id="stms_authorize_test" value="1" <?php if ( stms_isset($stms['payments']['authorize']['test']) == 1 ) echo 'checked="checked"'; ?> /> <code>Enable Authorize.net Sandbox Mode</code></label><br />
		</td>
	</tr>
	</table>
<?php
}

add_action('stms_ipn_authorize', 'stms_authorize_ipn_handler');
function stms_authorize_ipn_handler() {
	$stms = get_option('stms_settings');
	// Sanitize incoming data
	$post = $_REQUEST;
	
	if ( strtolower($post['x_type']) == 'void' || strtolower($post['x_type']) === 'credit' ) { // refund
		$trans_id  = $post['x_trans_id'];
		if ( !$tx_id = stms_authorize_get_id($trans_id) )
			stms_error_handler('Cannot find transaction id to process refund.');
			
		$payment = stms_get_payment($tx_id);
		if ( $payment->status == 'completed' && $payment->paid == 1 ) {
			stms_refund_payment($tx_id);
		}
	}
	
	// Only process silent post for ARB transactions
	if ( isset($post['x_subscription_id']) ) {
		// verify data
		$subscr_id = $post['x_subscription_id'];
		$hash_value = stms_sanitize($stms['payments']['authorize']['secret'], '', true);
		$trans_id = $post['x_trans_id'];
		$amount = $post['x_amount'];
		$md5_hash = strtoupper(md5($hash_value . $trans_id . $amount));
		
		if ( $post['x_MD5_Hash'] != $md5_hash )
			stms_error_handler("Authorize.Net silent post validation failed. Received:{$post['x_MD5_Hash']}; Expected: {$md5_hash}", 0, $subscr_id, 'ipn');
	
		if ( !$tx_id = stms_authorize_last_id($subscr_id) )
			stms_error_handler('Cannot find transaction record for this Silent Post', 0, $subscr_id, 'ipn');
		
		$payment = stms_get_payment($tx_id);
		
		// Get the response code. 1 is success, 2 is decline, 3 is error
    	$response_code = $post['x_response_code'];
 
	    // Get the reason code. 8 is expired card.
	    $reason_code = $post['x_response_reason_code'];
		
		// set previous payment to expired...
		$new_data = array();
		$new_data['status'] = 'expired';
		stms_update_payment($tx_id, $new_data );
		wp_cache_delete($payment->member_id, 'stms_member_payments'); // delete cache
		
		if ( $response_code == 1 ) { // rebill
			$args = array(
				'product_id' => $payment->product_id,
				'member_id'=> $payment->member_id,
				'aff_id' => $payment->aff_id,
				'payment_type' => 'recurr',
				'paysys'=> 'authorize',
				'receipt'=> $subscr_id,
				'currency'=> $payment->currency,
				'amount'=> $amount,
				'discount' => 0.00,
				'txn_id' => $trans_id,
				'paid'=> 1,
				'is_rebill' => 1,
				'status'=> 'completed',
				'date'=> stms_time(),
				'expired_date'=> stms_get_expired($payment->product_id, false)
			);
				
			$new_tx_id = stms_add_payment($args);
		}
	}
	exit;
}

function stms_authorize_last_id( $subscr_id ) {
    global $wpdb;
	$last = $wpdb->get_row(
		$wpdb->prepare(
			"SELECT `tx_id` FROM `{$wpdb->prefix}stms_transactions`
			WHERE `receipt` = %s AND `status` = %s
			ORDER BY `tx_id` DESC LIMIT 1",
			$subscr_id, 'completed'
		)
	);
	if ( !$last ) return false;
    return $last->tx_id;
}

function stms_authorize_get_id( $trans_id ) {
    global $wpdb;
	$last = $wpdb->get_row("SELECT `tx_id` FROM `{$wpdb->prefix}stms_transactions`
			WHERE `receipt` = '{$trans_id}' OR `txn_id` = '{$trans_id}'
			ORDER BY `tx_id` DESC LIMIT 1");
	if ( !$last ) return false;
    return $last->tx_id;
}