<?php
/*
Payment Name: 2Checkout
Payment Key: twocheckout
One Time: yes
Recurring: yes
Flow Type: normal
*/

add_action('stms_global_payment_twocheckout', 'stms_twocheckout_global_settings');
function stms_twocheckout_global_settings($stms) {
	$twoco_secret = ( stms_isset($stms['payments']['twocheckout']['secret']) != '' ) ? trim($stms['payments']['twocheckout']['secret']) : stms_generate_secret(10, false, true);
?>
	<table class="form-table">
	<tr valign="top">
		<th scope="row"><label style="cursor:default"><strong>Enable 2Checkout</strong></label></th>
		<td>
			<div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[is_twocheckout]" id="stms_pay_twocheckout" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="twoco-paysets" value="1" <?php if ( stms_isset($stms['payments']['is_twocheckout']) == 1 ) echo 'checked="checked"'; ?> />
		</td>
	</tr>
	<tr valign="top" class="twoco-paysets">
		<th scope="row" style="text-align:right"><label for="stms_twocheckout_id"><?php _e('2CO Account ID#', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" name="stms_sets[twocheckout][id]" id="stms_twocheckout_id" value="<?php echo stms_isset($stms['payments']['twocheckout']['id']); ?>" />
		</td>
	</tr>
	<tr valign="top" class="twoco-paysets">
		<th scope="row" style="text-align:right"><label for="stms_twocheckout_secret"><?php _e('2CO Secret Word', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" name="stms_sets[twocheckout][secret]" id="stms_twocheckout_secret" value="<?php echo $twoco_secret; ?>" />
			<div class="stms-desc">Please enter this secret phrase in your 2CO account (<code>Account -> Site Management -> Secret Word</code>). <strong>Important:</strong> The secret word value MUST be the same as in your 2CO account.</div>
		</td>
	</tr>
	<!--
	<tr valign="top" class="twoco-paysets">
		<th scope="row" style="text-align:right"><label for="stms_twocheckout_apiuser"><?php _e('2CO API Username', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" name="stms_sets[twocheckout][apiuser]" id="stms_twocheckout_apiuser" value="<?php echo stms_isset($stms['payments']['twocheckout']['apiuser']); ?>" />
		</td>
	</tr>
	<tr valign="top" class="twoco-paysets">
		<th scope="row" style="text-align:right"><label for="stms_twocheckout_pass"><?php _e('2CO Password', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="password" name="stms_sets[twocheckout][pass]" id="stms_twocheckout_pass" value="<?php echo stms_isset($stms['payments']['twocheckout']['pass']); ?>" />
		</td>
	</tr>
	-->
	<tr valign="top" class="twoco-paysets">
		<th scope="row" style="text-align:right"><label><?php _e('INS URL', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" value="<?php echo stms_get_ipnurl('twocheckout'); ?>" readonly />
			<div class="stms-desc">Please enter this INS URL in your 2CO account (under <code>Notifications -> Settings -> INS URL</code>)</div>
		</td>
	</tr>
	<tr valign="top" class="twoco-paysets">
		<th scope="row" style="text-align:right; padding-bottom:20px"><label><?php _e('Approved URL', 'stms'); ?></label></th>
		<td style="padding-bottom:20px">
			<input class="widefat stms-field" type="text" value="<?php echo stms_get_returnurl('twocheckout', true); ?>" readonly />
			<div class="stms-desc">Login to your 2CO account and go to <code>Account -> Site Management</code>. Enter the return URL specify here into the <code>Approved URL</code> setting, and set the <code>Direct Return</code> to "Header Redirect"</div>
		</td>
	</tr>
	<tr valign="top" class="twoco-paysets">
		<th scope="row" style="text-align:right; padding-bottom:20px"><label for="stms_twocheckout_demo"><?php _e('Enable 2Checkout Demo Mode', 'stms'); ?></label></th>
		<td style="padding-bottom:20px"><span class='stms-fancy-chkbox'></span><input type="checkbox" name="stms_sets[twocheckout][demo]" id="stms_twocheckout_demo" class="stms-chkbox" value="1" <?php if ( stms_isset($stms['payments']['twocheckout']['demo'], 0) == 1 ) echo 'checked="checked"'; ?> /></td>
	</tr>
	</table>
<?php
}

add_action('stms_ipn_twocheckout', 'stms_twocheckout_ipn_handler');
function stms_twocheckout_ipn_handler() {
	$stms = get_option('stms_settings');
	
	// Sanitize incoming data
	$post = array();
	foreach ( $_POST as $k => $v ) {
        $v = stripslashes(rawurldecode($v));
        $post[$k] = $v;
    }
	
	$txn_type = stms_sanitize($post['message_type']);
	$invoice = stms_sanitize($post['vendor_order_id']);
	$sale_id = stms_sanitize($post['sale_id']);
	$vendor_id = stms_sanitize($post['vendor_id']);
	$invoice_id = stms_sanitize($post['invoice_id']);
	
	// Let's validate the IPN first...
	$seller_id = stms_sanitize($stms['payments']['twocheckout']['id']);
	$secret_word = stms_sanitize($stms['payments']['twocheckout']['secret']);
	$md5_hash = strtoupper(md5($sale_id . $vendor_id . $invoice_id . $secret_word));
	
	if ( $md5_hash != $post['md5_hash'] )
		stms_error_handler('2Checkout INS validation failed.', 0, $post['sale_id'], 'ipn');
	
	// vendor checking
	if ( $seller_id != $post['vendor_id'] )
		stms_error_handler('2Checkout INS validation failed.', 0, $post['sale_id'], 'ipn');
	
	switch ( $txn_type ) {
		case 'ORDER_CREATED':
			// Do nothing... Let this handle by return script...
			break;
			
		case 'REFUND_ISSUED':
			$item_name = stms_sanitize($post['item_name_1']);
			$product = false;
			$member_id = 0;
			if ( $tx_id = stms_twocheckout_last_id($invoice) ) {
				$payment = stms_get_payment($tx_id);
				$product = stms_get_product($payment->product_id);
				$member_id = $payment->member_id;
			} else {
				if ( $product = stms_get_product_bytitle($item_name) ) {
					if ( $payment = stms_twocheckout_find_payment($sale_id, $product->ID) ) {
						$member_id = $payment->member_id;
					}
				}
			}
			
			if ( $product && $member_id > 0 ) {
				if ( $payments = stms_get_member_payments($member_id) ) {
					foreach ( $payments as $paid ) {
	                    if ( $paid->product_id == $payment->product_id && $paid->status == 'completed' ){
	                        stms_refund_payment($paid->tx_id);
	                    }
	                }
				}
				
			}
            break;
			
        case 'RECURRING_INSTALLMENT_SUCCESS':
			$item_name = stms_sanitize($post['item_name_1']);
			$product = false;
			$member_id = 0;
			if ( $tx_id = stms_twocheckout_last_id($invoice) ) {
				$payment = stms_get_payment($tx_id);
				$product = stms_get_product($payment->product_id);
				$member_id = $payment->member_id;
			} else {
				if ( $product = stms_get_product_bytitle($item_name) ) {
					if ( $payment = stms_twocheckout_find_payment($sale_id, $product->ID) ) {
						$member_id = $payment->member_id;
					}
				}
			}
			
			if ( $product && $member_id > 0 ) {
				if ( $payment ) {
					$new_data = array();
					$new_data['status'] = 'expired';
					$new_data['expired_date'] = strtotime("5 minutes ago", stms_time());
					stms_update_payment($payment->tx_id, $new_data);
					wp_cache_delete($payment->member_id, 'stms_member_payments'); // delete cache
				}
				
				$args = array(
					'product_id' => $product->ID,
					'member_id'=> $member_id,
					'aff_id' => stms_isset($payment->aff_id, 0),
					'payment_type' => 'recurr',
					'paysys' => 'twocheckout',
					'receipt' => $sale_id,
					'currency' => stms_isset($stms['global']['currency'], 0),
					'amount' => $product->price,
					'paid'=> 1,
					'is_rebill' => 1,
					'status'=> 'completed',
					'date'=> stms_time(),
					'expired_date'=> stms_get_expired($product->ID, false)
				);
				$new_tx_id = stms_add_payment($args);
				
				// log the ipn for further usage...
				$ipn = stms_log_ipn($post, $new_tx_id, 'twocheckout', 1, $member_id, $sale_id);
				exit;
			}
            break;
			
        case 'RECURRING_STOPPED':
            $item_name = stms_sanitize($post['item_name_1']);
			$product = false;
			$member_id = 0;
			if ( $tx_id = stms_twocheckout_last_id($invoice) ) {
				$payment = stms_get_payment($tx_id);
				$product = stms_get_product($payment->product_id);
				$member_id = $payment->member_id;
			} else {
				if ( $product = stms_get_product_bytitle($item_name) ) {
					if ( $payment = stms_twocheckout_find_payment($sale_id, $product->ID) ) {
						$member_id = $payment->member_id;
					}
				}
			}
			
			if ( $payment ) {
				$new_data = array();
				$new_data['status'] = 'cancelled';
				stms_update_payment($payment->tx_id, $new_data);
				wp_cache_delete($payment->member_id, 'stms_member_payments'); // delete cache
        	
				do_action('stms_subscr_cancelled', $payment->tx_id);
				exit;
			}
        	break;
			
		case 'RECURRING_RESTARTED':
            $item_name = stms_sanitize($post['item_name_1']);
			$product = false;
			$member_id = 0;
			if ( $tx_id = stms_twocheckout_last_id($invoice) ) {
				$payment = stms_get_payment($tx_id);
				$product = stms_get_product($payment->product_id);
				$member_id = $payment->member_id;
			} else {
				if ( $product = stms_get_product_bytitle($item_name) ) {
					if ( $payment = stms_twocheckout_find_payment($sale_id, $product->ID) ) {
						$member_id = $payment->member_id;
					}
				}
			}
			
			if ( $payment ) {
				$new_data = array();
				$new_data['status'] = 'completed';
				stms_update_payment($payment->tx_id, $new_data);
				wp_cache_delete($payment->member_id, 'stms_member_payments'); // delete cache
				exit;
			}
            break;
			
        case 'RECURRING_COMPLETE':
			$item_name = stms_sanitize($post['item_name_1']);
			$product = false;
			$member_id = 0;
			if ( $tx_id = stms_twocheckout_last_id($invoice) ) {
				$payment = stms_get_payment($tx_id);
				$product = stms_get_product($payment->product_id);
				$member_id = $payment->member_id;
			} else {
				if ( $product = stms_get_product_bytitle($item_name) ) {
					if ( $payment = stms_twocheckout_find_payment($sale_id, $product->ID) ) {
						$member_id = $payment->member_id;
					}
				}
			}
			
			if ( $payment ) {
				$new_data = array();
				$new_data['expired_date'] = strtotime("19 Jan 2038", stms_time());
				stms_update_payment($payment->tx_id, $new_data);
				wp_cache_delete($payment->member_id, 'stms_member_payments'); // delete cache
				exit;
			}
			break;
			
		case 'RECURRING_INSTALLMENT_FAILED':
		case 'FRAUD_STATUS_CHANGED' :
        case 'SHIP_STATUS_CHANGED' :
        case 'INVOICE_STATUS_CHANGED':
            // do nothing...
			break;
        
	}
	exit;
}

function stms_twocheckout_find_payment( $receipt, $product_id ) {
	global $wpdb;
	
	$sql = "SELECT * FROM `{$wpdb->prefix}stms_transactions`
			WHERE `receipt` = '{$receipt}' ORDER BY `tx_id` DESC";
			
	if ( !$payments = $wpdb->get_results($sql) )
		return false;
	
	if ( count($payments) == 1 )
		return $payments[0];
	
	foreach ( $payments as $payment ) {
		if ( $product_id == $payment->product_id )
			return $payment;
	}
	return false;
}

function stms_twocheckout_last_id( $first_tx_id ) {
    global $wpdb;
    if ( !$paid = stms_get_payment($first_tx_id) )
		return 0;
	
    $tx_id = $paid->tx_id;
	$last = $wpdb->get_row(
		$wpdb->prepare(
			"SELECT `tx_id` FROM `{$wpdb->prefix}stms_transactions`
			WHERE `product_id` = %d AND `member_id` = %d
			ORDER BY `tx_id` DESC LIMIT 1",
			$paid->product_id, $paid->member_id
		)
	);
	if ( !$last ) return 0;
    return $last->tx_id;
}

add_action('stms_validate_thanks_twocheckout', 'stms_twocheckout_thanks_handler');
function stms_twocheckout_thanks_handler( $tx_id ) {
	if ( $_GET['processor']!= 'twocheckout' )
		return false;

	// Sanitize incoming data
	$post = array();
	foreach ( $_REQUEST as $k => $v ) {
        $v = stripslashes(rawurldecode($v));
        $post[$k] = $v;
    }
	
	$is_upsell = false;
	$order_id = $post['merchant_order_id'];
	if ( function_exists('sflow_get_cart_items') ) {
		$items = sflow_get_cart_items($order_id);
		if ( $items )
			$is_upsell = true;
	}

	if ( !$is_upsell ) {
		if ( (($order_id != $tx_id)) || !($payment = stms_get_payment($order_id)) )
			wp_die('Payment ERROR: Transaction ID or data not found.');
	
		if ( $payment->status == 'completed' && $payment->paid == 1 )
			wp_die('Payment ERROR: Transaction ID or data not found.');
		
		if ( !$product = stms_get_product($payment->product_id) ) 
			wp_die('Payment ERROR: Purchased product not found.');
	}

	$stms = get_option('stms_settings');
	$secret_word = trim(stms_isset($stms['payments']['twocheckout']['secret']));
	
	// 2CO Validation
	$seller_id = $post['sid'];
	if ( $seller_id != stms_sanitize($stms['payments']['twocheckout']['id']) )
		wp_die('Payment validation failed. Wrong 2CO Seller ID.');
	
	$order_number = $post['order_number'];
	$order_total = $post['total'];
	$invoice_id = $post['invoice_id'];
	
	$orig_key = $post['key'];
	if ( stms_isset($stms['payments']['twocheckout']['demo'], 0) == 1 )
		$order_number = '1';
			
	$md5_key = strtoupper(md5($secret_word . $seller_id . $order_number . $order_total));
	if ( $orig_key != $md5_key )
		wp_die('Payment validation failed. Unknown transaction key.');
	
	if ( $is_upsell && $items ) {
		foreach ( $items as $item ) {
			if ( $py = stms_get_payment($item->tx_id) ) {
				$args = array(
					'product_id' => $py->product_id,
					'member_id' => $py->member_id,
					'payment_type' => $py->payment_type,
					'paysys' => 'twocheckout',
					'receipt' => $post['order_number'],
					'txn_id' => $post['invoice_id'],
					'paid' => 1,
					'is_rebill' => 0,
					'status' => 'completed',
					'expired_date' => stms_get_expired($py->product_id, true),
				);
				$u_tx_id = stms_complete_payment($py->tx_id, $args);
				do_action('stms_custom_autoresponder', $py->tx_id); // for custom autoresponder...
			}
		}
		
		$thanks_url = stms_format_url($stms['global']['magic'], 'insta_mode=all_access&flow_id=' . $order_id);
		wp_redirect($thanks_url);
		exit;
	}
	
	$full_name = stms_isset($post['card_holder_name']);
	$parts = explode(" ", $full_name);
	$check = get_transient('stms_payment_check_' . $tx_id);
	if ( stms_isset($check['acc_type']) == 'temp' && stms_isset($product->info['steps']) == '2,1' && stms_isset($product->info['auto_register']) == 1 )
		$payment->member_id = stms_auto_register_customer($tx_id, $post['email'], stms_isset($parts[0]), stms_isset($parts[1]));
	
	$args = array(
		'product_id' => $payment->product_id,
		'member_id' => $payment->member_id,
		'payment_type' => $product->type,
		'aff_id' => $payment->aff_id,
		'paysys' => 'twocheckout',
		'receipt' => $post['order_number'],
		'currency' => $payment->currency,
		'amount' => $post['total'],
		'txn_id' => $post['invoice_id'],
		'paid' => 1,
		'is_rebill' => 0,
		'status' => 'completed',
		'expired_date' => stms_get_expired($payment->product_id, true),
	);
	stms_complete_payment($tx_id, $args);
	do_action('stms_custom_autoresponder', $tx_id); // for custom autoresponder...
	
	@setcookie('__insta_payment', 0, stms_time()-60*60*24, SITECOOKIEPATH);
	if ( SITECOOKIEPATH != COOKIEPATH )
		@setcookie('__insta_payment', 0, stms_time()-60*60*24, COOKIEPATH);
	
	// Payment success... proceed to next step
	$home_url = ( !empty($product->home_id) ) ? get_permalink($product->home_id) : '';
	$redirect_url = ( filter_var($product->info['thankuri'], FILTER_VALIDATE_URL) ) ? $product->info['thankuri'] : $home_url;
	if ( $redirect_url == '' )
		$redirect_url = ( !empty($stms['global']['home']) ) ? get_permalink($stms['global']['home']) : get_bloginfo('siteurl');
			
	if ( $product->info['steps'] == '2,1' ) {
		if ( stms_isset($check['acc_type']) == 'real' ) {
			if ( isset($_COOKIE['__insta_flow']) ) {
				$flow_id = urldecode($_COOKIE['__insta_flow']);
				do_action('insta_upsells_redirect', $flow_id, $product->ID, 'twocheckout', $payment->member_id);
			}
			wp_redirect($redirect_url);
			exit;
		}
		
		if ( stms_isset($product->info['auto_register']) == 1 ) {
			$temp_member_id = stms_get_current_member_id();
			if ( $temp_member_id != $payment->member_id ) {
				stms_delete_member($temp_member_id, false);
			}
			stms_clear_auth_cookie(); // logged out the member first...
			stms_set_auth_cookie($payment->member_id); // re-logging in member...
			if ( isset($_COOKIE['__insta_flow']) ) {
				$flow_id = urldecode($_COOKIE['__insta_flow']);
				do_action('insta_upsells_redirect', $flow_id, $product->ID, 'twocheckout', $payment->member_id);
			}
			wp_redirect($redirect_url);
			exit;
		} else {
			if ( isset($_COOKIE['__insta_flow']) ) {
				$flow_id = urldecode($_COOKIE['__insta_flow']);
				do_action('insta_upsells_redirect', $flow_id, $product->ID, 'twocheckout', $payment->member_id);
			}
			
			if ( is_stmsmember_logged_in() ) stms_clear_auth_cookie();
			
			// proceed to registration
			$session = base64_encode("{$product->ID}|twocheckout|direct");
			$insta_token = stms_generate_secret(16, true, true );
			$token_data = array( 'token' => $insta_token, 'tx_id' => $payment->tx_id);
			set_transient('insta_token_' . $insta_token, $token_data, 60*60);
			$_reg_url = stms_get_handler_url('registration');
			$reg_url = stms_format_url($_reg_url, 'key=' . $session . '&insta_token=' . $insta_token);
			wp_redirect($reg_url);
		}
	} else {
		if ( isset($_COOKIE['__insta_flow']) ) {
			$flow_id = urldecode($_COOKIE['__insta_flow']);
			do_action('insta_upsells_redirect', $flow_id, $product->ID, 'twocheckout');
		}
		
		wp_redirect($redirect_url);
	}
	exit;
}

function stms_twocheckout_get_recurrence( $num, $mode ) {
	switch ( $mode ) {
		case 'd':
			$int_length = number_format($num/7);
			$int_unit = ' Week';
			break;
			
		case 'w':
			$int_length = intval($num);
			$int_unit = ' Week';
			break;
		
		case 'm':
			$int_length = intval($num);
			$int_unit = ' Month';
			break;
			
		case 'y':
			$int_length = 12;
			$int_unit = ' Year';
			break;
	}
	return $int_length . $int_unit;
}

function stms_twocheckout_get_duration( $num, $mode, $times ) {
	if ( empty($times) )
		return 'Forever';
	 
	switch ( $mode ) {
		case 'd':
			$int_length = number_format($num/7);
			$int_unit = ' Week';
			break;
			
		case 'w':
			$int_length = intval($num);
			$int_unit = ' Week';
			break;
		
		case 'm':
			$int_length = intval($num);
			$int_unit = ' Month';
			break;
			
		case 'y':
			$int_length = 12;
			$int_unit = ' Year';
			break;
	}
	
	$length = $int_length * $times;
	return $length . $int_unit;
}

add_action('insta_flow_checkout_twocheckout', 'stms_twocheckout_upsell_checkout');
function stms_twocheckout_upsell_checkout( $flow_id ) {
	$stms = get_option('stms_settings');
	$sflow = get_option('stms_sales_flow');
	$flow = stms_isset($sflow[$flow_id]);
	$front_id = stms_isset($flow['front_id']);
	$currency = stms_isset($stms['global']['currency'], 'USD');
	$seller_id = stms_sanitize($stms['payments']['twocheckout']['id'], '', true);
	$secret_key = stms_sanitize($stms['payments']['twocheckout']['secret'], '', true);
	$home_url = get_bloginfo('url');
	
	if ( !$member_id = stms_get_current_member_id() ) {
		wp_redirect($home_url);
		exit;
	}
	
	if ( empty($seller_id) || empty($secret_key) )
		wp_die('Configuration Error: Missing parameters for 2CO integration.');
	
	if ( !$items = sflow_get_cart_items($flow_id) )
		wp_die('ERROR: No items found in the shopping cart.');
	
	$qry_str = array(
	    'sid' => $seller_id,
	    'mode' => '2CO',
		'currency_code' => $currency,
	    'merchant_order_id' => $flow_id,
	    'fixed' => 'Y',
	    'x_Receipt_Link_URL' => stms_get_returnurl('twocheckout', true)
	);
	
	if ( stms_isset($stms['payments']['twocheckout']['demo'], 0) == 1 )
		$qry_str['demo'] = 'Y'; 
	
	$i = 0;
	foreach ( $items as $item ) {
		if ( $pr = stms_get_product($item->product_id) ) {
			$qry_str["li_{$i}_type"] = 'product';
		    $qry_str["li_{$i}_product_id"] = $pr->ID;
		    $qry_str["li_{$i}_quantity"] = 1;
		    $qry_str["li_{$i}_name"] = stms_cleanup($pr->title);
		    $qry_str["li_{$i}_price"] = $pr->price;
		    $qry_str["li_{$i}_tangible"] = 'N';
			
			if ( $pr->type == 'recurr' ) {
				$dur = maybe_unserialize($pr->duration);
				$recurrence = stms_twocheckout_get_recurrence($dur['num'], $dur['mode']);
		
				$qry_str["li_{$i}_recurrence"] = $recurrence;
				if ( $pr->is_trial == 1 ) {
					if ( $pr->t_price > $pr->price )
						wp_die("ERROR: When using 2CO, trial price MUST be less or equal the normal price (product:" . stms_cleanup($pr->title) . ")");
					
					$startup_fee = ( $pr->t_price <= 0 ) ? number_format($pr->price, 2) : number_format($pr->price - $pr->t_price, 2);
					$qry_str["li_{$i}_startup_fee"] = -$startup_fee;
				}

				$qry_str["li_{$i}_duration"] = stms_twocheckout_get_duration($dur['num'], $dur['mode'], $pr->rebill_times);
			}
			$i++;
		}
	}
	
	$payment_url = 'https://www.2checkout.com/checkout/purchase?' . http_build_query($qry_str);
	@header('Location:' . $payment_url);
	exit;
}

add_action('stms_payment_proceed_twocheckout', 'stms_twocheckout_proceed_handler');
function stms_twocheckout_proceed_handler( $tx_id ) {
	if ( !$payment = stms_get_payment($tx_id) )
		return false;
	
	if ( $payment->paysys != 'twocheckout' )
		return false;
	
	$payment_url = stms_format_url(get_bloginfo('siteurl'), 'insta_mode=payment_redirect&trans_id=' . $tx_id);
	wp_redirect($payment_url);
	exit;
}

add_action('stms_payment_redirect_head', 'stms_twocheckout_redirect_handler');
function stms_twocheckout_redirect_handler($payment) {
	if ( !is_object($payment) || $payment->paysys != 'twocheckout' )
		return false;
	
	global $wpdb;
	
	$stms = get_option('stms_settings');
	$currency = stms_isset($stms['global']['currency'], 'USD');
	$seller_id = stms_sanitize($stms['payments']['twocheckout']['id'], '', true);
	$secret_key = stms_sanitize($stms['payments']['twocheckout']['secret'], '', true);
	
	if ( empty($seller_id) || empty($secret_key) )
		wp_die('Configuration Error: Missing parameters for 2CO integration.');
	
	if ( !$product = stms_get_product($payment->product_id) )
		wp_die('Configuration Error: Product Not Found.');
	
	$check = get_transient('stms_payment_check_' . $payment->tx_id);
	$price = ( $product->type == 'recurr' && $product->is_trial == 1 ) ? $product->price : stms_isset($check['amount'], $product->price);
	if ( $product->type == 'recurr' && $product->is_trial != 1 && $price != $product->price ) {
		$discounted_price = stms_isset($check['amount'], $product->price);	
		$price = $product->price;
	}
	
	$qry_str = array(
	    'sid' => $seller_id,
	    'mode' => '2CO',
	    'li_0_type' => 'product',
	    'li_0_product_id' => $product->ID,
	    'li_0_quantity' => 1,
	    'li_0_name' => stms_cleanup($product->title),
	    'li_0_price' => $price,
	    'li_0_tangible' => 'N',
		'currency_code' => ( !empty($currency ) ) ? $currency : 'USD',
	    'merchant_order_id' => $payment->tx_id,
	    'fixed' => 'Y',
	    'x_Receipt_Link_URL' => stms_get_returnurl('twocheckout', true)
	);
	
	if ( stms_isset($stms['payments']['twocheckout']['demo'], 0) == 1 )
		$qry_str['demo'] = 'Y'; 
		
	if ( $product->type == 'recurr' ) {
		$dur = maybe_unserialize($product->duration);
		$recurrence = stms_twocheckout_get_recurrence($dur['num'], $dur['mode']);
		$qry_str['li_0_recurrence'] = $recurrence;
		if ( $product->is_trial == 1 ) {
			if ( $product->t_price > $product->price )
				wp_die("ERROR: When using 2CO, trial price MUST be less or equal the normal price (product:" . stms_cleanup($product->title) . ")");
			
			$startup_fee = ( $product->t_price == 0.00 ) ? number_format($product->t_price, 2) : number_format($product->price - $product->t_price, 2);
			$startup_fee = number_format($startup_fee - stms_isset($check['discount'], 0.00), 2);
			$qry_str["li_0_startup_fee"] = -$startup_fee;
		}
		
		if ( isset($discounted_price) ) {
			$startup_fee = number_format($price - $discounted_price, 2);
			$qry_str["li_0_startup_fee"] = -$startup_fee;
		}
		
		$qry_str['li_0_duration'] = stms_twocheckout_get_duration($dur['num'], $dur['mode'], $product->rebill_times);
	}
	
	$payment_url = 'https://www.2checkout.com/checkout/purchase?' . http_build_query($qry_str);
	echo '<meta http-equiv="refresh" content="2;URL=\'' . $payment_url . '\'" />';
}