<?php
/*
Payment Name: E-Junkie
Payment Key: ejunkie
One Time: yes
Recurring: no
Flow Type: normal
*/

add_action('stms_thirdpay_settings_ejunkie', 'stms_ejunkie_product_settings', 10, 2);
function stms_ejunkie_product_settings($product, $pay_settings) {
?>
	<tr valign="top" class="stms-ejunkie-level stms-no-recurring-sets">
		<th scope="row" colspan="2" style="border-top:1px solid #E5E5E5"><h3 style="color:#808080"><?php _e('E-Junkie Product Integration Settings', 'stms'); ?></h3></th>
	</tr>
	<tr valign="top" class="stms-ejunkie-level stms-no-recurring-sets">
		<th scope="row" style="text-align:right"><label for="stms_ejunkie_item"><strong><span style="color:#cc0000">*</span> <?php _e('Item Number', 'stms'); ?></strong></label></th>
		<td>
			<input class="stms-field" type="text" name="stms_level[pay_settings][ejunkie][item]" id="stms_ejunkie_item" value="<?php echo stms_cleanup(stms_isset($pay_settings['ejunkie']['item'])); ?>" style="width:80px" />
			<div class="stms-desc">Please enter the Item Number of your E-Junkie Product.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-ejunkie-level stms-no-recurring-sets">
		<th scope="row" style="text-align:right"><label for="stms_ejunkie_url"><strong><span style="color:#cc0000">*</span> <?php _e('Redirection URL', 'stms'); ?></strong></label></th>
		<td>
			<input class="stms-field widefat" type="text" id="stms_ejunkie_url" value="<?php echo stms_get_returnurl('ejunkie', false, true, $product->ID); ?>" readonly />
			<div class="stms-desc">Add/edit the product in your E-Junkie account, then please check the <code>Redirection</code> option -> click <code>More Options</code> button -> enter this URL in the <code>Redirection URL</code> field.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-ejunkie-level stms-no-recurring-sets">
		<th scope="row" style="text-align:right"><label for="stms_ejunkie_ipn"><strong><span style="color:#cc0000">*</span> <?php _e('Payment Variable URL', 'stms'); ?></strong></label></th>
		<td>
			<input class="stms-field widefat" type="text" id="stms_ejunkie_ipn" value="<?php echo stms_get_ipnurl('ejunkie') . '&insta_id=' . $product->ID; ?>" readonly />
			<div class="stms-desc">Add/edit the product in your E-Junkie account, then please check the <code>Send transaction data to a URL</code> option -> click <code>More Options</code> button -> enter this URL in the <code>Payment Variable Information URL</code> field.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-ejunkie-level stms-no-recurring-sets">
		<th scope="row" style="text-align:right"><label for="stms_ejunkie_payurl"><?php _e('E-Junkie Payment URL', 'stms'); ?></label></th>
		<td>
			<input class="stms-field widefat" type="text" name="stms_level[pay_settings][ejunkie][payurl]" id="stms_ejunkie_payurl" value="<?php echo stms_sanitize($pay_settings['ejunkie']['payurl']); ?>" />
			<div class="stms-desc">This is required only if you use the "Auto-Switch" payment button feature. Simply enter the payment URL generated by E-Junkie here. If you're not using the "Auto-Switch" payment feature, then you can leave this empty.</div>
		</td>
	</tr>
	
	<tr valign="top" class="stms-ejunkie-level stms-no-recurring-sets stms-last-integrate">
		<th scope="row" colspan="2"></th>
	</tr>
<?php
}

add_action('stms_global_payment_ejunkie', 'stms_ejunkie_global_settings');
function stms_ejunkie_global_settings($stms) {
?>
	<table class="form-table">
	<tr valign="top">
		<th scope="row"><label style="cursor:default"><strong>Enable E-Junkie</strong></label></th>
		<td><div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[is_ejunkie]" id="stms_pay_ejunkie" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="ejunkie-paysets" value="1" <?php if ( stms_isset($stms['payments']['is_ejunkie']) == 1 ) echo 'checked="checked"'; ?> /></td>
	</tr>
	<tr valign="top" class="ejunkie-paysets">
		<th scope="row" style="text-align:right"></th>
		<td>
			<div class="stms-error-msg">
				<p><strong>Important:</strong> You can use E-Junkie payment system to sell One-Time products ONLY. Currently, InstaMember have no integration support to process subscription/recurring payments for E-Junkie.</p>
			</div>
		</td>
	</tr>
	<tr valign="top" class="ejunkie-paysets">
		<th scope="row" style="text-align:right"><label for="stms_ejunkie_id"><?php _e('E-Junkie Client Account ID#', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" name="stms_sets[ejunkie][id]" id="stms_ejunkie_id" value="<?php echo stms_isset($stms['payments']['ejunkie']['id']); ?>" />
			<div class="stms-desc">Please enter your E-Junkie client account ID here. You can obtain this in your E-Junkie account (under <code>Seller Admin -> View Account Summary</code>)</div>
		</td>
	</tr>
	<tr valign="top" class="ejunkie-paysets">
		<th scope="row" style="text-align:right"><label for="stms_ejunkie_email"><?php _e('Your E-Junkie Login Email', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" name="stms_sets[ejunkie][email]" id="stms_ejunkie_email" value="<?php echo stms_isset($stms['payments']['ejunkie']['email']); ?>" />
			<div class="stms-desc">Please enter the email that you use to login to your E-Junkie account.</div>
		</td>
	</tr>
	<tr valign="top" class="ejunkie-paysets">
		<th scope="row" style="text-align:right"><label for="stms_ejunkie_pass"><?php _e('Your E-Junkie Password', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="password" name="stms_sets[ejunkie][pass]" id="stms_ejunkie_pass" value="<?php echo stms_isset($stms['payments']['ejunkie']['pass']); ?>" />
			<div class="stms-desc">Please enter the password that you use to login to your E-Junkie account.</div>
		</td>
	</tr>
	</table>
<?php
}

add_action('stms_ipn_ejunkie', 'stms_ejunkie_ipn_handler');
function stms_ejunkie_ipn_handler() {
	global $wpdb;
	
	$stms = get_option('stms_settings');
	$vars = $_REQUEST;
	
	// Let's validate the IPN first...
	$client_email = sanitize_email(trim(stms_isset($stms['payments']['ejunkie']['email'])));
	$client_pass = stms_cleanup($stms['payments']['ejunkie']['pass']);
	$expected_hash = md5($client_email . md5($client_pass));
	if ( $expected_hash != $vars['handshake'] )
		stms_error_handler('E-Junkie IPN validation failed.');
	
	$num = stms_isset($vars['item_cart_position'], '');
	$receipt = stms_isset($vars['txn_id']);
	$item = stms_sanitize($vars['item_number' . $num]);
	$title = stms_sanitize($vars['item_name' . $num]);
	$product_id = stms_isset($vars['insta_id'], 0);
	
	// customer data...
	$first_name = strtolower(stms_sanitize($vars['first_name']));
	$last_name = strtolower(stms_sanitize($vars['last_name']));
	$email = sanitize_email($vars['payer_email']);
	
	if ( !$product = stms_get_product($product_id) ) {
		if ( !$product = stms_find_product_by_externalid('ejunkie', $item) ) {
			if ( !$product = stms_get_product_bytitle($title) )
				stms_error_handler("Product not found. E-Junkie IPN Ignored.", 0, $receipt, 'ipn');
		}
	}
	
	// Create pending transaction first...
	$args = array(
		'product_id' => $product->ID,
		'member_id' => 0,
		'payment_type' => $product->type,
		'paysys' => 'ejunkie',
		'currency' => stms_isset($stms['global']['currency'], 'USD'),
		'amount' => $product->price
	);
	$tx_id = stms_add_pending_payment($args);
	
	if ( !$member_id = stms_email_exists($email) ) {
		$temp = stms_generate_temporary();
		
		$userdata = array();
		$userdata['member_id'] = 0;
		$userdata['username'] = ( stms_isset($product->info['steps']) == '2,1' && stms_isset($product->info['auto_register']) == 1 ) ? stms_generate_username($email, $first_name, $last_name) : $temp['username'];
		$userdata['password'] = wp_generate_password(8, false);
		$userdata['email'] = ( stms_isset($product->info['steps']) == '2,1' && stms_isset($product->info['auto_register']) == 1 ) ? $email : $temp['email'];
		$userdata['first_name'] = $first_name;
		$userdata['last_name'] = $last_name;
		$userdata['street'] = stms_sanitize($vars['address_street']);
		$userdata['city'] = stms_sanitize($vars['address_city']);
		$userdata['state'] = stms_isset($vars['address_state']);
		$userdata['zipcode'] = stms_sanitize($vars['address_zip']);
		$userdata['country'] = stms_isset($vars['address_country_code']);
		$userdata['status'] = ( stms_isset($product->info['auto_register']) == 1 ) ? 1 : 4;
		$userdata['is_aff'] = ( stms_isset($stms['global']['manual_aff'], 0) == 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
		$userdata['is_aff_pending'] = ( stms_isset($stms['global']['manual_aff'], 0) != 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
		
		$member_id = stms_save_member($userdata);
	}
	
	// log the ipn for further usage...
	$ipn = stms_log_ipn($vars, $tx_id, 'ejunkie', 0, $member_id, $receipt);
	
	// Found matching member... let's complete the payment...
	$args = array(
		'member_id' => $member_id,
		'paysys' => 'ejunkie',
		'receipt' => $receipt,
		'currency' => stms_isset($stms['global']['currency'], 'USD'),
		'amount' => $product->price,
		'paid' => 1,
		'status' => 'completed',
		'expired_date' => stms_get_expired($product->ID, true)
	);
	
	if ( $product->type == 'recurr' && $product->is_trial == 1 )
		$args['amount'] == $product->t_price;
	
	stms_complete_payment($tx_id, $args);
	exit;
}

//add_action('stms_validate_access_ejunkie', 'stms_ejunkie_thanks_handler');
function stms_ejunkie_thanks_handler() {
	@set_time_limit(0);

	global $wpdb;
	$product_id = intval($_GET['insta_id']);
	$stms = get_option('stms_settings');
	$rcpt = ( isset($_GET['txn_id']) ) ? stms_sanitize($_GET['txn_id']) : stms_sanitize($_GET['insta_receipt']);
	
	if ( empty($rcpt) ) {
		if ( $product = stms_get_product($product_id) ) {
			$home_url = ( !empty($product->home_id) ) ? get_permalink($product->home_id) : get_permalink($stms['global']['home']);
			wp_redirect($home_url);
			exit;
		} else {
			wp_die("ERROR: Page Not Found.");
		}
	}
	
	$support = stms_get_handler_url('support');
	if ( $ipn = stms_find_ejunkie_ipn($rcpt) ) {
		$vars = maybe_unserialize($ipn->postdata);
		if ( !$payment = stms_get_payment($ipn->tx_id) )
			wp_die('ERROR: Invalid Payment');
		
		$product = stms_get_product($payment->product_id);
		$home_url = ( !empty($product->home_id) ) ? get_permalink($product->home_id) : get_permalink($stms['global']['home']);
		$redirect_url = ( !empty($product->info['thankuri']) ) ? $product->info['thankuri'] : $home_url;
	
		if ( $ipn->status == 1 ) { // check if IPN has been processed...
			// IPN has been processed... then redirect to members download page...
			wp_redirect($home_url);
			exit;
		}
		
		$member_id = ( is_stmsmember_logged_in() ) ? stms_get_current_member_id() : $payment->member_id;
		$is_logged_in = ( is_stmsmember_logged_in() ) ? true : false;
		$is_existing = false;
		
		$temp_member = stms_member($payment->member_id);
		if ( $is_logged_in ) {
			if ( $member_id != $payment->member_id ) {
				// fix license key data ...
				$settings = stms_get_product_meta($payment->product_id, 'license');
				if ( $settings['enable'] == 1 )
					$wpdb->update("{$wpdb->prefix}stms_licenses", array('member_id' => $member_id), array('tx_id' => $payment->tx_id));
				
				// Update member id trx
				$new_data = array();
				$new_data['member_id'] = $member_id;
				stms_update_payment($payment->tx_id, $new_data);
				wp_cache_delete($payment->member_id, 'stms_member_payments'); // delete cache
				
				do_action('stms_payment_completed', $payment->tx_id); // so the receipt can be resend...
				
				if ( $temp_member->status == 4 )
					stms_delete_member($temp_member->ID, false);
			}
			$is_existing = true;
		}
		
		// Recall payment data to make sure that we use latest data...
		$payment = stms_get_payment($ipn->tx_id);
		// let's update ipn log...
		$update = $wpdb->update("{$wpdb->prefix}stms_ipn_log", array('status' => 1, 'member_id' => $payment->member_id), array('log_id' => $ipn->log_id));
		// remove retries data...
		delete_transient('stms_thanks_retries_' . $rcpt);
		
		do_action('stms_custom_autoresponder', $payment->tx_id); // for custom autoresponder...
		
		if ( $is_existing ) {
			// check and complete other payments (if any)
			stms_other_payments($member_id, $vars['payer_email'], 'ejunkie');
			
			// logging out member first...
			stms_clear_auth_cookie();
		
			// re-logging in...
			stms_set_auth_cookie($member_id);
			
			// now redirecting...
			wp_redirect($redirect_url);
			exit;
		}
		
		$first_name = stms_sanitize($vars['first_name']);
		$last_name = stms_sanitize($vars['last_name']);
			
		if ( stms_isset($product->info['auto_register']) == 1 ) {
			// update member data...
			$userdata = array();
			$userdata['member_id'] = $payment->member_id;
			$userdata['email'] = stms_isset($vars['payer_email']);
			$userdata['status'] = 1;
			$userdata['fix_username'] = stms_generate_username($vars['payer_email'], $first_name, $last_name);
			$userdata['pwd1'] = wp_generate_password(8, false);
			$userdata['first_name'] = $first_name;
			$userdata['last_name'] = $last_name;
			$userdata['is_aff'] = ( stms_isset($stms['global']['manual_aff'], 0) == 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
			$userdata['is_aff_pending'] = ( stms_isset($stms['global']['manual_aff'], 0) != 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
			
			stms_save_member($userdata, false, false, $payment->tx_id);
			
			// clean any login cookies first...
			stms_clear_auth_cookie();
			
			// logging in and then redirect...
			stms_set_auth_cookie($payment->member_id);
			wp_redirect($redirect_url);
			exit;
		} else {
			// Proceed to registration
			$session = base64_encode("{$product->ID}|ejunkie|third");
			$insta_token = stms_generate_secret(16, true, true );
			$token_data = array( 'token' => $insta_token, 'tx_id' => $payment->tx_id);
			set_transient('insta_token_' . $insta_token, $token_data, 86400);
			
			$reg_url = stms_format_url($stms['global']['magic'], 'imhandler=registration&key=' . $session . '&insta_token=' . $insta_token);
			// build reg vars...
			$reg_vars = array();
			$reg_vars['im_reg_email'] = stms_isset($vars['payer_email']);
			$reg_vars['im_reg_first_name'] = $first_name;
			$reg_vars['im_reg_last_name'] = $last_name;
			$reg_vars['im_reg_street'] = stms_sanitize($vars['address_street']);
			$reg_vars['im_reg_city'] = stms_sanitize($vars['address_city']);
			$reg_vars['im_reg_state'] = stms_sanitize($vars['address_state']);
			$reg_vars['im_reg_zipcode'] = stms_sanitize($vars['address_zip']);
			$reg_vars['im_reg_country'] = stms_isset($vars['address_country_code']);
			$auth_vars = base64_encode(json_encode($reg_vars));
			
			wp_redirect($reg_url . '&auth_vars=' . $auth_vars);
			exit;
		}
	} else {
		$retries = get_transient('stms_thanks_retries_' . $rcpt);
		$thanks_url = stms_format_url($stms['global']['magic'], http_build_query($_GET));
		if ( $retries >= 15 ) {
			$page_title = 'Payment Error';
			$refresh = '';
			$message = '
				<p style="text-align:center;"><strong>Payment Error</strong></p>
				<p>We\'re sorry, but there\'s a problem in validating your payment. Please contact our <a href="' . $support . '">support</a> to resolve this issue.</p>
			';
		} else {
			$count = $retries + 1;
			set_transient('stms_thanks_retries_' . $rcpt, $count, 60*15);
			$page_title = 'Waiting For Payment Confirmation...';
			$refresh = '<meta http-equiv="refresh" content="5;URL=\'' . $thanks_url . '\'" />';
			$message = '
				<h2 style="text-align:center;"><strong>Waiting For Payment Confirmation...</strong></h2>
				<p style="text-align:center;"><img src="' . STMS_URL . 'images/admin-loader.gif" border="0" /></p>
				<p style="text-align:center;">This page will be auto-refresh every 5 seconds until your payment confirmed.</p>
				<p style="text-align:center;"><strong>Please DO NOT close this page.</strong></p>
			';
		}
?>
<!DOCTYPE html>
<!--[if IE 6]>
<html id="ie6" <?php language_attributes(); ?>>
<![endif]-->
<!--[if IE 7]>
<html id="ie7" <?php language_attributes(); ?>>
<![endif]-->
<!--[if IE 8]>
<html id="ie8" <?php language_attributes(); ?>>
<![endif]-->
<!--[if !(IE 6) | !(IE 7) | !(IE 8)  ]><!-->
<html <?php language_attributes(); ?>>
<!--<![endif]-->
<head>
<meta charset="<?php bloginfo( 'charset' ); ?>" />
<title><?php echo $page_title; ?></title>
<?php echo $refresh; ?>
<!--[if lt IE 9]>
	<script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
<![endif]-->
<link rel="profile" href="http://gmpg.org/xfn/11" />
<meta name="HandheldFriendly" content="True" />
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<!-- Adding "maximum-scale=1" fixes the Mobile Safari auto-zoom bug: http://filamentgroup.com/examples/iosScaleBug/ -->
<link rel="stylesheet" href="http://fonts.googleapis.com/css?family=Droid+Sans" type="text/css" media="all" />
<style type="text/css">
body {
	margin:0;
	padding:0;
	font-size:14px;
	font-family:'Droid Sans', sans-serif;
	background-color:#F5F5F5;
	color:#808080;
}
#redirect_msg {
	margin:25px auto 0;
	padding:15px 20px;
	width:40%;
	background-color:#FFF;
}
</style>
</head>
<body>
<div id="redirect_msg">
	<?php echo $message; ?>
</div>
</body>
</html>
<?php
	}
	exit;
}

function stms_ejunkie_get_member_id( $email ) {
	global $wpdb;
	if ( $member = stms_get_data_by('email', $email) )
		return $member->ID;

	// let's try to find by PayPal email address
	$sql = "SELECT * FROM `{$wpdb->prefix}stms_members` WHERE `status` = 1 AND `paypal_email` = '{$email}'";
	if ( $payer = $wpdb->get_row($sql) )
		return $payer->ID;
	
	return false;
}

function stms_find_ejunkie_ipn( $receipt ) {
	global $wpdb;
	$ipn = $wpdb->get_row(
		"SELECT * FROM `{$wpdb->prefix}stms_ipn_log`
		WHERE `paysys` = 'ejunkie' AND `receipt` = '{$receipt}'"
	);
	if ( !$ipn ) return false;
	return $ipn;
}

add_filter('stms_thanks_setup_ejunkie', 'stms_ejunkie_thanks_setup');
function stms_ejunkie_thanks_setup( $settings ) {
	$settings['rcpt'] = 'txn_id';
	$settings['flow'] = 'normal';
	$settings['email_check'] = false;
	$settings['email_var'] = 'payer_email';
	$settings['firstname_var'] = 'first_name';
	$settings['lastname_var'] = 'last_name';
	return $settings;
}