<?php
/*
Payment Name: Nanacast
Payment Key: nanacast
One Time: yes
Recurring: yes
Flow Type: auto_only
*/

add_action('stms_thirdpay_settings_nanacast', 'stms_nanacast_product_settings', 10, 2);
function stms_nanacast_product_settings($product, $pay_settings) {
	$stms = get_option('stms_settings');
	$nanacast_secret = ( stms_isset($stms['payments']['nanacast']['secret']) != '' ) ? trim($stms['payments']['nanacast']['secret']) : stms_generate_secret(8, true, false, true);
?>
	<tr valign="top" class="stms-nanacast-level stms-autoreg-only-sets">
		<th scope="row" colspan="2" style="border-top:1px solid #E5E5E5"><h3 style="color:#808080"><?php _e('Nanacast Product Integration Settings', 'stms'); ?></h3></th>
	</tr>
	
	<tr valign="top" class="stms-nanacast-level stms-autoreg-only-sets">
		<th scope="row" style="text-align:right"><label for="stms_nanacast_item"><strong><span style="color:#cc0000">*</span> <?php _e('Product ID#', 'stms'); ?></strong></label></th>
		<td>
			<input class="stms-field" type="text" name="stms_level[pay_settings][nanacast][item]" id="stms_nanacast_item" value="<?php echo stms_cleanup(stms_isset($pay_settings['nanacast']['item'])); ?>" style="width:80px" />
			<div class="stms-desc">Please enter the Product ID of your Nanacast Product (usually listed under <code>Advanced API ID</code> or <code>ID used for Advanced API</code>).</div>
		</td>
	</tr>
	<tr valign="top" class="stms-nanacast-level stms-autoreg-only-sets">
		<th scope="row" style="text-align:right"><label for="stms_nanacast_url"><strong><span style="color:#cc0000">*</span> <?php _e('Thank You URL', 'stms'); ?></strong></label></th>
		<td>
			<input class="stms-field widefat" type="text" id="stms_nanacast_url" value="<?php echo stms_get_returnurl('nanacast', false, true, $product->ID); ?>" readonly />
			<div class="stms-desc">You MUST use custom thank you page and set the URL of the product you created in Nanacast to this URL, and also CHECK or ENABLE the option to pass custom variables to download/thank you page.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-nanacast-level stms-autoreg-only-sets">
		<th scope="row" style="text-align:right"><label><strong><span style="color:#cc0000">*</span><?php _e('Notification URL', 'stms'); ?></strong></label></th>
		<td>
			<input class="widefat stms-field" type="text" value="<?php echo stms_get_ipnurl('nanacast') . '&insta_id=' . $product->ID; ?>&key=<?php echo $nanacast_secret; ?>" readonly />
			<div class="stms-desc">Please enter this Notification URL by editing your product in your Nanacast account (under <code>Edit Notifications/Custom Fields</code>)</div>
		</td>
	</tr>
	<tr valign="top" class="stms-nanacast-level stms-autoreg-only-sets">
		<th scope="row" style="text-align:right"><label for="stms_nanacast_code"><?php _e('Order Form Code', 'stms'); ?></label></th>
		<td>
			<textarea class="widefat stms-field" name="stms_level[pay_settings][nanacast][code]" id="stms_nanacast_code" style="height:80px"><?php echo esc_html(stms_sanitize($pay_settings['nanacast']['code'])); ?></textarea>
			<div class="stms-desc">This is only required if you use the "Auto-Switch" payment button feature. Simply enter the form code generated by Nanacast here. If you're not using the "Auto-Switch" payment feature, then you can leave this empty.</div>
		</td>
	</tr>
	
	<tr valign="top" class="stms-nanacast-level stms-autoreg-only-sets stms-last-integrate">
		<th scope="row" colspan="2"></th>
	</tr>
<?php
}

add_action('stms_global_payment_nanacast', 'stms_nanacast_global_settings');
function stms_nanacast_global_settings( $stms ) {
	$nanacast_secret = ( stms_isset($stms['payments']['nanacast']['secret']) != '' ) ? trim($stms['payments']['nanacast']['secret']) : stms_generate_secret(8, true, false, true);
?>
	<table class="form-table">
	<tr valign="top">
		<th scope="row"><label style="cursor:default"><strong>Enable Nanacast</strong></label></th>
		<td><div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[is_nanacast]" id="stms_pay_nanacast" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="nanacast-paysets" value="1" <?php if ( stms_isset($stms['payments']['is_nanacast']) == 1 ) echo 'checked="checked"'; ?> /></td>
	</tr>
	</table>
	<input type="hidden" name="stms_sets[nanacast][secret]" value="<?php echo $nanacast_secret; ?>" />
<?php
}

add_action('stms_ipn_nanacast', 'stms_nanacast_ipn_handler');
function stms_nanacast_ipn_handler() {
	$stms = get_option('stms_settings');
	$secret = stms_sanitize($stms['payments']['nanacast']['secret']);
	$key = stms_sanitize($_REQUEST['key']);
	if ( $secret != $key )
		stms_error_handler("Secret key is different. Expected: {$secret}, Received: {$key}. Nanacast API ignored.", 0, '', 'ipn');
	
	$vars = $_REQUEST;
	
	if ( !isset($vars['mode']) )
		return false;
	
	$item_name = stms_sanitize($vars['item_name']);
	$list_id = stms_sanitize($vars['u_list_id']);
	$client_id = stms_sanitize($vars['id']);
	$access_code = stms_sanitize($vars['u_access_code']);
	$username = stms_sanitize($vars['u_username']);
	$email = stms_sanitize($vars['u_email']);
	$first_name = stms_sanitize($vars['u_firstname']);
	$last_name = stms_sanitize($vars['u_lastname']);
	$paypal_id = stms_sanitize($vars['u_paypal_payer_id']);
	$receipt = $access_code;
	
	$product_id = stms_isset($_REQUEST['insta_id'], 0);
	if ( !$product = stms_get_product($product_id) ) {
		if ( !$product = stms_find_product_by_externalid('nanacast', $list_id) ) {
			if ( !$product = stms_get_product_bytitle($item_name) )
				stms_error_handler("Product not found. Nanacast Outbound API Ignored.", 0, $receipt, 'ipn');
		}
	}
	
	switch ( $vars['mode'] ) {
		case 'add':
			if ( $lock = stms_nanacast_get_lock($product->ID, $receipt) )
				return false;
			
			// Create pending transaction first...
			$args = array(
				'product_id' => $product->ID,
				'member_id' => 0,
				'payment_type' => $product->type,
				'paysys' => 'nanacast',
				'currency' => stms_isset($stms['global']['currency'], 'USD'),
				'amount' => $vars['u_first_price'],
				'ipaddr' => $vars['u_subscribe_ip']
			);
			$tx_id = stms_add_pending_payment($args);
			if ( !$member_id = stms_nanacast_get_member_id($username, $email, $client_id, $access_code) ) {
				$userdata = array();
				$userdata['member_id'] = 0;
				$userdata['username'] = ( !empty($username) ) ? $username : stms_generate_username($email, $first_name, $last_name);
				$userdata['password'] = ( !empty($vars['u_password']) ) ? stms_sanitize($vars['u_password']) : wp_generate_password();
				$userdata['email'] = $email;
				$userdata['first_name'] = $first_name;
				$userdata['last_name'] = $last_name;
				$userdata['status'] = ( stms_isset($product->info['auto_register']) == 1 ) ? 1 : 4;
				$userdata['is_aff'] = ( stms_isset($stms['global']['manual_aff'], 0) == 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
				$userdata['is_aff_pending'] = ( stms_isset($stms['global']['manual_aff'], 0) != 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
				if ( !empty($paypal_id) )
					$userdata['paypal_id'] = $paypal_id;
				$member_id = stms_save_member($userdata);
			}
			
			// log the ipn for further usage...
			$ipn = stms_log_ipn($vars, $tx_id, 'nanacast', 0, $member_id, $receipt);
			
			// let's complete the payment...
			$args = array(
				'product_id' => $product->ID,
				'member_id' => $member_id,
				'paysys' => 'nanacast',
				'receipt' => $receipt,
				'currency' => stms_isset($stms['global']['currency'], 'USD'),
				'amount' => $vars['u_first_price'],
				'txn_id' => $client_id,
				'paid' => 1,
				'status' => 'completed',
				'ipaddr' => stms_isset($vars['u_subscribe_ip']),
				'date'=> stms_time(),
				'expired_date' => stms_get_expired($product->ID, true)
			);
			
			if ( $product->is_trial == 1 )
				$args['amount'] = $product->t_price;
			
			stms_complete_payment($tx_id, $args);
			break;
			
		case 'payment':
			$tx_id = stms_nanacast_last_id($receipt, $product->ID, $client_id);
			if ( $payment = stms_get_payment($tx_id) ) {
				$new_data = array();
				$new_data['status'] = 'expired';
				$new_data['expired_date'] = strtotime("5 minutes ago", stms_time());
				stms_update_payment($tx_id, $new_data);
				wp_cache_delete($payment->member_id, 'stms_member_payments'); // delete cache
				
				$member_id = $payment->member_id;
			}

			if ( !$member_id = stms_nanacast_get_member_id($username, $email, $client_id, $access_code) )
				stms_error_handler("Cannot find a member associated with this Nanacast 'payment' API.", 0, $receipt, 'ipn');
			
			// calculate expire date...
			$expired_date = stms_get_expired($product->ID, false);
			if ( is_numeric($product->rebill_times) && $product->rebill_times > 0 ) {
				if ( empty($vars['u_expiration']) ) {
					$expired_date = strtotime("19 Jan 2038", stms_time());
				} else {
					$rebills = $wpdb->get_results(
						"SELECT * FROM {$wpdb->prefix}stms_transactions
						WHERE paysys = 'nanacast' AND `member_id` = {$member_id}
						AND is_rebill = 1 AND product_id = {$product->ID}"
					);
					
					if ( $rebills ) {
						$rebilled = count($rebills);
						if ( $product->is_trial != 1 )
							$rebilled += 1;
							
						if ( $rebilled >= $product->rebill_times ) {
							$expired_date = strtotime("19 Jan 2038", stms_time());
						}
					}
				}
			}
			
			$args = array(
				'product_id' => $product->ID,
				'member_id'=> $member_id,
				'payment_type' => 'recurr',
				'paysys'=> 'nanacast',
				'receipt'=> $receipt,
				'currency' => stms_isset($stms['global']['currency'], 'USD'),
				'amount'=> $vars['u_recurring_price'],
				'txn_id' => $client_id,
				'paid'=> 1,
				'is_rebill' => 1,
				'status'=> 'completed',
				'ipaddr' => stms_isset($vars['u_subscribe_ip']),
				'date'=> stms_time(),
				'expired_date'=> $expired_date
			);
			$new_tx_id = stms_add_payment($args);
			break;
			
		case 'suspend':
		case 'delete':
			$tx_id = stms_nanacast_last_id($receipt, $product->ID, $client_id);
			if ( !$tx_id )
				stms_error_handler("Cannot find transaction record for this Nanacast '{$vars['mode']}' API (tx_id:{$tx_id})", 0, $client_id, 'ipn');
			
			$payment = stms_get_payment($tx_id);
			if ( stms_isset($vars['u_last_unsubscribe_reason']) == 'refund_and_unsubscribe' ) {
				$payments = stms_get_member_payments($payment->member_id);
				if ( $payments ) {
			        foreach ( $payments as $pay ) {
			            if ( $pay->product_id  == $payment->product_id && $pay->status == 'completed' ) {
			            	
							$refund_id = $pay->tx_id;
							stms_refund_payment($refund_id, 'third');
			            }
			        }
				}
			}
			break;
	}
	exit;
}

function stms_nanacast_get_member_id( $username, $email, $client_id, $receipt, $paypal_id = '' ) {
	global $wpdb;
	
	// find by username
	if ( $member = stms_get_data_by('login', $username) ) return $member->ID;
	// find by email
	if ( $member = stms_get_data_by('email', $email) ) return $member->ID;
	// find by transaction
	$sql = $wpdb->prepare(
				"SELECT `member_id` FROM `{$wpdb->prefix}stms_transactions`
				WHERE (`receipt` = %s OR `txn_id` = %s) ORDER BY `tx_id` DESC LIMIT 1",
				$receipt, $client_id
			);
	if ( $tx = $wpdb->get_row($sql) ) return $tx->member_id;
	
	// find by paypal id
	if ( !empty($paypal_id) ) {
		$sql = $wpdb->prepare(
				"SELECT `ID` FROM `{$wpdb->prefix}stms_members`
				WHERE paypal_id = %s",
				$paypal_id
			);
		if ( $member = $wpdb->get_row($sql) )  return $member->ID;
	}
	
	return false;
}

function stms_nanacast_get_lock( $product_id, $receipt ) {
	global $wpdb;
	
	$sql = $wpdb->prepare(
				"SELECT COUNT(*) FROM `{$wpdb->prefix}stms_transactions`
				WHERE `paysys` = %s AND `product_id` = %d AND `receipt` = %s
				AND `is_rebill` = 0",
				'nanacast', $product_id, $receipt
			);
	$count = $wpdb->get_var($sql);
	if ( $count > 0 ) return true;
	return false;
}

function stms_nanacast_last_id( $receipt, $product_id, $client_id ) {
	global $wpdb;
	
	$last_payment = $wpdb->get_row(
		$wpdb->prepare("SELECT tx_id FROM `{$wpdb->prefix}stms_transactions`
			WHERE `receipt` = %s OR (`product_id` = %d AND `client_id` = %s)
			ORDER BY tx_id DESC",
			$receipt,
			$product_id,
			$client_id
		)
	);
	
	if ( $last_payment )
		return $last_payment->tx_id;
	
	return false;
}

//add_action('stms_validate_access_nanacast', 'stms_nanacast_thanks_handler');
function stms_nanacast_thanks_handler() {
	@set_time_limit(0);
	
	if ( !isset($_REQUEST) )
		wp_die('ERROR: Invalid Payment');
	
	$post = $_REQUEST;
	
	global $wpdb;
	$product_id = intval($post['insta_id']);
	$stms = get_option('stms_settings');
	$rcpt = ( isset($post['u_access_code']) ) ? $post['u_access_code'] : $post['insta_receipt'];
	$list_id = stms_sanitize($post['list_id']);
	$client_id = stms_sanitize($post['client_id']);
	
	if ( empty($rcpt) ) {
		if ( $product = stms_get_product($product_id) ) {
			$home_url = ( !empty($product->home_id) ) ? get_permalink($product->home_id) : get_permalink($stms['global']['home']);
			wp_redirect($home_url);
			exit;
		} else {
			wp_die("ERROR: Page Not Found.");
		}
	}
	
	$support = stms_get_handler_url('support');
	if ( $ipn = stms_find_nanacast_ipn($ipn_key) ) {
		$vars = maybe_unserialize($ipn->postdata);
		if ( !$payment = stms_get_payment($ipn->tx_id) )
			wp_die('ERROR: Invalid Payment');
		
		$product = stms_get_product($payment->product_id);
		$home_url = ( !empty($product->home_id) ) ? get_permalink($product->home_id) : get_permalink($stms['global']['home']);
		$redirect_url = ( !empty($product->info['thankuri']) ) ? $product->info['thankuri'] : $home_url;
	
		if ( $ipn->status == 1 ) { // check if IPN has been processed...
			// IPN has been processed... then redirect to members download page...
			wp_redirect($home_url);
			exit;
		}
		
		$member_id = ( is_stmsmember_logged_in() ) ? stms_get_current_member_id() : $payment->member_id;
		$is_logged_in = ( is_stmsmember_logged_in() ) ? true : false;
		$is_existing = false;
		
		$temp_member = stms_member($payment->member_id);
		if ( $is_logged_in ) {
			if ( $member_id != $payment->member_id ) {
				// fix license key data ...
				$settings = stms_get_product_meta($payment->product_id, 'license');
				if ( $settings['enable'] == 1 )
					$wpdb->update("{$wpdb->prefix}stms_licenses", array('member_id' => $member_id), array('tx_id' => $payment->tx_id));
				
				// Update member id trx
				$new_data = array();
				$new_data['member_id'] = $member_id;
				stms_update_payment($payment->tx_id, $new_data);
				
				do_action('stms_payment_completed', $payment->tx_id); // so the receipt can be resend...
				
				if ( $temp_member->status == 4 )
					stms_delete_member($temp_member->ID, false);
			}
			
			$is_existing = true;
		}

		// Recall payment data to make sure that we use latest data...
		$payment = stms_get_payment($ipn->tx_id);
		// let's update ipn log...
		$update = $wpdb->update("{$wpdb->prefix}stms_ipn_log", array('status' => 1, 'member_id' => $member_id), array('log_id' => $ipn->log_id));
		// remove retries data...
		delete_transient('stms_thanks_retries_' . $ipn_key);
	
		if ( !$is_existing ) {
			// update member data...
			$userdata = array();
			$userdata['member_id'] = $payment->member_id;
			$userdata['email'] = stms_isset($vars['u_email']);
			$userdata['status'] = 1;
			$userdata['fix_username'] = ( !empty($vars['u_username']) ) ? stms_sanitize($vars['u_username']) : stms_generate_username($vars['u_email'], $vars['u_firstname'], $vars['u_lastname']);
			$userdata['pwd1'] = ( !empty($vars['u_password']) ) ? stms_sanitize($vars['u_password']) : wp_generate_password(8, false);
			$userdata['first_name'] = $vars['u_firstname'];
			$userdata['last_name'] = $vars['u_lastname'];
			$userdata['is_aff'] = ( stms_isset($stms['global']['manual_aff'], 0) == 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
			$userdata['is_aff_pending'] = ( stms_isset($stms['global']['manual_aff'], 0) != 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
			
			$member_id = stms_save_member($userdata, false, false, $payment->tx_id);
		}
		
		do_action('stms_custom_autoresponder', $payment->tx_id); // for custom autoresponder...
		
		// check and complete other payments (if any) ...
		stms_other_payments($member_id, $vars['u_email'], 'nanacast');
		
		// logging out member first...
		stms_clear_auth_cookie();
	
		// re-logging in...
		stms_set_auth_cookie($member_id);
		
		// now redirecting...
		wp_redirect($redirect_url);
		exit;
	} else {
		$retries = get_transient('stms_thanks_retries_' . $ipn_key);
		$thanks_url = stms_format_url($stms['global']['magic'], http_build_query($_REQUEST));
		if ( $retries >= 30 ) {
			$page_title = 'Payment Error';
			$refresh = '';
			$message = '
				<p style="text-align:center;"><strong>Payment Error</strong></p>
				<p>We\'re sorry, but there\'s a problem in validating your payment. Please contact our <a href="' . $support . '">support</a> to resolve this issue.</p>
			';
		} else {
			$count = $retries + 1;
			set_transient('stms_thanks_retries_' . $ipn_key, $count, 60*15);
			$page_title = 'Waiting For Payment Confirmation...';
			$refresh = '<meta http-equiv="refresh" content="10;URL=\'' . $thanks_url . '\'" />';
			$message = '
				<h2 style="text-align:center;"><strong>Waiting For Payment Confirmation...</strong></h2>
				<p style="text-align:center;"><img src="' . STMS_URL . 'images/admin-loader.gif" border="0" /></p>
				<p style="text-align:center;">This page will be auto-refresh every 10 seconds until your payment confirmed.</p>
				<p style="text-align:center;"><strong>Please DO NOT close this page.</strong></p>
			';
		}
?>
<!DOCTYPE html>
<!--[if IE 6]>
<html id="ie6" <?php language_attributes(); ?>>
<![endif]-->
<!--[if IE 7]>
<html id="ie7" <?php language_attributes(); ?>>
<![endif]-->
<!--[if IE 8]>
<html id="ie8" <?php language_attributes(); ?>>
<![endif]-->
<!--[if !(IE 6) | !(IE 7) | !(IE 8)  ]><!-->
<html <?php language_attributes(); ?>>
<!--<![endif]-->
<head>
<meta charset="<?php bloginfo( 'charset' ); ?>" />
<title><?php echo $page_title; ?></title>
<?php echo $refresh; ?>
<!--[if lt IE 9]>
	<script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
<![endif]-->
<link rel="profile" href="http://gmpg.org/xfn/11" />
<meta name="HandheldFriendly" content="True" />
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<!-- Adding "maximum-scale=1" fixes the Mobile Safari auto-zoom bug: http://filamentgroup.com/examples/iosScaleBug/ -->
<link rel="stylesheet" href="http://fonts.googleapis.com/css?family=Droid+Sans" type="text/css" media="all" />
<style type="text/css">
body {
	margin:0;
	padding:0;
	font-size:14px;
	font-family:'Droid Sans', sans-serif;
	background-color:#F5F5F5;
	color:#808080;
}
#redirect_msg {
	margin:25px auto 0;
	padding:15px 20px;
	width:40%;
	background-color:#FFF;
}
</style>
</head>
<body>
<div id="redirect_msg">
	<?php echo $message; ?>
</div>
</body>
</html>
<?php
	}
	exit;
}

function stms_find_nanacast_ipn( $receipt ) {
	global $wpdb;
	$ipn = $wpdb->get_row(
		"SELECT * FROM `{$wpdb->prefix}stms_ipn_log`
		WHERE `paysys` = 'nanacast' AND `receipt` = '{$receipt}'"
	);
	if ( !$ipn ) return false;
	return $ipn;
}

add_filter('stms_thanks_setup_nanacast', 'stms_nanacast_thanks_setup');
function stms_nanacast_thanks_setup( $settings ) {
	$settings['rcpt'] = 'u_access_code';
	$settings['flow'] = 'auto_only';
	$settings['email_check'] = false;
	$settings['email_var'] = 'u_email';
	$settings['firstname_var'] = 'u_firstname';
	$settings['lastname_var'] = 'u_lastname';
	$settings['username_var'] = 'u_username';
	$settings['password_var'] = 'u_password';
	return $settings;
}