<?php
/*
Payment Name: 1ShoppingCart
Payment Key: oneshopping
One Time: yes
Recurring: yes
Flow Type: auto_only
*/

add_action('stms_thirdpay_settings_oneshopping', 'stms_oneshopping_product_settings', 10, 2);
function stms_oneshopping_product_settings($product, $pay_settings) {
?>
	<tr valign="top" class="stms-oneshopping-level stms-autoreg-only-sets">
		<th scope="row" colspan="2" style="border-top:1px solid #E5E5E5"><h3 style="color:#808080"><?php _e('1ShoppingCart Product Integration', 'stms'); ?></h3></th>
	</tr>
	<tr valign="top" class="stms-oneshopping-level stms-autoreg-only-sets">
		<th scope="row" style="text-align:right"><label for="stms_oneshopping_item"><strong><span style="color:#cc0000">*</span> <?php _e('Product ID#', 'stms'); ?></strong></label></th>
		<td>
			<input class="stms-field" type="text" name="stms_level[pay_settings][oneshopping][item]" id="stms_oneshopping_item" value="<?php echo stms_cleanup(stms_isset($pay_settings['oneshopping']['item'])); ?>" style="width:80px" />
			<div class="stms-desc">Please enter the Product ID of your 1ShoppingCart Product.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-oneshopping-level stms-autoreg-only-sets">
		<th scope="row" style="text-align:right"><label for="stms_oneshopping_url"><strong><span style="color:#cc0000">*</span> <?php _e('Thank You Page URL', 'stms'); ?></strong></label></th>
		<td>
			<input class="stms-field widefat" type="text" id="stms_oneshopping_url" value="<?php echo stms_get_returnurl('oneshopping', false, true, $product->ID); ?>" readonly />
			<div class="stms-desc">You MUST set the thank you page URL of the product you created in 1ShoppingCart to this URL.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-oneshopping-level stms-autoreg-only-sets">
		<th scope="row" style="text-align:right"><label for="stms_oneshopping_payurl"><?php _e('1SC Checkout URL', 'stms'); ?></label></th>
		<td>
			<input class="stms-field widefat" type="text" name="stms_level[pay_settings][oneshopping][payurl]" id="stms_oneshopping_payurl" value="<?php echo stms_sanitize($pay_settings['oneshopping']['payurl']); ?>" />
			<div class="stms-desc">This is required only if you use the "Auto-Switch" payment button feature. Simply enter the checkout URL generated by 1ShoppingCart here. If you're not using the "Auto-Switch" payment feature, then you can leave this empty.</div>
		</td>
	</tr>
	
	<tr valign="top" class="stms-oneshopping-level stms-autoreg-only-sets stms-last-integrate">
		<th scope="row" colspan="2"></th>
	</tr>
<?php
}

add_action('stms_global_payment_oneshopping', 'stms_oneshopping_global_settings');
function stms_oneshopping_global_settings($stms) {
	if ( !class_exists('DOMDocument') ) {
		echo '
		<div class="stms-error-msg">
			<p>This payment system require the PHP "DOM" extension to be installed in your server. To be able to use 1ShoppingCart as your payment system, please contact your host admin to install the "DOM" extension first.</p>
		</div>
		';
	} else {
?>
	<table class="form-table">
	<tr valign="top">
		<th scope="row"><label style="cursor:default"><strong>Enable 1ShoppingCart</strong></label></th>
		<td><div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[is_oneshopping]" id="stms_pay_oneshopping" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="oneshop-paysets" value="1" <?php if ( stms_isset($stms['payments']['is_oneshopping']) == 1 ) echo 'checked="checked"'; ?> /></td>
	</tr>
	<tr valign="top" class="oneshop-paysets">
		<th scope="row" style="text-align:right"></th>
		<td>
			<div class="stms-error-msg">
				<p><strong>Important:</strong> You can use 1ShoppingCart payment system to sell One-Time products ONLY. Currently, InstaMember have no integration support to process subscription/recurring payments for 1ShoppingCart.</p>
			</div>
		</td>
	</tr>
	<tr valign="top" class="oneshop-paysets">
		<th scope="row" style="text-align:right"><label for="stms_merchant_id"><?php _e('Merchant ID #', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" name="stms_sets[oneshopping][merchant_id]" id="stms_merchant_id" value="<?php echo stms_sanitize($stms['payments']['oneshopping']['merchant_id'], '', true); ?>" />
		</td>
	</tr>
	<tr valign="top" class="oneshop-paysets">
		<th scope="row" style="text-align:right"><label for="stms_sc_api_key"><?php _e('Merchant API Key', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" name="stms_sets[oneshopping][api_key]" id="stms_sc_api_key" value="<?php echo stms_sanitize($stms['payments']['oneshopping']['api_key'], '', true); ?>" />
			<div class="stms-desc">You can obtain this by logging into your 1ShoppingCart account, and navigate to (<code>My Account -> API Settings -> Your Current Merchant API Key</code>)</div>
		</td>
	</tr>
	<tr valign="top" class="oneshop-paysets">
		<th scope="row" style="text-align:right"><label for="stms_sc_api_url"><?php _e('API URL', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" name="stms_sets[oneshopping][api_url]" id="stms_sc_api_url" value="<?php echo stms_isset($stms['payments']['oneshopping']['api_url'], 'https://www.mcssl.com'); ?>" />
			<div class="stms-desc">Most of the time, your 1ShoppingCart API URL is <code>https://www.mcssl.com</code>. However, if it turned out different, then please enter the correct 1ShoppingCart API URL here.</div>
		</td>
	</tr>
	<tr valign="top" class="oneshop-paysets">
		<th scope="row" style="text-align:right"><label><?php _e('Notification URL', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" value="<?php echo stms_get_ipnurl('oneshopping'); ?>" readonly />
			<div class="stms-desc">Please enter this Notification URL into your 1ShoppingCart account (under <code>My Account -> API Settings -> Notification URL</code>)</div>
		</td>
	</tr>
	</table>
<?php
	}
}

add_action('stms_ipn_oneshopping', 'stms_oneshopping_ipn_handler');
function stms_oneshopping_ipn_handler() {
	require_once(STMS_SOURCES . 'OneShopAPI.php');
	
	global $wpdb;
	$stms = get_option('stms_settings');
	$merchant_id = stms_sanitize($stms['payments']['oneshopping']['merchant_id'], '', true);
	$api_key = stms_sanitize($stms['payments']['oneshopping']['api_key'], '', true);
	$api_url = stms_sanitize($stms['payments']['oneshopping']['api_url'], 'https://www.mcssl.com', true);
	
	$API = new OneShopAPI($merchant_id, $api_key, $api_url);
    $requestBodyXML = new DOMDocument();
	
	// Load the request body into XML and check that the result has been parsed into XML    
    if ( $requestBodyXML->loadXML($HTTP_RAW_POST_DATA) == true ) {
        $notificationType = $requestBodyXML->documentElement->nodeName;  
        $tokenNode = $requestBodyXML->getElementsByTagName('Token')->item(0)->nodeValue;  
        switch ( $notificationType ) {
            case "NewOrder":
                $apiResult = $API->GetOrderById($tokenNode);
            	break;
            
            default:
                // do nothing...
           	 	break;
        }
        
		if ( isset($apiResult) ) {
	        $apiResultXML = new DOMDocument();
	        if ( $apiResultXML->loadXML($apiResult) == true ) {            
	            // Check if the API returned an error
	            $apiSuccess = $apiResultXML->getElementsByTagName('Response')->item(0)->getAttribute('success');
				if ( $apiSuccess == 'true' ) {
					$clientId = $apiResultXML->getElementsByTagName("ClientId")->item(0)->nodeValue;
					$OrderChargeStatusType = $apiResultXML->getElementsByTagName('OrderChargeStatusType')->item(0)->nodeValue;
					$OrderStatusType = $apiResultXML->getElementsByTagName('OrderStatusType')->item(0)->nodeValue;
					$orderId = $apiResultXML->getElementsByTagName('Id')->item(0)->nodeValue;
					$transactionId = $apiResultXML->getElementsByTagName('TransactionId')->item(0)->nodeValue;
					$receipt = ( !empty($orderId) ) ? $orderId : $transactionId; 
					if ( strtolower($OrderStatusType) == 'accepted' ) {
						$clientResult = $API->GetClientById($clientId);
						$clientResultXML = new DOMDocument();
						if ( $clientResultXML->loadXML($clientResult) == true ) {
							$clientSuccess = $clientResultXML->getElementsByTagName('Response')->item(0)->getAttribute('success');
							if ( $clientSuccess != 'true' )
								stms_error_handler('Failed to retrieve client data in 1SC API Notification.', 0, $receipt, 'ipn');
							
							$email = $clientResultXML->getElementsByTagName('Email')->item(0)->nodeValue;
							$first_name = $clientResultXML->getElementsByTagName('FirstName')->item(0)->nodeValue;
							$last_name = $clientResultXML->getElementsByTagName('LastName')->item(0)->nodeValue;
							$street = $clientResultXML->getElementsByTagName('Address1')->item(0)->nodeValue;
							$city = $clientResultXML->getElementsByTagName('City')->item(0)->nodeValue;
							$zip = $clientResultXML->getElementsByTagName('Zip')->item(0)->nodeValue;
							$state = $clientResultXML->getElementsByTagName('StateName')->item(0)->nodeValue;
						}
						
						if ( !$member_id = stms_oneshopping_get_member_id($email, $clientId) ) {
							$userdata = array();
							$userdata['member_id'] = 0;
							$userdata['username'] = stms_generate_username($email, $first_name, $last_name);
							$userdata['password'] = wp_generate_password(8, false);
							$userdata['email'] = $email;
							$userdata['first_name'] = $first_name;
							$userdata['last_name'] = $last_name;
							$userdata['street'] = $street;
							$userdata['city'] = $city;
							$userdata['state'] = $state;
							$userdata['zipcode'] = $zip;
							$userdata['status'] = ( stms_isset($product->info['auto_register']) == 1 ) ? 1 : 4;
							$userdata['is_aff'] = ( stms_isset($stms['global']['manual_aff'], 0) == 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
							$userdata['is_aff_pending'] = ( stms_isset($stms['global']['manual_aff'], 0) != 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
							$member_id = stms_save_member($userdata);
						}
						
						$LineItemInfo = $apiResultXML->getElementsByTagName('LineItemInfo');
						foreach( $LineItemInfo as $lineItemInfo ) {
							$vars = array();
							$vars['item_id'] = $lineItemInfo->getElementsByTagName("ProductId")->item(0)->nodeValue;
							$vars['item_name'] = $lineItemInfo->getElementsByTagName("ProductName")->item(0)->nodeValue;
							$vars['receipt'] = $lineItemInfo->getElementsByTagName("OrderId")->item(0)->nodeValue;
							$vars['amount'] = $lineItemInfo->getElementsByTagName("UnitPrice")->item(0)->nodeValue;
							$vars['payer_email'] = $email;
							$vars['first_name'] = $first_name;
							$vars['last_name'] = $last_name;
							
							$item_id = $vars['item_id'];
							$title = stms_sanitize($vars['item_name']);
							if ( !$product = stms_find_product_by_externalid('oneshopping', $item_id) ) {
								$product = stms_get_product_bytitle($title);
							}
							
							if ( $product ) {
								$is_rebill = 0;
								if ( $product->type == 'recurr' ) {
									$sql = "SELECT * FROM `{$wpdb->prefix}stms_transactions`
											WHERE `member_id` = {$member_id} AND `product_id` = {$product->ID}
											AND `status` = 'completed' AND `paid` = 1 ORDER BY `tx_id` DESC LIMIT 1";
											
									if ( $payment = $wpdb->get_row($sql) ) {
										$is_rebill = 1;
										$new_data = array();
										$new_data['status'] = 'expired';
										$new_data['expired_date'] = strtotime("5 minutes ago", stms_time());
										stms_update_payment($payment->tx_id, $new_data);
										wp_cache_delete($payment->member_id, 'stms_member_payments'); // delete cache
									}
								}
									
								// Create pending transaction first...
								$args = array(
									'product_id' => $product->ID,
									'member_id' => $member_id,
									'payment_type' => $product->type,
									'paysys' => 'oneshopping',
									'currency' => stms_isset($stms['global']['currency'], 'USD'),
									'amount' => $product->price
								);
								$tx_id = stms_add_pending_payment($args);
								
								// log the ipn for further usage...
								$ipn = stms_log_ipn($vars, $tx_id, 'oneshopping', 0, $member_id, $vars['receipt']);
								
								// Let's complete the payment...
								$args = array(
									'member_id' => $member_id,
									'paysys' => 'oneshopping',
									'receipt' => $vars['receipt'],
									'currency' => stms_isset($stms['global']['currency'], 'USD'),
									'amount' => $product->price,
									'paid' => 1,
									'status' => 'completed',
									'txn_id' => $clientId,
									'date' => stms_time(),
									'expired_date' => stms_get_expired($product->ID, true),
									'is_rebill' => $is_rebill
								);
								
								if ( !is_rebill && $product->is_trial == 1 )
									$args['amount'] = $product->t_price;
								
								stms_complete_payment($tx_id, $args);
							}
						}
					}
	            }
	        }
	    }
	}
	exit;  
}

//add_action('stms_validate_access_oneshopping', 'stms_oneshopping_thanks_handler');
function stms_oneshopping_thanks_handler() {
	@set_time_limit(0);
	
	if ( !isset($_REQUEST) )
		wp_die('ERROR: Invalid Payment');
	
	$post = $_REQUEST;
	
	global $wpdb;
	$product_id = intval($post['insta_id']);
	$stms = get_option('stms_settings');
	$rcpt = ( isset($post['orderID']) ) ? $post['orderID'] : $post['insta_receipt'];
	
	if ( empty($rcpt) ) {
		if ( $product = stms_get_product($product_id) ) {
			$home_url = ( !empty($product->home_id) ) ? get_permalink($product->home_id) : get_permalink($stms['global']['home']);
			wp_redirect($home_url);
			exit;
		} else {
			wp_die("ERROR: Page Not Found.");
		}
	}
	
	$support = stms_get_handler_url('support');
	if ( $ipn = stms_find_oneshopping_ipn($rcpt) ) {
		$vars = maybe_unserialize($ipn->postdata);
		if ( !$payment = stms_get_payment($ipn->tx_id) )
			wp_die('ERROR: Invalid Payment');
		
		$product = stms_get_product($payment->product_id);
		$home_url = ( !empty($product->home_id) ) ? get_permalink($product->home_id) : get_permalink($stms['global']['home']);
		$redirect_url = ( !empty($product->info['thankuri']) ) ? $product->info['thankuri'] : $home_url;
	
		if ( $ipn->status == 1 ) { // check if IPN has been processed...
			// IPN has been processed... then redirect to members download page...
			wp_redirect($home_url);
			exit;
		}
		
		$member_id = ( is_stmsmember_logged_in() ) ? stms_get_current_member_id() : $payment->member_id;
		$is_logged_in = ( is_stmsmember_logged_in() ) ? true : false;
		$is_existing = false;
		
		$temp_member = stms_member($payment->member_id);
		if ( $is_logged_in ) {
			if ( $member_id != $payment->member_id ) {
				// fix license key data ...
				$settings = stms_get_product_meta($payment->product_id, 'license');
				if ( $settings['enable'] == 1 )
					$wpdb->update("{$wpdb->prefix}stms_licenses", array('member_id' => $member_id), array('tx_id' => $payment->tx_id));
				
				// Update member id trx
				$new_data = array();
				$new_data['member_id'] = $member_id;
				stms_update_payment($payment->tx_id, $new_data);
				
				do_action('stms_payment_completed', $payment->tx_id); // so the receipt can be resend...
				
				if ( $temp_member->status == 4 )
					stms_delete_member($temp_member->ID, false);
			}
			
			$is_existing = true;
		}

		// Recall payment data to make sure that we use latest data...
		$payment = stms_get_payment($ipn->tx_id);
		// let's update ipn log...
		$update = $wpdb->update("{$wpdb->prefix}stms_ipn_log", array('status' => 1, 'member_id' => $payment->member_id), array('log_id' => $ipn->log_id));
		// remove retries data...
		delete_transient('stms_thanks_retries_' . $rcpt);
		
		if ( !$is_existing ) {
			// update member data...
			$userdata = array();
			$userdata['member_id'] = $member_id;
			$userdata['email'] = stms_isset($vars['payer_email']);
			$userdata['status'] = 1;
			$userdata['fix_username'] = stms_generate_username($vars['payer_email'], $vars['first_name'], $vars['last_name']);
			$userdata['pwd1'] = wp_generate_password(8, false);
			$userdata['first_name'] = $vars['first_name'];
			$userdata['last_name'] = $vars['last_name'];
			$userdata['is_aff'] = ( stms_isset($stms['global']['manual_aff'], 0) == 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
			$userdata['is_aff_pending'] = ( stms_isset($stms['global']['manual_aff'], 0) != 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
			
			$member_id = stms_save_member($userdata, false, false, $payment->tx_id);
		}
		
		do_action('stms_custom_autoresponder', $payment->tx_id); // for custom autoresponder...
		
		// check and complete other payments (if any) ...
		stms_other_payments($member_id, $vars['payer_email'], 'oneshopping');
		
		// logging out member first...
		stms_clear_auth_cookie();
	
		// re-logging in...
		stms_set_auth_cookie($member_id);
		
		// now redirecting...
		wp_redirect($redirect_url);
		exit;
	} else {
		// still not receiving IPN...
		$retries = get_transient('stms_thanks_retries_' . $rcpt);
		$thanks_url = stms_format_url($stms['global']['magic'], http_build_query($_REQUEST));
		if ( $retries >= 30 ) {
			$page_title = 'Payment Error';
			$refresh = '';
			$message = '
				<p style="text-align:center;"><strong>Payment Error</strong></p>
				<p>We\'re sorry, but there\'s a problem in validating your payment. Please contact our <a href="' . $support . '">support</a> to resolve this issue.</p>
			';
		} else {
			$count = $retries + 1;
			set_transient('stms_thanks_retries_' . $rcpt, $count, 60*15);
			$page_title = 'Waiting For Payment Confirmation...';
			$refresh = '<meta http-equiv="refresh" content="10;URL=\'' . $thanks_url . '\'" />';
			$message = '
				<h2 style="text-align:center;"><strong>Waiting For Payment Confirmation...</strong></h2>
				<p style="text-align:center;"><img src="' . STMS_URL . 'images/admin-loader.gif" border="0" /></p>
				<p style="text-align:center;">This page will be auto-refresh every 10 seconds until your payment confirmed.</p>
				<p style="text-align:center;"><strong>Please DO NOT close this page.</strong></p>
			';
		}
?>
<!DOCTYPE html>
<!--[if IE 6]>
<html id="ie6" <?php language_attributes(); ?>>
<![endif]-->
<!--[if IE 7]>
<html id="ie7" <?php language_attributes(); ?>>
<![endif]-->
<!--[if IE 8]>
<html id="ie8" <?php language_attributes(); ?>>
<![endif]-->
<!--[if !(IE 6) | !(IE 7) | !(IE 8)  ]><!-->
<html <?php language_attributes(); ?>>
<!--<![endif]-->
<head>
<meta charset="<?php bloginfo( 'charset' ); ?>" />
<title><?php echo $page_title; ?></title>
<?php echo $refresh; ?>
<!--[if lt IE 9]>
	<script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
<![endif]-->
<link rel="profile" href="http://gmpg.org/xfn/11" />
<meta name="HandheldFriendly" content="True" />
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<!-- Adding "maximum-scale=1" fixes the Mobile Safari auto-zoom bug: http://filamentgroup.com/examples/iosScaleBug/ -->
<link rel="stylesheet" href="http://fonts.googleapis.com/css?family=Droid+Sans" type="text/css" media="all" />
<style type="text/css">
body {
	margin:0;
	padding:0;
	font-size:14px;
	font-family:'Droid Sans', sans-serif;
	background-color:#F5F5F5;
	color:#808080;
}
#redirect_msg {
	margin:25px auto 0;
	padding:15px 20px;
	width:40%;
	background-color:#FFF;
}
</style>
</head>
<body>
<div id="redirect_msg">
	<?php echo $message; ?>
</div>
</body>
</html>
<?php
	}
	exit;
}

function stms_find_oneshopping_ipn( $receipt ) {
	global $wpdb;
	$ipn = $wpdb->get_row(
		"SELECT * FROM `{$wpdb->prefix}stms_ipn_log`
		WHERE `paysys` = 'oneshopping' AND `receipt` = '{$receipt}'"
	);
	if ( !$ipn ) return false;
	return $ipn;
}

function stms_oneshopping_get_member_id( $email, $client_id ) {
	global $wpdb;
	
	// find by email
	if ( $member = stms_get_data_by('email', $email) ) return $member->ID;
	// find by transaction
	$sql = $wpdb->prepare(
				"SELECT `member_id` FROM `{$wpdb->prefix}stms_transactions`
				WHERE `txn_id` = %s ORDER BY `tx_id` DESC LIMIT 1",
				$client_id
			);
	if ( $tx = $wpdb->get_row($sql) ) return $tx->member_id;
	
	return false;
}

add_filter('stms_thanks_setup_oneshopping', 'stms_oneshopping_thanks_setup');
function stms_oneshopping_thanks_setup( $settings ) {
	$settings['rcpt'] = 'orderID';
	$settings['flow'] = 'auto_only';
	$settings['email_check'] = false;
	$settings['email_var'] = 'payer_email';
	$settings['firstname_var'] = 'first_name';
	$settings['lastname_var'] = 'last_name';
	return $settings;
}