<?php
/*
Payment Name: WSO Pro Adaptive
Payment Key: wsoproa
One Time: yes
Recurring: no
Flow Type: normal
*/

add_action('stms_thirdpay_settings_wsoproa', 'stms_wsoproa_product_settings', 10, 2);
function stms_wsoproa_product_settings($product, $pay_settings) {
	$stms = get_option('stms_settings');
	$wsoproa_secret = ( !empty($stms['payments']['wsoproa']['secret']) ) ? trim($stms['payments']['wsoproa']['secret']) : stms_generate_secret(8, true, false, true);
?>
	<tr valign="top" class="stms-wsoproa-level stms-no-recurring-sets">
		<th scope="row" colspan="2" style="border-top:1px solid #E5E5E5"><h3 style="color:#808080"><?php _e('WSO Pro Adaptive Product Integration Settings', 'stms'); ?></h3></th>
	</tr>
	<tr valign="top" class="stms-wsoproa-level stms-no-recurring-sets">
		<th scope="row" colspan="2"><div class="stms-help-msg"><p><strong>Important: </strong>To successfully integrate InstaMember and WSOPro Adaptive, the product name in your WSOPro Adaptive account must be EXACTLY the same as in InstaMember. Make sure it has no colons, forward slashes and backslashes or the integration will break.</p></div></th>
	</tr>
	<tr valign="top" class="stms-wsoproa-level stms-no-recurring-sets">
		<th scope="row" style="text-align:right"><label for="stms_wsoproa_url"><strong><span style="color:#cc0000">*</span> <?php _e('Delivery URL', 'stms'); ?></strong></label></th>
		<td>
			<input class="stms-field widefat" type="text" id="stms_wsoproa_url" value="<?php echo stms_get_returnurl('wsoproa', false, true, $product->ID); ?>" readonly />
			<div class="stms-desc">You MUST set the product delivery page URL of the product you created in WSO Standard to this URL.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-wsoproa-level stms-no-recurring-sets">
		<th scope="row" style="text-align:right"><label><strong><span style="color:#cc0000">*</span> <?php _e('Key Generation URL', 'stms'); ?></strong></label></th>
		<td>
			<input class="widefat stms-field" type="text" value="<?php echo stms_get_ipnurl('wsoproakeygen') . '&insta_id=' . $product->ID; ?>&key=<?php echo $wsoproa_secret; ?>" readonly />
			<div class="stms-desc">You MUST set the Key Generation URL in the WSO Adaptive product settings to this URL.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-wsoproa-level stms-no-recurring-sets">
		<th scope="row" style="text-align:right"><label><strong><span style="color:#cc0000">*</span> <?php _e('IPN Forwarding URL', 'stms'); ?></strong></label></th>
		<td>
			<input class="widefat stms-field" type="text" value="<?php echo stms_get_ipnurl('wsoproa') . '&insta_id=' . $product->ID; ?>&key=<?php echo $wsoproa_secret; ?>" readonly />
			<div class="stms-desc">You MUST set the IPN Forwarding URL in the WSO Adaptive product settings to this URL.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-wsoproa-level stms-no-recurring-sets">
		<th scope="row" style="text-align:right"><label for="stms_wsoproa_code"><?php _e('Order Button Code', 'stms'); ?></label></th>
		<td>
			<textarea class="widefat stms-field" name="stms_level[pay_settings][wsoproa][code]" id="stms_wsoproa_code" style="height:80px"><?php echo esc_html(stms_sanitize($pay_settings['wsoproa']['code'])); ?></textarea>
			<div class="stms-desc">This is only required if you use the "Auto-Switch" payment button feature. Since WSOPro Adaptive has its own payment button, then you have to enter the order button code here so that InstaMember can display it correctly. If you're not using the "Auto-Switch" payment feature, then you can leave this empty.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-wsoproa-level stms-no-recurring-sets stms-last-integrate">
		<th scope="row" colspan="2"></th>
	</tr>
<?php
}

add_action('stms_global_payment_wsoproa', 'stms_wsoproa_global_settings');
function stms_wsoproa_global_settings( $stms ) {
	$wsoproa_secret = ( !empty($stms['payments']['wsoproa']['secret']) ) ? trim($stms['payments']['wsoproa']['secret']) : stms_generate_secret(8, true, false, true);
?>
	<table class="form-table">
	<tr valign="top">
		<th scope="row"><label style="cursor:default"><strong>Enable WSO Pro Adaptive</strong></label></th>
		<td><div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[is_wsoproa]" id="stms_pay_wsoproa" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="wsopro-paysets" value="1" <?php if ( stms_isset($stms['payments']['is_wsoproa']) == 1 ) echo 'checked="checked"'; ?> /></td>
	</tr>
	</table>
	<input type="hidden" name="stms_sets[wsoproa][secret]" value="<?php echo $wsoproa_secret; ?>" />
<?php
}

add_action('stms_ipn_wsoproakeygen', 'stms_wsoproa_keygen_handler');
function stms_wsoproa_keygen_handler() {
	$stms = get_option('stms_settings');
	$secret = stms_isset($stms['payments']['wsoproa']['secret']);
	$key = trim($_REQUEST['key']);
	if ( $secret != $key )
		stms_error_handler("Secret key is different. Expected: {$secret}, Received: {$key}. WSO Pro Adaptive KeyGen ignored.", 0, $_POST['txn_id'], 'ipn');

	$posts = $_REQUEST;
	
	$txn_id = stms_isset($posts['WP_TXNID']);
	$receipt = stms_isset($posts['WP_SALEID']);
	$payer_email = sanitize_email($posts['WP_BUYER_EMAIL']);
	$product_id = stms_isset($posts['insta_id'], 0);
	
	$access_url = stms_get_returnurl('wsoproa', false, true) . "&insta_id={$product_id}&insta_receipt={$receipt}";
	
	echo "<p><strong>Congratulations on Your Purchase!</strong></p>";
	echo "<p><strong>In order to access the product, you MUST visit the special URL below:</strong><br />";
	echo "<a href='{$access_url}'><strong>&gt;&gt; Click Here To Access Your Purchase NOW! &lt;&lt;</strong></a></p>";
	exit;
}

add_action('stms_ipn_wsoproa', 'stms_wsoproa_ipn_handler');
function stms_wsoproa_ipn_handler() {
	$stms = get_option('stms_settings');
	$secret = stms_isset($stms['payments']['wsoproa']['secret']);
	
	$key = trim($_REQUEST['key']);
	if ( $secret != $key )
		stms_error_handler("Secret key is different. Expected: {$secret}, Received: {$key}. WSO Pro Adaptive IPN ignored.", 0, $_POST['txn_id'], 'ipn');
	
	$posts = $_REQUEST;
	$process = stms_process_wsoproa($posts);
}

function stms_process_wsoproa( $vars ) {
	global $wpdb;
	
	$stms = get_option('stms_settings');
	$currency = stms_isset($stms['global']['currency'], 'USD');
	
	$txn_id = stms_sanitize($vars['WP_TXNID']);
	$payer_id = stms_sanitize($vars['PAYERID']);
	$receipt = stms_sanitize($vars['WP_SALEID']);
	$title = stms_sanitize($vars['WP_ITEM_NAME']);
	$product_id = ( isset($vars['insta_id']) ) ? $vars['insta_id'] : 0;
	
	// customer data...
	$full_name = stms_sanitize($vars['WP_BUYER_NAME']);
	$names = explode(" ", $full_name, 2);
	$first_name = strtolower(stms_sanitize($names[0]));
	$last_name = strtolower(stms_sanitize($names[1]));
	
	$email = sanitize_email($vars['WP_BUYER_EMAIL']);
	
	if ( !$product = stms_get_product($product_id) ) {
		if ( !$product = stms_get_product_bytitle($title) )
			stms_error_handler("Product not found. WSO Pro Adaptive IPN Ignored.", 0, $receipt, 'ipn');
	}
	
	if ( $ipn = stms_get_ipn_log('wsoproa', $receipt) )
		stms_error_handler("Payment already processed. WSO Pro Adaptive IPN Ignored.", 0, $receipt, 'ipn');
	
	$args = array(
		'product_id' => $product->ID,
		'member_id' => 0,
		'payment_type' => $product->type,
		'paysys' => 'wsoproa',
		'currency' => stms_isset($stms['global']['currency'], 'USD'),
		'amount' => $product->price,
		'ipaddr' => ''
	);
	$tx_id = stms_add_pending_payment($args);
	
	if ( !$member_id = stms_wsoproa_get_member_id($email) ) {
		$temp = stms_generate_temporary();
		
		$userdata = array();
		$userdata['member_id'] = 0;
		$userdata['username'] = ( stms_isset($product->info['steps']) == '2,1' && stms_isset($product->info['auto_register']) == 1 ) ? stms_generate_username($email, $first_name, $last_name) : $temp['username'];
		$userdata['password'] = wp_generate_password(8, false);
		$userdata['email'] = ( stms_isset($product->info['steps']) == '2,1' && stms_isset($product->info['auto_register']) == 1 ) ? $email : $temp['email'];
		$userdata['first_name'] = $first_name;
		$userdata['last_name'] = $last_name;
		$userdata['status'] = ( stms_isset($product->info['auto_register']) == 1 ) ? 1 : 4;
		$userdata['is_aff'] = ( stms_isset($stms['global']['manual_aff'], 0) == 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
		$userdata['is_aff_pending'] = ( stms_isset($stms['global']['manual_aff'], 0) != 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
		$userdata['paypal_email'] = stms_isset($email);
		
		$member_id = stms_save_member($userdata);
	}
	
	// log the ipn for further usage...
	$ipn = stms_log_ipn($vars, $tx_id, 'wsoproa', 0, $member_id, $receipt);
	
	$price = $product->price;
	if ( $product->type == 'recurr' && $product->is_trial == 1 )
		$price = $product->t_price;
		
	$total_amount = ( isset($vars['WP_SALE_AMOUNT']) ) ? number_format($vars['WP_SALE_AMOUNT'], 2, '.', '') : $price;
	// let's complete the payment...
	$args = array(
		'member_id' => $member_id,
		'paysys' => 'wsoproa',
		'receipt' => $receipt,
		'currency' => stms_isset($stms['global']['currency'], 'USD'),
		'amount' => $total_amount,
		'paid' => 1,
		'status' => 'completed',
		'date' => stms_time(),
		'expired_date' => stms_get_expired($product->ID, true)
	);
	
	stms_complete_payment($tx_id, $args);
	exit;
}

function stms_wsoproa_get_member_id( $email ) {
	global $wpdb;
	
	$email = sanitize_email($email);
	if ( $member = stms_get_data_by('email', $email) )
		return $member->ID;

	return false;
}

function stms_find_wsoproa_ipn( $receipt ) {
	global $wpdb;
	$ipn = $wpdb->get_row(
		"SELECT * FROM `{$wpdb->prefix}stms_ipn_log`
		WHERE `paysys` = 'wsoproa' AND `receipt` = '{$receipt}'"
	);
	if ( !$ipn ) return false;
	return $ipn;
}

add_filter('stms_thanks_setup_wsoproa', 'stms_wsoproa_thanks_setup');
function stms_wsoproa_thanks_setup( $settings ) {
	$settings['rcpt'] = 'insta_receipt';
	$settings['flow'] = 'normal';
	$settings['email_check'] = true;
	$settings['email_var'] = 'WP_BUYER_EMAIL';
	$settings['fullname_var'] = 'WP_BUYER_NAME';
	return $settings;
}
