<?php
/*
Payment Name: Zaxaa
Payment Key: zaxaa
One Time: yes
Recurring: yes
Flow Type: normal
*/

add_action('stms_thirdpay_settings_zaxaa', 'stms_zaxaa_product_settings', 10, 2);
function stms_zaxaa_product_settings( $product, $pay_settings ) {
?>
	<tr valign="top" class="stms-zaxaa-level">
		<th scope="row" colspan="2" style="border-top:1px solid #E5E5E5"><h3 style="color:#808080"><?php _e('Zaxaa Product Integration Settings', 'stms'); ?></h3></th>
	</tr>
	<tr valign="top" class="stms-zaxaa-level">
		<th scope="row" style="text-align:right"><label for="stms_zaxaa_item"><strong><span style="color:#cc0000">*</span> <?php _e('SKU', 'stms'); ?></strong></label></th>
		<td>
			<input class="stms-field" type="text" name="stms_level[pay_settings][zaxaa][item]" id="stms_zaxaa_item" value="<?php echo stms_cleanup(stms_isset($pay_settings['zaxaa']['item'])); ?>" style="width:80px" />
			<div class="stms-desc">Please enter the SKU of your Zaxaa Product. To obtain the Zaxaa SKU, simply create a new product in your Zaxaa account. The SKU will be at the top of the edit product screen (under "General Settings" tab)</div>
		</td>
	</tr>
	<tr valign="top" class="stms-zaxaa-level">
		<th scope="row" style="text-align:right"><label><strong><span style="color:#cc0000">*</span> <?php _e('Thank You Page (URL)', 'stms'); ?></strong></label></th>
		<td>
			<input class="widefat stms-field" type="text" value="<?php echo stms_get_returnurl('zaxaa', false, true, $product->ID); ?>" readonly />
			<div class="stms-desc">You MUST set the thank you page URL of the product you created in Zaxaa to this URL.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-zaxaa-level">
		<th scope="row" style="text-align:right"><label><strong><span style="color:#cc0000">*</span> <?php _e('ZPN (URL)', 'stms'); ?></strong></label></th>
		<td>
			<input class="widefat stms-field" type="text" value="<?php echo stms_get_ipnurl('zaxaa') . '&insta_id=' . $product->ID; ?>" readonly />
			<div class="stms-desc">Please enable the "Third Party Script Integration" in Zaxaa product settings, and You MUST set the <strong>Zaxaa Notification URL</strong> to this URL. <strong>Important:</strong> you MUST ENABLE the <code>Payment Data Transfer</code> option.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-zaxaa-level">
		<th scope="row" style="text-align:right"><label for="stms_zaxaa_code"><?php _e('Order Button Code', 'stms'); ?></label></th>
		<td>
			<textarea class="widefat stms-field" name="stms_level[pay_settings][zaxaa][code]" id="stms_zaxaa_code" style="height:80px"><?php echo esc_html(stms_sanitize($pay_settings['zaxaa']['code'])); ?></textarea>
			<div class="stms-desc">This is only required if you use the "Auto-Switch" payment button feature. Since Zaxaa has its own payment button, then you have to enter the order button code here so that InstaMember can display it correctly. If you're not using the "Auto-Switch" payment feature, then you can leave this empty.</div>
		</td>
	</tr>
	<tr valign="top" class="stms-zaxaa-level stms-last-integrate">
		<th scope="row" colspan="2"></th>
	</tr>
<?php
}

add_action('stms_global_payment_zaxaa', 'stms_zaxaa_global_settings');
function stms_zaxaa_global_settings($stms) {
	$zaxaa_signature = ( stms_isset($stms['payments']['zaxaa']['signature']) != '' ) ? trim($stms['payments']['zaxaa']['signature']) : '';
?>
	<table class="form-table">
	<tr valign="top">
		<th scope="row"><label style="cursor:default"><strong>Enable Zaxaa</strong></label></th>
		<td><div class="stms-toggle-btn"></div><input type="checkbox" name="stms_sets[is_zaxaa]" id="stms_pay_zaxaa" class="stms-toggle-checkbox stms-toggle-switch" data-blockname="zaxaa-paysets" value="1" <?php if ( stms_isset($stms['payments']['is_zaxaa']) == 1 ) echo 'checked="checked"'; ?> /></td>
	</tr>
	<tr valign="top" class="zaxaa-paysets">
		<th scope="row" style="text-align:right"><label for="stms_zaxaa_signature"><?php _e('Zaxaa API Signature', 'stms'); ?></label></th>
		<td>
			<input class="widefat stms-field" type="text" name="stms_sets[zaxaa][signature]" id="stms_zaxaa_signature" value="<?php echo $zaxaa_signature; ?>" />
			<div class="stms-desc">To obtain you Zaxaa API Signature, please login to your Zaxaa account, and navigate to (<code>Settings -> Account Settings</code>), and click the "API Signature" button.
		</td>
	</tr>
	</table>
<?php
}

add_action('stms_ipn_zaxaa', 'stms_zaxaa_ipn_handler');
function stms_zaxaa_ipn_handler() {
	$stms = get_option('stms_settings');
	$signature = stms_sanitize($stms['payments']['zaxaa']['signature'], '', true);
	
	$posts = ( !isset($_POST) && !empty($_REQUEST['trans_type']) ) ? $_REQUEST : $_POST;
	if ( empty($posts['trans_type']) ) return false;
	
	$trans_type = $posts['trans_type'];
	$trans_receipt = $posts['trans_receipt'];
	$trans_amount = $posts['trans_amount'];
	$seller_id = $posts['seller_id'];
	$hash_key = $posts['hash_key'];
	$myHashKey = strtoupper(md5($sellerID . $signature . $transReceipt . $transAmount));
	
	$process = false;
	if ( $myHashKey != $hashKey ) {
		stms_log_ipn($vars, 0, 'zaxaa', 1, 0, $trans_receipt);
		stms_error_handler("Zaxaa IPN Validation Failed. Zaxaa IPN Ignored. Received key: {$hashKey} - IM Key: {$myHashKey}", 0, $trans_receipt, 'ipn');
	}
	
	$process = stms_process_zaxaa($_POST);
}

function stms_process_zaxaa( $vars ) {
	global $wpdb;
	
	$stms = get_option('stms_settings');
	$trans_type = $vars['trans_type'];
	$trans_receipt = $vars['trans_receipt'];
	$trans_amount = $vars['trans_amount'];
	$seller_id = $vars['seller_id'];
	$products = $vars['products'];
	
	$email = sanitize_email($vars['cust_email']);
	$parts = explode("@", $email);
	$first_name = ( !empty($vars['cust_firstname']) ) ? stms_sanitize($vars['cust_firstname']) : stms_sanitize($parts[0]);
	$last_name = stms_sanitize($vars['cust_lastname']);
	
	switch ( $trans_type ) {
		case 'SALE':
		case 'FIRST_BILL':
			foreach ( $products as $pr ) {
				$item = $pr['prod_number'];
				if ( !$product = stms_find_product_by_externalid('zaxaa', $item) ) {
					stms_error_handler("Product for Zaxaa item '{$item}' not found. Zaxaa IPN Ignored.", 0, $trans_receipt, 'ipn');
					continue;
				}
				
				// Create pending transaction first...
				$args = array(
					'product_id' => $product->ID,
					'member_id' => 0,
					'payment_type' => $product->type,
					'paysys' => 'zaxaa',
					'currency' => stms_isset($stms['global']['currency'], 'USD'),
					'amount' => $product->price,
					'ipaddr' => ''
				);
				$tx_id = stms_add_pending_payment($args);
			
				if ( !isset($member_id) ) {
					if ( !$member_id = stms_email_exists($email) ) {
						$temp = stms_generate_temporary();
				
						$userdata = array();
						$userdata['member_id'] = 0;
						$userdata['username'] = ( stms_isset($product->info['steps']) == '2,1' && stms_isset($product->info['auto_register']) == 1 ) ? stms_generate_username($email, $first_name, $last_name) : $temp['username'];
						$userdata['password'] = wp_generate_password(8, false);
						$userdata['email'] = ( stms_isset($product->info['steps']) == '2,1' && stms_isset($product->info['auto_register']) == 1 ) ? $email : $temp['email'];
						$userdata['first_name'] = ucwords($first_name);
						$userdata['last_name'] = ucwords($last_name);
						$userdata['status'] = ( stms_isset($product->info['auto_register']) == 1 ) ? 1 : 4;
						$userdata['is_aff'] = ( stms_isset($stms['global']['manual_aff'], 0) == 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
						$userdata['is_aff_pending'] = ( stms_isset($stms['global']['manual_aff'], 0) != 1 ) ? 0 : (( stms_isset($stms['global']['click_aff'], 1) == 1 ) ? 0 : 1);
						
						$member_id = stms_save_member($userdata);
					}
				}
				
				// log the ipn for further usage...
				$ipn = stms_log_ipn($vars, $tx_id, 'zaxaa', 0, $member_id, $trans_receipt);
			
				$price = $product->price;
				if ( $product->type == 'recurr' && $product->is_trial == 1 )
					$price = $product->t_price;
			
				$total_amount = ( isset($pr['amount']) ) ? number_format($pr['amount'], 2, '.', '') : $price;
				
				// let's complete the payment...
				$args = array(
					'member_id' => $member_id,
					'paysys' => 'zaxaa',
					'receipt' => $trans_amount,
					'currency' => stms_isset($stms['global']['currency'], 'USD'),
					'amount' => $trans_amount,
					'paid' => 1,
					'status' => 'completed',
					'txn_id' => ( !empty($pr['recurring_status']) ) ? $pr['recurring_status'] : '',
					'date' => stms_time(),
					'expired_date' => stms_get_expired($product->ID, true)
				);
				
				stms_complete_payment($tx_id, $args);
			}
			break;
			
		case 'REBILL':
			foreach ( $products as $pr ) {
				$item = $pr['prod_number'];
				$recurring_id = $pr['recurring_id'];
				$recurring_status = $pr['recurring_status'];
				if ( $payment = stms_zaxaa_last_payment($trans_receipt, $recurring_id) ) {
					$member_id = $payment->member_id;
					$product = stms_get_product($payment->product_id);
					
					// Update existing payment status first...
					$new_data = array();
					$new_data['status'] = 'expired';
					$new_data['expired_date'] = strtotime("5 minutes ago", stms_time());
					stms_update_payment($payment->tx_id, $new_data);
					wp_cache_delete($payment->member_id, 'stms_member_payments'); // delete cache
					
					$expired_date = stms_get_expired($product->ID, false);
					if ( $recurring_status == 'COMPLETED' )
						$expired_date = strtotime("19 Jan 2038", wpsem_time());
					
					$total_amount = ( isset($pr['amount']) ) ? number_format($pr['amount'], 2, '.', '') : $product->price;	
					// Add new payment for rebill
					$args = array(
						'product_id' => $product->ID,
						'member_id' => $member_id,
						'payment_type' => 'recurr',
						'paysys' => 'zaxaa',
						'receipt' => $trans_receipt,
						'currency' => stms_isset($stms['global']['currency'], 'USD'),
						'amount' => $total_amount,
						'txn_id' => '',
						'paid' => 1,
						'is_rebill' => 1,
						'txn_id' => ( !empty($pr['recurring_status']) ) ? $pr['recurring_status'] : '',
						'status' => 'completed',
						'expired_date' => $expired_date
					);
					$new_tx_id = stms_add_payment($args);
				}
			}
			break;
		
		case 'CANCELED':
			// Subscription is canceled
			foreach ( $products as $pr ) {
				$item = $pr['prod_number'];
				$recurring_id = $pr['recurring_id']; // This might be useful to recognize past recurring payments
				if ( $payment = stms_zaxaa_last_payment($trans_receipt, $recurring_id) ) {
					$new_data = array();
					$new_data['status'] = 'cancelled';
					stms_update_payment($payment->tx_id, $new_data );
		        	wp_cache_delete($payment->member_id, 'stms_member_payments'); // delete cache
		        	
					do_action('stms_subscr_cancelled', $payment->tx_id);
				}
			}
			break;
			
		case 'REFUND':
			// Refunded payment...
			foreach ( $products as $product ) {
				$item = $pr['prod_number'];
				$recurring_id = ( !empty($pr['recurring_id']) ) ? $pr['recurring_id'] : '';
				if ( $payment = stms_zaxaa_last_payment($trans_receipt, $recurring_id) ) {
					if ( $payments = stms_get_member_payments($payment->member_id) ) {
						foreach ( $payments as $pay ) {
							if ( $pay->product_id  == $payment->product_id
								&& $pay->status == 1
								&& $trans_receipt == $pay->receipt
							) {
									$refund_id = $pay->tx_id;
									stms_refund_payment($refund_id, 'third');
							}
						}
					}
				}
			}
			break;
	}
	exit;
}

function stms_zaxaa_last_payment( $receipt, $recurring_id ) {
	global $wpdb;
	
	$last_payment = $wpdb->get_row(
		$wpdb->prepare("SELECT * FROM `{$wpdb->prefix}stms_transactions`
			WHERE `receipt` <> '' AND (`txn_id` = %s OR `receipt` = %s) ORDER BY `tx_id` DESC LIMIT 1",
			$recurring_id, $receipt
		)
	);
	
	if ( !$last_payment )
		return false;
	
	return $last_payment;
}

add_filter('stms_thanks_setup_zaxaa', 'stms_zaxaa_thanks_setup');
function stms_zaxaa_thanks_setup( $settings ) {
	$settings['rcpt'] = 'rcpt';
	$settings['flow'] = 'normal';
	$settings['email_check'] = true;
	$settings['email_var'] = 'cust_email';
	$settings['firstname_var'] = 'cust_firstname';
	$settings['lastname_var'] = 'cust_lastname';
	return $settings;
}