<?php
if ( !function_exists('callResource') ) :
function callResource($aConfig, $sResource, $sMethod, $mPostData = null) {

	// Set the URL we will be making requests to
	$sApiUrl    = 'https://app.icontact.com/icp' . $sResource;

	// Our resource handle
	$rHandle    = curl_init();

	// Request headers
	$aHeaders   = array(
		'Except:',
		'Accept: application/json',
		'Content-type: application/json',
		'Api-Version:  2.2',
		'Api-AppId:    ' . $aConfig['apiKey'],
		'Api-Username: ' . $aConfig['username'],
		'Api-Password: ' . $aConfig['password']

	);

	curl_setopt($rHandle, CURLOPT_URL,            $sApiUrl);
	curl_setopt($rHandle, CURLOPT_HTTPHEADER,     $aHeaders);
	curl_setopt($rHandle, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($rHandle, CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt($rHandle, CURLOPT_SSL_VERIFYHOST, 0);



	switch ($sMethod) {
		// We just want something
		case 'GET'  :
			// There is nothing to do
			// here, so simply do nothing
			// Done
			break;

		// We are saving something
		case 'POST' :
			curl_setopt($rHandle, CURLOPT_POST,       true);
			curl_setopt($rHandle, CURLOPT_POSTFIELDS, json_encode($mPostData));
			break;

		// We are uploading something
		case 'PUT'  :
			$rFile = fopen($mPostData, 'r');
			curl_setopt($rHandle, CURLOPT_PUT,    true);
			curl_setopt($rHandle, CURLOPT_INFILE, $rFile);
			break;

		default     :
			// Return failure
			return false;
	}

	// Execute the handle
	$sResponse = curl_exec($rHandle);
	$aResponse = json_decode($sResponse, true);
	$iCode     = curl_getinfo($rHandle, CURLINFO_HTTP_CODE);

	curl_close($rHandle);

	// Return the data and response code
	return array(
		'data' => $aResponse,
		'code' => $iCode
	);

}
endif;