<?php
if ( !function_exists('callImnicaMail') ) :
function callImnicaMail( $method = 'POST', $postdata = null, $http_auth = false, $http_username = '', $http_password = '' ) {
	if ( !function_exists('curl_init') )
		return false;

	// Set the URL we will be making requests to
	$api_url    = 'http://www.imnicamail.com/v4/api.php?';
	$user_agent = 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3';
	$postdata   = implode('&', $postdata);

	// Our resource handle
	$curl    = curl_init();

	curl_setopt($curl, CURLOPT_URL,            	$api_url);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, 	true);
	curl_setopt($curl, CURLOPT_TIMEOUT, 		60);
	curl_setopt($curl, CURLOPT_USERAGENT, 		$user_agent);
	// curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 	0);
	// curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 	0);

	if ( (ini_get('safe_mode') != false) && (ini_get('open_basedir') != false) ) {
		curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
       	}

	switch ($method) {
		// We just want something
		case 'GET'  :
			// There is nothing to do
			// here, so simply do nothing
			// Done
			break;
		// We are saving something
		case 'POST' :
			curl_setopt($curl, CURLOPT_POST,       true);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $postdata);
			break;
		// We are uploading something
		case 'PUT'  :
			$file = fopen($postdata, 'r');
			curl_setopt($curl, CURLOPT_PUT,    true);
			curl_setopt($curl, CURLOPT_INFILE, $file);
			break;
		default     :
			// Return failure
			return false;
			// Done
			break;
	}

	if ( $http_auth ) {
		curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
		curl_setopt($curl, CURLOPT_USERPWD,  $http_username . ':' . $http_password);
	}

	// Execute the handle
	$result = curl_exec($curl);
	$response = json_decode($result, true);
	$code    = curl_getinfo($curl, CURLINFO_HTTP_CODE);

	curl_close($curl);

	// Return the data and response code
	return array(
		'data' => $response,
		'code' => $code
	);
}
endif;